Package: puma
Type: Package
Title: Propagating Uncertainty in Microarray Analysis(including
        Affymetrix tranditional 3' arrays and exon arrays and Human
        Transcriptome Array 2.0)
Version: 3.54.0
Date: 2015-7-29
Author: Richard D. Pearson, Xuejun Liu, Magnus Rattray, Marta Milo, Neil D.
    Lawrence, Guido Sanguinetti, Li Zhang
Maintainer: Xuejun Liu <xuejun.liu@nuaa.edu.cn>
Depends: R (>= 3.2.0), oligo (>= 1.32.0),graphics,grDevices, methods,
        stats, utils, mclust, oligoClasses
Imports: Biobase (>= 2.5.5), affy (>= 1.46.0), affyio, oligoClasses
Suggests: pumadata, affydata, snow, limma, ROCR,annotate
Description: Most analyses of Affymetrix GeneChip data (including tranditional 3' arrays and exon arrays and Human Transcriptome Array 2.0) are based on point estimates of expression levels and ignore the uncertainty of such estimates. By propagating uncertainty to downstream analyses we can improve results from microarray analyses. For the first time, the puma package makes a suite of uncertainty propagation methods available to a general audience. In additon to calculte gene expression from Affymetrix 3' arrays, puma also provides methods to process exon arrays and produces gene and isoform expression for alternative splicing study. puma also offers improvements in terms of scope and speed of execution over previously available uncertainty propagation methods. Included are summarisation, differential expression detection, clustering and PCA methods, together with useful plotting functions.
License: LGPL
biocViews: Microarray, OneChannel, Preprocessing,
        DifferentialExpression, Clustering, ExonArray, GeneExpression,
        mRNAMicroarray, ChipOnChip, AlternativeSplicing,
        DifferentialSplicing, Bayesian, TwoChannel, DataImport, HTA2.0
URL: http://umber.sbs.man.ac.uk/resources/puma
Packaged: 2026-04-29 00:00:56 UTC; biocbuild
NeedsCompilation: yes
git_url: https://git.bioconductor.org/packages/puma
git_branch: RELEASE_3_23
git_last_commit: dbcf914
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28

<p align="center">
  <img src="docs/images/standard-logo.svg" alt="Puma logo">
</p>

# Puma: A Ruby Web Server Built For Parallelism

[![Actions](https://github.com/puma/puma/actions/workflows/tests.yml/badge.svg?branch=main)](https://github.com/puma/puma/actions/workflows/tests.yml?query=branch%3Amain)

Puma is a **simple, fast, multi-threaded, and highly parallel HTTP 1.1 server for Ruby/Rack applications**.

## Built For Speed &amp; Parallelism

Puma is a server for [Rack](https://github.com/rack/rack)-powered HTTP applications written in Ruby.  It is:
* **Multi-threaded**. Each request is served in a separate thread. This helps you serve more requests per second with less memory use.
* **Multi-process**. "Pre-forks" in cluster mode, using less memory per-process thanks to copy-on-write memory.
* **Standalone**. With SSL support, zero-downtime rolling restarts and a built-in request bufferer, you can deploy Puma without any reverse proxy.
* **Battle-tested**. Our HTTP parser is inherited from Mongrel and has over 15 years of production use. Puma is currently the most popular Ruby webserver, and is the default server for Ruby on Rails.

Originally designed as a server for [Rubinius](https://github.com/rubinius/rubinius), Puma also works well with Ruby (MRI) and JRuby.

On MRI, there is a Global VM Lock (GVL) that ensures only one thread can run Ruby code at a time. But if you're doing a lot of blocking IO (such as HTTP calls to external APIs like Twitter), Puma still improves MRI's throughput by allowing IO waiting to be done in parallel. Truly parallel Ruby implementations (TruffleRuby, JRuby) don't have this limitation.

## Quick Start

```
$ gem install puma
$ puma
```

Without arguments, puma will look for a rackup (.ru) file in
working directory called `config.ru`.

## SSL Connection Support

Puma will install/compile with support for ssl sockets, assuming OpenSSL
development files are installed on the system.

If the system does not have OpenSSL development files installed, Puma will
install/compile, but it will not allow ssl connections.

## Frameworks

### Rails

Puma is the default server for Rails, included in the generated Gemfile.

Start your server with the `rails` command:

```
$ rails server
```

Many configuration options and Puma features are not available when using `rails server`. It is recommended that you use Puma's executable instead:

```
$ bundle exec puma
```

### Sinatra

You can run your Sinatra application with Puma from the command line like this:

```
$ ruby app.rb -s Puma
```

In order to actually configure Puma using a config file, like `puma.rb`, however, you need to use the `puma` executable. To do this, you must add a rackup file to your Sinatra app:

```ruby
# config.ru
require './app'
run Sinatra::Application
```

You can then start your application using:

```
$ bundle exec puma
```

## Configuration

Puma provides numerous options. Consult `puma -h` (or `puma --help`) for a full list of CLI options, or see `Puma::DSL` or [dsl.rb](https://github.com/puma/puma/blob/main/lib/puma/dsl.rb).

You can also find several configuration examples as part of the
[test](https://github.com/puma/puma/tree/main/test/config) suite.

For debugging purposes, you can set the environment variable `PUMA_LOG_CONFIG` with a value
and the loaded configuration will be printed as part of the boot process.

### Thread Pool

Puma uses a thread pool. You can set the minimum and maximum number of threads that are available in the pool with the `-t` (or `--threads`) flag:

```
$ puma -t 8:32
```

Puma will automatically scale the number of threads, from the minimum until it caps out at the maximum, based on how much traffic is present. The current default is `0:16` and on MRI is `0:5`. Feel free to experiment, but be careful not to set the number of maximum threads to a large number, as you may exhaust resources on the system (or cause contention for the Global VM Lock, when using MRI).

Be aware that additionally Puma creates threads on its own for internal purposes (e.g. handling slow clients). So, even if you specify -t 1:1, expect around 7 threads created in your application.

### Cluster mode

Puma also offers "cluster mode". Cluster mode `fork`s workers from a master process. Each child process still has its own thread pool. You can tune the number of workers with the `-w` (or `--workers`) flag:

```
$ puma -t 8:32 -w 3
```

Or with the `WEB_CONCURRENCY` environment variable:

```
$ WEB_CONCURRENCY=3 puma -t 8:32
```

When using a config file, most applications can simply set `workers :auto` (requires the `concurrent-ruby` gem) to match the number of worker processes to the available processors:

```ruby
# config/puma.rb
workers :auto
```

See [`workers :auto` gotchas](lib/puma/dsl.rb).

Note that threads are still used in cluster mode, and the `-t` thread flag setting is per worker, so `-w 2 -t 16:16` will spawn 32 threads in total, with 16 in each worker process.

If `workers` is set to `:auto`, or the `WEB_CONCURRENCY` environment variable is set to `"auto"`, and the `concurrent-ruby` gem is available in your application, Puma will set the worker process count to the result of [available processors](https://msp-greg.github.io/concurrent-ruby/Concurrent.html#available_processor_count-class_method).

For an in-depth discussion of the tradeoffs of thread and process count settings, [see our docs](docs/deployment.md).

In cluster mode, Puma can "preload" your application. This loads all the application code *prior* to forking. Preloading reduces total memory usage of your application via an operating system feature called [copy-on-write](https://en.wikipedia.org/wiki/Copy-on-write).

If the number of workers is greater than 1 (and `--prune-bundler` has not been specified), preloading will be enabled by default. Otherwise, you can use the `--preload` flag from the command line:

```
$ puma -w 3 --preload
```

Or, if you're using a configuration file, you can use the `preload_app!` method:

```ruby
# config/puma.rb
workers 3
preload_app!
```

Preloading can’t be used with phased restart, since phased restart kills and restarts workers one-by-one, and preloading copies the code of master into the workers.

#### Cluster mode hooks

When using clustered mode, Puma's configuration DSL provides `before_fork`, `before_worker_boot`, and `after_worker_shutdown`
hooks to run code when the master process forks, the child workers are booted, and after each child worker exits respectively.

It is recommended to use these hooks with `preload_app!`, otherwise constants loaded by your
application (such as `Rails`) will not be available inside the hooks.

```ruby
# config/puma.rb
before_fork do
  # Add code to run inside the Puma master process before it forks a worker child.
end

before_worker_boot do
  # Add code to run inside the Puma worker process after forking.
end

after_worker_shutdown do |worker_handle|
  # Add code to run inside the Puma master process after a worker exits. `worker.process_status` can be used to get the
  # `Process::Status` of the exited worker.
end
```

In addition, there is an `before_refork` and `after_refork` hooks which are used only in [`fork_worker` mode](docs/fork_worker.md),
when the worker 0 child process forks a grandchild worker:

```ruby
before_refork do
  # Used only when fork_worker mode is enabled. Add code to run inside the Puma worker 0
  # child process before it forks a grandchild worker.
end
```

```ruby
after_refork do
  # Used only when fork_worker mode is enabled. Add code to run inside the Puma worker 0
  # child process after it forks a grandchild worker.
end
```

Importantly, note the following considerations when Ruby forks a child process:

1. File descriptors such as network sockets **are** copied from the parent to the forked
   child process. Dual-use of the same sockets by parent and child will result in I/O conflicts
   such as `SocketError`, `Errno::EPIPE`, and `EOFError`.
2. Background Ruby threads, including threads used by various third-party gems for connection
   monitoring, etc., are **not** copied to the child process. Often this does not cause
   immediate problems until a third-party connection goes down, at which point there will
   be no supervisor to reconnect it.

Therefore, we recommend the following:

1. If possible, do not establish any socket connections (HTTP, database connections, etc.)
   inside Puma's master process when booting.
2. If (1) is not possible, use `before_fork` and `before_refork` to disconnect the parent's socket
   connections when forking, so that they are not accidentally copied to the child process.
3. Use `before_worker_boot` to restart any background threads on the forked child.
4. Use `after_refork` to restart any background threads on the parent.

#### Master process lifecycle hooks

Puma's configuration DSL provides master process lifecycle hooks `after_booted`, `before_restart`, and `after_stopped`
which may be used to specify code blocks to run on each event:

```ruby
# config/puma.rb
after_booted do
  # Add code to run in the Puma master process after it boots,
  # and also after a phased restart completes.
end

before_restart do
  # Add code to run in the Puma master process when it receives
  # a restart command but before it restarts.
end

after_stopped do
  # Add code to run in the Puma master process when it receives
  # a stop command but before it shuts down.
end
```

### Error handling

If Puma encounters an error outside of the context of your application, it will respond with a 400/500 and a simple
textual error message (see `Puma::Server#lowlevel_error` or [server.rb](https://github.com/puma/puma/blob/main/lib/puma/server.rb)).
You can specify custom behavior for this scenario. For example, you can report the error to your third-party
error-tracking service (in this example, [rollbar](https://rollbar.com)):

```ruby
lowlevel_error_handler do |e, env, status|
  if status == 400
    message = "The server could not process the request due to an error, such as an incorrectly typed URL, malformed syntax, or a URL that contains illegal characters.\n"
  else
    message = "An error has occurred, and engineers have been informed. Please reload the page. If you continue to have problems, contact support@example.com\n"
    Rollbar.critical(e)
  end

  [status, {}, [message]]
end
```

### Binding TCP / Sockets

Bind Puma to a socket with the `-b` (or `--bind`) flag:

```
$ puma -b tcp://127.0.0.1:9292
```

To use a UNIX Socket instead of TCP:

```
$ puma -b unix:///var/run/puma.sock
```

If you need to change the permissions of the UNIX socket, just add a umask parameter:

```
$ puma -b 'unix:///var/run/puma.sock?umask=0111'
```

Need a bit of security? Use SSL sockets:

```
$ puma -b 'ssl://127.0.0.1:9292?key=path_to_key&cert=path_to_cert'
```
#### Self-signed SSL certificates (via the [`localhost`] gem, for development use):

Puma supports the [`localhost`] gem for self-signed certificates. This is particularly useful if you want to use Puma with SSL locally, and self-signed certificates will work for your use-case. Currently, the integration can only be used in MRI.

Puma automatically configures SSL when the [`localhost`] gem is loaded in a `development` environment:

Add the gem to your Gemfile:
```ruby
group(:development) do
  gem 'localhost'
end
```

And require it implicitly using bundler:
```ruby
require "bundler"
Bundler.require(:default, ENV["RACK_ENV"].to_sym)
```

Alternatively, you can require the gem in your configuration file, either `config/puma/development.rb`, `config/puma.rb`, or set via the `-C` cli option:
```ruby
require 'localhost'
# configuration methods (from Puma::DSL) as needed
```

Additionally, Puma must be listening to an SSL socket:

```shell
$ puma -b 'ssl://localhost:9292' -C config/use_local_host.rb

# The following options allow you to reach Puma over HTTP as well:
$ puma -b ssl://localhost:9292 -b tcp://localhost:9393 -C config/use_local_host.rb
```

[`localhost`]: https://github.com/socketry/localhost

#### Controlling SSL Cipher Suites

To use or avoid specific SSL ciphers for TLSv1.2 and below, use `ssl_cipher_filter` or `ssl_cipher_list` options.

##### Ruby:

```
$ puma -b 'ssl://127.0.0.1:9292?key=path_to_key&cert=path_to_cert&ssl_cipher_filter=!aNULL:AES+SHA'
```

##### JRuby:

```
$ puma -b 'ssl://127.0.0.1:9292?keystore=path_to_keystore&keystore-pass=keystore_password&ssl_cipher_list=TLS_RSA_WITH_AES_128_CBC_SHA,TLS_RSA_WITH_AES_256_CBC_SHA'
```

To configure the available TLSv1.3 ciphersuites, use `ssl_ciphersuites` option (not available for JRuby).

##### Ruby:

```
$ puma -b 'ssl://127.0.0.1:9292?key=path_to_key&cert=path_to_cert&ssl_ciphersuites=TLS_AES_256_GCM_SHA384:TLS_AES_128_GCM_SHA256'
```

See https://www.openssl.org/docs/man1.1.1/man1/ciphers.html for cipher filter format and full list of cipher suites.

Disable TLS v1 with the `no_tlsv1` option:

```
$ puma -b 'ssl://127.0.0.1:9292?key=path_to_key&cert=path_to_cert&no_tlsv1=true'
```

#### Controlling OpenSSL Verification Flags

To enable verification flags offered by OpenSSL, use `verification_flags` (not available for JRuby):

```
$ puma -b 'ssl://127.0.0.1:9292?key=path_to_key&cert=path_to_cert&verification_flags=PARTIAL_CHAIN'
```

You can also set multiple verification flags (by separating them with a comma):

```
$ puma -b 'ssl://127.0.0.1:9292?key=path_to_key&cert=path_to_cert&verification_flags=PARTIAL_CHAIN,CRL_CHECK'
```

List of available flags: `USE_CHECK_TIME`, `CRL_CHECK`, `CRL_CHECK_ALL`, `IGNORE_CRITICAL`, `X509_STRICT`, `ALLOW_PROXY_CERTS`, `POLICY_CHECK`, `EXPLICIT_POLICY`, `INHIBIT_ANY`, `INHIBIT_MAP`, `NOTIFY_POLICY`, `EXTENDED_CRL_SUPPORT`, `USE_DELTAS`, `CHECK_SS_SIGNATURE`, `TRUSTED_FIRST`, `SUITEB_128_LOS_ONLY`, `SUITEB_192_LOS`, `SUITEB_128_LOS`, `PARTIAL_CHAIN`, `NO_ALT_CHAINS`, `NO_CHECK_TIME`
(see https://www.openssl.org/docs/manmaster/man3/X509_VERIFY_PARAM_set_hostflags.html#VERIFICATION-FLAGS).

#### Controlling OpenSSL Password Decryption

To enable runtime decryption of an encrypted SSL key (not available for JRuby), use `key_password_command`:

```
$ puma -b 'ssl://127.0.0.1:9292?key=path_to_key&cert=path_to_cert&key_password_command=/path/to/command.sh'
```

`key_password_command` must:

1. Be executable by Puma.
2. Print the decryption password to stdout.

 For example:

```shell
#!/bin/sh

echo "this is my password"
```

`key_password_command` can be used with `key` or `key_pem`. If the key
is not encrypted, the executable will not be called.

### Control/Status Server

Puma has a built-in status and control app that can be used to query and control Puma.

```
$ puma --control-url tcp://127.0.0.1:9293 --control-token foo
```

Puma will start the control server on localhost port 9293. All requests to the control server will need to include control token (in this case, `token=foo`) as a query parameter. This allows for simple authentication. Check out `Puma::App::Status` or [status.rb](https://github.com/puma/puma/blob/main/lib/puma/app/status.rb) to see what the status app has available.

You can also interact with the control server via `pumactl`. This command will restart Puma:

```
$ pumactl --control-url 'tcp://127.0.0.1:9293' --control-token foo restart
```

To see a list of `pumactl` options, use `pumactl --help`.

### Configuration File

You can also provide a configuration file with the `-C` (or `--config`) flag:

```
$ puma -C /path/to/config
```

If no configuration file is specified, Puma will look for a configuration file at `config/puma.rb`. If an environment is specified (via the `--environment` flag or through the `APP_ENV`, `RACK_ENV`, or `RAILS_ENV` environment variables) Puma looks for a configuration file at `config/puma/<environment_name>.rb` and then falls back to `config/puma.rb`.

If you want to prevent Puma from looking for a configuration file in those locations, include the `--no-config` flag:

```
$ puma --no-config

# or

$ puma -C "-"
```

The other side-effects of setting the environment are whether to show stack traces (in `development` or `test`), and setting RACK_ENV may potentially affect middleware looking for this value to change their behavior. The default puma RACK_ENV value is `development`. You can see all config default values in `Puma::Configuration#puma_default_options` or [configuration.rb](https://github.com/puma/puma/blob/61c6213fbab/lib/puma/configuration.rb#L182-L204).

Check out `Puma::DSL` or [dsl.rb](https://github.com/puma/puma/blob/main/lib/puma/dsl.rb) to see all available options.

## Restart

Puma includes the ability to restart itself. When available (MRI, Rubinius, JRuby), Puma performs a "hot restart". This is the same functionality available in *Unicorn* and *NGINX* which keep the server sockets open between restarts. This makes sure that no pending requests are dropped while the restart is taking place.

For more, see the [Restart documentation](docs/restart.md).

## Signals

Puma responds to several signals. A detailed guide to using UNIX signals with Puma can be found in the [Signals documentation](docs/signals.md).

## Platform Constraints

Some platforms do not support all Puma features.

  * **JRuby**, **Windows**: server sockets are not seamless on restart, they must be closed and reopened. These platforms have no way to pass descriptors into a new process that is exposed to Ruby. Also, cluster mode is not supported due to a lack of fork(2).
  * **Windows**: Cluster mode is not supported due to a lack of fork(2).
  * **Kubernetes**: The way Kubernetes handles pod shutdowns interacts poorly with server processes implementing graceful shutdown, like Puma. See the [kubernetes section of the documentation](docs/kubernetes.md) for more details.

## Deployment

 * Puma has support for Capistrano with an [external gem](https://github.com/seuros/capistrano-puma).

 * Additionally, Puma has support for built-in daemonization via the [puma-daemon](https://github.com/kigster/puma-daemon) ruby gem. The gem restores the `daemonize` option that was removed from Puma starting version 5, but only for MRI Ruby.


It is common to use process monitors with Puma. Modern process monitors like systemd or rc.d
provide continuous monitoring and restarts for increased reliability in production environments:

* [rc.d](docs/jungle/rc.d/README.md)
* [systemd](docs/systemd.md)

Community guides:

* [Deploying Puma on OpenBSD using relayd and httpd](https://gist.github.com/anon987654321/4532cf8d6c59c1f43ec8973faa031103)

## Community Extensions

### Plugins

* [puma-metrics](https://github.com/harmjanblok/puma-metrics) — export Puma metrics to Prometheus
* [puma-plugin-statsd](https://github.com/yob/puma-plugin-statsd) — send Puma metrics to statsd
* [puma-plugin-systemd](https://github.com/sj26/puma-plugin-systemd) — deeper integration with systemd for notify, status and watchdog. Puma 5.1.0 integrated notify and watchdog, which probably conflicts with this plugin. Puma 6.1.0 added status support which obsoletes the plugin entirely.
* [puma-plugin-telemetry](https://github.com/babbel/puma-plugin-telemetry) - telemetry plugin for Puma offering various targets to publish
* [puma-acme](https://github.com/anchordotdev/puma-acme) - automatic SSL/HTTPS certificate provisioning and setup

### Monitoring

* [puma-status](https://github.com/ylecuyer/puma-status) — Monitor CPU/Mem/Load of running puma instances from the CLI

## Contributing

Find details for contributing in the [contribution guide](CONTRIBUTING.md).

## License

Puma is copyright Evan Phoenix and contributors, licensed under the BSD 3-Clause license. See the included LICENSE file for details.

# Hack Directory

Development and testing utilities for PUMA.

## Structure

```
hack/
└── scripts/          # Test and utility scripts
    └── test_api.sh
```

## Scripts

### `scripts/test_api.sh`

Tests all PUMA API endpoints manually.

**Usage:**
```bash
# Start PUMA server first
./puma serve

# In another terminal
./hack/scripts/test_api.sh
```

**Tests:**
- Health check
- List models
- Chat completion (non-streaming)
- Chat completion (streaming)
- Text completion

**Requirements:**
- Running PUMA server
- `curl` and `jq` installed

---


## Adding New Scripts

Place development and testing scripts in `hack/scripts/`:

```bash
# Create new script
cat > hack/scripts/my_script.sh << 'EOF'
#!/bin/bash
# Your script here
EOF

# Make executable
chmod +x hack/scripts/my_script.sh
```

---

## Why "hack"?

The `hack/` directory is a convention from Kubernetes and other projects for:
- Development utilities
- Test scripts
- Build helpers
- CI/CD scripts
- One-off tools

It keeps the root directory clean while providing a place for development tools.

# Puma as a service using rc.d

Manage multiple Puma servers as services on one box using FreeBSD's rc.d service.

## Dependencies

* `jq` - a command-line json parser is needed to parse the json in the config file

## Installation

    # Copy the puma script to the rc.d directory (make sure everyone has read/execute perms)
    sudo cp puma /usr/local/etc/rc.d/

    # Create an empty configuration file
    sudo touch /usr/local/etc/puma.conf

    # Enable the puma service
    sudo echo 'puma_enable="YES"' >> /etc/rc.conf

## Managing the jungle

Puma apps are referenced in /usr/local/etc/puma.conf by default.

Start the jungle running:

`service puma start`

This script will run at boot time.


You can also stop the jungle (stops ALL puma instances) by running:

`service puma stop`


To restart the jungle:

`service puma restart`

## Conventions

* The script expects:
  * a config file to exist under `config/puma.rb` in your app. E.g.: `/home/apps/my-app/config/puma.rb`.

You can always change those defaults by editing the scripts.

## Here's what a minimal app's config file should have

```
{
	"servers" : [
		{
			"dir": "/path/to/rails/project",
			"user": "deploy-user",
			"ruby_version": "ruby.version",
			"ruby_env": "rbenv"
		}
	]
}
```

## Before starting...

You need to customise `puma.conf` to:

* Set the right user your app should be running on unless you want root to execute it!
* Set the directory of the app
* Set the ruby version to execute
* Set the ruby environment (currently set to rbenv, since that is the only ruby environment currently supported)
* Add additional server instances following the scheme in the example

## Notes:

Only rbenv is currently supported.

# Large file upload demo

This is a simple app to demonstrate memory used by Puma for large file uploads and
compare it to proposed changes in PR https://github.com/puma/puma/pull/3062

### Steps to test memory improvements in https://github.com/puma/puma/pull/3062

- Run the app with puma_worker_killer: `bundle exec puma -p 9090 --config puma.rb`
- Make a POST request with curl: `curl --form "data=@some_large_file.mp4" --limit-rate 10M http://localhost:9090/`
- Puma will log memory usage in the console

Below is example of the results uploading a 115MB video.

### Puma 6.0.2

```
[11820] Puma starting in cluster mode...
[11820] * Puma version: 6.0.2 (ruby 3.2.0-p0) ("Sunflower")
[11820] *  Min threads: 0
[11820] *  Max threads: 5
[11820] *  Environment: development
[11820] *   Master PID: 11820
[11820] *      Workers: 1
[11820] *     Restarts: (✔) hot (✔) phased
[11820] * Listening on http://0.0.0.0:3000
[11820] Use Ctrl-C to stop
[11820] - Worker 0 (PID: 11949) booted in 0.06s, phase: 0
[11820] PumaWorkerKiller: Consuming 70.984375 mb with master and 1 workers.
[11820] PumaWorkerKiller: Consuming 70.984375 mb with master and 1 workers.

...curl request made - memory increases as file is received

[11820] PumaWorkerKiller: Consuming 72.796875 mb with master and 1 workers.
[11820] PumaWorkerKiller: Consuming 75.921875 mb with master and 1 workers.
[11820] PumaWorkerKiller: Consuming 78.953125 mb with master and 1 workers.
[11820] PumaWorkerKiller: Consuming 82.15625 mb with master and 1 workers.
[11820] PumaWorkerKiller: Consuming 85.265625 mb with master and 1 workers.
[11820] PumaWorkerKiller: Consuming 88.046875 mb with master and 1 workers.

...(clipped out lines) memory keeps increasing while request is received

[11820] PumaWorkerKiller: Consuming 121.53125 mb with master and 1 workers.
[11820] PumaWorkerKiller: Consuming 122.75 mb with master and 1 workers.
[11820] PumaWorkerKiller: Consuming 125.40625 mb with master and 1 workers.

...request handed off from Puma to Rack/Sinatra

[11820] PumaWorkerKiller: Consuming 220.6875 mb with master and 1 workers.
127.0.0.1 - - [26/Jan/2023:20:09:56 -0500] "POST /upload HTTP/1.1" 200 162 0.0553
[11820] PumaWorkerKiller: Consuming 228.96875 mb with master and 1 workers.
[11820] PumaWorkerKiller: Consuming 228.96875 mb with master and 1 workers.
```

### With PR https://github.com/puma/puma/pull/3062

```
[20815] Puma starting in cluster mode...
[20815] * Puma version: 6.0.2 (ruby 3.2.0-p0) ("Sunflower")
[20815] *  Min threads: 0
[20815] *  Max threads: 5
[20815] *  Environment: development
[20815] *   Master PID: 20815
[20815] *      Workers: 1
[20815] *     Restarts: (✔) hot (✔) phased
[20815] * Listening on http://0.0.0.0:3000
[20815] Use Ctrl-C to stop
[20815] - Worker 0 (PID: 20944) booted in 0.1s, phase: 0
[20815] PumaWorkerKiller: Consuming 73.25 mb with master and 1 workers.
[20815] PumaWorkerKiller: Consuming 73.25 mb with master and 1 workers.

...curl request made - memory stays level as file is received

[20815] PumaWorkerKiller: Consuming 73.28125 mb with master and 1 workers.
[20815] PumaWorkerKiller: Consuming 73.296875 mb with master and 1 workers.
[20815] PumaWorkerKiller: Consuming 73.34375 mb with master and 1 workers.
[20815] PumaWorkerKiller: Consuming 73.359375 mb with master and 1 workers.
[20815] PumaWorkerKiller: Consuming 73.359375 mb with master and 1 workers.
[20815] PumaWorkerKiller: Consuming 73.359375 mb with master and 1 workers.

...(clipped out lines) memory continues to stay level

[20815] PumaWorkerKiller: Consuming 73.703125 mb with master and 1 workers.
[20815] PumaWorkerKiller: Consuming 73.703125 mb with master and 1 workers.
[20815] PumaWorkerKiller: Consuming 73.703125 mb with master and 1 workers.

...request handed off from Puma to Rack/Sinatra

[20815] PumaWorkerKiller: Consuming 181.96875 mb with master and 1 workers.
127.0.0.1 - - [26/Jan/2023:20:27:16 -0500] "POST /upload HTTP/1.1" 200 162 0.0585
[20815] PumaWorkerKiller: Consuming 183.78125 mb with master and 1 workers.
[20815] PumaWorkerKiller: Consuming 183.78125 mb with master and 1 workers.
```

# Puma daemon service

Deprecatation Warning : `init.d` was replaced by `systemd` since Debian 8 and Ubuntu 16.04, you should look into [/docs/systemd](https://github.com/puma/puma/blob/master/docs/systemd.md) unless you are on an older OS. 

Init script to manage multiple Puma servers on the same box using start-stop-daemon.

## Installation 

    # Copy the init script to services directory 
    sudo cp puma /etc/init.d
    sudo chmod +x /etc/init.d/puma
    
    # Make it start at boot time. 
    sudo update-rc.d -f puma defaults

    # Copy the Puma runner to an accessible location
    sudo cp run-puma /usr/local/bin
    sudo chmod +x /usr/local/bin/run-puma

    # Create an empty configuration file
    sudo touch /etc/puma.conf

## Managing the jungle 

Puma apps are held in /etc/puma.conf by default. It's mainly a CSV file and every line represents one app. Here's the syntax:

    app-path,user,config-file-path,log-file-path,environment-variables

You can add an instance by editing the file or running the following command:

    sudo /etc/init.d/puma add /path/to/app user /path/to/app/config/puma.rb /path/to/app/log/puma.log

The config and log paths, as well as the environment variables, are optional parameters and default to:

* config: /path/to/app/*config/puma.rb*
* log: /path/to/app/*log/puma.log*
* environment: (empty)

Multiple environment variables need to be separated by a semicolon, e.g.

    FOO=1;BAR=2

To remove an app, simply delete the line from the config file or run:

    sudo /etc/init.d/puma remove /path/to/app

The command will make sure the Puma instance stops before removing it from the jungle.

## Assumptions 

* The script expects a temporary folder named /path/to/app/*tmp/puma* to exist. Create it if it's not there by default.
The pid and state files should live there and must be called: *tmp/puma/pid* and *tmp/puma/state*.
You can change those if you want but you'll have to adapt the script for it to work.

* Here's what a minimal app's config file should have:

```
pidfile "/path/to/app/tmp/puma/pid"
state_path "/path/to/app/tmp/puma/state"
activate_control_app
```

pumaPCAUpdateCinv <- function
(
    model
,   expectations
,   varY
,   Y
)
{
    C <- apply(expectations@xxT, 1:2, mean) -
            ( 2 * matrix(colMeans(expectations@x)) %*% model@m ) +
            ( t(model@m) %*% model@m )
    Cinv <- solve(C)
#    C
}

pumaPCAUpdateMu <- function
(
    model
,   expectations
,   varY
,   Y
)
{
    dataDim <- dim(Y)[2]
    numData <- dim(Y)[1]

    G <- matrix(nrow=dataDim, ncol=numData)

    for (i in 1:numData)
    {
        G[, i] <- ( 1 / (model@sigma^2 + varY[i,] ) ) * ( Y[i,] - model@W %*% expectations@x[i, ] )
    }
    Q <- colSums( 1 / ( model@sigma^2 + varY ) )
    mu <- t(matrix(rowSums(G) / Q))
    mu
}

compareLimmapumaDE <- function (
	eset_mmgmos
,	eset_comb = NULL
,	eset_other = eset_mmgmos
,	limmaRes = calculateLimma(eset_other)
,	pumaDERes = pumaDE(eset_comb)
,	contrastMatrix = createContrastMatrix(eset_mmgmos)
,	numberToCompareForContrasts = 3
,	numberToCompareForVenn = 100
,	plotContrasts = TRUE
,	contrastsFilename = NULL
,	plotOther = FALSE
,	otherFilename = "other"
,	plotBcombContrasts = FALSE
,	bcombContrastsFilename = "bcomb_contrasts"
,	plotVenn = FALSE
,	vennFilename = "venn.pdf"
,	showTopMatches = FALSE
,	returnResults = FALSE
)
{
	numberOfContrasts <- dim(contrastMatrix)[2]
	numberOfGenes <- numberOfGenes(limmaRes)
	if(numberOfGenes != numberOfGenes(pumaDERes))
	{ stop("Different numbers of genes") }
	for(i in 1:numberOfContrasts)
	{
		genes_to_plot <- as.integer(
			c(
				topGenes(pumaDERes,numberOfGenes=numberToCompareForContrasts,contrast=i)
			,	topGenes(limmaRes,numberOfGenes=numberToCompareForContrasts,contrast=i)
			)
		)
		if(plotContrasts)
		{
			if(!is.null(contrastsFilename))
			{
				pdf(
					paste(
						contrastsFilename
					,	"_"
					,	colnames(contrastMatrix)[i]
					,	".pdf"
					,	sep=""
					)
				,	width=10
				,	height=6
				,	pointsize=6
				)
			}
			# else
			# 	do.call(getOption("device"),list())
			if(is.null(eset_comb))
				plotErrorBars(eset_mmgmos, genes_to_plot, showGeneNames=TRUE)
			else
				plotErrorBars(eset_mmgmos, genes_to_plot, showGeneNames=TRUE, eset_comb=eset_comb)
			if(!is.null(contrastsFilename)) dev.off()
		}
		if(plotOther)
		{
			if(!is.null(otherFilename))
			{
				pdf(
					paste(
						otherFilename
					,	"_"
					,	colnames(contrastMatrix)[i]
					,	".pdf"
					,	sep=""
					)
				,	width=10
				,	height=6
				,	pointsize=6
				)
			}
			# else
			# 	do.call(getOption("device"),list())
			plotErrorBars(eset_other, genes_to_plot, showGeneNames=TRUE)
			if(!is.null(contrastsFilename)) dev.off()
		}
		if(plotBcombContrasts && !(is.null(eset_comb)))
		{
			if(!is.null(bcombContrastsFilename))
			{
				pdf(
					paste(
						bcombContrastsFilename
					,	"_"
					,	colnames(contrastMatrix)[i]
					,	".pdf"
					,	sep=""
					)
				,	width=10
				,	height=6
				,	pointsize=6
				)
			}
			else
				do.call(getOption("device"),list())
			plotErrorBars(eset_comb, genes_to_plot, showGeneNames=TRUE)
			if(!is.null(bcombContrastsFilename)) dev.off()
		}
		if(showTopMatches)
		{
			cat(paste("Contrast",colnames(contrastMatrix)[i]),"\n")
			print("Position of limma top matches in pumaDE list")
			print(
				match(
					topGenes(limmaRes,numberOfGenes=numberToCompareForContrasts,contrast=i)
				,	topGenes(pumaDERes,numberOfGenes=numberOfGenes,contrast=i)
				)
			)
			print("PPLR of limma top matches")
			print(
				statistic(pumaDERes)[match(
					topGenes(limmaRes,numberOfGenes=numberToCompareForContrasts,contrast=i)
				,	topGenes(pumaDERes,numberOfGenes=numberOfGenes,contrast=i)
				)
				,i]
			)
			print("")
		}
	}
	results <- list()
	for(i in 1:numberOfContrasts)
	{
		topLimma <- rep(0, numberOfGenes)
		topLimma[topGenes(limmaRes,numberOfGenes=numberToCompareForVenn,contrast=i)] <- 1
		toppumaDE <- rep(0, numberOfGenes)
		toppumaDE[topGenes(pumaDERes,numberOfGenes=numberToCompareForVenn,contrast=i)] <- 1
		results[[i]] <- cbind (topLimma, toppumaDE)
	}
	if(plotVenn)
	{
		plotColumns <- ceiling(sqrt(numberOfContrasts))
		plotRows <- ceiling(numberOfContrasts/plotColumns)
		pdf(vennFilename, paper="a4", pointsize=6)
		par(mfrow=c(plotRows, plotColumns))
		for(i in 1:numberOfContrasts)
		{
			vennDiagram(results[[i]], main=colnames(contrastMatrix)[i])
		}
		dev.off()
	}
	if(returnResults) return(results)
}

justmgMOS <- function(
  ...
, filenames=character(0)
, widget=getOption("BioC")$affy$use.widgets
, compress=getOption("BioC")$affy$compress.cel
, celfile.path=getwd()
, sampleNames=NULL
, phenoData=NULL
, description=NULL
, notes=""
, background=TRUE
, gsnorm=c("median", "none", "mean", "meanlog")
, savepar=FALSE
, eps=1.0e-6
)
{

  l <- AllButCelsForReadAffy(..., filenames=filenames,
                             widget=widget,
                             celfile.path=celfile.path,
                             sampleNames=sampleNames,
                             phenoData=phenoData,
                             description=description)


  ##and now we are ready to read cel files
 ret<- just.mgmos(filenames=l$filenames,
                  phenoData=l$phenoData,
                  description=l$description,
                  notes=notes,
                  compress=compress,
                  background=background,
                  gsnorm=gsnorm,
                  savepar=savepar,
                  eps=eps)
  ##sampleNames(ret) <- l$sampleNames
  return(ret)

}

just.mgmos <- function(
  ...
, filenames=character(0)
, phenoData=new("AnnotatedDataFrame")
, description=NULL
, notes=""
, compress=getOption("BioC")$affy$compress.cel
, background=TRUE
, gsnorm=c("median", "none", "mean", "meanlog")
, savepar=FALSE
, eps=1.0e-6
)
{

  auxnames <- as.list(substitute(list(...)))[-1]
  filenames <- .Primitive("c")(filenames, auxnames)

  n <- length(filenames)

  ## error if no file name !
  if (n == 0)
    stop("No file name given !")

  pdata <- pData(phenoData)
  ##try to read sample names form phenoData. if not there use CEL filenames
  if(dim(pdata)[1]!=n){#if empty pdata filename are samplenames
    warning("Incompatible phenoData object. Created a new one.\n")

    samplenames <- gsub("^/?([^/]*/)*", "", unlist(filenames))
    pdata <- data.frame(sample=1:n,row.names=samplenames)
    phenoData <- new(
      "phenoData"
     , pData=pdata
     , varLabels=list(sample="arbitrary numbering")
     )
  }
  else samplenames <- rownames(pdata)

  if (is.null(description))
    {
      description <- new("MIAME")
      description@preprocessing$filenames <- filenames
      description@preprocessing$affyversion <- library(
                                                 help=affy
                                               )$info[[2]][[2]][2]
	  description@other <- list(notes)
    }
  ## read the first file to see what we have
  ##if (verbose) cat(1, "reading",filenames[[1]],"...")

  ## get information from cdf environment

  headdetails <- read.celfile.header(filenames[[1]])
  dim.intensity <- headdetails[[2]]
  cdfname <- headdetails[[1]]

  tmp <- new("AffyBatch",
             cdfName=cdfname,
             annotation=cleancdfname(cdfname, addcdf=FALSE))
  pmIndex <- pmindex(tmp)
  probenames <- rep(names(pmIndex), unlist(lapply(pmIndex,length)))
  pmIndex <- unlist(pmIndex)

  ## read pm data into matrix

  pm <- read.probematrix(filenames=unlist(filenames),which="pm")$pm
  mm <- read.probematrix(filenames=unlist(filenames),which="mm")$mm

  ## pass matrix of probe values to mgmos
  ## call mgmos
  conds <- n
  genes <- length(featureNames(tmp))

  phis <- c(0,0,0)  
  prctiles <- 0.01*c(5, 25, 50, 75, 95);
  
  if (background == TRUE)
  {
    for (i in c(1:conds)){
      m<-min(c(min(pm[,i]),min(mm[,i])))
      pm[,i]<-pm[,i]-m+1
      mm[,i]<-mm[,i]-m+1
    }
  }

  res <-
    .Call(
      "mgmos_c"
     , pm
     , mm
     , genes
     , probenames
     , phis
     , prctiles
     , length(prctiles)
     , savepar
     , eps
     , PACKAGE="puma"
     )

  expr <- matrix(res[c(1:genes),],genes,conds)
  se <- matrix(res[c((genes+1):(2*genes)),],genes,conds)
  prc5 <- matrix(res[c((2*genes+1):(3*genes)),],genes,conds)
  prc25 <- matrix(res[c((3*genes+1):(4*genes)),],genes,conds)
  prc50 <- matrix(res[c((4*genes+1):(5*genes)),],genes,conds)
  prc75 <- matrix(res[c((5*genes+1):(6*genes)),],genes,conds)
  prc95 <- matrix(res[c((6*genes+1):(7*genes)),],genes,conds)

  rm(res)

  if (gsnorm[1]=="mean")
  {
    expr <- as.data.frame(2^expr)
    
    chipm <- apply(expr,2,mean)
    chipm <- chipm/chipm[1]

    expr <- as.matrix(log2(expr))
    for (i in 1:conds)
    {
      expr[,i] <- expr[,i]-log2(chipm[i])
      prc5[,i] <- prc5[,i]-log2(chipm[i])
      prc25[,i] <- prc25[,i]-log2(chipm[i])
      prc50[,i] <- prc50[,i]-log2(chipm[i])
      prc75[,i] <- prc75[,i]-log2(chipm[i])
      prc95[,i] <- prc95[,i]-log2(chipm[i])
    }
  }
  else if (gsnorm[1]=="median")
  {
    expr <- as.data.frame(2^expr)
    
    chipm <- apply(expr,2,median)
    chipm <- chipm/chipm[1]

    expr <- as.matrix(log2(expr))
    for (i in 1:conds)
    {
      expr[,i] <- expr[,i]-log2(chipm[i])
      prc5[,i] <- prc5[,i]-log2(chipm[i])
      prc25[,i] <- prc25[,i]-log2(chipm[i])
      prc50[,i] <- prc50[,i]-log2(chipm[i])
      prc75[,i] <- prc75[,i]-log2(chipm[i])
      prc95[,i] <- prc95[,i]-log2(chipm[i])
    }
  }
  else if (gsnorm[1]=="meanlog")
  {
    chipm <- apply(expr,2,mean)
    chipm <- chipm-chipm[1]

    for (i in 1:conds)
    {
      expr[,i] <- expr[,i]-chipm[i]
      prc5[,i] <- prc5[,i]-chipm[i]
      prc25[,i] <- prc25[,i]-chipm[i]
      prc50[,i] <- prc50[,i]-chipm[i]
      prc75[,i] <- prc75[,i]-chipm[i]
      prc95[,i] <- prc95[,i]-chipm[i]
    }
  }

  rownames(expr) <- featureNames(tmp)
  colnames(expr) <- samplenames
  rownames(se) <- featureNames(tmp)
  colnames(se) <- samplenames
  rownames(prc5) <- featureNames(tmp)
  colnames(prc5) <- samplenames
  rownames(prc25) <- featureNames(tmp)
  colnames(prc25) <- samplenames
  rownames(prc50) <- featureNames(tmp)
  colnames(prc50) <- samplenames
  rownames(prc75) <- featureNames(tmp)
  colnames(prc75) <- samplenames
  rownames(prc95) <- featureNames(tmp)
  colnames(prc95) <- samplenames

  annotation <- annotation(tmp)

  new(
    "exprReslt"
    , prcfive=prc5
    , prctwfive=prc25
    , prcfifty=prc50
    , prcsevfive=prc75
    , prcninfive=prc95
    , exprs=expr
    , se.exprs=se
    , phenoData=phenoData
    , annotation=annotation
    , experimentData=description
    )
}

pumaPCANewtonUpdateLogSigma <- function
(
    model
,   expectations
,   varY
,   Y
)
{
    sigma <- model@sigma
    deltaL1 <- 1
    maxIters <- 10
    counter2 <- 0
    Step <- 1
    while (deltaL1 > 1e-5 & counter2 <= 10 & Step > 1e-5)
    {
        deltaL <- -1
        counter2 <- counter2 + 1
        oldL <- pumaPCASigmaObjective(sigma, model, expectations, varY, Y)
        Step <- newtonStep(sigma, model, expectations, varY, Y)
        counter <- 0
        while (deltaL < 0)
        {
            counter <- counter + 1
            L <- pumaPCASigmaObjective(sigma-Step, model, expectations, varY, Y)
            deltaL <- oldL - L
            Step <- Step/2
        }
        deltaL1 <- deltaL
        sigma <- sigma - 2*Step
    }
#   Step;
    as.vector(sigma)
}

newtonStep <- function
(
    sigma
,   model
,   expectations
,   varY
,   Y
)
{
    eps <- 0 ## ???
    if (sigma < eps)
    {
        sigma <- eps
    }
    eta <- 0.1

    dataDim <- dim(Y)[2]
    numData <- dim(Y)[1]

    Sigma <- 0
    curvature <- 0

    for (i in 1:numData)
    {
        Fun <- diag(1/(sigma^2+varY[i,]))
        F2 <- Fun*Fun
        F3 <- F2*Fun
        ## computes the gradient with respect to sigma
        Sigma <- Sigma -
            2 * ( (Y[i,] - model@mu) %*% F2 %*% t(Y[i,] - model@mu) ) * sigma +
            2 * sum(diag(Fun)) * sigma +
            ( 4 * expectations@x[i,] %*% t(model@W) %*% F2 %*% t(Y[i,] - model@mu) ) * sigma -
            2 * sum(diag(t(model@W) %*% F2 %*% model@W %*% expectations@xxT[,,i])) * sigma
        ## computes the curvature with respect to sigma
        curvature <- curvature +
            8 * ( (Y[i,] - model@mu) %*% F3 %*% t(Y[i,] - model@mu) ) * sigma -
            4 * sum(diag(F2)) * sigma +
            ( -16 * expectations@x[i,] %*% t(model@W) %*% F3 %*% t(Y[i,] - model@mu) ) * sigma +
            8 * sum(diag(t(model@W) %*% F3 %*% model@W %*% expectations@xxT[,,i])) * sigma
    }
    l <- log(sigma)
    Grad <- 0.5 * Sigma
    Curv <- ( 0.5 * curvature * sigma + Grad/sigma) * sigma * sigma / 4
    Step.l <- Grad*exp(l)/(Curv*exp(2*l)+Grad*exp(l))

    Step <- exp(l-Step.l)
}

  #.First.lib <- function(lib, pkgname, where) {
#    ## load the compiled code
#    library.dynam("puma", pkgname, lib)
#  
#    if(.Platform$OS.type == "windows" && require(Biobase) && require(methods) && interactive()
#          && .Platform$GUI ==  "Rgui"){
#          addVigs2WinMenu("puma")
#     }
#  
#    cat(paste("\nWelcome to puma version", packageDescription('puma')$Version,"\n\n"))
#  
#    cat("puma is free for research purposes only. For more details, type\n")
#    cat("license.puma(). Type citation('puma') for details on how to cite\n")
#    cat("puma in publications.\n")
#  }

license.puma <- function(){

  license.file <- system.file("COPYING", package="puma")

  rl <- readLines(license.file)
  rl <- rl[-c(1,length(rl))]
  rl <- gsub("*", "", rl, fixed=TRUE)
  for (i in 1:length(rl)) cat(paste(rl[i],"\n"))

}

 igmoExon<-function(
     cel.path
     ,SampleNameTable
     ,exontype = c("Human", "Mouse", "Rat")
     ,background=FALSE
     ,gsnorm=c("median", "none", "mean", "meanlog")
     ,savepar=FALSE
     ,eps=1.0e-6
     ,addConstant = 0
     ,condition=c("Yes","No")
     ,cl=NULL
     ,BatchFold=10
)
{     
    if(!is.null(cl))
	     clusterEvalQ(cl, library(puma))
    library(pumadata);

   if(missing(cel.path)){
	stop("'cel.path' is missing! Please give the path to your CEL files!")
     }
   
   if(missing(SampleNameTable)){
	stop("'SampleNameTable' is missing! Please give the path of the your sample table!")
     }


   setwd(cel.path);
   desc <- read.table(SampleNameTable,header=TRUE,sep="\t",stringsAsFactors=FALSE)

   celnames<-desc[,1];

   condition_all<-desc[,2];

   object_condition_names<-c();

  

    expr_g_all<-c()
     se_g_all<-c()
     prc5_g_all<-c()
     prc25_g_all<-c()
     prc50_g_all<-c()
     prc75_g_all<-c()
     prc95_g_all<-c()


     expr_t_all<-c()
     se_t_all<-c()
     prc5_t_all<-c()
     prc25_t_all<-c()
     prc50_t_all<-c()
     prc75_t_all<-c()
     prc95_t_all<-c()
  
    
for(i in c(1:max(condition_all))){   

   

      celname_condition=celnames[which(condition_all==i)]
  
   
      object_condition<-read.celfiles(celname_condition);

    if(condition[1]=="Yes"){
         object_condition_names<-c(object_condition_names,celname_condition); 
    }

    if(condition[1]=="Yes"&&i==max(condition_all)){
         object<-read.celfiles(object_condition_names);
    }
   if(condition[1]!="Yes"){
        object<-object_condition;
    }
   
    chipnum<-length(sampleNames(object_condition));
    chipnum_all<-length(celnames);
        
              Human_transcript_NO <- NULL
            Human_transcript_name <-    NULL  
              Human_probes_transcripts <- NULL
             Human_Location <-NULL
            rm(Human_transcript_NO);
            rm(Human_probes_transcripts);
            rm(Human_transcript_name);
           rm(Human_Location);

              Mouse_transcript_NO <- NULL
            Mouse_transcript_name <-    NULL  
              Mouse_probes_transcripts <- NULL
             Mouse_Location <-NULL
            rm(Mouse_transcript_NO);
            rm(Mouse_probes_transcripts);
            rm(Mouse_transcript_name);
           rm(Mouse_Location);

        Rat_transcript_NO <- NULL
            Rat_transcript_name <-    NULL  
              Rat_probes_transcripts <- NULL
             Rat_Location <-NULL
            rm(Rat_transcript_NO);
            rm(Rat_probes_transcripts);
            rm(Rat_transcript_name);
            rm(Rat_Location);

###load corresponding between gene and transcirpt and probes and alpha num of every gene
    
    if(exontype[1]=="Human")                     
       {   
            cat('Exon type is Human');      

            data(Human_transcript_NO); 
            Gene_T_NO =Human_transcript_NO ;
               
            data(Human_probes_transcripts);
            Probes_A_NUM = Human_probes_transcripts;
       
            data(Human_transcript_name)
            transcript_name <- Human_transcript_name;          
           
            data(Human_Location);
            location=Human_Location;
            
         
       }else if(exontype[1]=="Mouse")
         {  
           cat('Exon type is Mouse');      

            data(Mouse_transcript_NO); 
            Gene_T_NO =Mouse_transcript_NO ;

            data(Mouse_probes_transcripts);
            Probes_A_NUM = Mouse_probes_transcripts;

            data(Mouse_transcript_name)
            transcript_name <- Mouse_transcript_name;
            
            data(Mouse_Location);
            location=Mouse_Location;
              

        } else if(exontype[1]=="Rat")
        {
            cat('Exon type is Rat');      

            data(Rat_transcript_NO); 
            Gene_T_NO =Rat_transcript_NO ;
               
            data(Rat_probes_transcripts);
            Probes_A_NUM = Rat_probes_transcripts;
         
            data(Rat_transcript_name)
            transcript_name <- Rat_transcript_name; 

            data(Rat_Location) 
            location=Rat_Location

       }
   

    cat('\n');
 ###find pm of every gene######




    #All_index <- xy2indices(Gene_T_NO[,1],Gene_T_NO[,2],abatch=object_condition);    ###pos_x and pos_y to indices
    All_index <-Gene_T_NO[,2]*2560+Gene_T_NO[,1]+1
    Gene_T_INdex = cbind( Gene_T_NO[,3],All_index);  ###table of gene transcript index   

   
    unique_index  <- unique(All_index);
    
   if(background == TRUE)
   {
    for (i in c(1:chipnum)){
     
      m<-min(oligo::pm(object_condition,target='probeset')[,i])
      oligo::pm(object_condition,target='probeset')[,i]<-oligo::pm(object_condition,target='probeset')[,i]-m+1
      
    }
  }

    pm_g <- oligo::pm(object_condition,target='probeset');                           ##pm of cel 
   

    Length_unique_index <- length(unique_index);
      
   if(chipnum==1)
   {
       pm <- pm_g[location]         ##nofind pm use 1 to substitute for one chips
       for (j in c(1:Length_unique_index))
       {
           if(is.na(pm[j]))
             pm[j] <- 1;
       }
   }else
   {  
       pm <- pm_g[location,]         ##nofind pm use 1 to substitute for multi chips
       for (j in c(1:Length_unique_index))
       {
           if(is.na(pm[j,2]))
           {            
             pm[j,] <- 1;
            }
       }

   }

  
  
   rm(location)
   rm(Gene_T_NO)

   pm <- cbind(unique_index,pm);  ##Table of PM
   rm(unique_index)

   total_probes_everygene <- Probes_A_NUM[,1];    ##total num of probes for everygene
   total_isoform<-dim(Human_transcript_name)[1];
   rm(pm_g);
  

   
   st <- 0;
   ed <- 0;

   Total_genes <- dim(Probes_A_NUM)[1];  ##total num of genes
   unique_probes_everygene <- seq(1,Total_genes,by=1);  

   for(i in c(1:Total_genes ))
   { 
      ed <- st + total_probes_everygene[i];
      st <- st + 1;
     
      unique_probes_everygene[i] <- length(unique(All_index[st:ed]));
     
      st<-ed;
   }

  alpha_num_everygene <- Probes_A_NUM[,2];  ###alpha num of everygene

  rm(All_index)

  gc();

  ####optimise#####
 prctiles <- 0.01*c(5, 25, 50, 75, 95);
  len_pc<-length(prctiles);
   pm_index <- c();
   gt_index <- c();
   pmst=0;
   gtst=0;
    for(i in c(1:Total_genes ))
   { 
      pm_index[i] <- pmst;
      pmst <- pmst + unique_probes_everygene[i];
      
      gt_index[i] <- gtst;
      
      gtst <- gtst+ total_probes_everygene[i];
      
   }
   pm_index[Total_genes+1]<-pmst
   gt_index[Total_genes+1]<-gtst
   
   expectedCompletionTime <-	system.time(
								res <-
  	      							.Call(
  	  								"gme_c"
         								, pm
         								, Gene_T_INdex
         								, unique_probes_everygene
         								, total_probes_everygene
         								, alpha_num_everygene
         								, 10                        
                        , prctiles
  	                    , len_pc
         								, savepar
         								, eps
  	 								)
							)[3];
   if(is.null(cl))
   {
      expectedCompletionTime <- expectedCompletionTime*Total_genes/10;
   }else
   {
      expectedCompletionTime <- expectedCompletionTime*Total_genes/10/length(cl);
   }
   if (expectedCompletionTime < 120){
		expectedTimeString <- paste(round(expectedCompletionTime, 0), "seconds")
	}else if (expectedCompletionTime < 7200){
		expectedTimeString <- paste(round(expectedCompletionTime/60, 0), "minutes")
	}else if (expectedCompletionTime < 172800){
		expectedTimeString <- paste(round(expectedCompletionTime/3600, 0), "hours")
	}else
	     {	expectedTimeString <- paste(round(expectedCompletionTime/172800, 0), "days")
             }	
    cat(paste("optimise expected completion time is", expectedTimeString,"\n"))


   if(is.null(cl))
   {
        ####optimise#####
        res <-
  	      .Call(
  	  	"gme_c"
         	, pm
         	, Gene_T_INdex
         	, unique_probes_everygene
         	, total_probes_everygene
         	, alpha_num_everygene
         	, Total_genes
                , prctiles
  	       , len_pc
         	, savepar
         	, eps
  	 	)
   }else
   {
           cl_genes_num<-matrix(0,1,ncol=BatchFold*length(cl))
          cl_genes_num_temp = trunc(Total_genes/(BatchFold*length(cl)));
   
  
     for (j in c(1:(BatchFold*length(cl)-1))){
          cl_genes_num[1,j]<-cl_genes_num_temp
      }
     cl_genes_num[1,BatchFold*length(cl)]<-Total_genes-cl_genes_num_temp*(BatchFold*length(cl)-1)


		paramsList<-list();   
		if(length(cl)>1)
		{
			for (i in 1:(BatchFold*length(cl)))
			{
                                
				paramsList[[i]] <- list(
				 pm[(pm_index[sum(cl_genes_num[1,0:(i-1)])+1]+1):pm_index[sum(cl_genes_num[1,0:i])+1],]			###pm
				, Gene_T_INdex[(gt_index[sum(cl_genes_num[1,0:(i-1)])+1]+1):gt_index[sum(cl_genes_num[1,0:i])+1],]	###Gene_T_INdex
				, unique_probes_everygene[(sum(cl_genes_num[1,0:(i-1)])+1):(sum(cl_genes_num[1,0:i]))]    		###unique_probes_everygene
         			, total_probes_everygene[(sum(cl_genes_num[1,0:(i-1)])+1):(sum(cl_genes_num[1,0:i]))]      		###total_probes_everygene
         			, alpha_num_everygene[(sum(cl_genes_num[1,0:(i-1)])+1):(sum(cl_genes_num[1,0:i]))]        		###alpha_num_everygene
			  	, cl_genes_num[1,i]											###total_genes
				);
				
			}
		}
		
		cat('start parallel compute...');	   
            temp_res <- clusterApplyLB(
						 cl
						,paramsList
						,function(
                                                  params        
                                                                , prctiles
  	                                                        , len_pc
								, savepar
         							, eps
								) 
							{
     							 	res <- .Call(
  	  							"gme_c"
         							, params[[1]]                 ###pm
         							, params[[2]]               	###Gene_T_INdex
         							, params[[3]]   			###unique_probes_everygene
         							, params[[4]]     		###total_probes_everygene
         							, params[[5]]       		###alpha_num_everygene
          							, params[[6]] 
                                                                , prctiles
  	                                                        , len_pc              	
          							, savepar                    	###savepar
          							, eps                        	###eps
     	 							)
							}
                                                , prctiles
  	                                        , len_pc
						, savepar
         					, eps
						)
            

            cl_isoform_num<-c()
            for(i in 1:(BatchFold*length(cl))){

               cl_isoform_num[i]<-(length(temp_res[[i]][,1])-cl_genes_num[1,i]*7)/7

            }

            expr_g<-c();
            se_g<-c();
            expr_t<-c();
            se_t<-c();
            prc5_g<-c();
            prc25_g<-c();
            prc50_g<-c();
            prc75_g<-c();
            prc95_g<-c();
            prc5_t<-c();
            prc25_t<-c();
            prc50_t<-c();
            prc75_t<-c();
            prc95_t<-c();
            res_t<-c();
		for(i in 1:(BatchFold*length(cl)))
  		{
			expr_g <- rbind(expr_g,temp_res[[i]][1:cl_genes_num[1,i],])
                        se_g <- rbind(se_g,temp_res[[i]][(cl_genes_num[1,i]+1):(2*cl_genes_num[1,i]),])
                       prc5_g <- rbind(prc5_g,temp_res[[i]][(2*cl_genes_num[1,i]+1):(3*cl_genes_num[1,i]),])
                        prc25_g <- rbind(prc25_g,temp_res[[i]][(3*cl_genes_num[1,i]+1):(4*cl_genes_num[1,i]),])
                        prc50_g <- rbind(prc50_g,temp_res[[i]][(4*cl_genes_num[1,i]+1):(5*cl_genes_num[1,i]),])
                        prc75_g <- rbind(prc75_g,temp_res[[i]][(5*cl_genes_num[1,i]+1):(6*cl_genes_num[1,i]),])
                        prc95_g <- rbind(prc95_g,temp_res[[i]][(6*cl_genes_num[1,i]+1):(7*cl_genes_num[1,i]),])

                        
                         expr_t<-rbind(expr_t,temp_res[[i]][(cl_genes_num[1,i]*7+1):(cl_genes_num[1,i]*7+cl_isoform_num[i]),])
                        se_t<-rbind(se_t,temp_res[[i]][(1+ cl_genes_num[1,i]*7+cl_isoform_num[i]):(cl_genes_num[1,i]*7+2*cl_isoform_num[i]),])
                        prc5_t<-rbind(prc5_t,temp_res[[i]][(1+ cl_genes_num[1,i]*7+2*cl_isoform_num[i]):(cl_genes_num[1,i]*7+3*cl_isoform_num[i]),])
                        prc25_t<-rbind(prc25_t,temp_res[[i]][(1+ cl_genes_num[1,i]*7+3*cl_isoform_num[i]):(cl_genes_num[1,i]*7+4*cl_isoform_num[i]),])
                        prc50_t<-rbind(prc50_t,temp_res[[i]][(1+ cl_genes_num[1,i]*7+4*cl_isoform_num[i]):(cl_genes_num[1,i]*7+5*cl_isoform_num[i]),])
                        prc75_t<-rbind(prc75_t,temp_res[[i]][(1+ cl_genes_num[1,i]*7+5*cl_isoform_num[i]):(cl_genes_num[1,i]*7+6*cl_isoform_num[i]),])
                        prc95_t<-rbind(prc95_t,temp_res[[i]][(1+ cl_genes_num[1,i]*7+6*cl_isoform_num[i]):(cl_genes_num[1,i]*7+7*cl_isoform_num[i]),])
    
 		}
     
  }




  if(is.null(cl)){

      res_g<-res[1:(Total_genes*7),]
     res_t<-res[(Total_genes*7+1):((Total_genes+total_isoform)*7),]

     expr_g <- matrix(res_g[c(1:Total_genes),],Total_genes,chipnum);
     se_g <- matrix(res_g[c((Total_genes+1):(2*Total_genes)),],Total_genes,chipnum);
     prc5_g <- matrix(res_g[c((2*Total_genes+1):(3*Total_genes)),],Total_genes,chipnum)
     prc25_g <- matrix(res_g[c((3*Total_genes+1):(4*Total_genes)),],Total_genes,chipnum)
     prc50_g <- matrix(res_g[c((4*Total_genes+1):(5*Total_genes)),],Total_genes,chipnum)
     prc75_g <- matrix(res_g[c((5*Total_genes+1):(6*Total_genes)),],Total_genes,chipnum)
     prc95_g <- matrix(res_g[c((6*Total_genes+1):(7*Total_genes)),],Total_genes,chipnum)


     expr_t <- matrix(res_t[c(1:total_isoform),],total_isoform,chipnum);
     se_t <- matrix(res_t[c((total_isoform+1):(2*total_isoform)),],total_isoform,chipnum);
     prc5_t <- matrix(res_t[c((2*total_isoform+1):(3*total_isoform)),],total_isoform,chipnum)
     prc25_t <- matrix(res_t[c((3*total_isoform+1):(4*total_isoform)),],total_isoform,chipnum)
     prc50_t <- matrix(res_t[c((4*total_isoform+1):(5*total_isoform)),],total_isoform,chipnum)
     prc75_t <- matrix(res_t[c((5*total_isoform+1):(6*total_isoform)),],total_isoform,chipnum)
     prc95_t <- matrix(res_t[c((6*total_isoform+1):(7*total_isoform)),],total_isoform,chipnum)

    }
    

     expr_g_all<-cbind(expr_g_all,expr_g)
     se_g_all<-cbind(se_g_all,se_g)
     prc5_g_all<-cbind(prc5_g_all,prc5_g)
     prc25_g_all<-cbind(prc25_g_all,prc25_g)
     prc50_g_all<-cbind(prc50_g_all,prc50_g)
     prc75_g_all<-cbind(prc75_g_all,prc75_g)
     prc95_g_all<-cbind(prc95_g_all,prc95_g)

     expr_t_all<-cbind(expr_t_all,expr_t)
     se_t_all<-cbind(se_t_all,se_t)
     prc5_t_all<-cbind(prc5_t_all,prc5_t)
     prc25_t_all<-cbind(prc25_t_all,prc25_t)
     prc50_t_all<-cbind(prc50_t_all,prc50_t)
     prc75_t_all<-cbind(prc75_t_all,prc75_t)
     prc95_t_all<-cbind(prc95_t_all,prc95_t)

 }## done 

  if(!is.null(cl))
  {
	stopCluster(cl);
  }


 

 rm(pm);
 rm(Gene_T_INdex);
 

 rm(res); 
  gc();
   ###save result#####

   ###gene_names <- rownames(Probes_A_NUM);


   cat("\n")
   cat("Gene and transcirpt expression values are returned.");

   cat('Done.')
 

 
 
  if (gsnorm[1]=="mean")
   {
      expr_g_all <- as.data.frame(2^expr_g_all)
     
      chipm <- apply(expr_g_all,2,mean)
      chipm <- chipm/chipm[1]

      expr_g_all <- as.matrix(log2(expr_g_all))
      for (i in 1:chipnum)
      {
          expr_g_all[,i] <- expr_g_all[,i]-log2(chipm[i])
          se_g_all[,i]<- se_g[,i]/chipm[i]
          prc5_g_all[,i] <- prc5_g_all[,i]-log2(chipm[i])
          prc25_g_all[,i] <- prc25_g_all[,i]-log2(chipm[i])
          prc50_g_all[,i] <- prc50_g_all[,i]-log2(chipm[i])
          prc75_g_all[,i] <- prc75_g_all[,i]-log2(chipm[i])
          prc95_g_all[,i] <- prc95_g_all[,i]-log2(chipm[i])
    }
  }else if (gsnorm[1]=="median")
    {
       expr_g_all <- as.data.frame(2^expr_g_all)
    
       chipm <- apply(expr_g_all,2,median)
       chipm <- chipm/chipm[1]

        expr_g_all <- as.matrix(log2(expr_g_all))
        for (i in 1:chipnum)
        {
          expr_g_all[,i] <- expr_g_all[,i]-log2(chipm[i])
          se_g_all[,i]<- se_g[,i]/chipm[i]
          prc5_g_all[,i] <- prc5_g_all[,i]-log2(chipm[i])
          prc25_g_all[,i] <- prc25_g_all[,i]-log2(chipm[i])
          prc50_g_all[,i] <- prc50_g_all[,i]-log2(chipm[i])
          prc75_g_all[,i] <- prc75_g_all[,i]-log2(chipm[i])
          prc95_g_all[,i] <- prc95_g_all[,i]-log2(chipm[i])
        }
  }else if (gsnorm[1]=="meanlog")
  {
       chipm <- apply(expr_g_all,2,mean)
        chipm <- chipm-chipm[1]

       for (i in 1:chipnum)
       {
         expr_g_all[,i] <- expr_g_all[,i]-chipm[i]
         se_g_all[,i]<- se_g[,i]/chipm[i]
         prc5_g_all[,i] <- prc5_g_all[,i]-chipm[i]
         prc25_g_all[,i] <- prc25_g_all[,i]-chipm[i]
         prc50_g_all[,i] <- prc50_g_all[,i]-chipm[i]
         prc75_g_all[,i] <- prc75_g_all[,i]-chipm[i]
         prc95_g_all[,i] <- prc95_g_all[,i]-chipm[i]
      }
  }





  if (gsnorm[1]=="mean")
  {
    expr_t_all <- as.data.frame(2^expr_t_all)
    chipm <- apply(expr_t_all,2,mean)
    chipm <- chipm/chipm[1]

    expr_t_all <- as.matrix(log2(expr_t_all))
    for (i in 1:chipnum)
    {
      expr_t_all[,i] <- expr_t_all[,i]-log2(chipm[i])
      se_t_all[,i]<- se_t[,i]/chipm[i]
      prc5_t_all[,i] <- prc5_t_all[,i]-log2(chipm[i])
      prc25_t_all[,i] <- prc25_t_all[,i]-log2(chipm[i])
      prc50_t_all[,i] <- prc50_t_all[,i]-log2(chipm[i])
      prc75_t_all[,i] <- prc75_t_all[,i]-log2(chipm[i])
      prc95_t_all[,i] <- prc95_t_all[,i]-log2(chipm[i])
    }
  }
 
 else if (gsnorm[1]=="median")
  {
    expr_t_all <- as.data.frame(2^expr_t_all)
    
    chipm <- apply(expr_t_all,2,median)
    chipm <- chipm/chipm[1]

    expr_t_all <- as.matrix(log2(expr_t_all))
    for (i in 1:chipnum)
    {
      expr_t_all[,i] <- expr_t_all[,i]-log2(chipm[i])
      se_t_all[,i]<- se_t[,i]/chipm[i]
      prc5_t_all[,i] <- prc5_t_all[,i]-log2(chipm[i])
      prc25_t_all[,i] <- prc25_t_all[,i]-log2(chipm[i])
      prc50_t_all[,i] <- prc50_t_all[,i]-log2(chipm[i])
      prc75_t_all[,i] <- prc75_t_all[,i]-log2(chipm[i])
      prc95_t_all[,i] <- prc95_t_all[,i]-log2(chipm[i])
    }
  }
  else if (gsnorm[1]=="meanlog")
  {
    chipm <- apply(expr_t_all,2,mean)
    chipm <- chipm-chipm[1]

    for (i in 1:chipnum)
    {
      expr_t_all[,i] <- expr_t_all[,i]-chipm[i]
      se_t_all[,i]<- se_t[,i]/chipm[i]
      prc5_t_all[,i] <- prc5_t_all[,i]-chipm[i]
      prc25_t_all[,i] <- prc25_t_all[,i]-chipm[i]
      prc50_t_all[,i] <- prc50_t_all[,i]-chipm[i]
      prc75_t_all[,i] <- prc75_t_all[,i]-chipm[i]
      prc95_t_all[,i] <- prc95_t_all[,i]-chipm[i]
    }
  }

 
  rownames(expr_t_all) <- transcript_name[,1];

  colnames(expr_t_all) <- sampleNames(object)
  rownames(se_t_all) <- transcript_name[,1];
  colnames(se_t_all) <- sampleNames(object)
 
  rownames(prc5_t_all) <- transcript_name[,1];
  colnames(prc5_t_all) <- sampleNames(object)
  rownames(prc25_t_all) <- transcript_name[,1];
  colnames(prc25_t_all) <- sampleNames(object)
 
  rownames(prc50_t_all) <- transcript_name[,1];
  colnames(prc50_t_all) <- sampleNames(object);

  rownames(prc75_t_all) <- transcript_name[,1];
  colnames(prc75_t_all) <- sampleNames(object)
 
  rownames(prc95_t_all) <- transcript_name[,1];
  colnames(prc95_t_all) <- sampleNames(object)
  
 rm(transcript_name);
 gc();  


  phenodata <- phenoData(object)
  annotation <- annotation(object)
  description <- description(object)
  return_exprReslt_t <- new(
		"exprReslt"
	,	exprs=log2((2^expr_t_all)+addConstant)
	,	se.exprs=se_t_all
  	,	phenoData = new(
			"AnnotatedDataFrame"
		,	data=pData(object)
		,	varMetadata=data.frame(labelDescription=varLabels(phenoData(object)))
		)
	# , notes=notes
	)
          prcfive(return_exprReslt_t) <- prc5_t_all
	prctwfive(return_exprReslt_t) <- prc25_t_all
	prcfifty(return_exprReslt_t) <- prc50_t_all
	prcsevfive(return_exprReslt_t) <- prc75_t_all
	prcninfive(return_exprReslt_t) <- prc95_t_all
  
  annotation(return_exprReslt_t) <- annotation(object)
  description(return_exprReslt_t) <- description(object)
  notes(return_exprReslt_t) <- notes(object)
 



  rownames(expr_g_all) <-rownames(Probes_A_NUM);
  colnames(expr_g_all) <- sampleNames(object)
  rownames(se_g_all) <- rownames(Probes_A_NUM);
  colnames(se_g_all) <- sampleNames(object)
  
  rownames(prc5_g_all) <- rownames(Probes_A_NUM);
  colnames(prc5_g_all) <- sampleNames(object)
  rownames(prc25_g_all) <- rownames(Probes_A_NUM);
  colnames(prc25_g_all) <- sampleNames(object)
  rownames(prc50_g_all) <- rownames(Probes_A_NUM);
  colnames(prc50_g_all) <- sampleNames(object)
  rownames(prc75_g_all) <- rownames(Probes_A_NUM);
  colnames(prc75_g_all) <- sampleNames(object)
  rownames(prc95_g_all) <- rownames(Probes_A_NUM);
  colnames(prc95_g_all) <- sampleNames(object)




  phenodata <- phenoData(object)
  annotation <- annotation(object)
  description <- description(object)

  return_exprReslt_g <- new(
		"exprReslt"
	,	exprs=log2((2^expr_g_all)+addConstant)
	,	se.exprs=se_g_all
  	,	phenoData = new(
			"AnnotatedDataFrame"
		,	data=pData(object)
		,	varMetadata=data.frame(labelDescription=varLabels(phenoData(object)))
		)
	# , notes=notes
	)
          prcfive(return_exprReslt_g) <- prc5_g_all
         	prctwfive(return_exprReslt_g) <- prc25_g_all
	prcfifty(return_exprReslt_g) <- prc50_g_all
	prcsevfive(return_exprReslt_g) <- prc75_g_all
	prcninfive(return_exprReslt_g) <- prc95_g_all
  

  annotation(return_exprReslt_g) <- annotation(object)
  description(return_exprReslt_g) <- description(object)
  notes(return_exprReslt_g) <- notes(object)

  rm(object);
  gc();




  return_exprReslt<-list(gene=return_exprReslt_g,transcript=return_exprReslt_t)
  
  return (return_exprReslt)



}

numFP <- function (
	scores
,	truthValues
,	TPRate = 0.5
)
{
	numberOfTPToCount <- length(which(truthValues)) * TPRate
	scoresIndex <- sort(scores,decreasing=TRUE,index.return=TRUE)$ix
	numberOfFP <- 0
	numberOfTP <- 0
	for(i in 1:length(scoresIndex))
	{
		if(truthValues[scoresIndex[i]]) numberOfTP <- numberOfTP+1 else numberOfFP <- numberOfFP+1
		if(numberOfTP >= numberOfTPToCount) return(numberOfFP)
	}
}

numTP <- function (
	scores
,	truthValues
,	FPRate = 0.5
)
{
	numberOfFPToCount <- length(which(!truthValues)) * FPRate
	scoresIndex <- sort(scores,decreasing=TRUE,index.return=TRUE)$ix
	numberOfFP <- 0
	numberOfTP <- 0
	for(i in 1:length(scoresIndex))
	{
		if(truthValues[scoresIndex[i]]) numberOfTP <- numberOfTP+1 else numberOfFP <- numberOfFP+1
		if(numberOfFP > numberOfFPToCount) return(numberOfTP)
	}
}

mmgmos <- function(
	object
,	background=FALSE
,	replaceZeroIntensities=TRUE
,	gsnorm=c("median", "none", "mean", "meanlog")
,	savepar=FALSE
,	eps=1.0e-6	
,	addConstant = 0
)
{

if (class(object)[1]=='ExpressionFeatureSet'){           # if the user use the oligo package loading the cel files
   
   
          conds <- length(sampleNames(object));
	genes <-length(unique(oligo:::probeNames(object)));
	phis <- c(0,0,0);

          pm_g<-oligo:::pm(object);
          mm_g<-oligo:::mm(object);
          probe<-(oligo:::probeNames(object));   

          index<-order(probe);
          probe_sort<-probe[index];
          probe<-probe_sort;
          pm_g<-pm_g[index,];
          mm_g<-mm_g[index,];


       if(conds==1){
          pm_g<-as.matrix(pm_g);
          mm_g<-as.matrix(mm_g);
       }

           
      if (background == TRUE)
      {
         for (i in c(1:conds)){
             m<-min(c(min(pm_g[,i]),min(mm_g[,i])))
             pm_g[,i]<-pm_g[,i]-m+1
             mm_g[,i]<-mm_g[,i]-m+1
         }
      }

      if (replaceZeroIntensities)
     {
         pm_g[which(pm_g==0)] <- 1
         mm_g[which(mm_g==0)] <- 1
     }

      prctiles <- 0.01*c(5, 25, 50, 75, 95);

  res <-
  	.Call(
  	  "mmgmos_c"
  	 , pm_g
  	 , mm_g
  	 , genes
  	 , probe
  	 , phis
  	 , prctiles
  	 , length(prctiles)
  	 , savepar
  	 , eps
  	 , PACKAGE="puma"
  	 )

}else if (class(object)[1]=='AffyBatch')             ##if the user use the affy package loading the cel files 
{
        probes <- length(affy:::probeNames(object))
	conds <- length(object)
	genes <- length(featureNames(object))
        orig.phis = FALSE
	cdf <- cleancdfname(cdfName(object))
	phiname <- paste(substr(cdf,1,nchar(cdf)-3), "phis", sep="")
	if(phiname %in% do.call("data", list(package="puma"))$results[, 3])
	{
	    do.call("data", list(phiname))
	    phis <- eval(parse(text=phiname))
	}
	else
	{
		if(orig.phis)
		{
			do.call("data", list("hgu95aphis"))
			phis <- eval(parse(text="hgu95aphis"))
		}
		else
			phis <- c(0,0,0)
        }
        prctiles <- 0.01*c(5, 25, 50, 75, 95);
  
       if (background == TRUE)
       {
          for (i in c(1:conds)){
             m<-min(c(min(affy:::pm(object)[,i]),min(affy:::mm(object)[,i])))
             affy:::pm(object)[,i]<-affy:::pm(object)[,i]-m+1
             affy:::mm(object)[,i]<-affy:::mm(object)[,i]-m+1
           }
       }

     if (replaceZeroIntensities)
     {
        affy:::pm(object)[which(affy:::pm(object)==0)] <- 1
        affy:::mm(object)[which(affy:::mm(object)==0)] <- 1
     }


    res <-
  	.Call(
  	  "mmgmos_c"
  	 , affy:::pm(object)
  	 , affy:::mm(object)
  	 , genes
  	 , affy:::probeNames(object)
  	 , phis
  	 , prctiles
  	 , length(prctiles)
  	 , savepar
  	 , eps
  	 , PACKAGE="puma"
  	 )

}        


  expr <- matrix(res[c(1:genes),],genes,conds)
  se <- matrix(res[c((genes+1):(2*genes)),],genes,conds)
  prc5 <- matrix(res[c((2*genes+1):(3*genes)),],genes,conds)
  prc25 <- matrix(res[c((3*genes+1):(4*genes)),],genes,conds)
  prc50 <- matrix(res[c((4*genes+1):(5*genes)),],genes,conds)
  prc75 <- matrix(res[c((5*genes+1):(6*genes)),],genes,conds)
  prc95 <- matrix(res[c((6*genes+1):(7*genes)),],genes,conds)

  rm(res)

  if (gsnorm[1]=="mean")
  {
    expr <- as.data.frame(2^expr)
    
    chipm <- apply(expr,2,mean)
    chipm <- chipm/chipm[1]

    expr <- as.matrix(log2(expr))
    for (i in 1:conds)
    {
      expr[,i] <- expr[,i]-log2(chipm[i])
      prc5[,i] <- prc5[,i]-log2(chipm[i])
      prc25[,i] <- prc25[,i]-log2(chipm[i])
      prc50[,i] <- prc50[,i]-log2(chipm[i])
      prc75[,i] <- prc75[,i]-log2(chipm[i])
      prc95[,i] <- prc95[,i]-log2(chipm[i])
    }
  }
  else if (gsnorm[1]=="median")
  {
    expr <- as.data.frame(2^expr)
    
    chipm <- apply(expr,2,median)
    chipm <- chipm/chipm[1]

    expr <- as.matrix(log2(expr))
    for (i in 1:conds)
    {
      expr[,i] <- expr[,i]-log2(chipm[i])
      prc5[,i] <- prc5[,i]-log2(chipm[i])
      prc25[,i] <- prc25[,i]-log2(chipm[i])
      prc50[,i] <- prc50[,i]-log2(chipm[i])
      prc75[,i] <- prc75[,i]-log2(chipm[i])
      prc95[,i] <- prc95[,i]-log2(chipm[i])
    }
  }
  else if (gsnorm[1]=="meanlog")
  {
    chipm <- apply(expr,2,mean)
    chipm <- chipm-chipm[1]

    for (i in 1:conds)
    {
      expr[,i] <- expr[,i]-chipm[i]
      prc5[,i] <- prc5[,i]-chipm[i]
      prc25[,i] <- prc25[,i]-chipm[i]
      prc50[,i] <- prc50[,i]-chipm[i]
      prc75[,i] <- prc75[,i]-chipm[i]
      prc95[,i] <- prc95[,i]-chipm[i]
    }
  }

if (class(object)[1]=='ExpressionFeatureSet'){


  probe_names<-unique(probe);
  rownames(expr) <-probe_names
  colnames(expr) <- sampleNames(object)
  rownames(se) <-probe_names
  colnames(se) <- sampleNames(object)
  rownames(prc5) <-probe_names
  colnames(prc5) <- sampleNames(object)
  rownames(prc25) <-probe_names
  colnames(prc25) <- sampleNames(object)
  rownames(prc50) <-probe_names
  colnames(prc50) <- sampleNames(object)
  rownames(prc75) <-probe_names
  colnames(prc75) <- sampleNames(object)
  rownames(prc95) <-probe_names
  colnames(prc95) <- sampleNames(object)
}else if (class(object)[1]=='AffyBatch')
{
    rownames(expr) <- featureNames(object)
  colnames(expr) <- sampleNames(object)
  rownames(se) <- featureNames(object)
  colnames(se) <- sampleNames(object)
  rownames(prc5) <- featureNames(object)
  colnames(prc5) <- sampleNames(object)
  rownames(prc25) <- featureNames(object)
  colnames(prc25) <- sampleNames(object)
  rownames(prc50) <- featureNames(object)
  colnames(prc50) <- sampleNames(object)
  rownames(prc75) <- featureNames(object)
  colnames(prc75) <- sampleNames(object)
  rownames(prc95) <- featureNames(object)
  colnames(prc95) <- sampleNames(object)
}
  phenodata <- phenoData(object)
  annotation <- annotation(object)
  description <- description(object)
  # notes <- notes(object)

	return_exprReslt <- new(
		"exprReslt"
	,	exprs=log2((2^expr)+addConstant)
	,	se.exprs=se
  	,	phenoData = new(
			"AnnotatedDataFrame"
		,	data=pData(object)
		,	varMetadata=data.frame(labelDescription=varLabels(phenoData(object)))
		)
	# , notes=notes
	)
	prcfive(return_exprReslt) <- prc5
	prctwfive(return_exprReslt) <- prc25
	prcfifty(return_exprReslt) <- prc50
	prcsevfive(return_exprReslt) <- prc75
	prcninfive(return_exprReslt) <- prc95
	# phenoData(return_exprReslt) <- phenoData(object)
	# pData(return_exprReslt) <- pData(object)
	annotation(return_exprReslt) <- annotation(object)
	description(return_exprReslt) <- description(object)
	notes(return_exprReslt) <- notes(object)
	return_exprReslt;
}

pumaCombImproved <- function (
	eset
,	design.matrix=NULL
,	numOfChunks=1000
,       maxOfIterations=200 
,	save_r=FALSE
,	cl=NULL
,	parallelCompute=FALSE
# ,	parallelCompute=if(
# 		"Rmpi" %in% installed.packages() & "snow" %in% installed.packages()
# 	)
# 	as.logical(length(grep("origin",system("lamnodes",TRUE,TRUE))))
# 	else FALSE
)
{
	if(!(is(eset, "ExpressionSet") || is(eset, "ExpressionSetIllumina")))
		stop("eset is not a valid ExpressionSet object!")
	if(is.null(design.matrix) && is.null(pData(eset)))
		stop("ExpressionSet contains no valid phenoData and no design.matrix
			given!")
	if(parallelCompute && is.null(cl))
	{
		# library(Rmpi)
		library(snow)
		cl <- getMPIcluster()
		if(is.null(cl))
			cl <- makeCluster(length(system("lamnodes",TRUE,TRUE))-1)
		# clusterEvalQ(cl, library(puma))
	}
	if(!is.null(cl))
		clusterEvalQ(cl, library(puma))	
	if(is.null(design.matrix))
		design.matrix <- createDesignMatrix(eset)
	# if(length(names(which(colSums(dm2)==1))) > 1)
	# 	warning("The following conditions have no replicates", names(which(colSums(dm2)==1)),". While it is possible to use PPLR without any biological replicates, this is not advised.")
	e <- exprs(eset)
	se <- assayDataElement(eset,"se.exprs")
	# se <- se.exprs(eset)
	numOfGenes <- dim(e)[1]
	if(numOfChunks > (numOfGenes/10))
		numOfChunks <- max(floor(numOfGenes/10),1)
	numPerChunk <- c(0, rep(floor(numOfGenes / numOfChunks),numOfChunks))
	numOfExtras <- numOfGenes - sum(numPerChunk)
	if(numOfExtras > 0)
		numPerChunk[2:(numOfExtras+1)] <- numPerChunk[2:(numOfExtras+1)] + 1
	eList <- list()
	seList <- list()
	rl <- list()
	rFirst <- list()
	paramsList <- list()
	for (i in 1:numOfChunks)
	{
		eList[[i]] <- e[(1 + sum(numPerChunk[1:i])):sum(numPerChunk[1:(i+1)]),]
		seList[[i]] <- se[(1 + sum(numPerChunk[1:i])):sum(numPerChunk[1:(i+1)]),]
#		seList[[i]] <- se[(1 + (numPerChunk[i] * (i-1))):min((numPerChunk[i+1] * i),numOfGenes),]
		paramsList[[i]] <- list(
			eList[[i]]
		,	seList[[i]]
		,	replicates=apply(design.matrix,1,function(x) which(x==1))
                ,       max_num=maxOfIterations
		)
	}

	if(is.null(cl))
	{
		expectedCompletionTime <-	system.time(
										rFirst <- list(
											hcomb(
												paramsList[[1]][[1]]
											,	paramsList[[1]][[2]]
											,	paramsList[[1]][[3]]
											,	paramsList[[1]][[4]]
											)
										)
									)[3] * numOfChunks
	}else
	{
		expectedCompletionTime <- system.time(
									rFirst <- clusterApplyLB(
										cl
									,	paramsList[1:length(cl)]
									,	function(paramsList) 
										{
											b <- hcomb(
												paramsList[[1]]
											,	paramsList[[2]]
											,	paramsList[[3]]
											,	paramsList[[4]]
											)
										}
									)
								)[3] * numOfChunks /length(cl)
	}
	if (expectedCompletionTime < 120)
		expectedTimeString <- paste(round(expectedCompletionTime, 0), "seconds")
	else if (expectedCompletionTime < 7200)
		expectedTimeString <- paste(round(expectedCompletionTime/60, 0), "minutes")
	else if (expectedCompletionTime < 172800)
		expectedTimeString <- paste(round(expectedCompletionTime/3600, 0), "hours")
	else
		expectedTimeString <- paste(round(expectedCompletionTime/172800, 0), "days")
	cat(paste("pumaComb expected completion time is", expectedTimeString,"\n"))
	cat(".......20%.......40%.......60%.......80%......100%\n")
	i <- 0
	chunksPerDot <- ceiling(numOfChunks / 50)
	if(is.null(cl) & numOfChunks > 1)
    	rl <- lapply(
    			paramsList[2:length(paramsList)]
    		,	function(paramsList) 
    			{
    				b <- hcomb(
						paramsList[[1]]
					,	paramsList[[2]]
					,	paramsList[[3]]
                                        ,	paramsList[[4]]
					)
					i <<- i + 1
					dotsPerChunk <- floor( (50/(numOfChunks-1))*i ) - floor( (50/(numOfChunks-1))*(i-1) )
					#if(i %% chunksPerDot == 0) for(d in 1:dotsPerChunk) cat(".")
					if(dotsPerChunk > 0) for(d in 1:dotsPerChunk) cat(".")
					return(b)
				}
			)
	if(is.null(cl) & numOfChunks == 1)
		cat("..................................................")
    if(!is.null(cl))
    {
    	if(numOfChunks > length(cl))
			rl <-	clusterApplyLBDots(
						cl
					,	paramsList[(length(cl)+1):length(paramsList)]
					,	function(paramsList) 
						{
							b <- hcomb(
								paramsList[[1]]
							,	paramsList[[2]]
							,	paramsList[[3]]
                                                        ,	paramsList[[4]]
							)
						}
					)
    	if(numOfChunks <= length(cl))
			cat("..................................................")
	}
	cat("\n")
	rl <- c(rFirst, rl)
	r <- rl[[1]]
	if(numOfChunks > 1)
		for (i in 2:numOfChunks)
			r <- rbind(r,rl[[i]])
	colnames(r) <- c(paste("M", colnames(design.matrix)), paste("Std", colnames(design.matrix)))
	if(save_r)
		save(r, file="r.rda")
	eset_r <- create_eset_r(eset, r, design.matrix)
	# colnames(exprs(eset_r)) <- paste("M", colnames(design.matrix), sep="_")
	# colnames(assayDataElement(eset_r,"se.exprs")) <- paste("Std", colnames(design.matrix), sep="_")
	# design.matrix.ordering <- replace(
	# 	which(unique(design.matrix)==1)%%(dim(design.matrix)[2])
	# ,	which(unique(design.matrix)==1)%%(dim(design.matrix)[2])==0
	# ,	dim(design.matrix)[2]
	# )
	# design.matrix.ordering <- which(unique(design.matrix)==1, arr.ind=TRUE)[,1][which(unique(design.matrix)==1, arr.ind=TRUE)[,1]]
	# rownames(pData(eset_r)) <- colnames(design.matrix)[design.matrix.ordering]
	# varLabels(eset_r) <- colnames(pData(eset)[1:numOfFactorsToUse(removeUninformativeFactors(eset))])
	# colnames(pData(eset_r)) <- colnames(pData(eset))
	return(eset_r)
             cat('\nDone.')
}

"pplr" <-
function (e, control, experiment, sorted=TRUE) 
{
    dim_e <- dim(e)
    genes <- dim_e[1]
    conds <- dim_e[2]/2
    res <- matrix(0, genes, 9)
    if(length(control) > 1)
    { res[, 2] <- rowMeans(e[, control]) }
    else
    { res[, 2] <- e[, control] }
    if(length(experiment) > 1)
    { res[, 3] <- rowMeans(e[, experiment]) }
    else
    { res[, 3] <- e[, experiment] }
    if(length(control) > 1)
    { res[, 4] <- sqrt(rowSums(e[, conds + control]^2)) }
    else
    { res[, 4] <- e[, conds + control] }
    if(length(experiment) > 1)
    { res[, 5] <- sqrt(rowSums(e[, conds + experiment]^2)) }
    else
    { res[, 5] <- e[, conds + experiment] }
    res[, 6] <- res[, 3] - res[, 2]
#    res[, 7] <- sqrt(e[, conds + control]^2 + e[, conds + experiment]^2)
    res[, 7] <- sqrt((res[, 4]^2) + (res[, 5]^2))
    res[, 8] <- -res[, 6]/(res[, 7] * sqrt(2))
    res[, 9] <- erfc(res[, 8])/2
	if(sorted)
    {
		sortout <- sort(abs(res[, 8]), method = "quick", index.return = TRUE, decreasing=TRUE)
    	res[, c(2:9)] <- res[sortout$ix, c(2:9)]
    	res[, 1] <- sortout$ix
	}
    colnames(res) <- c("index", "cM", "sM", "cStd", "sStd", "LRM", 
        "LRStd", "stat", "PPLR")
	if(sorted)
	   	rownames(res) <- rownames(e)[sortout$ix]
	if(!sorted)
		rownames(res) <- rownames(e)
    return(as.data.frame(res))
}

clusterApplyLBDots <- function (cl, x, fun, ...) 
{
    chunksCount <- 0
    numOfChunks <- length(x)
    numOfNodes <- length(cl)
    #fun <- fun
    if (numOfChunks > 0 && numOfNodes > 0) {
        wrap <- function(x, i, ...) list(value = try(fun(x, ...)), 
            index = i)
        submit <- function(node, job) {
            args <- c(list(x[[job]]), list(job), list(...))
            sendCall(cl[[node]], wrap, args)
        }
        for (i in 1:min(numOfChunks, numOfNodes)) submit(i, i)
        val <- vector("list", length(x))
        for (i in seq(along = x)) {
			chunksCount <- chunksCount + 1
			dotsPerChunk <- floor( (50/numOfChunks)*chunksCount ) - floor( (50/numOfChunks)*(chunksCount-1) )
			if(dotsPerChunk > 0) for(dotsCount in 1:dotsPerChunk) cat(".")
            d <- recvOneResult(cl)
            j <- i + min(numOfChunks, numOfNodes)
            if (j <= numOfChunks) 
                submit(d$node, j)
            val[d$value$index] <- list(d$value$value)
        }
        val
    }
}

pumaComb <- function (
	eset
,	design.matrix=NULL
,	method="em"
,	numOfChunks=1000
,	save_r=FALSE
,	cl=NULL
,	parallelCompute=FALSE
# ,	parallelCompute=if(
# 		"Rmpi" %in% installed.packages() & "snow" %in% installed.packages()
# 	)
# 	as.logical(length(grep("origin",system("lamnodes",TRUE,TRUE))))
# 	else FALSE
)
{
	if(!(is(eset, "ExpressionSet") || is(eset, "ExpressionSetIllumina")))
		stop("eset is not a valid ExpressionSet object!")
	if(is.null(design.matrix) && is.null(pData(eset)))
		stop("ExpressionSet contains no valid phenoData and no design.matrix
			given!")
	if(parallelCompute && is.null(cl))
	{
		# library(Rmpi)
		library(snow)
		cl <- getMPIcluster()
		if(is.null(cl))
			cl <- makeCluster(length(system("lamnodes",TRUE,TRUE))-1)
		# clusterEvalQ(cl, library(puma))
	}
	if(!is.null(cl))
		clusterEvalQ(cl, library(puma))	
	if(is.null(design.matrix))
		design.matrix <- createDesignMatrix(eset)
	# if(length(names(which(colSums(dm2)==1))) > 1)
	# 	warning("The following conditions have no replicates", names(which(colSums(dm2)==1)),". While it is possible to use PPLR without any biological replicates, this is not advised.")
	e <- exprs(eset)
	se <- assayDataElement(eset,"se.exprs")
	# se <- se.exprs(eset)
	numOfGenes <- dim(e)[1]
	if(numOfChunks > (numOfGenes/10))
		numOfChunks <- max(floor(numOfGenes/10),1)
	numPerChunk <- c(0, rep(floor(numOfGenes / numOfChunks),numOfChunks))
	numOfExtras <- numOfGenes - sum(numPerChunk)
	if(numOfExtras > 0)
		numPerChunk[2:(numOfExtras+1)] <- numPerChunk[2:(numOfExtras+1)] + 1
	eList <- list()
	seList <- list()
	rl <- list()
	rFirst <- list()
	paramsList <- list()
	for (i in 1:numOfChunks)
	{
		eList[[i]] <- e[(1 + sum(numPerChunk[1:i])):sum(numPerChunk[1:(i+1)]),]
		seList[[i]] <- se[(1 + sum(numPerChunk[1:i])):sum(numPerChunk[1:(i+1)]),]
#		seList[[i]] <- se[(1 + (numPerChunk[i] * (i-1))):min((numPerChunk[i+1] * i),numOfGenes),]
		paramsList[[i]] <- list(
			eList[[i]]
		,	seList[[i]]
		,	replicates=apply(design.matrix,1,function(x) which(x==1))
		,	method=method
		)
	}
	cat("Calculating expected completion time\n")
	if(is.null(cl))
	{
		expectedCompletionTime <-	system.time(
										rFirst <- list(
											bcomb(
												paramsList[[1]][[1]]
											,	paramsList[[1]][[2]]
											,	paramsList[[1]][[3]]
											,	paramsList[[1]][[4]]
											)
										)
									)[3] * numOfChunks
	}
	else
	{
		expectedCompletionTime <- system.time(
									rFirst <- clusterApplyLB(
										cl
									,	paramsList[1:length(cl)]
									,	function(paramsList) 
										{
											b <- bcomb(
												paramsList[[1]]
											,	paramsList[[2]]
											,	paramsList[[3]]
											,	paramsList[[4]]
											)
										}
									)
								)[3] * numOfChunks / length(cl)
	}
	if (expectedCompletionTime < 120)
		expectedTimeString <- paste(round(expectedCompletionTime, 0), "seconds")
	else if (expectedCompletionTime < 7200)
		expectedTimeString <- paste(round(expectedCompletionTime/60, 0), "minutes")
	else if (expectedCompletionTime < 172800)
		expectedTimeString <- paste(round(expectedCompletionTime/3600, 0), "hours")
	else
		expectedTimeString <- paste(round(expectedCompletionTime/172800, 0), "days")
	cat(paste("pumaComb expected completion time is", expectedTimeString,"\n"))
	cat(".......20%.......40%.......60%.......80%......100%\n")
	i <- 0
	chunksPerDot <- ceiling(numOfChunks / 50)
	if(is.null(cl) & numOfChunks > 1)
    	rl <- lapply(
    			paramsList[2:length(paramsList)]
    		,	function(paramsList) 
    			{
    				b <- bcomb(
						paramsList[[1]]
					,	paramsList[[2]]
					,	paramsList[[3]]
					,	paramsList[[4]]
					)
					i <<- i + 1
					dotsPerChunk <- floor( (50/(numOfChunks-1))*i ) - floor( (50/(numOfChunks-1))*(i-1) )

					#if(i %% chunksPerDot == 0) for(d in 1:dotsPerChunk) cat(".")
					if(dotsPerChunk > 0) for(d in 1:dotsPerChunk) cat(".")
					return(b)
				}
			)
	if(is.null(cl) & numOfChunks == 1)
		cat("..................................................")
    if(!is.null(cl))
    {
    	if(numOfChunks > length(cl))
			rl <-	clusterApplyLBDots(
						cl
					,	paramsList[(length(cl)+1):length(paramsList)]
					,	function(paramsList) 
						{
							b <- bcomb(
								paramsList[[1]]
							,	paramsList[[2]]
							,	paramsList[[3]]
							,	paramsList[[4]]
							)
						}
					)
    	if(numOfChunks <= length(cl))
			cat("..................................................")
	}
	cat("\n")
	rl <- c(rFirst, rl)
	r <- rl[[1]]
	if(numOfChunks > 1)
		for (i in 2:numOfChunks)
			r <- rbind(r,rl[[i]])
	colnames(r) <- c(paste("M", colnames(design.matrix)), paste("Std", colnames(design.matrix)))
	if(save_r)
		save(r, file="r.rda")
	eset_r <- create_eset_r(eset, r, design.matrix)
	# colnames(exprs(eset_r)) <- paste("M", colnames(design.matrix), sep="_")
	# colnames(assayDataElement(eset_r,"se.exprs")) <- paste("Std", colnames(design.matrix), sep="_")
	# design.matrix.ordering <- replace(
	# 	which(unique(design.matrix)==1)%%(dim(design.matrix)[2])
	# ,	which(unique(design.matrix)==1)%%(dim(design.matrix)[2])==0
	# ,	dim(design.matrix)[2]
	# )
	# design.matrix.ordering <- which(unique(design.matrix)==1, arr.ind=TRUE)[,1][which(unique(design.matrix)==1, arr.ind=TRUE)[,1]]
	# rownames(pData(eset_r)) <- colnames(design.matrix)[design.matrix.ordering]
	# varLabels(eset_r) <- colnames(pData(eset)[1:numOfFactorsToUse(removeUninformativeFactors(eset))])
	# colnames(pData(eset_r)) <- colnames(pData(eset))
	return(eset_r)
}

removeUninformativeFactors <- function(eset)
{
	informativeFactors <- which(
		apply(
			as.matrix(pData(eset))
		,	2
		,	function(x) length(levels(as.factor(x)))
		) > 1
	)
	phenoData(eset) <- phenoData(eset)[,informativeFactors]
	return(eset)
}

numOfFactorsToUse <- function (eset)
{
	numOfFactors <- dim(pData(eset))[2]
	if(numOfFactors == 0)
		stop("eset has no informative factors! Does eset have an appropriate phenoData slot?")
	while (
		length(
			levels(
				as.factor(
					apply(
						as.matrix(pData(eset)[,1:numOfFactors])
						,	1
						,	function(items) paste(items, collapse=".")
					)
				)
			)
		)
		<
		prod(
			apply(
				as.matrix(pData(eset)[,1:numOfFactors])
			,	2
			,	function(x) length(levels(as.factor(x)))
			)
		)
	) numOfFactors <- numOfFactors - 1
	return(numOfFactors)
}

createDesignMatrix <- function (eset)
{
	if(!(is(eset, "ExpressionSet") || is(eset, "ExpressionSetIllumina")))
		stop("eset is not a valid ExpressionSet object!")
	numOfFactors <- numOfFactorsToUse(removeUninformativeFactors(eset))
	if(numOfFactors == 0)
		stop("eset has no informative factors! Does eset have an appropriate phenoData slot?")
	pd <- as.data.frame(pData(removeUninformativeFactors(eset))[,1:numOfFactors])
	for (i in 1:numOfFactors)
	## coerce all columns of pheno data to factors - needed because
	## read.phenoData doesn't treat numerics as factors
	{
		pd[,i] <- factor(pd[,i])
	}
	# levelsOfFactors <- rev(lapply(pd,levels))
	levelsOfFactors <- lapply(pd,levels)
	lengthsOfLevels <- sapply(levelsOfFactors,length)

#	levelsOfFactors <- rep(0,numOfFactors)
#	for(i in 1:numOfFactors)
#		levelsOfFactors[i] <- length(levels(pd[,i]))
#	for(firstFactor in 1:levelsOfFactors[1])
#	levelsOfFactors <- rev(levelsOfFactors)
	##create an n dimensional array where n is number of factors. Each element
	##this array is a name combining the levels of each factor

	arrayOfNames <- levelsOfFactors[[1]]
	if(numOfFactors > 1)
	{
		for(i in 2:numOfFactors)
		{
			arrayOfNames <- sapply(
				arrayOfNames
			,	function(x) paste(x,levelsOfFactors[[i]],sep=".")
			)
		}
	}
	arrayOfNames <- aperm(array(arrayOfNames, rev(lengthsOfLevels)))
	# arrayOfNames <- aperm(array(colnames(design), rev(lengthsOfLevels)))
	# vectorOfNames <- levelsOfFactors[[1]]
	# if(numOfFactors > 1)
	# {
	# 	for(i in 2:numOfFactors)
	# 	{
	# 		vectorOfNames <- sapply(
	# 			vectorOfNames
	# 		,	function(x) paste(x,levelsOfFactors[[i]],sep=".")
	# 		)
	# 	}
	# }
	vectorOfNames <- as.character(as.vector(arrayOfNames))
	conditionLevels <-	factor(
							apply(
								as.matrix(pd[,1:numOfFactors])
							,	1
							,	function(items) paste(items, collapse=".")
							)
						,	levels = vectorOfNames
						# ,	levels = unique(
						# 		apply(
						# 			as.matrix(pData(eset)[,1:numOfFactors])
						# 		,	1
						# 		,	function(items) paste(items, collapse=".")
						# 		)
						# 	)
						)
	design.matrix <- model.matrix(~0+conditionLevels)
	colnames(design.matrix) <- vectorOfNames
	# colnames(design.matrix) <- unique(conditionLevels)
	rownames(design.matrix) <- sampleNames(eset)
	return(design.matrix)
}

createContrastMatrix <- function (eset, design=NULL)
{
	if(!(is(eset, "ExpressionSet") || is(eset, "exprSet") || is(eset, "ExpressionSetIllumina")))
		stop("eset is not a valid ExpressionSet object!")
	if(is.null(design))
		design <- createDesignMatrix(eset)
	numOfFactors <- numOfFactorsToUse(removeUninformativeFactors(eset))
	pd <- as.data.frame(pData(removeUninformativeFactors(eset))[,1:numOfFactors])
	for (i in 1:numOfFactors)
	## coerce all columns of pheno data to factors - needed because
	## read.phenoData doesn't treat numerics as factors
	{
		pd[,i] <- as.factor(pd[,i])
	}
	# levelsOfFactors <- rev(lapply(pd,levels))
	levelsOfFactors <- lapply(pd,levels)
	lengthsOfLevels <- sapply(levelsOfFactors,length)
	
#	levelsOfFactors <- rep(0,numOfFactors)
#	for(i in 1:numOfFactors)
#		levelsOfFactors[i] <- length(levels(pd[,i]))
#	for(firstFactor in 1:levelsOfFactors[1])
#	levelsOfFactors <- rev(levelsOfFactors)
	##create an n dimensional array where n is number of factors. Each element
	##this array is a name combining the levels of each factor
	
	# arrayOfNames <- aperm(array(colnames(design), rev(lengthsOfLevels)))
	arrayOfNames <- levelsOfFactors[[1]]
	if(numOfFactors > 1)
	{
		for(i in 2:numOfFactors)
		{
			arrayOfNames <- sapply(
				arrayOfNames
				,	function(x) paste(x,levelsOfFactors[[i]],sep=".")
			)
		}
	}
	arrayOfNames <- aperm(array(arrayOfNames, rev(lengthsOfLevels)))
	
	############################################################################
	## 1-1 contrasts where only one factor is changing for fixed levels of all other
	############################################################################
	
	## create a 2n dimensional array each element of which corrresponds to a
	## combination of two sets of levels. The idea is we then loop through this
	## array looking for combinations which are of interest, i.e. ones for which
	## only one dimension has changed between the two sets, and which have not
	## already been included in the "reverse" direction
	comp_array <- array(1:prod(lengthsOfLevels)^2,dim=c(lengthsOfLevels, lengthsOfLevels))
	
	## find which elements (contrasts) of comp_array are of interest
	cont_vector <- vector()
	for(i in 1:length(comp_array))
	{
		if(
			length(
				which(
					which(comp_array==i, arr.ind=TRUE)[1:numOfFactors]
						==	which(comp_array==i, arr.ind=TRUE)[(numOfFactors+1):(numOfFactors*2)]
				)
			) == (numOfFactors - 1)
			&&
			length(
				which(
					which(comp_array==i, arr.ind=TRUE)[1:numOfFactors]
						<	which(comp_array==i, arr.ind=TRUE)[(numOfFactors+1):(numOfFactors*2)]
				)
			) == 0
			)
			cont_vector <- c(cont_vector,i)
	}
	
	## get dimensions for each contrast of interest, where first n dimensions
	## specify the "experiment" condition, and second n dimensions specify the
	## "control" condition
	cl <- lapply(cont_vector, function(x) which(comp_array == x, arr.ind=TRUE))
	## create a list, each item of which is a contrast, specified as an n-
	## dimensional array
	ct <- list()
	for(i in 1:length(cl))
	{
		ct[[i]] <- array(0,dim=lengthsOfLevels)
		ct[[i]][t(as.matrix(cl[[i]][1:numOfFactors]))] <- 1
		ct[[i]][t(as.matrix(cl[[i]][(numOfFactors+1):(numOfFactors*2)]))] <- -1
	}
	
	## make a matrix out of the list
	cm <- sapply(ct, as.vector)
	colnames(cm) <- sapply(
		cl
		,	function(x) paste(
				arrayOfNames[t(as.matrix(x[,1:numOfFactors]))]
				,	arrayOfNames[t(as.matrix(x[,(numOfFactors+1):(numOfFactors*2)]))]
				,	sep="_vs_"
			)
	)
	rownames(cm) <- arrayOfNames
	
	############################################################################
	## 1-other contrasts where only one factor is changing for fixed levels of all other
	############################################################################
	
	if(numOfFactors == 1)
	{
		ct <- list()
		count <- 0
		contrastNames <- vector()
		if(lengthsOfLevels[1] > 2)
		{
			cm8 <- matrix(0, lengthsOfLevels[1], lengthsOfLevels[1])
			for(k in 1:lengthsOfLevels[1])
			{
				cm8[k,k] <- 1
				cm8[(1:lengthsOfLevels[1])[-k],k] <- -1
			}
			colnames(cm8) <- paste(levelsOfFactors[[1]], "_vs_others", sep="")
			cm <- cbind(cm,cm8)
		}
	}
	
	if(numOfFactors > 1)
	{
		for(index_Factor in 1:length(lengthsOfLevels))
		{
			if(lengthsOfLevels[index_Factor] > 2)
			{
				temp <- array(0,dim=lengthsOfLevels[-index_Factor])
				perms <- which(temp==0, arr.ind=TRUE)
				ct <- list()
				count <- 0
				contrastNames <- vector()
				for(index_unchangingLevels in 1:(dim(perms)[1]))
				{
					for(index_changingLevels in 1:lengthsOfLevels[index_Factor])
					{
						count <- count+1
						ct[[count]] <- array(0,dim=lengthsOfLevels)
						dims<-vector(length=length(lengthsOfLevels))
						dims[-index_Factor] <- perms[index_unchangingLevels,]
						dims[index_Factor] <- index_changingLevels
						dims_for_names <- dims
						dimsmat <- t(matrix(dims))
						ct[[count]][dimsmat] <- 1
						dimsmat <- matrix(0,lengthsOfLevels[index_Factor],length(lengthsOfLevels))
						count2 <- 0
						for(index_changingFactor in
							(1:lengthsOfLevels[index_Factor])[-index_changingLevels])
						{
							dims[index_Factor] <- index_changingFactor
							dimsmat[index_changingFactor,] <- t(matrix(dims))
						}
						ct[[count]][dimsmat] <- -1
						if(index_Factor == 1)
							contrastNames[count] <- levelsOfFactors[[1]][dims_for_names[1]]
						else
							contrastNames[count] <- levelsOfFactors[[1]][dims_for_names[1]]
						for(m in 2:numOfFactors)
						{
							if(index_Factor == m)
								contrastNames[count] <- paste(contrastNames[count], "."
									,  levelsOfFactors[[m]][dims_for_names[m]], sep="")
							else
								contrastNames[count] <- paste(contrastNames[count], "."
									,  levelsOfFactors[[m]][dims_for_names[m]], sep="")
						}
						contrastNames[count] <- paste(contrastNames[count], "_vs_", sep="")
						if(index_Factor == 1)
							contrastNames[count] <- paste(contrastNames[count]
								, "others", sep="")
						else
							contrastNames[count] <- paste(contrastNames[count]
								, levelsOfFactors[[1]][dims_for_names[1]], sep="")
						for(m in 2:numOfFactors)
						{
							if(index_Factor == m)
								contrastNames[count] <- paste(contrastNames[count]
									, ".",  "others", sep="")
							else
								contrastNames[count] <- paste(contrastNames[count]
									, ".",  levelsOfFactors[[m]][dims_for_names[m]], sep="")
						}
					}
				}
				## make a matrix out of the list
				cm7 <- sapply(ct, as.vector)
				colnames(cm7) <- contrastNames
				cm <- cbind(cm,cm7)
			}
		}
	}
	
	
	############################################################################
	## contrasts where only one factor is changing for all levels of all other
	############################################################################
	
	if(numOfFactors > 1)
	{
		i <- 0
		ct <- list()
		contrastNames <- vector()
		for(factorIndex in 1:numOfFactors)
		{
			for(firstLevel in 1:(lengthsOfLevels[factorIndex]-1))
			{
				for(secondLevel in (firstLevel+1):lengthsOfLevels[factorIndex])
				{
					i <- i+1
					ct[[i]] <- array(0,dim=lengthsOfLevels)
					ct[[i]][which(slice.index(ct[[i]],factorIndex)==firstLevel)] <- 1
					ct[[i]][which(slice.index(ct[[i]],factorIndex)==secondLevel)] <- -1
					contrastNames[i] <- paste(
						names(levelsOfFactors)[factorIndex]
						,	"_"
						,	levelsOfFactors[[factorIndex]][firstLevel]
						,	"_vs_"
						,	levelsOfFactors[[factorIndex]][secondLevel]
						,	sep=""
					)
				}
			}
		}
		cm2 <- sapply(ct, as.vector)
		colnames(cm2) <- contrastNames
		cm <- cbind(cm,cm2)
	}
	
	############################################################################
	## 2-way interaction terms when only two factors
	############################################################################
	
	if(numOfFactors == 2)
	{
		i <- 0
		ct <- list()
		contrastNames <- vector()
		for(factor1 in 1:(numOfFactors-1))
		{
			for(factor2 in (factor1+1):numOfFactors)
			{
				for(factor1level1 in 1:(lengthsOfLevels[factor1]-1))
				{
					for(factor1level2 in (factor1level1+1):lengthsOfLevels[factor1])
					{
						for(factor2level1 in 1:(lengthsOfLevels[factor2]-1))
						{
							for(factor2level2 in (factor2level1+1):lengthsOfLevels[factor2])
							{
								i <- i+1
								ct[[i]] <- array(0,dim=lengthsOfLevels)
								ct[[i]][factor1level1,factor2level1] <- 1
								ct[[i]][factor1level1,factor2level2] <- -1
								ct[[i]][factor1level2,factor2level1] <- -1
								ct[[i]][factor1level2,factor2level2] <- 1
								contrastNames[i] <- paste(
									"Int__"
									,	names(levelsOfFactors)[factor1]
									,	"_"
									,	levelsOfFactors[[factor1]][factor1level1]
									,	"."
									,	levelsOfFactors[[factor1]][factor1level2]
									,	"_vs_"
									,	names(levelsOfFactors)[factor2]
									,	"_"
									,	levelsOfFactors[[factor2]][factor2level1]
									,	"."
									,	levelsOfFactors[[factor2]][factor2level2]
									,	sep=""
								)
							}
						}
					}
				}
			}
		}
		cm3 <- sapply(ct, as.vector)
		colnames(cm3) <- contrastNames
		cm <- cbind(cm, cm3)
	}
	
	############################################################################
	## 2-way interaction terms for each level of third factor
	############################################################################
	
	if(numOfFactors == 3)
	{
		i <- 0
		ct <- list()
		contrastNames <- vector()
		for(factor1 in 1:(numOfFactors-1))
		{
			for(factor2 in (factor1+1):numOfFactors)
			{
				for(factor1level1 in 1:(lengthsOfLevels[factor1]-1))
				{
					for(factor1level2 in (factor1level1+1):lengthsOfLevels[factor1])
					{
						for(factor2level1 in 1:(lengthsOfLevels[factor2]-1))
						{
							for(factor2level2 in (factor2level1+1):lengthsOfLevels[factor2])
							{
								factor3 <- (1:numOfFactors)[-c(factor1, factor2)]
								for(factor3level in 1:lengthsOfLevels[factor3])
								{
									i <- i+1
									ct[[i]] <- array(0,dim=lengthsOfLevels)
									arrayDims <- array(0,dim=c(1,3))
									arrayDims[1,factor1] <- factor1level1
									arrayDims[1,factor2] <- factor2level1
									arrayDims[1,factor3] <- factor3level
									ct[[i]][arrayDims] <- 1
									arrayDims[1,factor1] <- factor1level1
									arrayDims[1,factor2] <- factor2level2
									arrayDims[1,factor3] <- factor3level
									ct[[i]][arrayDims] <- -1
									arrayDims[1,factor1] <- factor1level2
									arrayDims[1,factor2] <- factor2level1
									arrayDims[1,factor3] <- factor3level
									ct[[i]][arrayDims] <- -1
									arrayDims[1,factor1] <- factor1level2
									arrayDims[1,factor2] <- factor2level2
									arrayDims[1,factor3] <- factor3level
									ct[[i]][arrayDims] <- 1
									contrastNames[i] <- paste(
										"Int__"
										,	names(levelsOfFactors)[factor3]
										,	"_"
										,	levelsOfFactors[[factor3]][factor3level]
										,	"__"
										,	names(levelsOfFactors)[factor1]
										,	"_"
										,	levelsOfFactors[[factor1]][factor1level1]
										,	"."
										,	levelsOfFactors[[factor1]][factor1level2]
										,	"_vs_"
										,	names(levelsOfFactors)[factor2]
										,	"_"
										,	levelsOfFactors[[factor2]][factor2level1]
										,	"."
										,	levelsOfFactors[[factor2]][factor2level2]
										,	sep=""
									)
								}
							}
						}
					}
				}
			}
		}
		cm4 <- sapply(ct, as.vector)
		colnames(cm4) <- contrastNames
		cm <- cbind(cm, cm4)
	}
	
	############################################################################
	## 2-way interaction terms for all levels of third factor
	############################################################################
	
	if(numOfFactors == 3)
	{
		i <- 0
		ct <- list()
		contrastNames <- vector()
		for(factor1 in 1:(numOfFactors-1))
		{
			for(factor2 in (factor1+1):numOfFactors)
			{
				for(factor1level1 in 1:(lengthsOfLevels[factor1]-1))
				{
					for(factor1level2 in (factor1level1+1):lengthsOfLevels[factor1])
					{
						for(factor2level1 in 1:(lengthsOfLevels[factor2]-1))
						{
							for(factor2level2 in (factor2level1+1):lengthsOfLevels[factor2])
							{
								factor3 <- (1:numOfFactors)[-c(factor1, factor2)]
								i <- i+1
								ct[[i]] <- array(0,dim=lengthsOfLevels)
								arrayDims <- array(0,dim=c(1,3))
								for(factor3level in 1:lengthsOfLevels[factor3])
								{
									arrayDims[1,factor1] <- factor1level1
									arrayDims[1,factor2] <- factor2level1
									arrayDims[1,factor3] <- factor3level
									ct[[i]][arrayDims] <- 1
									arrayDims[1,factor1] <- factor1level1
									arrayDims[1,factor2] <- factor2level2
									arrayDims[1,factor3] <- factor3level
									ct[[i]][arrayDims] <- -1
									arrayDims[1,factor1] <- factor1level2
									arrayDims[1,factor2] <- factor2level1
									arrayDims[1,factor3] <- factor3level
									ct[[i]][arrayDims] <- -1
									arrayDims[1,factor1] <- factor1level2
									arrayDims[1,factor2] <- factor2level2
									arrayDims[1,factor3] <- factor3level
									ct[[i]][arrayDims] <- 1
								}
								contrastNames[i] <- paste(
									"Int__"
									,	names(levelsOfFactors)[factor3]
									,	":all-levels"
									,	"__"
									,	names(levelsOfFactors)[factor1]
									,	"_"
									,	levelsOfFactors[[factor1]][factor1level1]
									,	"."
									,	levelsOfFactors[[factor1]][factor1level2]
									,	"_vs_"
									,	names(levelsOfFactors)[factor2]
									,	"_"
									,	levelsOfFactors[[factor2]][factor2level1]
									,	"."
									,	levelsOfFactors[[factor2]][factor2level2]
									,	sep=""
								)
							}
						}
					}
				}
			}
		}
		cm5 <- sapply(ct, as.vector)
		colnames(cm5) <- contrastNames
		cm <- cbind(cm, cm5)
	}
	
	############################################################################
	## 3-way interaction terms
	############################################################################
	
	if(numOfFactors == 3)
	{
		i <- 0
		ct <- list()
		contrastNames <- vector()
		for(factor1 in 1:(numOfFactors-2))
		{
			for(factor2 in (factor1+1):(numOfFactors-1))
			{
				for(factor3 in (factor2+1):numOfFactors)
				{
					for(factor1level1 in 1:(lengthsOfLevels[factor1]-1))
					{
						for(factor1level2 in (factor1level1+1):lengthsOfLevels[factor1])
						{
							for(factor2level1 in 1:(lengthsOfLevels[factor2]-1))
							{
								for(factor2level2 in (factor2level1+1):lengthsOfLevels[factor2])
								{
									for(factor3level1 in 1:(lengthsOfLevels[factor3]-1))
									{
										for(factor3level2 in (factor3level1+1):lengthsOfLevels[factor3])
										{
											i <- i+1
											ct[[i]] <- array(0,dim=lengthsOfLevels)
											ct[[i]][factor1level1,factor2level1,factor3level1] <- 1
											ct[[i]][factor1level1,factor2level1,factor3level2] <- -1
											ct[[i]][factor1level1,factor2level2,factor3level1] <- -1
											ct[[i]][factor1level1,factor2level2,factor3level2] <- 1
											ct[[i]][factor1level2,factor2level1,factor3level1] <- -1
											ct[[i]][factor1level2,factor2level1,factor3level2] <- 1
											ct[[i]][factor1level2,factor2level2,factor3level1] <- 1
											ct[[i]][factor1level2,factor2level2,factor3level2] <- -1
											contrastNames[i] <- paste(
												"Int__"
												,	names(levelsOfFactors)[factor1]
												,	"_"
												,	levelsOfFactors[[factor1]][factor1level1]
												,	"."
												,	levelsOfFactors[[factor1]][factor1level2]
												,	"_vs_"
												,	names(levelsOfFactors)[factor2]
												,	"_"
												,	levelsOfFactors[[factor2]][factor2level1]
												,	"."
												,	levelsOfFactors[[factor2]][factor2level2]
												,	"_vs_"
												,	names(levelsOfFactors)[factor3]
												,	"_"
												,	levelsOfFactors[[factor3]][factor3level1]
												,	"."
												,	levelsOfFactors[[factor3]][factor3level2]
												,	sep=""
											)
										}
									}
								}
							}
						}
					}
				}
			}
		}
		cm6 <- sapply(ct, as.vector)
		colnames(cm6) <- contrastNames
		cm <- cbind(cm, cm6)
	}
	
	return(cm)
}

pumaFull <- function(
	ExpressionFeatureSet = NULL
,	data_dir = getwd()
,	load_ExpressionFeatureSet = FALSE
,	calculate_eset = TRUE
,	calculate_pumaPCAs = TRUE
,	calculate_bcomb = TRUE
,	mmgmosComparisons = FALSE
)
{
	if(is.null(ExpressionFeatureSet) && !load_ExpressionFeatureSet && calculate_eset)
	{
                    setwd(data_dir);
	 	ExpressionFeatureSet<-read.celfiles(list.celfiles());
		save(ExpressionFeatureSet, file=paste(data_dir,"ExpressionFeatureSet.rda",sep="/"))
	}

	if(load_ExpressionFeatureSet && calculate_eset)
	{
	  load(paste(data_dir,"ExpressionFeatureSet.rda",sep="/"))
	}

	if(calculate_eset)
	{
		cat("calculating eset_mmgmos\n")
		eset_mmgmos <- mmgmos(ExpressionFeatureSet)
		save(eset_mmgmos, file=paste(data_dir,"/eset_mmgmos.rda",sep=""))
		if(mmgmosComparisons)
		{
			cat("calculating eset_mmgmos_bg\n")
			eset_mmgmos_bg <- mmgmos(
				ExpressionFeatureSet
			,	background=TRUE
			,	replaceZeroIntensities=FALSE
			)
			save(
				eset_mmgmos_bg
			,	file=paste(data_dir,"/eset_mmgmos_bg.rda",sep="")
			)
		}
		cat("calculating eset_rma\n")
		eset_rma <- oligo:::rma(ExpressionFeatureSet)
		save(eset_rma, file=paste(data_dir,"/eset_rma.rda",sep=""))
	}

	if(!calculate_eset)
	{
		load(paste(data_dir,"/eset_mmgmos.rda",sep=""))
		load(paste(data_dir,"/eset_rma.rda",sep=""))
		if(mmgmosComparisons)
		{
			load(paste(data_dir,"/eset_mmgmos_bg.rda",sep=""))
		}
	}

	##############################
	## pumaPCA
	##############################
	if(calculate_pumaPCAs)
	{
		pumaPCA_results <- pumaPCA(eset_mmgmos)
		save(pumaPCA_results, file=paste(data_dir,"/pumaPCA_results.rda",sep=""))
	}
	if(!calculate_pumaPCAs)
	{
		load(paste(data_dir,"/pumaPCA_results.rda",sep=""))
	}

	pdf("pca.pdf",width=7, height=10)
	par(mfrow=c(2,1))
	plot(pumaPCA_results,legend1pos="topleft",legend2pos="top", main="pumaPCA")
	pca_results <- prcomp(t(exprs(eset_rma)))
	if(dim(pData(eset_rma))[2] > 1)
	{	
		plot(
			pca_results$x
		,	xlab="Component 1"
		,	ylab="Component 2"
		,	pch=unclass(as.factor(pData(eset_rma)[,1]))
		,	col=unclass(as.factor(pData(eset_rma)[,2]))
		,	main="PCA"
		)
	}
	else
	{
		plot(
			pca_results$x
		,	xlab="Component 1"
		,	ylab="Component 2"
		,	pch=unclass(as.factor(pData(eset_rma)[,1]))
		,	col=unclass(as.factor(pData(eset_rma)[,1]))
		,	main="PCA"
		)
	}
	dev.off()

	##############################
	## Genes with highest interaction
	##############################

	pdf("boxplots.pdf",width=10, height=7)
	par(mfcol=c(2,2))
	boxplot(data.frame(exprs(eset_mmgmos)), main="mmgMOS - No norm")
	boxplot(data.frame(exprs(eset_rma)), main="Standard RMA")
	eset_mmgmos_normd <- pumaNormalize(eset_mmgmos, "median")
	boxplot(data.frame(exprs(eset_mmgmos_normd)), main="mmgMOS - median scaling")
	dev.off()

	if(calculate_bcomb)
	{
		eset_comb <- pumaComb(eset_mmgmos)
		save(eset_comb, file=paste(data_dir,"/eset_comb.rda",sep=""))
		eset_normd_comb <- pumaComb(eset_mmgmos_normd)
		save(
			eset_normd_comb
		,	file=paste(data_dir,"/eset_normd_comb.rda",sep="")
		)
	}
	if(!calculate_bcomb)
	{
		load(paste(data_dir,"/eset_comb.rda",sep=""))
		load(paste(data_dir,"/eset_normd_comb.rda",sep=""))
	}

	compareLimmapumaDE(
		eset_mmgmos
	,	eset_comb
	,	eset_rma
	,	contrastsFilename="contrasts_mmgmos"
	,	plotOther=TRUE
	,	otherFilename="contrasts_rma"
	)
	compareLimmapumaDE(
		eset_mmgmos_normd
	,	eset_normd_comb
	,	eset_rma
	,	contrastsFilename="contrasts_mmgmos_normd"
	)
}

pumaPCASigmaGradient <- function
(
    sigma
,   model
,   expectations
,   varY
,   Y
)
{
    dataDim <- dim(Y)[2]
    numData <- dim(Y)[1]

    Sigma <- 0
    curvature <- 0

    for (i in 1:numData)
    {
        Fun <- diag(1/(sigma^2+varY[i,]))
        F2 <- Fun*Fun
        ## computes the gradient with respect to sigma
        Sigma <- Sigma -
            2 * ( (Y[i,] - model@mu) %*% F2 %*% t(Y[i,] - model@mu) ) * sigma +
            2 * sum(diag(Fun)) * sigma +
            ( 4 * expectations@x[i,] %*% t(model@W) %*% F2 %*% t(Y[i,] - model@mu) ) * sigma -
            2 * sum(diag(t(model@W) %*% F2 %*% model@W %*% expectations@xxT[,,i])) * sigma
    }
    Grad <- 0.5 * Sigma
    as.vector(Grad)
}

pumaPCAEstep <- function
(
    model
,   expectations
,   varY
,   Y
)
{
    dataDim <- dim(Y)[2]
##  latentDim <- size(expectations.x, 2);
    numData <- dim(Y)[1]

    for (i in 1:numData)   #computes the inverses of the matrices M_n
    {
        Binv <- diag(1/(model@sigma^2 + varY[i,]))
  ## This inverse should really be done across a q dimensional matrix.
        SigmaInv <- t(model@W) %*% Binv %*% model@W + model@Cinv
#        print(SigmaInv)
#        Sigma_x <- solve(SigmaInv)
#        print(Sigma_x)
        expectations@logDetCov[i] <- -log(det(SigmaInv))
#        print(model@W)
#        print(Binv)
#        print(model@mu)
#        expectations@x[i,] <- (Sigma_x %*% (t(model@W) %*% Binv %*% (Y[i,] - model@mu) + model@Cinv %*% model@m))
#        expectations@xxT[,,i] <- Sigma_x + expectations@x[i,] %*% t(expectations@x[i,])
        expectations@x[i,] <- (solve(SigmaInv, (t(model@W) %*% Binv %*% t(Y[i,] - model@mu) + model@Cinv %*% t(model@m))))
        expectations@xxT[,,i] <- solve(SigmaInv) + expectations@x[i,] %*% t(expectations@x[i,])
    ##  expectations.xTx(i) = trace(expectations.xxT(:,:,i));
    }
    expectations
}

pumaPCALikelihoodCheck <- function
(
    model
,   expectations
,   varY
,   Y
,   oldL
,   param
,	stepChecks
)
{
    L <- pumaPCALikelihoodBound(model, expectations, varY, Y)
    deltaL <- oldL - L
    oldL <- L
    if( stepChecks )
		cat(
	        sprintf(
	            'Likelihood change with update of %s: %2.4f\n'
	        ,   param
	        ,   deltaL
	        )
	    )
    if (deltaL < 0)
    {
        print(
            paste(
                'Likelihood drop of '
            ,   deltaL
            ,   ' after update of '
            ,   param
            ,   '.'
            )
        )
    }
    list(deltaL, L)
}

"pumaClust" <-
function (e = NULL, se = NULL, efile = NULL, sefile = NULL, subset = NULL, 
    gsnorm = FALSE, clusters = 10, iter.max = 100, nstart = 10, eps = 1e-06, 
    del0 = 0.01) 
{
    if(any(class(e)=="exprReslt") | any(class(e)=="ExpressionSet"))
	{
		se <- assayDataElement(e,"se.exprs")
		e <- exprs(e)
	}

	if (length(e) == 0) {
        e <- read.csv(efile, check.names = FALSE, row.names = 1)
    }
    dim_e <- dim(e)
    genes <- dim_e[1]
    chips <- dim_e[2]
    if (length(se) == 0 & length(sefile) > 0) {
        se <- read.csv(sefile, check.names = FALSE, row.names = 1)
        se <- se^2
        m <- 1
    }
    else {
        if (length(se) == 0 & length(sefile) == 0) {
            se <- matrix(0, genes, chips)
            m <- 0
        }
        else {
            se <- se^2
            m <- 1
        }
    }
    if (gsnorm == TRUE) 
        e <- normalisation.gs(e)
    if (length(subset) > 0) {
        e <- e[subset, ]
        se <- se[subset, ]
        dim_e <- dim(e)
        genes <- dim_e[1]
        chips <- dim_e[2]
    }
    if (m == 1) {
        se <- t(apply(cbind(e, se), 1, clusterNormVar))
    }
    e <- t(apply(e, 1, clusterNormE))
 
    cl <- kmeans(e, clusters, iter.max = iter.max, nstart = nstart)
   
    clsig <- 0 * c(1:clusters)
    for (i in 1:clusters) {
        clsig[i] <- mean(diag(cov(e[which(cl$cluster == i), ])))
    }
    res <- .Call("pumaclust_c", as.matrix(e), as.matrix(se), 
        clusters, cl$centers, clsig, eps, del0, PACKAGE = "puma")
    names(res[[1]]) <- rownames(e)
    colnames(res[[2]]) <- colnames(e)
    rownames(res[[2]]) <- paste(1:clusters)
    names(res[[3]]) <- paste(1:clusters)
    rownames(res[[4]]) <- rownames(e)
    colnames(res[[4]]) <- paste(1:clusters)
    return(list(cluster = res[[1]], centers = res[[2]], centersigs = res[[3]], 
        likelipergene = res[[4]], bic = res[[5]]))
}

clusterNormE <- function(x)
{
    meanExp <- mean(x)
    stdExp <- sqrt(var(x))
    x <- (x-meanExp)/stdExp
    return(x)
}

clusterNormVar <- function(x)
{
    n <- length(x)
    stdExp <- var(x[c(1:(n/2))])
    x <- x[c((n/2+1):n)]/stdExp
    return(x)
}

matrixDistance <- function(
    matrixA
,   matrixB
)
{
     distance <- 0
     for(i in 1:dim(matrixA)[1])
     {  distance <- distance +
                    dist(
                        rbind(
                            matrixA[i,]
                        ,   matrixB[i,]
                        )
                    )[1]
    }
    distance <- distance / dim(matrixA)[1]
}

# se.exprs <- function (eset) assayDataElement(eset,"se.exprs")
# 
pumaNormalize <- function (
	eset
,	arrayScale = c("median", "none", "mean", "meanlog")
,	probesetScale = c("none", "mean", "median")
,	probesetNormalisation = NULL
,	replicates = list(1:dim(exprs(eset))[2])
)
{
	if(!(
		is(eset, "ExpressionSet") ||
		is(eset, "exprReslt")
	))
		stop("eset is not a valid ExpressionSet object!")
	E <- exprs(eset)
	SE <- assayDataElement(eset,"se.exprs")
	chipm <- rep(0,dim(exprs(eset))[2])
	if (arrayScale[1]=="mean")
	{
		expr <- as.data.frame(2^E)

		chipm <- apply(expr,2,mean)
		chipm <- chipm/chipm[1]
	}
	else if (arrayScale[1]=="median")
	{
		expr <- as.data.frame(2^E)

		chipm <- apply(expr,2,median)
		chipm <- chipm/chipm[1]
	}
	else if (arrayScale[1]=="meanlog")
	{
		chipm <- apply(E,2,mean)
		chipm <- chipm-chipm[1]
	}
	# expr <- as.matrix(log2(expr))
	if (
		arrayScale[1]=="mean" |
		arrayScale[1]=="median"
	)
	{
		for (i in 1:dim(exprs(eset))[2])
		{
			exprs(eset)[,i] <- exprs(eset)[,i]-log2(chipm[i])
			if(is(eset, "exprReslt"))
			{
				prcfive(eset)[,i] <- prcfive(eset)[,i]-log2(chipm[i])
				prctwfive(eset)[,i] <- prctwfive(eset)[,i]-log2(chipm[i])
				prcfifty(eset)[,i] <- prcfifty(eset)[,i]-log2(chipm[i])
				prcsevfive(eset)[,i] <- prcsevfive(eset)[,i]-log2(chipm[i])
				prcninfive(eset)[,i] <- prcninfive(eset)[,i]-log2(chipm[i])
			}
		}
	}
	if (
		arrayScale[1]=="meanlog" |
		arrayScale[1]=="medianlog"
	)
	{
		for (i in 1:dim(exprs(eset))[2])
		{
			exprs(eset)[,i] <- exprs(eset)[,i]-chipm[i]
			if(is(eset, "exprReslt"))
			{
				prcfive(eset)[,i] <- prcfive(eset)[,i]-chipm[i]
				prctwfive(eset)[,i] <- prctwfive(eset)[,i]-chipm[i]
				prcfifty(eset)[,i] <- prcfifty(eset)[,i]-chipm[i]
				prcsevfive(eset)[,i] <- prcsevfive(eset)[,i]-chipm[i]
				prcninfive(eset)[,i] <- prcninfive(eset)[,i]-chipm[i]
			}
		}
	}

	# if(arrayScale[1] == "mean")
	# 	E <- log2(sweep(2^E, 2, apply(2^E, 2, mean)))
	# if(arrayScale[1] == "median")
	# 	E <- log2(sweep(2^E, 2, apply(2^E, 2, median)))
	# if(arrayScale[1] == "meanlog")
	# 	E <- sweep(E, 2, apply(E, 2, mean))
	# if(arrayScale[1] == "medianlog")
	# 	E <- sweep(E, 2, apply(E, 2, median))
	E <- exprs(eset)
	# if(!is.null(probesetScale))
	# {
		# E_normd <- matrix(nrow=dim(E)[1], ncol=dim(E)[2])
		if(probesetScale[1]=="mean")
		{
			for(repl in replicates)
				E[,repl] <- sweep(E[,repl], 1, apply(E[,repl], 1, mean))
		}
		if(probesetScale[1]=="median")
		{
			for(repl in replicates)
				E[,repl] <- sweep(E[,repl], 1, apply(E[,repl], 1, median))
		}
		exprs(eset) <- E
	# }
	if(!is.null(probesetNormalisation))
	{
		assayDataElement(eset,"se.exprs") <- sqrt(
			t(
				apply(
					cbind(
						exprs(eset)
					,	assayDataElement(eset,"se.exprs")^2
					)
				,	1
				,	clusterNormVar
				)
			)
		)
		exprs(eset) <- t(apply(exprs(eset), 1, clusterNormE))
	}
	# exprs(eset) <- E
	return(eset)
}


# normalize se.exprs or exprs
# normalize array-level or probeset-level
# normalize value or value and se of value
# normalize to mean or median

pumaPCALikelihoodBound <- function
(
    model
,   expectations
,   varY
,   Y
)
{
    dataDim <- dim(Y)[2]
    numData <- dim(Y)[1]

#    z <- rep(0,numData)
#    s <- rep(0,numData)
#    s1 <- rep(0,numData)
#    s2 <- rep(0,numData)
#    s3 <- matrix(0, numData, dataDim)
#    trxHatCxHatT <- rep(0, numData)
    sigma2 <- model@sigma * model@sigma

#    for (i in 1:numData)
#    {
#        yHat <- Y[i,] - model@mu
#        Binv <- 1/t(sigma2 + varY[i,])
#        z[i] <- -sum(log(Binv))
#        s[i] <- yHat %*% t(Binv * yHat)
#        s1[i] <- expectations@x[i,] %*% t(model@W) %*% t(Binv*yHat)
#		s2[i] <- sum(Binv[] * diag(model@W[,] %*% expectations@xxT[,,i] %*% t(model@W[,])))
#        for (j in 1:dataDim)
#        {
#            s2[i] <- s2[i] + Binv[j] * model@W[j,] %*% expectations@xxT[,,i] %*% model@W[j,]
#        }

#        trxHatCxHatT[i] <- sum(expectations@xxT[,,i] * t(model@Cinv)) - 2 * expectations@x[i,] %*% model@Cinv %*% t(model@m) + model@m %*% model@Cinv %*% t(model@m)
#    }

        yHat <- t(Y) - as.vector(model@mu)
        Binv <- 1/t(sigma2 + varY)
        z <- -sum(log(1/t(sigma2 + varY[,])))
        s <- sum(yHat * ( Binv * yHat))
##        s <- sum(diag(t(yHat) %*% ( Binv * yHat)))
##        s <- sum(diag(t(t(Y[,]) - as.vector(model@mu)) %*% ( (1/t(sigma2 + varY[,])) * (t(Y[,]) - as.vector(model@mu)))))
        s1 <- sum( t( expectations@x[,] %*% t(model@W) ) * (Binv*yHat) )
#        s1 <- sum(diag(expectations@x[,] %*% t(model@W) %*% (Binv*yHat) ) )
        s2 <- 0
        trxHatCxHatT <- as.vector(0)
	    for (i in 1:numData)
    	{
			s2 <- s2 + sum(Binv[,i] * diag(model@W[,] %*% expectations@xxT[,,i] %*% t(model@W[,])))
	        trxHatCxHatT <- trxHatCxHatT + as.vector(sum(expectations@xxT[,,i] * t(model@Cinv)) - 2 * expectations@x[i,] %*% model@Cinv %*% t(model@m) + model@m %*% model@Cinv %*% t(model@m))
		}


#    s2 <- rowSums(s3)
    f <- 0.5 * (z + trxHatCxHatT + s - 2*s1 + s2 - sum(expectations@logDetCov)) - 0.5 * numData * log(det(model@Cinv))
#    f <- f - 0.5 * sum(expectations@logDetCov)
}

PMmmgmos<-function(
	object
,	background=TRUE
,	replaceZeroIntensities=TRUE
,	gsnorm=c("median", "none", "mean", "meanlog")
,	savepar=FALSE
,	eps=1.0e-6
,        addConstant = 0
)
{   
    
       
 	conds <- length(sampleNames(object));
	genes <-length(unique(oligo:::probeNames(object)));
    
   
          probe<-(oligo:::probeNames(object));        
          pm_g<-oligo:::pm(object);
      
          index<-order(probe);
          probe_sort<-probe[index];
          probe<-probe_sort;
          pm_g<-pm_g[index,];
   

  if(conds==1){
    pm_g<-as.matrix(pm_g);
  }
        
	

  if(background==TRUE)
  {
     for (i in c(1:conds))
    {
      m<-min(pm_g[,i])
      pm_g[,i]<-pm_g[,i]-m+1
     
    }
  }

  if (replaceZeroIntensities)
  {
    pm_g[which(pm_g==0)] <- 1
   
  }
  prctiles <- 0.01*c(5, 25, 50, 75, 95);
 
  res <-
 	.Call(
  	  "pmmmgmos_c"
  	 , pm_g
  	 , genes
         , probe
         , prctiles
  	 , length(prctiles)
   	 , savepar
  	 , eps
  	 , PACKAGE="puma"
  	 )
     
     expr <- matrix(res[c(1:genes),],genes,conds);
     se <- matrix(res[c((genes+1):(2*genes)),],genes,conds);
     prc5 <- matrix(res[c((2*genes+1):(3*genes)),],genes,conds)
     prc25 <- matrix(res[c((3*genes+1):(4*genes)),],genes,conds)
     prc50 <- matrix(res[c((4*genes+1):(5*genes)),],genes,conds)
     prc75 <- matrix(res[c((5*genes+1):(6*genes)),],genes,conds)
     prc95 <- matrix(res[c((6*genes+1):(7*genes)),],genes,conds)
  
    rm(res)
   if (gsnorm[1]=="mean")
   {
     expr <- as.data.frame(2^expr)
    
     chipm <- apply(expr,2,mean)
     chipm <- chipm/chipm[1]

     expr <- as.matrix(log2(expr))
   
    for (i in 1:conds)
    {
      expr[,i] <- expr[,i]-log2(chipm[i])
      prc5[,i] <- prc5[,i]-log2(chipm[i])
      prc25[,i] <- prc25[,i]-log2(chipm[i])
      prc50[,i] <- prc50[,i]-log2(chipm[i])
      prc75[,i] <- prc75[,i]-log2(chipm[i])
      prc95[,i] <- prc95[,i]-log2(chipm[i])
    }
  }
  else if (gsnorm[1]=="median")
  {
     expr <- as.data.frame(2^expr)
    
     chipm <- apply(expr,2,median)
     chipm <- chipm/chipm[1]

     expr <- as.matrix(log2(expr))
    for (i in 1:conds)
    {
      expr[,i] <- expr[,i]-log2(chipm[i])
      prc5[,i] <- prc5[,i]-log2(chipm[i])
      prc25[,i] <- prc25[,i]-log2(chipm[i])
      prc50[,i] <- prc50[,i]-log2(chipm[i])
      prc75[,i] <- prc75[,i]-log2(chipm[i])
      prc95[,i] <- prc95[,i]-log2(chipm[i])
    }
  }
  else if (gsnorm[1]=="meanlog")
  {
    chipm <- apply(expr,2,mean)
    chipm <- chipm-chipm[1]

    for (i in 1:conds)
    {
      expr[,i] <- expr[,i]-chipm[i]
      prc5[,i] <- prc5[,i]-chipm[i]
      prc25[,i] <- prc25[,i]-chipm[i]
      prc50[,i] <- prc50[,i]-chipm[i]
      prc75[,i] <- prc75[,i]-chipm[i]
      prc95[,i] <- prc95[,i]-chipm[i]
    }
  }
   
   probe_names<-unique(probe);
   rownames(expr) <- probe_names
   colnames(expr) <- sampleNames(object)
   rownames(se) <- probe_names
   colnames(se) <- sampleNames(object)
   rownames(prc5) <- probe_names
   colnames(prc5) <- sampleNames(object)
   rownames(prc25) <- probe_names
   colnames(prc25) <- sampleNames(object)
   rownames(prc50) <- probe_names
   colnames(prc50) <- sampleNames(object)
   rownames(prc75) <- probe_names
   colnames(prc75) <- sampleNames(object)
   rownames(prc95) <- probe_names
   colnames(prc95) <- sampleNames(object)


    phenodata <- phenoData(object)
    annotation <- annotation(object)
    escription <- description(object)
  #notes <- notes(object)
	
    return_exprReslt <- new(
		"exprReslt"
	,	exprs=log2((2^expr)+addConstant)
	,	se.exprs=se
 	,	phenoData = new(
			"AnnotatedDataFrame"
		,	data=pData(object)
		,	varMetadata=data.frame(labelDescription=varLabels(phenoData(object)))
		)
	# , notes=notes
	)
       
          prcfive(return_exprReslt) <- prc5
	prctwfive(return_exprReslt) <- prc25
          
          prcfifty(return_exprReslt) <- prc50
	prcsevfive(return_exprReslt) <- prc75
	prcninfive(return_exprReslt) <- prc95
	#phenoData(return_exprReslt) <- phenoData(object)
	#pData(return_exprReslt) <- pData(object)
    
     annotation(return_exprReslt) <- annotation(object)
     description(return_exprReslt) <- description(object)
     notes(return_exprReslt) <- notes(object)
     rm(object);
     return_exprReslt
     
     ##write.table(se,'ddd.txt',quote=FALSE,sep='\t',row.names=FALSE,col.name=FALSE);

}

"pumaClustii" <-function(e=NULL, se=NULL, efile=NULL, sefile=NULL, 
                       subset=NULL, gsnorm=FALSE, mincls, maxcls, 
                       conds, reps,  
                       verbose=FALSE,
                       eps=1.0e-5, del0=0.01)
{
  if (length(e)==0)
  {
    e <- read.csv(efile,check.names=FALSE,row.names=1)
  }
  
  dim_e <- dim(e)
  genes <- dim_e[1]
  chips <- dim_e[2]

  if (length(se)==0 & length(sefile)>0)
  {
    se <- read.csv(sefile,check.names=FALSE,row.names=1)
    se <- se^2
    m <- 1; 
  } 
  else
  {
    if (length(se)==0 & length(sefile)==0)
    {
      se <- matrix(0, genes, chips)
      m <- 0;  
    }
    else
    {
      se <- se^2
      m <- 1;
    }
  }

  if(gsnorm==TRUE)
    e<-normalisation.gs(e)
 
  if (length(subset)>0)
  {
    e <- e[subset,]
    se<- se[subset,]
    dim_e <- dim(e)
    genes <- dim_e[1]
    chips <- dim_e[2]
  }

  if (m==1)
  {
    se <- t(apply(cbind(e,se), 1, clusterNormVar))
  }
  e <- t(apply(e, 1, clusterNormE))
  ee<-matrix(0,genes,conds)
  for (i in 1:conds)
  {
  	ind<-which(reps==i)
  	if (length(ind)==1)
  	  ee[,i]<-e[,i]
  	else
      ee[,i]<-t(apply(e[,ind],1,mean))
  }

  
  cl<-Mclust(ee,G=maxcls) 
  centers <- matrix(0,maxcls,conds)
  clsig <- matrix(0,maxcls,conds)
  for (i in 1:maxcls)
  {
    if (length(which(cl$classification==i))<1)
       stop("please specify a smaller maxcls")
       
    centers[i,] <- apply(ee[which(cl$classification==i),],2,mean)
    clsig[i,]<-diag(cov(ee[which(cl$classification==i),]))

  }

  res<-.Call("pumaclustii_c", as.matrix(e), as.matrix(se),conds,reps, mincls, maxcls, as.matrix(centers), as.matrix(clsig), verbose, eps, del0, PACKAGE="puma")
  
  names(res[[1]]) <- rownames(e)
  colnames(res[[2]]) <- paste(1:conds)
  rownames(res[[2]]) <- paste(1:res[[5]])
  colnames(res[[3]]) <- paste(1:conds)
  rownames(res[[3]]) <- paste(1:res[[5]])
  rownames(res[[4]]) <- rownames(e)
  colnames(res[[4]]) <- paste(1:res[[5]])

  return(list(cluster=res[[1]], centers=res[[2]], centersigs=res[[3]], likelipergene=res[[4]], optK=res[[5]], optF=res[[6]]))
}

calculateLimma <- function (
	eset
,	design.matrix = createDesignMatrix(eset)
,	contrast.matrix = createContrastMatrix(eset)
)
{
	require(limma)
	
	numOfGenes <- length(featureNames(eset))
	numOfContrasts <- dim(contrast.matrix)[2]
	fit <- lmFit(eset, design.matrix)
	fit2 <- contrasts.fit(fit, contrast.matrix)
	fit2 <- eBayes(fit2)
	p.value <- fit2$p.value
	fold.change <- fit2$coefficients
	new("DEResult", statistic=p.value, FC=fold.change
	, statisticDescription="limma p.value", DEMethod="calculateLimma")
}

calculateFC <- function (
	eset
,	design.matrix = createDesignMatrix(eset)
,	contrast.matrix = createContrastMatrix(eset)
)
{
	p <- matrix(0, dim(exprs(eset))[1], dim(contrast.matrix)[2]
	, dimnames=list(rownames(exprs(eset)), colnames(contrast.matrix)))
    fold.change <- matrix(0, dim(exprs(eset))[1], dim(contrast.matrix)[2]
	, dimnames=list(rownames(exprs(eset)), colnames(contrast.matrix)))
    for(i in 1:dim(contrast.matrix)[2])
	{
		plus_contrasts <- which(contrast.matrix[,i]==1)
		minus_contrasts <- which(contrast.matrix[,i]==-1)
		plus_arrays <- as.matrix(
			which(design.matrix[,plus_contrasts]==1,arr.ind=TRUE))[,1]
		minus_arrays <- as.matrix(
			which(design.matrix[,minus_contrasts]==1,arr.ind=TRUE))[,1]
		fold.change[,i] <-	rowMeans(as.matrix(exprs(eset)[,plus_arrays])) -
			rowMeans(as.matrix(exprs(eset)[,minus_arrays]))
	}
	p <- abs(fold.change)
	new("DEResult", statistic=p, FC=fold.change
	, statisticDescription="abs(fold change)", DEMethod="calculateFC")
}

calculateTtest <- function (
	eset
,	design.matrix = createDesignMatrix(eset)
,	contrast.matrix = createContrastMatrix(eset)
)
{
    p <- matrix(0, dim(exprs(eset))[1], dim(contrast.matrix)[2]
	, dimnames=list(rownames(exprs(eset)), colnames(contrast.matrix)))
    fold.change <- matrix(0, dim(exprs(eset))[1], dim(contrast.matrix)[2]
	, dimnames=list(rownames(exprs(eset)), colnames(contrast.matrix)))
    for(i in 1:dim(contrast.matrix)[2])
	{
		plus_contrasts <- which(contrast.matrix[,i]==1)
		minus_contrasts <- which(contrast.matrix[,i]==-1)
		plus_arrays <- as.matrix(which(design.matrix[,plus_contrasts]==1,arr.ind=TRUE))[,1]
		minus_arrays <- as.matrix(which(design.matrix[,minus_contrasts]==1,arr.ind=TRUE))[,1]
		p[,i] <- apply( exprs(eset), 1
		,	function(x) t.test(x[plus_arrays],x[minus_arrays])$p.value)
		fold.change[,i] <-	rowMeans(as.matrix(exprs(eset)[,plus_arrays])) -
			rowMeans(as.matrix(exprs(eset)[,minus_arrays]))
	}
	new("DEResult", statistic=p, FC=fold.change
	, statisticDescription="T-test p.value", DEMethod="calculateTtest")
}

plotErrorBars <- function(
	eset
,	probesets = if(dim(exprs(eset))[1] <= 12) 1:dim(exprs(eset))[1] else 1
	# just plot the first probe set if none supplied and more than 12 available
,	arrays = 1:dim(pData(eset))[1] # default is to use all
,	xlab = paste(colnames(pData(eset))[1:numOfFactorsToUse(eset)], collapse=":")
,	ylab = "Expression Estimate"
,	xLabels = apply(
                  as.matrix(pData(eset)[arrays,1:numOfFactorsToUse(eset)])
                , 1
                , function(mat){paste(mat, collapse=":")}
                )
,	ylim = NA
,	numOfSEs = qnorm(0.975)
,	globalYlim = FALSE # Not yet implemented!
,	plot_cols = NA
,	plot_rows = NA
,	featureNames = NA
,	showGeneNames = FALSE
# ,	showGeneNames = if(length(featureNames)==1 & is.na(featureNames[1]))
# 		FALSE else TRUE
,	showErrorBars = if(
					length(assayDataElement(eset,"se.exprs"))==0 ||
					length(assayDataElement(eset,"se.exprs")) == sum(is.na(assayDataElement(eset,"se.exprs")))
					) FALSE else TRUE
,	plotColours = FALSE
,	log.it = if(max(exprs(eset)) > 32) TRUE else FALSE
,	eset_comb = NULL
,	jitterWidth = NA
,	qtpcrData = NULL
, ...
)
{
  if(!is.na(featureNames[1]))
  {
    geneRowNumber <- function(geneName) {which(featureNames(eset)==geneName)}
    probesets <- sapply(featureNames,geneRowNumber)
  }
  cols = rep(1,length(sampleNames(eset)))
  multiplier <- 1
  for(i in 1:numOfFactorsToUse(eset))
  { levelValues <- unclass(as.factor(pData(eset)[,i])) - 1
    cols <- cols + levelValues * multiplier
    levels <- length(levels(pData(eset)[,i]))
    multiplier <- multiplier * levels
  }
  # palette(rainbow(multiplier))
  # palette(rainbow(5))
  if(is.na(plot_cols)&is.na(plot_rows))
  { plot_cols <- ceiling(sqrt(length(probesets))) }
  if(is.na(plot_cols)&!is.na(plot_rows))
  { plot_cols <- ceiling(length(probesets)/plot_rows) }
  if(is.na(plot_rows))
  { plot_rows <- ceiling(length(probesets)/plot_cols) }
  par(mfrow=c(plot_rows, plot_cols))
  for(i in probesets)
  {
    if(log.it)
	    expvals <- log2(exprs(eset)[i, arrays])
    else
	    expvals <- exprs(eset)[i, arrays]
	if(length(assayDataElement(eset,"se.exprs"))==0)
	{
		se_expvals <- expvals
		se_expvals[] <- 0
    }
	else
	{	
		se_expvals <- assayDataElement(eset,"se.exprs")[i, arrays]
    	se_expvals[which(is.na(se_expvals))] <- 0
	}
	if(numOfFactorsToUse(eset) == 1)
	{
		xValues <- unclass(pData(eset)[arrays,1])
		# xLabels <- xValues
		# xValuesForAxis <- xValues
	}
	else
		xValues <- cols
	xJitters <- rep(0,length(xValues))
	jitterCount <- 1
	for(levelCount in unique(xValues))
	{
		numInLevel <- sum(xValues==levelCount)
		if(is.null(eset_comb))
		{
			tempOffsets <- seq(
				-((numInLevel-1)/2)
			,	(numInLevel-1)/2
			)
		}
		else
		{
			if(even(numInLevel))
			{
				tempOffsets <- seq(
					-((numInLevel)/2)
				,	(numInLevel)/2
				)[-((numInLevel/2)+1)]
			}
			if(odd(numInLevel))
			{
				tempOffsets <- seq(
					-((numInLevel-1)/2)
				,	(numInLevel+1)/2
				)[-((numInLevel+1)/2)]
			}
		}
		xJitters[jitterCount:(jitterCount+(numInLevel-1))] <- tempOffsets
		jitterCount <- jitterCount + numInLevel
	}
	if(is.na(jitterWidth))
		jitterWidth <- (as.numeric(max(xValues)) - as.numeric(min(xValues)))/100
	xValuesJittered <- as.numeric(xValues) + (xJitters * jitterWidth)
	# xValues <- rep(1:5,each=3)
	# xValues <- 1:length(arrays)
    plot(
      xValuesJittered
    , expvals
    , axes = FALSE
    , pch = cols[arrays]
	, type = "p"
#    , cex = 1.5
    , col = if(plotColours[1]) plotColours else cols[arrays]
    , xlab = xlab
    , ylab = ylab
    , ylim =  if(is.na(ylim[1]))
			{
				c(
					min(expvals-numOfSEs*se_expvals)
				,	max(expvals+numOfSEs*se_expvals)
				)
			}
              else
              ylim
    , ...
    )
    if(showErrorBars)
	{
		arrows(
		  xValuesJittered
		, expvals[1:length(arrays)]
		, xValuesJittered
		, expvals[1:length(arrays)] + numOfSEs*se_expvals[1:length(arrays)]
		, angle = 90
		, length = 0.05
		, col = if(plotColours[1]) plotColours else cols[arrays]
		, ...
		)
		arrows(
		  xValuesJittered
		, expvals[1:length(arrays)]
		, xValuesJittered
		, expvals[1:length(arrays)] - numOfSEs*se_expvals[1:length(arrays)]
		, angle = 90
		, length = 0.05
		, col = if(plotColours[1]) plotColours else cols[arrays]
		, ...
		)
	}
	if(!is.null(eset_comb))
	{
		expvals_comb <- exprs(eset_comb)[i,]
	    se_expvals_comb <- assayDataElement(eset_comb,"se.exprs")[i,]
	    # se_expvals_comb[which(is.na(se_expvals_comb))] <- 0
	    # xValues_comb <- unclass(pData(eset_comb)[,1])
		xValues_comb <- sort(unique(xValues))
		points(
	      xValues_comb
	      # xValues
	    , expvals_comb
	    , pch = cols[arrays]
		, type = "p"
	    # , col = if(plotColours[1]) unique(plotColours) else unique(cols[arrays])
	    , col = if(plotColours[1])
	 				unique(plotColours)
				else
					sort(unique(cols[arrays]))
	    , ...
	    )
		if(numOfFactorsToUse(eset) == 1 & is.numeric(pData(eset)[,1]))
			points(
		     	xValues_comb
		    ,	expvals_comb
		    ,	pch = cols[arrays]
			,	type = "l"
		    ,	col = "black"
			,	lwd=3
		    , ...
		    )
	    if(showErrorBars)
		{
			arrows(
			 	xValues_comb
			,	expvals_comb[1:length(arrays)]
			,	xValues_comb
			,	expvals_comb[1:length(arrays)]
					+ numOfSEs*se_expvals_comb[1:length(arrays)]
			,	angle = 90
			,	length = 0.05
			,	col = if(plotColours[1])
					unique(plotColours)
				else
					sort(unique(cols[arrays]))
			,	lwd = 3
			, ...
			)
			arrows(
			 	xValues_comb
			,	expvals_comb[1:length(arrays)]
			,	xValues_comb
			,	expvals_comb[1:length(arrays)]
					- numOfSEs*se_expvals_comb[1:length(arrays)]
			,	angle = 90
			,	length = 0.05
			,	col = if(plotColours[1])
					unique(plotColours)
				else
					sort(unique(cols[arrays]))
			,	lwd = 3
			, ...
			)
		}
	}
	if(!is.null(qtpcrData))
	{
		points(
	     	qtpcrData[,1]
	    ,	qtpcrData[,2]
	    ,	pch = 1
		,	type = "b"
	    ,	col = "black"
		,	lty=2
	    , ...
	    )
	}

    axis(
      1
    , at = xValues
#    , las = 3
    , labels = xLabels
    , ...
    )
	# axis(1, ...)
	axis(2, ...)
#    FC <- round(
#            mean(expvals[which(pheno_simple$uv[arrays]=="Yes")])
#            -
#            mean(expvals[which(pheno_simple$uv[arrays]=="No")])
#          , 3
#          )
#    title(paste("Probeset ", i, ", log(fold change)=", FC, sep = ""))
    if(showGeneNames)
    {
      title(featureNames(eset[i]))
    }
    else
    {
      title(paste("Probe set number", i, sep = ""))
    }
  }
}

bcomb <-function(e,se,replicates,method=c("map","em"), 
                 gsnorm=FALSE, nsample=1000, eps=1.0e-6)
{

  #e<-read.csv(efile,check.names=FALSE,row.names=1)
  #se<-read.csv(sefile,check.names=FALSE,row.names=1)
  
  dim_e<-dim(e)
  genes<-dim_e[1]
  chips<-dim_e[2]
  conds<-max(replicates)
  
  if(conds<2){
    cat("The number of conditions is too small. It should be at least two.
      Check the input of replicates.\n")
    return();
  }

  if(method=="em")
    m<-1
  else if(method=="map")
    m<-4
  else{
    cat("Unrecognised method:", method, "\n")
    return();
  }
  
  if(gsnorm==TRUE)
    e<-normalisation.gs(e)
  
  se<-se^2
  
  set.seed(123456)
  res<-.Call(
    "bcomb_c"
  , as.matrix(e)
  , as.matrix(se)
  , replicates
  , m
  , conds
  , nsample
  , eps
  , PACKAGE="puma"
  )
  
  out<-matrix(res, genes, 2*conds)
  
  rownames(out)<-rownames(e)
  
  a<-c("M1")
  b<-c("Std1")
  for(i in 2:conds){
    a<-c(a,paste("M",i,sep=""))
    b<-c(b,paste("Std",i,sep=""))
  }
  colnames(out)<-c(a,b)
  
  return(as.data.frame(out))
}

pumaPCAUpdateW <- function
(
    model
,   expectations
,   varY
,   Y
)
{
    dataDim <- dim(Y)[2]
    numData <- dim(Y)[1]
    latentDim <- dim(expectations@x)[2]

    H <- matrix(0,dataDim, latentDim)
    L <- array(0, c(latentDim, latentDim, dataDim))
    W <- matrix(0,dataDim, latentDim)

##    print(sprintf("Time before ifor : %s\n", date()))
    for (i in 1:numData)
    {
        H <- H +    matrix(
                        1 / 
                        ( model@sigma ^ 2 + varY[i,] ) *
                        (Y[i,] - model@mu)
                    ) %*%
                    expectations@x[i,]
        for (j in 1:dataDim)
        {
            L[,,j] <- L[,,j] + (1/(model@sigma^2 + varY[i, j])) *
                                 expectations@xxT[,,i]
        }
    }
##    print(sprintf('Time before sum  : %s\n', date()))
    for (j in 1:dataDim)
    {
        W[j,] <- solve(L[,,j],H[j,])
    }
    W
}

pumaPCARemoveRedundancy <- function
(
    model
)
{
    latentDim <- dim(model@W)[2]
    model@mu <- model@mu + model@m %*% t(model@W)
    Cmatrix <- model@W %*% solve(model@Cinv) %*% t(model@W)
    Cmatrix <- Cmatrix/2 + t(Cmatrix)/2
    eigenC <- eigen(Cmatrix)
    U <- eigenC$vectors
    V <- abs(eigenC$values)
##  V = diag(V)
##  [V, index] = sort(V);
##  index = index(end:-1:1);
##  V = V(end:-1:1);
##  U = U(:, index);

    oldW <- model@W
    model@W <- U[, 1:latentDim] %*% diag(sqrt(V[1:latentDim]))
    for(i in 1:dim(model@W)[2])
    {
        if(dist(rbind(model@W[,i],oldW[,i]))
            >
            dist(rbind(model@W[,i],-oldW[,i]))
        )
        {
            model@W[,i] <- -model@W[,i]
        }
    }
    model@Cinv <- diag(dim(model@Cinv)[1])
    model@m <- matrix(0,1,dim(model@m)[2])

    model
}

orig_pplr <-function(e, control, experiment){

  dim_e<-dim(e)
  genes<-dim_e[1]
  conds<-dim_e[2]/2
  
  res<-matrix(0,genes,9)
  res[,2]<-e[,control]
  res[,3]<-e[,experiment]
  res[,4]<-e[,conds+control]
  res[,5]<-e[,conds+experiment]
  res[,6]<-e[,experiment]-e[,control]
  res[,7]<-sqrt(e[,conds+control]^2+e[,conds+experiment]^2)
  res[,8]<--res[,6]/(res[,7]*sqrt(2))
  res[,9]<-erfc(res[,8])/2
  
  sortout<-sort(res[,8],method="quick",index.return=TRUE)
  
  res[,c(2:9)]<-res[sortout$ix,c(2:9)]
  res[,1]<-sortout$ix
  
  colnames(res)<-c("index","cM","sM","cStd","sStd","LRM","LRStd","stat","PPLR")
  rownames(res)<-rownames(e)[sortout$ix]
   
  return(as.data.frame(res)  )
}

erfc <- function(x) 2 * pnorm(x * sqrt(2), lower.tail=FALSE)

normalisation.gs <-function(x)
{
  x<-as.data.frame(2^x)
  d<-dim(x)
  c<-d[2]
  m<-sapply(x, mean)
  # m<-mean(x)
  m<-m/m[1]
  
  for(i in 2:c)
    x[[i]]<-x[[i]]/m[i]
  x<-log2(x)  
  
  return(x)
}

pumaPCA <- function
(
    eset
,   latentDim           = 	if(dim(exprs(eset))[2] <= 3)
 								dim(exprs(eset))[[2]]-1
							else
								3
,   sampleSize          =	if(dim(exprs(eset))[1] <= 1000)
								 dim(exprs(eset))[[1]]
							else
								1000	## Set to integer or FALSE for all
,   initPCA             =	TRUE	## Initialise parameters with PCA
,   randomOrder         =	FALSE	## Update parameters in random order
,   optimMethod         =	"BFGS"  ## ?optim for details of methods
,   stoppingCriterion   =	"deltaW"## can also be "deltaL"
,   tol                 =	1e-3	## Stop when delta update < this
,   stepChecks          =	FALSE	## Check likelihood after each update?
,   iterationNumbers    =	TRUE	## Show iteration numbers?
,   showUpdates         =	FALSE	## Show values after each update?
,   showTimings         =	FALSE	## Show timings after each update?
,   showPlot            =	FALSE	## Show projection plot after each update?
,   maxIters            =	500		## Number of EM iterations.
,   transposeData       =	FALSE	## Transpose eset matrices?
,   returnExpectations  =	FALSE
,   returnData          =	FALSE
,   returnFeedback      =	FALSE
,	pumaNormalize		=	TRUE
)
{
    if(pumaNormalize)
	{
		eset <- pumaNormalize(
			eset
		,	arrayScale="median"
		,	probesetScale="median"
		)
	}
	if(sampleSize)
    {
		sampleY <- sample(dim(exprs(eset))[1], sampleSize)
		Y <- exprs(eset)[sampleY, ]
		varY <- assayDataElement(eset,"se.exprs")[sampleY, ]
    }
    else
    {
		Y <- exprs(eset)
		varY <- assayDataElement(eset,"se.exprs")
    }
    
    if(transposeData)
    {
        Y <- t(Y)
        varY <- t(varY)
    }

    model <- new("pumaPCAModel")
	# model <- list()
    expectations <- new("pumaPCAExpectations")
    # expectations <- list()
    
    numData <- dim(Y)[1]
    dataDim <- dim(Y)[2]
    
    ##  Initialise the model
    if (initPCA)
    {
        avgVarY     <-  colMeans(varY)
        ## scale the rows to transform FA to PCA
        scaledY     <-  t(solve(diag(sqrt(avgVarY)),t(Y)))
        pca         <-  prcomp(scaledY)
        model@sigma <-  sqrt(mean(pca$sdev[(latentDim + 1):dataDim] ^ 2))
        model@m     <-  matrix(0, 1, latentDim)
        model@Cinv  <-  diag(latentDim)
        model@W     <-  diag(sqrt(avgVarY)) %*%
                        (   pca$rotation[, 1:latentDim] %*%
                            diag(
                                sqrt(
                                    pca$sdev[1:latentDim] ^ 2 - model@sigma ^ 2
                                )
                            )
                        )
        ## initialise mean to weighted mean
        weightedY <- matrix(0, numData, dataDim)
        for (i in 1:numData)
        {
            weightedY[i, ] <- varY[i, ] * Y[i, ]
        }
        model@mu <- matrix(
                        solve(
                            diag(colSums(varY))
                        ,   colSums(weightedY)
                        )
                    ,   1
                    ,   dataDim
                    )
    }
    else
    {
    precYPlusSigma <- 1/varY
    model@mu <- matrix(
                    colSums(
                        (Y * (1/varY))
                        /
                        rep(colSums(1/varY),each=numData)
                    )
                ,   1
                ,   dataDim
                )
    model@sigma <-  mean
                    (
                        colSums
                        (
                            (
                                (Y - rep(model@mu, each=numData)) ^ 2
                                *
                                (1 / varY)
                            )
                            /
                            colSums(1 / varY)
                        )
                        /
                        colSums(1 / varY)
                    )
    model@W <- matrix(rnorm(dataDim * latentDim) * 0.1, dataDim, latentDim)
    ##model@W <- matrix(0.1, dataDim, latentDim)
    model@m <- matrix(0, 1, latentDim)
    model@Cinv <- diag(latentDim)
    }
    
    ##  Initialise the expectations
    expectations@x <- matrix(0, numData, latentDim)
    expectations@xxT <- array(0, c(latentDim, latentDim, numData))
    expectations <- pumaPCAEstep(model, expectations, varY, Y)
    
    ##  Compute the starting likelihood.
    maxDeltaL <- 1
    deltaW <- 1
    counter <- 0
    params <- c('mu', 'W', 'sigma', 'estep')
    oldL <- pumaPCALikelihoodBound(model, expectations, varY, Y)
    likelihoodHistory <- list()
    timingHistory <- list()
    modelHistory <- list()
    exitReason <- "unknown exit reason"
    if(stoppingCriterion=="deltaL")
    {
        exitReason <- sprintf(
            'Update of Likelihood less than tolerance %f'
        ,   tol
        )
    }
    else if(stoppingCriterion=="deltaW")
    {
        exitReason <- sprintf(
            'Update of W less than tolerance %f'
        ,   tol
        )
    }
    
    timeToCompute <- system.time(
    {
    tryCatch(
    {
        while (
            (   ( stoppingCriterion == "deltaL" & maxDeltaL > tol ) |
                ( stoppingCriterion == "deltaW" & deltaW > tol )
            )
            &   counter < maxIters
        )
        {
            maxDeltaL <- 0
            counter <- counter + 1
            if(randomOrder) { params <- sample(params) }
            for (param in params)
            {
                if (param == 'mu')
                {
                    model@m <- pumaPCAUpdateM(model, expectations, varY, Y)
                    model@mu <- pumaPCAUpdateMu(model, expectations, varY, Y)
                }
                else if (param == 'W')
                {
                    model@Cinv <-   pumaPCAUpdateCinv(
                                        model
                                    ,   expectations
                                    ,   varY
                                    ,   Y
                                    )
                    model@W <- pumaPCAUpdateW(model, expectations, varY, Y)
                    modelHistory[[counter]] <- model@W
                    if (counter > 1)
                    {
                        deltaW <-   matrixDistance(
                                        model@W[,1:2]
                                    ,   modelHistory[[counter-1]][,1:2]
                                    )
                        if(showUpdates)
							cat(sprintf('Movement in W %s\n', deltaW))
                    }
                
                }
                else if (param == 'sigma')
                {
                    if(
                        optimMethod == "optimise"
                        |
                        optimMethod == "optimize"
                    )
                    {
                         model@sigma <- optimise(
                                            function(sigma)
                                            pumaPCASigmaObjective
                                            (
                                                sigma
                                            ,   model
                                            ,   expectations
                                            ,   varY
                                            ,   Y
                                            )
                                        ,   c(0, model@sigma)
                                        ,   tol=1e-12
                                        )$minimum
                     }
                     else if (optimMethod == "newton")
                     {
                        model@sigma <-  pumaPCANewtonUpdateLogSigma(
                                            model
                                        ,   expectations
                                        ,   varY
                                        ,   Y
                                        )
                     }
                     else if (optimMethod == "0")
                     {
                        model@sigma <- 0
                     }
                     else
                     {
                        optimOutput <- optim(
                                            par=model@sigma
                                        ,   fn=pumaPCASigmaObjective
                                        ,   gr=pumaPCASigmaGradient
                                        ,   method=optimMethod
                                        ,   model=model
                                        ,   expectations=expectations
                                        ,   varY=varY
                                        ,   Y=Y
                                        )
                        model@sigma <- optimOutput$par
                        if(showUpdates)
							cat(optimOutput$counts, "\n")
                    }
                }
                else if (param == 'estep')
                {
                    model <- pumaPCARemoveRedundancy(model)
                    expectations <- pumaPCAEstep(model, expectations, varY, Y)
                }
                if (stepChecks)
                {
    
                    deltaLoldL <-   pumaPCALikelihoodCheck(
                                        model
                                    ,   expectations
                                    ,   varY
                                    ,   Y
                                    ,   oldL
                                    ,   i
									,	stepChecks
                                    )
                    deltaL <- deltaLoldL[[1]]
                    oldL <- deltaLoldL[[2]]
                    maxDeltaL <- max(maxDeltaL, deltaL)
                    likelihoodHistory[[param]][counter] <- deltaL
                }
                timingHistory[[param]][counter] <- date()
                if (showTimings)
                {
                    cat(sprintf('%s after update of %s\n', date(), param))
                }
                if (showPlot)
                {
                    par(mfcol=c(1,2))
                    plot(
                        x   =   model@W[,1]
                    ,   y   =   model@W[,2]
                    ,   pch =   unclass(
							as.factor(
			 					apply(
			 						as.matrix(pData(eset))
			 					,	1
			 					,	function(items) paste(items, collapse=".")
			 					)
			 				)
						)
                    )
                    plot(
                        x   =   model@W[,1]
                    ,   y   =   model@W[,3]
                    ,   pch =   unclass(
							as.factor(
			 					apply(
			 						as.matrix(pData(eset))
			 					,	1
			 					,	function(items) paste(items, collapse=".")
			 					)
			 				)
						)
                    )
                }
            }
            if (!stepChecks)
            {
                deltaLoldL <-   pumaPCALikelihoodCheck(
                                    model
                                ,   expectations
                                ,   varY
                                ,   Y
                                ,   oldL
                                ,   param
								,	stepChecks
                                )
                maxDeltaL <- deltaLoldL[[1]]
                oldL <- deltaLoldL[[2]]
                likelihoodHistory[["estep"]][counter] <- maxDeltaL
            }
    
            if (iterationNumbers)
            {
                cat(sprintf('Iteration number: %d\n', counter))
            }
        }
    }
    ,   interrupt = function(interrupt)
        {
            cat("User interrupt!\n")
            exitReason <<- "User interrupt"
        }
    )
    }
    )[3]
    if (counter >= maxIters)
    {
        cat(sprintf('Warning maximum iterations exceeded.\n'))
        exitReason <- "Iterations exceeded"
    }
    model <- pumaPCARemoveRedundancy(model)
    expectations <- pumaPCAEstep(model, expectations, varY, Y)
	new(
		"pumaPCARes"
    ,   model               = model
    ,   expectations        = if(returnExpectations) expectations
								else new("pumaPCAExpectations")
    ,   varY                = if(returnData) varY else matrix()
    ,   Y                   = if(returnData) Y else matrix()
	,	phenoData			= phenoData(eset)
    ,   timeToCompute       = if(returnFeedback) timeToCompute else 0
    ,   numberOfIterations  = if(returnFeedback) counter else 0
    ,   likelihoodHistory   = if(returnFeedback) likelihoodHistory else list()
    ,   timingHistory       = if(returnFeedback) timingHistory else list()
    ,   modelHistory        = if(returnFeedback) modelHistory else list()
    ,   exitReason          = if(returnFeedback) exitReason else ""
    )
}

pumaDE <- function (
	eset
,	design.matrix = createDesignMatrix(eset)
,	contrast.matrix = createContrastMatrix(eset)
)
{
	p <- matrix(0, dim(exprs(eset))[1], dim(contrast.matrix)[2]
	,	dimnames=list(rownames(exprs(eset)), colnames(contrast.matrix)))
	fold.change <- matrix(0, dim(exprs(eset))[1], dim(contrast.matrix)[2]
	,	dimnames=list(rownames(exprs(eset)), colnames(contrast.matrix)))
	for(i in 1:dim(contrast.matrix)[2])
	{
		plus_contrasts <- which(contrast.matrix[,i]==1)
		minus_contrasts <- which(contrast.matrix[,i]==-1)
		p[,i] <- pplr(
	    	cbind(exprs(eset), assayDataElement(eset,"se.exprs"))
	    ,	as.matrix(which(design.matrix[,minus_contrasts]==1,arr.ind=TRUE))[,1]
	    ,	as.matrix(which(design.matrix[,plus_contrasts]==1,arr.ind=TRUE))[,1]
		,	sorted=FALSE
	    )[,9]
		plus_arrays <- as.matrix(
			which(design.matrix[,plus_contrasts]==1,arr.ind=TRUE))[,1]
		minus_arrays <- as.matrix(
			which(design.matrix[,minus_contrasts]==1,arr.ind=TRUE))[,1]
		fold.change[,i] <-	rowMeans(log2((2^as.matrix(exprs(eset)[,plus_arrays]))+1)) -
			rowMeans(log2((2^as.matrix(exprs(eset)[,minus_arrays]))+1))
	}
	new("DEResult", statistic=p
	,	statisticDescription="Probability of Positive Log Ratio (PPLR)"
	,	FC=fold.change
	,	DEMethod="pumaDE")
}

pumaDEUnsorted <- function (
	pp
)
{
	p <- matrix(0,dim(pp[[1]])[1], dim(pp[[1]])[2])
	for(i in 1:dim(pp[[1]])[2])
	{
		sortpumaDE <- sort(pp[[2]][,i], method="quick", index.return=TRUE)[[2]]
		p[,i] <- pp[[1]][sortpumaDE,i]
	}
	return(p)
}

pplrUnsorted <- function (
	p
)
{
	sortPplr <- sort(p[,1], method="quick", index.return=TRUE)[[2]]
	pSorted <- p[,9][sortPplr]
	names(pSorted) <- rownames(p[sortPplr,])
	return(pSorted)
}

hcomb <-function(e,se,replicates, max_num=c(200,500,1000),gsnorm=FALSE,  eps=1.0e-6)
{

  dim_e<-dim(e)
  genes<-dim_e[1]
  chips<-dim_e[2]
  conds<-max(replicates)
  
  if(conds<2){
    cat("The number of conditions is too small. It should be at least two. Check the input of replicates.\n")
    return();
  }

  if(gsnorm==TRUE)
    e<-normalisation.gs(e)
  
  se<-se^2
         
  set.seed(123456)
  res<-.Call("hcomb_c", as.matrix(e), as.matrix(se), replicates,conds, max_num, eps, PACKAGE="puma")
  
  out<-matrix(res, genes, 2*conds)
  
  rownames(out)<-rownames(e)
  
  a<-c("M1")
  b<-c("Std1")
  for(i in 2:conds){
    a<-c(a,paste("M",i,sep=""))
    b<-c(b,paste("Std",i,sep=""))
  }
  colnames(out)<-c(a,b)
  
  return(as.data.frame(out))
}

plotHistTwoClasses <- function (
	scores			# A set of scores (e.g. output of pplr function)
,	class1Elements	# Logical vector, TRUE if element is in first class
,	class2Elements	# Logical vector, TRUE if element is in second class
,	space=0			# no space between bars
,	col=c("white", "grey40")
,	xlab="PPLR"
,	ylab="Number of genes"
# ,	ylim=c(0, 5000)
,	ylim=NULL
,	las=0 # axis labels all perpendicular to axes
,	legend=c("non-spike-in genes", "spike-in genes")
,	inset=0.05
,	minScore=0
,	maxScore=1
,	numOfBars=20
,	main=NULL
)
{
	class1Bars <- hist(
						scores[class1Elements]
					,	breaks=seq(
							minScore
						,	maxScore
						,	(maxScore-minScore)/numOfBars
						)
					,	plot=FALSE
					)
	class2Bars <- hist(
						scores[class2Elements]
					,	breaks=seq(
							minScore
						,	maxScore
						,	(maxScore-minScore)/numOfBars
						)
					,	plot=FALSE
					)
	barsToPlot <- rbind(class2Bars$counts, class1Bars$counts)
	barplot(
		barsToPlot
	,	space=space
	,	col=col
	,	xlab=xlab
	,	ylab=ylab
	,	ylim=ylim
	,	main=main
	)
	axis(1, at=0:numOfBars, labels=class1Bars$breaks)
	box()
	legend(
		"topright"
	,	legend=legend
	,	fill=col
	,	inset=inset
	)
}

plotWhiskers <- function (
	eset
,	comparisons=c(1,2)
,	sortMethod = c("logRatio", "PPLR")
,	numGenes=50
,	xlim
,	main = "PUMA Whiskers plot"
,	highlightedGenes=NULL
)
{
	if(length(comparisons) != 2)
		stop("Must supply a 2-vector for comparisons (columns to compare)")
	if(max(comparisons) > dim(exprs(eset))[2])
		stop("Maximum comparison must be less than number of samples")
	logRatio <- abs(exprs(eset[,comparisons[1]])-exprs(eset[,comparisons[2]]))
	if(sortMethod[1] == "logRatio")
	{
		sortLogRatio <- sort(logRatio, decreasing=TRUE, method="quick", index.return=TRUE)[[2]]
		topGenes <- sortLogRatio[1:numGenes]
	}
	else
	{
		topGenes <- pumaDE(eset[,comparisons])[[2]][1:numGenes]
	}
	topLogRatio <- logRatio[topGenes]
	topPlotPoints <- cbind(topLogRatio, -1:-numGenes)
	SEs <- sqrt(assayDataElement(eset[,comparisons[1]],"se.exprs")^2 + assayDataElement(eset[,comparisons[2]],"se.exprs")^2)
	topSE <- SEs[topGenes]
	plot(topPlotPoints, xlim=xlim, pch=8, main=main)
	segments(topLogRatio + qnorm(0.05)*topSE, -1:-numGenes, topLogRatio + qnorm(0.95)*topSE, -1:-numGenes)
	topGenesSpikeIn <- which(!is.na(match(topGenes,highlightedGenes)))
	points(topPlotPoints[topGenesSpikeIn,1], topPlotPoints[topGenesSpikeIn,2],pch=22,cex=2)
	abline(v=0)
}

plotROC <- function (
	scoresList
,	truthValues
,	includedProbesets=1:length(truthValues)
,	legendTitles=1:length(scoresList)
,	main = "PUMA ROC plot"
,	lty = 1:length(scoresList)
,	col = rep(1,length(scoresList))
,	lwd = rep(1,length(scoresList))
,	yaxisStat = "tpr"
,	xaxisStat = "fpr"
,	downsampling = 100
,	showLegend = TRUE
,	showAUC = TRUE
,	...
)
{
	require(ROCR)
	
	predictions <- list()
	ROCs <- list()
	AUCs <- list()
	legend <- NULL
	for(i in 1:length(scoresList))
	{
		predictions[[i]] <- prediction(scoresList[[i]][includedProbesets]
			,	truthValues[includedProbesets])
		ROCs[[i]] <- performance(predictions[[i]], yaxisStat, xaxisStat)
		AUCs[[i]] <- performance(predictions[[i]], "auc")@y.values[[1]]
		if(i==1)
			plot(ROCs[[i]], lty=lty[i], main=main, col=col[i], lwd=lwd[i], downsampling=downsampling, ...)
		else
			plot(ROCs[[i]], lty=lty[i], add=TRUE, col=col[i], lwd=lwd[i], downsampling=downsampling, ...)
		if(showAUC)
			legend = c(legend, paste(legendTitles[i],"AUC = ", round(AUCs[[i]],3)))
		if(!showAUC)
			legend = c(legend, paste(legendTitles[i]))
	}
	if(showLegend)
	{
		legend2(
			"bottomright"
		,	legend=legend
		,	lty=lty
		,	col=col
		,	inset=0.05
		,	seg.len=10
		# ,	...
		)
	}
}

calcAUC <- function (
	scores
,	truthValues
,	includedProbesets=1:length(truthValues)
)
{
	require(ROCR)
	
	predictions <- prediction(scores[includedProbesets]
		,	truthValues[includedProbesets])
	AUC <- performance(predictions, "auc")@y.values[[1]]
}

plot.pumaPCARes <- function(
	x
,	...
,	firstComponent=1
,	secondComponent=2
,	useFilenames=FALSE
,	phenotype = pData(x@phenoData)
,	legend1pos = "topright"
,	legend2pos = "bottomright"
)
{
	plot(
		x=x@model@W[,firstComponent]
	,	y=x@model@W[,secondComponent]
	,	type=if(useFilenames) "n" else "p"
	,	xlab=paste("Component", firstComponent)
	,	ylab=paste("Component", secondComponent)
	,	pch=if(dim(phenotype)[2] >= 1)
				unclass(as.factor(phenotype[,1]))
			else 1
	,	col=if(dim(phenotype)[2] >= 2)
				unclass(as.factor(phenotype[,2]))
			else if(dim(phenotype)[2] == 1)
				unclass(as.factor(phenotype[,1]))
			else
				1
	,	...
	)
	if(useFilenames)
		text(
			x=x@model@W[,1]
		,	y=x@model@W[,2]
		,	labels=rownames(phenotype)
		)
    if(dim(phenotype)[2] >= 1)
		legend(
	      x=legend1pos
	    , legend=levels(as.factor(phenotype[,1]))
	    , pch=1:nlevels(as.factor(phenotype[,1]))
		, col=1:nlevels(as.factor(phenotype[,1]))
		, title=colnames(phenotype)[1]
	    )
	if(dim(phenotype)[2] >= 2)
	    legend(
	      x=legend2pos
	    , legend=levels(as.factor(phenotype[,2]))
	    , text.col=1:nlevels(as.factor(phenotype[,2]))
		, title=colnames(phenotype)[2]
	    )
}

legend2 <- function (x, y = NULL, legend, fill = NULL, col = par("col"), 
    lty, lwd, pch, angle = 45, density = NULL, bty = "o", bg = par("bg"), 
    box.lwd = par("lwd"), box.lty = par("lty"), pt.bg = NA, cex = 1, 
    pt.cex = cex, pt.lwd = lwd, xjust = 0, yjust = 1, x.intersp = 1, 
    y.intersp = 1, adj = c(0, 0.5), text.width = NULL, text.col = par("col"), 
    merge = do.lines && has.pch, trace = FALSE, plot = TRUE, 
    ncol = 1, horiz = FALSE, title = NULL, inset = 0, seg.len = 2) 
{
    if (missing(legend) && !missing(y) && (is.character(y) || 
        is.expression(y))) {
        legend <- y
        y <- NULL
    }
    mfill <- !missing(fill) || !missing(density)
    if (length(title) > 1) 
        stop("invalid title")
    n.leg <- if (is.call(legend)) 
        1
    else length(legend)
    if (n.leg == 0) 
        stop("'legend' is of length 0")
    auto <- if (is.character(x)) 
        match.arg(x, c("bottomright", "bottom", "bottomleft", 
            "left", "topleft", "top", "topright", "right", "center"))
    else NA
    if (is.na(auto)) {
        xy <- xy.coords(x, y)
        x <- xy$x
        y <- xy$y
        nx <- length(x)
        if (nx < 1 || nx > 2) 
            stop("invalid coordinate lengths")
    }
    else nx <- 0
    xlog <- par("xlog")
    ylog <- par("ylog")
    rect2 <- function(left, top, dx, dy, density = NULL, angle, 
        ...) {
        r <- left + dx
        if (xlog) {
            left <- 10^left
            r <- 10^r
        }
        b <- top - dy
        if (ylog) {
            top <- 10^top
            b <- 10^b
        }
        rect(left, top, r, b, angle = angle, density = density, 
            ...)
    }
    segments2 <- function(x1, y1, dx, dy, ...) {
        x2 <- x1 + dx
        if (xlog) {
            x1 <- 10^x1
            x2 <- 10^x2
        }
        y2 <- y1 + dy
        if (ylog) {
            y1 <- 10^y1
            y2 <- 10^y2
        }
        segments(x1, y1, x2, y2, ...)
    }
    points2 <- function(x, y, ...) {
        if (xlog) 
            x <- 10^x
        if (ylog) 
            y <- 10^y
        points(x, y, ...)
    }
    text2 <- function(x, y, ...) {
        if (xlog) 
            x <- 10^x
        if (ylog) 
            y <- 10^y
        text(x, y, ...)
    }
    if (trace) 
        catn <- function(...) do.call("cat", c(lapply(list(...), 
            formatC), list("\n")))
    cin <- par("cin")
    Cex <- cex * par("cex")
    if (is.null(text.width)) 
        text.width <- max(abs(strwidth(legend, units = "user", 
            cex = cex)))
    else if (!is.numeric(text.width) || text.width < 0) 
        stop("'text.width' must be numeric, >= 0")
    xc <- Cex * xinch(cin[1], warn.log = FALSE)
    yc <- Cex * yinch(cin[2], warn.log = FALSE)
    if (xc < 0) 
        text.width <- -text.width
    xchar <- xc
    xextra <- 0
    yextra <- yc * (y.intersp - 1)
    ymax <- yc * max(1, strheight(legend, units = "user", cex = cex)/yc)
    ychar <- yextra + ymax
    if (trace) 
        catn("  xchar=", xchar, "; (yextra,ychar)=", c(yextra, 
            ychar))
    if (mfill) {
        xbox <- xc * 0.8
        ybox <- yc * 0.5
        dx.fill <- xbox
    }
    do.lines <- (!missing(lty) && (is.character(lty) || any(lty > 
        0))) || !missing(lwd)
    n.legpercol <- if (horiz) {
        if (ncol != 1) 
            warning("horizontal specification overrides: Number of columns := ", 
                n.leg)
        ncol <- n.leg
        1
    }
    else ceiling(n.leg/ncol)
    if (has.pch <- !missing(pch) && length(pch) > 0) {
        if (is.character(pch) && !is.na(pch[1]) && nchar(pch[1], 
            type = "c") > 1) {
            if (length(pch) > 1) 
                warning("not using pch[2..] since pch[1] has multiple chars")
            np <- nchar(pch[1], type = "c")
            pch <- substr(rep.int(pch[1], np), 1:np, 1:np)
        }
        if (!merge) 
            dx.pch <- x.intersp/2 * xchar
    }
    x.off <- if (merge) 
        -0.7
    else 0
    if (is.na(auto)) {
        if (xlog) 
            x <- log10(x)
        if (ylog) 
            y <- log10(y)
    }
    if (nx == 2) {
        x <- sort(x)
        y <- sort(y)
        left <- x[1]
        top <- y[2]
        w <- diff(x)
        h <- diff(y)
        w0 <- w/ncol
        x <- mean(x)
        y <- mean(y)
        if (missing(xjust)) 
            xjust <- 0.5
        if (missing(yjust)) 
            yjust <- 0.5
    }
    else {
        h <- (n.legpercol + (!is.null(title))) * ychar + yc
        w0 <- text.width + (x.intersp + 1) * xchar
        if (mfill) 
            w0 <- w0 + dx.fill
        if (has.pch && !merge) 
            w0 <- w0 + dx.pch
        if (do.lines) 
            w0 <- w0 + (seg.len + x.off) * xchar
        w <- ncol * w0 + 0.5 * xchar
        if (!is.null(title) && (tw <- strwidth(title, units = "user", 
            cex = cex) + 0.5 * xchar) > w) {
            xextra <- (tw - w)/2
            w <- tw
        }
        if (is.na(auto)) {
            left <- x - xjust * w
            top <- y + (1 - yjust) * h
        }
        else {
            usr <- par("usr")
            inset <- rep(inset, length.out = 2)
            insetx <- inset[1] * (usr[2] - usr[1])
            left <- switch(auto, bottomright = , topright = , 
                right = usr[2] - w - insetx, bottomleft = , left = , 
                topleft = usr[1] + insetx, bottom = , top = , 
                center = (usr[1] + usr[2] - w)/2)
            insety <- inset[2] * (usr[4] - usr[3])
            top <- switch(auto, bottomright = , bottom = , bottomleft = usr[3] + 
                h + insety, topleft = , top = , topright = usr[4] - 
                insety, left = , right = , center = (usr[3] + 
                usr[4] + h)/2)
        }
    }
    if (plot && bty != "n") {
        if (trace) 
            catn("  rect2(", left, ",", top, ", w=", w, ", h=", 
                h, ", ...)", sep = "")
        rect2(left, top, dx = w, dy = h, col = bg, density = NULL, 
            lwd = box.lwd, lty = box.lty)
    }
    xt <- left + xchar + xextra + (w0 * rep.int(0:(ncol - 1), 
        rep.int(n.legpercol, ncol)))[1:n.leg]
    yt <- top - 0.5 * yextra - ymax - (rep.int(1:n.legpercol, 
        ncol)[1:n.leg] - 1 + (!is.null(title))) * ychar
    if (mfill) {
        if (plot) {
            fill <- rep(fill, length.out = n.leg)
            rect2(left = xt, top = yt + ybox/2, dx = xbox, dy = ybox, 
                col = fill, density = density, angle = angle, 
                border = "black")
        }
        xt <- xt + dx.fill
    }
    if (plot && (has.pch || do.lines)) 
        col <- rep(col, length.out = n.leg)
    if (missing(lwd)) 
        lwd <- par("lwd")
    if (do.lines) {
        if (missing(lty)) 
            lty <- 1
        lty <- rep(lty, length.out = n.leg)
        lwd <- rep(lwd, length.out = n.leg)
        ok.l <- !is.na(lty) & (is.character(lty) | lty > 0)
        if (trace) 
            catn("  segments2(", xt[ok.l] + x.off * xchar, ",", 
                yt[ok.l], ", dx=", seg.len * xchar, ", dy=0, ...)")
        if (plot) 
            segments2(xt[ok.l] + x.off * xchar, yt[ok.l], dx = seg.len * 
                xchar, dy = 0, lty = lty[ok.l], lwd = lwd[ok.l], 
                col = col[ok.l])
        xt <- xt + (seg.len + x.off) * xchar
    }
    if (has.pch) {
        pch <- rep(pch, length.out = n.leg)
        pt.bg <- rep(pt.bg, length.out = n.leg)
        pt.cex <- rep(pt.cex, length.out = n.leg)
        pt.lwd <- rep(pt.lwd, length.out = n.leg)
        ok <- !is.na(pch) & (is.character(pch) | pch >= 0)
        x1 <- (if (merge) 
            xt - (seg.len/2) * xchar
        else xt)[ok]
        y1 <- yt[ok]
        if (trace) 
            catn("  points2(", x1, ",", y1, ", pch=", pch[ok], 
                ", ...)")
        if (plot) 
            points2(x1, y1, pch = pch[ok], col = col[ok], cex = pt.cex[ok], 
                bg = pt.bg[ok], lwd = pt.lwd[ok])
        if (!merge) 
            xt <- xt + dx.pch
    }
    xt <- xt + x.intersp * xchar
    if (plot) {
        if (!is.null(title)) 
            text2(left + w/2, top - ymax, labels = title, adj = c(0.5, 
                0), cex = cex, col = text.col)
        text2(xt, yt, labels = legend, adj = adj, cex = cex, 
            col = text.col)
    }
    invisible(list(rect = list(w = w, h = h, left = left, top = top), 
        text = list(x = xt, y = yt)))
}

create_eset_r <- function(eset, r, design.matrix=createDesignMatrix(eset))
{
	numOfFactors <- numOfFactorsToUse(removeUninformativeFactors(eset))
	pData_eset <- as.data.frame(
		as.data.frame(unique(pData(removeUninformativeFactors(eset))[,1:numOfFactors]))[
			apply(unique(design.matrix),2,function(x) which(x==1)),]
		)
	colnames(pData_eset) <- colnames(pData(removeUninformativeFactors(eset)))[1:numOfFactors]
	rownames(pData_eset) <- colnames(design.matrix)
	exprs <- as.matrix(r[,1:(dim(r)[2]/2)])
	se.exprs <- as.matrix(r[,((dim(r)[2]/2)+1):(dim(r)[2])])
	colnames(exprs) <- NULL
	colnames(se.exprs) <- NULL
	eset_r <- new(
		'ExpressionSet'
	,	exprs=exprs
	,	se.exprs=se.exprs
	,	phenoData = new(
			"AnnotatedDataFrame"
		,	data=pData_eset
		,	varMetadata=data.frame(
				labelDescription=varLabels(phenoData(eset))[1:numOfFactors]
			)
				# ,	varMetadata=data.frame(
		# 		matrix(
		# 			varMetadata(eset)[1:numOfFactors,]
		# 		,	dimnames=list(
		# 				rownames(varMetadata(eset))[1:1]
		# 			,	"labelDescription"
		# 			)
		# 		)
		# 	)
		)
	)
  # pData(eset_r) <- pData_eset
	return(eset_r)
}

setClass("pumaPCAModel"
,	representation(
		sigma	=	"numeric"
    ,	m		=	"matrix"
    ,	Cinv	=	"matrix"
    ,	W		=	"matrix"
	,	mu		=	"matrix"
	)
,	prototype(
		sigma	=	0
    ,	m		=	matrix()
    ,	Cinv	=	matrix()
    ,	W		=	matrix()
	,	mu		=	matrix()
	)
)
# setAs("NULL", "pumaPCAModel", function(from, to) new(to))

setClass("pumaPCAExpectations"
,	representation(
		x			=	"matrix"
	,	xxT			=	"array"
	,	logDetCov	=	"numeric"
	)
,	prototype(
		x			=	matrix()
	,	xxT			=	array()
	,	logDetCov	=	0
	)
)
# setAs("NULL", "pumaPCAExpectations", function(from, to) new(to))

setClass("pumaPCARes"
,	representation(
	    model               = "pumaPCAModel"
    ,   expectations        = "pumaPCAExpectations"
    ,   varY                = "matrix"
    ,   Y                   = "matrix"
	,	phenoData			= "AnnotatedDataFrame"
    ,   timeToCompute       = "numeric"
    ,   numberOfIterations  = "numeric"
    ,   likelihoodHistory   = "list"
    ,   timingHistory       = "list"
    ,   modelHistory        = "list"
    ,   exitReason          = "character"
	)
,	prototype(
	    model               = new("pumaPCAModel")
    ,   expectations        = new("pumaPCAExpectations")
    ,   varY                = matrix()
    ,   Y                   = matrix()
	,	phenoData			= new("AnnotatedDataFrame")
    ,   timeToCompute       = 0
    ,   numberOfIterations  = 0
    ,   likelihoodHistory   = list()
    ,   timingHistory       = list()
    ,   modelHistory        = list()
    ,   exitReason          = ""
	)
)
# setAs("NULL", "pumaPCARes", function(from, to) new(to))
# setMethod("plot",signature(x="pumaPCARes",y="missing"),
#           function(x,y,...) {
#               .plot.pumaPCARes(x,...)
#           })

setGeneric("write.reslts", function(x,...) standardGeneric("write.reslts"))

setMethod(
	"write.reslts"
,	signature(x="pumaPCARes")
,	function(
		x
	,	file = "tmp"
	,	append = FALSE
	,	quote = FALSE
	,	sep = ","
	,	eol = "\n"
	,	na = "NA"
	,	dec = "."
	,	row.names = TRUE
	,	col.names = NA
	,	qmethod = c("escape", "double")
	)
	{
		write.table(
			x@model@W
		,	file = paste(file,".csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = rownames(pData(x@phenoData))
		,	col.names = col.names
		,	qmethod = qmethod
		)
	}
)

setClass("DEResult"
,	representation(
		statistic="matrix"
	,	FC="matrix"
	,	statisticDescription="character"
	,	DEMethod="character"
	)
,	prototype(
		statistic=matrix()
	,	FC=matrix()
	,	statisticDescription="unknown"
	,	DEMethod="unknown"
	)
)

setMethod("show", "DEResult",
          function(object) {
            cat("DEResult object:\n")
            cat("  DEMethod = ", object@DEMethod, "\n", sep="")
            cat("  statisticDescription = ", object@statisticDescription, "\n", sep="")
            cat("  statistic =", nrow(object@statistic), "probesets x", ncol(object@statistic), "contrasts\n")
          })

# if( !isGeneric("statistic"))
  setGeneric("statistic", function(object) standardGeneric("statistic"))

setMethod("statistic", "DEResult", function(object) object@statistic)

# if( !isGeneric("statistic<-"))
  setGeneric("statistic<-", function(object, value) standardGeneric("statistic<-"))

setReplaceMethod("statistic", signature=c("DEResult", "matrix"),
                 function(object, value) {
                   object@statistic <- as.matrix(value)
					return(object)
                 })

# if( !isGeneric("FC"))
  setGeneric("FC", function(object) standardGeneric("FC"))

setMethod("FC", "DEResult", function(object) object@FC)

# if( !isGeneric("FC<-"))
  setGeneric("FC<-", function(object, value) standardGeneric("FC<-"))

setReplaceMethod("FC", signature=c("DEResult", "matrix"),
                 function(object, value) {
                   object@FC <- as.matrix(value)
					return(object)
                 })


# if( !isGeneric("statisticDescription"))
  setGeneric("statisticDescription", function(object) standardGeneric("statisticDescription"))

setMethod("statisticDescription", "DEResult", function(object) object@statisticDescription)

# if( !isGeneric("statisticDescription<-"))
  setGeneric("statisticDescription<-", function(object, value) standardGeneric("statisticDescription<-"))

setReplaceMethod("statisticDescription", signature=c("DEResult", "character"),
                 function(object, value) {
                   object@statisticDescription <- as.character(value)
					return(object)
                 })

# if( !isGeneric("DEMethod"))
  setGeneric("DEMethod", function(object) standardGeneric("DEMethod"))

setMethod("DEMethod", "DEResult", function(object) object@DEMethod)

# if( !isGeneric("DEMethod<-"))
  setGeneric("DEMethod<-", function(object, value) standardGeneric("DEMethod<-"))

setReplaceMethod("DEMethod", signature=c("DEResult", "character"),
                 function(object, value) {
                   object@DEMethod <- as.character(value)
					return(object)
                 })



# if( !isGeneric("pLikeValues") )
	setGeneric("pLikeValues"
	,	function(object, contrast=1, direction="either") standardGeneric("pLikeValues"))
setMethod("pLikeValues", "DEResult",
	function(object, contrast=1, direction="either") {
		if(object@DEMethod=="pumaDE")
		{
			if(direction=="either")
				return(1-abs(2*(object@statistic[,contrast]-0.5)))
			if(direction=="up")
				return(1-object@statistic[,contrast])
			if(direction=="down")
				return(object@statistic[,contrast])
		}
		if(object@DEMethod=="calculateLimma" || object@DEMethod=="calculateTtest")
		{
			if(direction=="either")
				return(object@statistic[,contrast])
			if(direction=="up")
				return( ( ( (object@statistic[,contrast]-1) * sign(object@FC[,contrast]) )
					/ 2 ) + 0.5)
			if(direction=="down")
				return( ( ( (1-object@statistic[,contrast]) * sign(object@FC[,contrast]) )
				 	/ 2 ) + 0.5)
		}
		if(object@DEMethod=="calculateFC")
		{
			if(direction=="either")
				return(1-(rank(object@statistic[,contrast])-1)
					/	(length(object@statistic[,contrast])-1))
			if(direction=="up")
				return(1-(rank(object@FC[,contrast])-1)
					/	(length(object@FC[,contrast])-1))
			if(direction=="down")
				return((rank(object@FC[,contrast])-1)
					/	(length(object@FC[,contrast])-1))
		}
		if(object@DEMethod=="calculateCyberT")
		{
			if(direction=="either")
				return(1-(rank(abs(object@statistic[,contrast]))-1)
					/	(length(object@statistic[,contrast])-1))
			if(direction=="up")
				return((rank(object@statistic[,contrast])-1)
					/	(length(object@statistic[,contrast])-1))
			if(direction=="down")
				return(1-(rank(object@statistic[,contrast])-1)
					/	(length(object@statistic[,contrast])-1))
		}
     })

# if( !isGeneric("topGenes") )
	setGeneric("topGenes", function(object, numberOfGenes=1, contrast=1, direction="either") standardGeneric("topGenes"))
setMethod("topGenes", "DEResult",
	function(object, numberOfGenes=1, contrast=1, direction="either") {
		sort(pLikeValues(object, contrast, direction), method="quick"
		, index.return=TRUE)$ix[1:numberOfGenes]
	})

# if( !isGeneric("topGeneIDs") )
	setGeneric("topGeneIDs", function(object, numberOfGenes=1, contrast=1, direction="either") standardGeneric("topGeneIDs"))
setMethod("topGeneIDs", "DEResult",
	function(object, numberOfGenes=1, contrast=1, direction="either") {
		rownames(object@statistic)[sort(pLikeValues(object, contrast, direction), method="quick"
		, index.return=TRUE)$ix[1:numberOfGenes]]
	})

# if( !isGeneric("numberOfProbesets") )
	setGeneric("numberOfProbesets", function(object) standardGeneric("numberOfProbesets"))
setMethod("numberOfProbesets", "DEResult",
	function(object) {
		nrow(object@statistic)
	})

# if( !isGeneric("numberOfGenes") )
	setGeneric("numberOfGenes", function(object) standardGeneric("numberOfGenes"))
setMethod("numberOfGenes", "DEResult",
	function(object) {
		nrow(object@statistic)
	})

# if( !isGeneric("numberOfContrasts") )
	setGeneric("numberOfContrasts", function(object) standardGeneric("numberOfContrasts"))
setMethod("numberOfContrasts", "DEResult",
	function(object) {
		ncol(object@statistic)
	})

# if( !isGeneric("write.reslts") )
	# setGeneric("write.reslts", function(x,...) standardGeneric("write.reslts"))
setMethod(
	"write.reslts"
,	signature(x="DEResult")
,	function(
		x
	,	file = "tmp"
	,	append = FALSE
	,	quote = FALSE
	,	sep = ","
	,	eol = "\n"
	,	na = "NA"
	,	dec = "."
	,	row.names = TRUE
	,	col.names = NA
	,	qmethod = c("escape", "double")
	)
	{
		write.table(
			statistic(x)
		,	file = paste(file,"_statistics.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
		write.table(
			FC(x)
		,	file = paste(file,"_FCs.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
	}
)

setClass("exprReslt"
,	representation(
		prcfive="matrix",
		prctwfive="matrix",
		prcfifty="matrix",
		prcsevfive="matrix",
		prcninfive="matrix",
		exprs="matrix",   #this
		se.exprs="matrix",
		description="MIAME",
		annotation="character",
		notes="character",
		cdfName="character",
		nrow="numeric",
		ncol="numeric"
	)
,	prototype=list(
		prcfive=matrix(nr=0,nc=0),
		prctwfive=matrix(nr=0,nc=0),
		prcfifty=matrix(nr=0,nc=0),
		prcsevfive=matrix(nr=0,nc=0),
		prcninfive=matrix(nr=0,nc=0),
		exprs=matrix(nr=0,nc=0),
		se.exprs = matrix(nr=0,nc=0),
		description=new("MIAME"),
		annotation="",
		notes="",
		cdfName="",
		nrow=0,
		ncol=0
	)
,	contains="ExpressionSet"
)
	 
##define a generic for obtaining the data
# if( !isGeneric("se.exprs") )
#	setGeneric("se.exprs", function(object) standardGeneric("se.exprs"))
setMethod("se.exprs", "exprReslt", function(object) assayDataElement(object,"se.exprs"))

# if( !isGeneric("se.exprs<-") )
#	setGeneric("se.exprs<-", function(object, value)
#		standardGeneric("se.exprs<-"))

setReplaceMethod("se.exprs", "exprReslt",
                 function(object, value) {
                   assayDataElement(object,"se.exprs") <- value
                   return(object)
                 })

##define a generic for obtaining the data
# if( !isGeneric("prcfive") )
	setGeneric("prcfive", function(object) standardGeneric("prcfive"))
setMethod("prcfive", "exprReslt", function(object) object@prcfive)

# if( !isGeneric("prcfive<-") )
	setGeneric("prcfive<-", function(object, value)
		standardGeneric("prcfive<-"))

setReplaceMethod("prcfive", "exprReslt",
                 function(object, value) {
                   object@prcfive <- value
                   return(object)
                 })

##define a generic for obtaining the data
# if( !isGeneric("prctwfive") )
	setGeneric("prctwfive", function(object) standardGeneric("prctwfive"))
setMethod("prctwfive", "exprReslt", function(object) object@prctwfive)

# if( !isGeneric("prctwfive<-") )
	setGeneric("prctwfive<-", function(object, value)
    	standardGeneric("prctwfive<-"))

setReplaceMethod(
	"prctwfive"
,	"exprReslt"
,	function(object, value) {
		object@prctwfive <- value
		return(object)
	}
)
  ##define a generic for obtaining the data
# if( !isGeneric("prcfifty") )
	setGeneric("prcfifty", function(object) standardGeneric("prcfifty"))
setMethod("prcfifty", "exprReslt", function(object) object@prcfifty)

# if( !isGeneric("prcfifty<-") )
	setGeneric("prcfifty<-", function(object, value)
		standardGeneric("prcfifty<-"))

setReplaceMethod(
	"prcfifty"
,	"exprReslt"
,	function(object, value) {
		object@prcfifty <- value
		return(object)
	}
)
  ##define a generic for obtaining the data
# if( !isGeneric("prcsevfive") )
	setGeneric("prcsevfive", function(object) standardGeneric("prcsevfive"))
setMethod("prcsevfive", "exprReslt", function(object) object@prcsevfive)

# if( !isGeneric("prcsevfive<-") )
	setGeneric("prcsevfive<-", function(object, value)
		standardGeneric("prcsevfive<-"))

setReplaceMethod(
	"prcsevfive"
,	"exprReslt"
,	function(object, value) {
		object@prcsevfive <- value
		return(object)
	}
)
  ##define a generic for obtaining the data
# if( !isGeneric("prcninfive") )
	setGeneric("prcninfive", function(object) standardGeneric("prcninfive"))
setMethod("prcninfive", "exprReslt", function(object) object@prcninfive)

# if( !isGeneric("prcninfive<-") )
	setGeneric("prcninfive<-", function(object, value)
		standardGeneric("prcninfive<-"))

setReplaceMethod(
	"prcninfive"
,	"exprReslt"
,	function(object, value) {
		object@prcninfive <- value
		return(object)
	}
)

setMethod("show", "exprReslt", function(object ) {
	dm <-dim(exprs(object))
	ngenes <- dm[1]
	nsamples <- dm[2]
	cat("Expression Set (exprReslt) with \n\t", ngenes, " genes\n\t", sep="")
	cat(nsamples, "samples\n\t")
	show(phenoData(object))
})
	 
# if( !isGeneric("write.reslts") )
	# setGeneric("write.reslts", function(x,...) standardGeneric("write.reslts"))
setMethod(
	"write.reslts"
,	signature(x="exprReslt")
,	function(
		x
	,	file = "tmp"
	,	append = FALSE
	,	quote = FALSE
	,	sep = ","
	,	eol = "\n"
	,	na = "NA"
	,	dec = "."
	,	row.names = TRUE
	,	col.names = NA
	,	qmethod = c("escape", "double")
	)
	{
		write.table(
			exprs(x)
		,	file = paste(file,"_exprs.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
		write.table(
			se.exprs(x)
		,	file = paste(file,"_se.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
		write.table(
			prcfive(x)
		,	file = paste(file,"_prctile5.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
		write.table(
			prctwfive(x)
		,	file = paste(file,"_prctile25.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
		write.table(
			prcfifty(x)
		,	file = paste(file,"_prctile50.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
		write.table(
			prcsevfive(x)
		,	file = paste(file,"_prctile75.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
		write.table(
			prcninfive(x)
		,	file = paste(file,"_prctile95.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
	}
)

setMethod(
	"write.reslts"
,	signature(x="ExpressionSet")
,	function(
		x
	,	file = "tmp"
	,	append = FALSE
	,	quote = FALSE
	,	sep = ","
	,	eol = "\n"
	,	na = "NA"
	,	dec = "."
	,	row.names = TRUE
	,	col.names = NA
	,	qmethod = c("escape", "double")
	)
	{
		write.table(
			exprs(x)
		,	file = paste(file,"_exprs.csv",sep="")
		,	append = append
		,	quote = quote
		,	sep = sep
		,	eol = eol
		,	na = na
		,	dec = dec
		,	row.names = row.names
		,	col.names = col.names
		,	qmethod = qmethod
		)
	}
)

#!/bin/bash
set -e  # exit when any command fails

echo "Testing PuMA C++ library"
pumaX_testing 1
rm $CONDA_PREFIX/bin/pumaX_testing

echo "Testing PuMA GUI"
pumaGUI &
killall pumaGUI

echo "Testing pumapy"
cd python/test
python -m unittest test_workspace.TestWorkspace

#!/bin/bash

echo "Testing PUMA OpenAI-Compatible API"
echo "===================================="
echo

# Base URL
BASE_URL="http://localhost:8000"

echo "1. Health Check"
curl -s "$BASE_URL/health"
echo -e "\n"

echo "2. List Models"
curl -s "$BASE_URL/v1/models" | jq '.'
echo

echo "3. Chat Completion (Non-streaming)"
curl -s "$BASE_URL/v1/chat/completions" \
  -H "Content-Type: application/json" \
  -d '{
    "model": "test-model",
    "messages": [
      {"role": "user", "content": "Hello!"}
    ],
    "max_tokens": 50
  }' | jq '.'
echo

echo "4. Chat Completion (Streaming)"
curl -s -N "$BASE_URL/v1/chat/completions" \
  -H "Content-Type: application/json" \
  -d '{
    "model": "test-model",
    "messages": [
      {"role": "user", "content": "Tell me a story"}
    ],
    "stream": true,
    "max_tokens": 50
  }'
echo -e "\n"

echo "5. Legacy Text Completion"
curl -s "$BASE_URL/v1/completions" \
  -H "Content-Type: application/json" \
  -d '{
    "model": "test-model",
    "prompt": "Once upon a time",
    "max_tokens": 50
  }' | jq '.'
echo

echo "Done!"

#!/bin/bash
set -e  # exit when any command fails


echo -e "\n### INSTALLING PuMA C++ library ###\n"
cd install 
mkdir -p cmake-build-release
cd cmake-build-release
cmake -D CONDA_PREFIX=$PREFIX \
      -D CMAKE_INSTALL_PREFIX=$PREFIX \
      "$SRC_DIR"/cpp
make -j$CPU_COUNT
make install
rm ${PREFIX}/bin/pumaX_main


echo -e "\n### INSTALLING TexGen ###\n"
cd "$SRC_DIR"/install/TexGen
mkdir -p bin
cd bin
PY_VERSION="$(python -c 'import sys; print(sys.version_info[1])')"
if [ $PY_VERSION -le 7 ]; then
    PY_VERSION="${PY_VERSION}m"
fi
cmake -D BUILD_PYTHON_INTERFACE=ON \
      -D CMAKE_INSTALL_PREFIX=$PREFIX \
      -D PYTHON_INCLUDE_DIR="$PREFIX"/include/python3.$PY_VERSION \
      -D PYTHON_LIBRARY="$PREFIX"/lib/libpython3.$PY_VERSION$SHLIB_EXT \
      -D PYTHON_SITEPACKAGES_DIR="$SP_DIR" \
      -D BUILD_GUI=OFF \
      -D BUILD_RENDERER=OFF \
      -D CMAKE_MACOSX_RPATH=ON \
      -D CMAKE_INSTALL_RPATH_USE_LINK_PATH=ON \
      -D CMAKE_INSTALL_RPATH="$PREFIX"/lib \
      -D BUILD_SHARED_LIBS=OFF \
      ..
make -j$CPU_COUNT
make install


echo -e "\n### INSTALLING pumapy ###\n"
cd "$SRC_DIR"
$PYTHON setup.py install --single-version-externally-managed --record=record.txt


echo -e "\n### INSTALLING PuMA GUI ###\n"
cd "$SRC_DIR"/gui/build
# workarounds for openGL and g++ on linux
if [ "$(uname)" != "Darwin" ]; then
      echo "QMAKE_LIBS_OPENGL=${BUILD_PREFIX}/${HOST}/sysroot/usr/lib64/libGL.so" >> pumaGUI.pro
      ln -s ${GXX} g++ || true
      chmod +x g++
      export PATH=${PWD}:${PATH}
fi
qmake \
      BUILD_PREFIX=$PREFIX \
      INSTALL_PREFIX=$PREFIX
make -j$CPU_COUNT
make install

echo -e "\n### END OF INSTALLATION ###\n"

# You are encouraged to use @ioquatix's wrk fork, located here: https://github.com/ioquatix/wrk

bundle exec bin/puma -t 4 test/rackup/hello.ru &
PID1=$!
sleep 5
wrk -c 4 -s benchmarks/wrk/lua/big_body.lua --latency http://localhost:9292

kill $PID1

# You are encouraged to use @ioquatix's wrk fork, located here: https://github.com/ioquatix/wrk

bundle exec bin/puma -t 4 test/rackup/hello.ru &
PID1=$!
sleep 5
wrk -c 4 -d 30 --latency http://localhost:9292

kill $PID1

#!/usr/bin/env bash

# benchmarks/local/long_tail_hey-0-2-4-8.sh
#
# -d app delay, default 0.010
# -t Threads, default 3:3
# -c hey requests per connection, default 100
#
# see comments in long_tail_hey.rb

while getopts :b:C:c:d:kR:r:s:T:t:w:Y option
do
case "${option}" in
#———————————————————— RUBY options
Y) export RUBYOPT=--yjit;;
#———————————————————— Puma options
C) conf=${OPTARG};;
t) THREADS=${OPTARG};;
#———————————————————— app/common options
d) DLY=${OPTARG};;
#———————————————————— wrk options
c) REQS_PER_CONN=${OPTARG};;
?) echo "Error: Invalid option was specified -$OPTARG"; exit;;
esac
done

if [[ -z "$THREADS" ]]; then
  THREADS=3:3
fi

if [[ -z "$REQS_PER_CONN" ]]; then
  REQS_PER_CONN=100
fi

if [[ -z "$DLY" ]]; then
  DLY=0.010
fi

SECONDS=0

benchmarks/local/long_tail_hey.sh -w8 -t$THREADS -R$REQS_PER_CONN -d$DLY
sleep 2s
benchmarks/local/long_tail_hey.sh -w4 -t$THREADS -R$REQS_PER_CONN -d$DLY
sleep 2s
benchmarks/local/long_tail_hey.sh -w2 -t$THREADS -R$REQS_PER_CONN -d$DLY
sleep 2s
benchmarks/local/long_tail_hey.sh     -t$THREADS -R$REQS_PER_CONN -d$DLY
sleep 2s
# disable keep-alive
benchmarks/local/long_tail_hey.sh -w8 -t$THREADS -R$REQS_PER_CONN -d$DLY -k
sleep 2s
benchmarks/local/long_tail_hey.sh -w4 -t$THREADS -R$REQS_PER_CONN -d$DLY -k
sleep 2s
benchmarks/local/long_tail_hey.sh -w2 -t$THREADS -R$REQS_PER_CONN -d$DLY -k
sleep 2s
benchmarks/local/long_tail_hey.sh     -t$THREADS -R$REQS_PER_CONN -d$DLY -k
sleep 2s

TZ=UTC0 printf '\n%(%H:%M:%S)T All Total Time\n' $SECONDS

#!/bin/bash

# see comments in response_time_wrk.rb

source benchmarks/local/bench_base.sh

if [ "$skt_type" == "unix" ] || [ "$skt_type" == "aunix" ]; then
  printf "\nwrk doesn't support UNIXSockets...\n\n"
  exit
fi

StartPuma

ruby -I./lib benchmarks/local/response_time_wrk.rb $ruby_args -W $wrk_str
wrk_exit=$?

printf "\n"
exit $wrk_exit

# PowerShell script for building & testing SQLite3-Ruby fat binary gem
# Code by MSP-Greg, see https://github.com/MSP-Greg/av-gem-build-test

# load utility functions, pass 64 or 32
. $PSScriptRoot\shared\appveyor_setup.ps1 $args[0]
if ($LastExitCode) { exit }

# above is required code
#———————————————————————————————————————————————————————————————— above for all repos

Make-Const gem_name  'puma'
Make-Const repo_name 'puma'
Make-Const url_repo  'https://github.com/puma/puma.git'

#———————————————————————————————————————————————————————————————— lowest ruby version
Make-Const ruby_vers_low 22
# null = don't compile; false = compile, ignore test (allow failure);
# true = compile & test
Make-Const trunk     $false ; Make-Const trunk_x64     $false
Make-Const trunk_JIT $null  ; Make-Const trunk_x64_JIT $null

#———————————————————————————————————————————————————————————————— make info
Make-Const dest_so   'lib\puma'
Make-Const exts      @(
  @{ 'conf' = 'ext/puma_http11/extconf.rb' ; 'so' = 'puma_http11' }
)
Make-Const write_so_require $true

#———————————————————————————————————————————————————————————————— Pre-Compile
# runs before compiling starts on every ruby version
function Pre-Compile {
  # load the correct OpenSSL version in the build system
  Check-OpenSSL
  Write-Host Compiling With $env:SSL_VERS
}

#———————————————————————————————————————————————————————————————— Pre-Gem-Install
function Pre-Gem-Install {
  if ($ruby -lt '23') {
    gem install -N --no-user-install nio4r:2.3.1
  } else {
    gem install -N --no-user-install nio4r
  }
}

#———————————————————————————————————————————————————————————————— Run-Tests
function Run-Tests {
  # call with comma separated list of gems to install or update
  Update-Gems minitest, minitest-retry, minitest-proveit, rack, rake
  $env:CI = 1
  rake -f Rakefile_wintest -N -R norakelib | Set-Content -Path $log_name -PassThru -Encoding UTF8
  # add info after test results
  $(ruby -ropenssl -e "STDOUT.puts $/ + OpenSSL::OPENSSL_LIBRARY_VERSION") |
    Add-Content -Path $log_name -PassThru -Encoding UTF8
  minitest  # collects test results
}

#———————————————————————————————————————————————————————————————— below for all repos
# below is required code
Make-Const dir_gem  $(Convert-Path $PSScriptRoot\..)
Make-Const dir_ps   $PSScriptRoot

Push-Location $PSScriptRoot
.\shared\make.ps1
.\shared\test.ps1
Pop-Location
exit $ttl_errors_fails + $exit_code

#!/bin/bash

# -T client threads (wrk -t)
# -c connections per client thread
# -R requests per client
#
# Total connections/requests = l * c * r
#
# -b response body size kB
# -d app delay
#
# -s Puma bind socket type, default ssl, also tcp or unix
# -t Puma threads
# -w Puma workers
# -r Puma rackup file

if [[ "$@" =~ ^[^-].* ]]; then
  echo "Error: Invalid option was specified $1"
  exit
fi

PUMA_BENCH_CMD=$0
PUMA_BENCH_ARGS=$@

export PUMA_BENCH_CMD
export PUMA_BENCH_ARGS

if [ -z "$PUMA_TEST_HOST4" ]; then export PUMA_TEST_HOST4=127.0.0.1; fi
if [ -z "$PUMA_TEST_HOST6" ]; then export PUMA_TEST_HOST6=::1;       fi
if [ -z "$PUMA_TEST_PORT"  ]; then export PUMA_TEST_PORT=40001;      fi
if [ -z "$PUMA_TEST_CTRL"  ]; then export PUMA_TEST_CTRL=40010;      fi
if [ -z "$PUMA_TEST_STATE" ]; then export PUMA_TEST_STATE=tmp/bench_test_puma.state; fi

export PUMA_CTRL=$PUMA_TEST_HOST4:$PUMA_TEST_CTRL

while getopts :b:C:c:D:d:kR:r:s:T:t:w:Y option
do
case "${option}" in
#———————————————————— RUBY options
Y) export RUBYOPT=--yjit;;
#———————————————————— Puma options
C) conf=${OPTARG};;
t) threads=${OPTARG};;
w) workers=${OPTARG};;
r) rackup_file=${OPTARG};;
#———————————————————— app/common options
b) body_conf=${OPTARG};;
s) skt_type=${OPTARG};;
d) dly_app=${OPTARG};;
#———————————————————— request_stream options
T) stream_threads=${OPTARG};;
D) duration=${OPTARG};;
R) req_per_socket=${OPTARG};;
#———————————————————— wrk options
c) connections=${OPTARG};;
# T) stream_threads=${OPTARG};;
# D) duration=${OPTARG};;
#———————————————————— hey options
k) disable_keepalive=true;;
?) echo "Error: Invalid option was specified -$OPTARG"; exit;;
esac
done

# -n not empty, -z is empty

ruby_args="-S $PUMA_TEST_STATE"

if [ -n "$connections" ]; then
  ruby_args="$ruby_args -c$connections"
fi

if [ -n "$stream_threads" ]; then
  ruby_args="$ruby_args -T$stream_threads"
fi

if [ -n "$duration" ] ; then
  ruby_args="$ruby_args -D$duration"
fi

if [ -n "$req_per_socket" ]; then
  ruby_args="$ruby_args -R$req_per_socket"
fi

if [ -n "$dly_app" ]; then
  ruby_args="$ruby_args -d$dly_app"
fi

if [ -n "$body_conf" ]; then
  ruby_args="$ruby_args -b $body_conf"
  export CI_BODY_CONF=$body_conf
fi

if [ -z "$skt_type" ]; then
  skt_type=tcp
fi

ruby_args="$ruby_args -s $skt_type"

puma_args="-S $PUMA_TEST_STATE"

if [ -n "$workers" ]; then
  puma_args="$puma_args -w$workers"
  ruby_args="$ruby_args -w$workers"
fi


if [ -n "$disable_keepalive" ]; then
  ruby_args="$ruby_args -k"
fi

if [ -z "$threads" ]; then
  threads=0:5
fi

puma_args="$puma_args -t$threads"
ruby_args="$ruby_args -t$threads"

if [ -n "$conf" ]; then
  puma_args="$puma_args -C $conf"
fi

if [ -z "$rackup_file" ]; then
  rackup_file="test/rackup/sleep.ru"
fi

ip4=$PUMA_TEST_HOST4:$PUMA_TEST_PORT
ip6=[$PUMA_TEST_HOST6]:$PUMA_TEST_PORT

case $skt_type in
  ssl4)
  bind="ssl://$PUMA_TEST_HOST4:$PUMA_TEST_PORT?cert=examples/puma/cert_puma.pem&key=examples/puma/puma_keypair.pem&verify_mode=none"
  curl_str=https://$ip4
  wrk_str=https://$ip4
  ;;
  ssl)
  bind="ssl://$ip4?cert=examples/puma/cert_puma.pem&key=examples/puma/puma_keypair.pem&verify_mode=none"
  curl_str=https://$ip4
  wrk_str=https://$ip4
  ;;
  ssl6)
  bind="ssl://$ip6?cert=examples/puma/cert_puma.pem&key=examples/puma/puma_keypair.pem&verify_mode=none"
  curl_str=https://$ip6
  wrk_str=https://$ip6
  ;;
  tcp4)
  bind=tcp://$ip4
  curl_str=http://$ip4
  wrk_str=http://$ip4
  ;;
  tcp)
  bind=tcp://$ip4
  curl_str=http://$ip4
  wrk_str=http://$ip4
  ;;
  tcp6)
  bind=tcp://$ip6
  curl_str=http://$ip6
  wrk_str=http://$ip6
  ;;
  unix)
  bind=unix://tmp/benchmark_skt.unix
  curl_str="--unix-socket tmp/benchmark_skt.unix http:/n"
  ;;
  aunix)
  bind=unix://@benchmark_skt.aunix
  curl_str="--abstract-unix-socket benchmark_skt.aunix http:/n"
  ;;
  *)
  echo "Error: Invalid socket type option was specified '$skt_type'"
  exit
  ;;
esac

StartPuma()
{
  if [ -n "$1" ]; then
    rackup_file=$1
  fi
  printf "\nbundle exec bin/puma -q -b $bind $puma_args --control-url=tcp://$PUMA_CTRL --control-token=test $rackup_file\n\n"
  bundle exec bin/puma -q -b $bind $puma_args --control-url=tcp://$PUMA_CTRL --control-token=test $rackup_file &
  sleep 1s
}

#!/bin/bash

set -eo pipefail

ITERATIONS=400000
HOST=127.0.0.1:9292
URL="http://$HOST/cpu/$ITERATIONS"

MIN_WORKERS=1
MAX_WORKERS=4

MIN_THREADS=4
MAX_THREADS=4

DURATION=2
MIN_CONCURRENT=1
MAX_CONCURRENT=8

retry() {
  local tries="$1"
  local sleep="$2"
  shift 2

  for i in $(seq 1 $tries); do
    if eval "$@"; then
      return 0
    fi

    sleep "$sleep"
  done

  return 1
}

ms() {
  VALUE=$(cat)
  FRAC=${VALUE%%[ums]*}
  case "$VALUE" in
    *us)
      echo "scale=1; ${FRAC}/1000" | bc
      ;;

    *ms)
      echo "scale=1; ${FRAC}/1" | bc
      ;;

    *s)
      echo "scale=1; ${FRAC}*1000/1" | bc
      ;;
  esac
}

run_wrk() {
  mkdir tmp &>/dev/null || true
  result=$(wrk -H "Connection: Close" -c "$wrk_c" -t "$wrk_t" -d "$DURATION" --latency "$@" | tee -a tmp/wrk.txt)
  req_sec=$(echo "$result" | grep "^Requests/sec:" | awk '{print $2}')
  latency_avg=$(echo "$result" | grep "^\s*Latency.*%" | awk '{print $2}' | ms)
  latency_stddev=$(echo "$result" | grep "^\s*Latency.*%" | awk '{print $3}' | ms)
  latency_50=$(echo "$result" | grep "^\s*50%" | awk '{print $2}' | ms)
  latency_75=$(echo "$result" | grep "^\s*75%" | awk '{print $2}' | ms)
  latency_90=$(echo "$result" | grep "^\s*90%" | awk '{print $2}' | ms)
  latency_99=$(echo "$result" | grep "^\s*99%" | awk '{print $2}' | ms)

  echo -e "$workers\t$threads\t$wrk_c\t$wrk_t\t$req_sec\t$latency_avg\t$latency_stddev\t$latency_50\t$latency_75\t$latency_90\t$latency_99"
}

run_concurrency_tests() {
  echo
  echo -e "PUMA_W\tPUMA_T\tWRK_C\tWRK_T\tREQ_SEC\tL_AVG\tL_DEV\tL_50%\tL_75%\tL_90%\tL_99%"
  for wrk_c in $(seq $MIN_CONCURRENT $MAX_CONCURRENT); do
    wrk_t="$wrk_c"
    eval "$@"
    sleep 1
  done
  echo
}

with_puma() {
  # start puma and wait for 10s for it to start
  bundle exec bin/puma -w "$workers" -t "$threads" -b "tcp://$HOST" -C test/config/cpu_spin.rb &
  local puma_pid=$!
  trap "kill $puma_pid" EXIT

  # wait for Puma to be up
  if ! retry 10 1s curl --fail "$URL" &>/dev/null; then
    echo "Failed to connect to $URL."
    return 1
  fi

  # execute testing command
  eval "$@"
  kill "$puma_pid" || true
  trap - EXIT
  wait
}

for workers in $(seq $MIN_WORKERS $MAX_WORKERS); do
  for threads in $(seq $MIN_THREADS $MAX_THREADS); do
    with_puma \
      run_concurrency_tests \
      run_wrk "$URL"
  done
done

#!/usr/bin/env bash

# -T client threads (wrk -t)
# -c connections per client thread
# -R requests per client
#
# Total connections/requests = l * c * r
#
# -b response body size kB
# -d app delay
#
# -s Puma bind socket type, default ssl, also tcp or unix
# -t Puma threads
# -w Puma workers
# -r Puma rackup file

if [[ "$@" =~ ^[^-].* ]]; then
  echo "Error: Invalid option was specified $1"
  exit
fi

PUMA_BENCH_CMD=$0
PUMA_BENCH_ARGS=$@

export PUMA_BENCH_CMD
export PUMA_BENCH_ARGS

if [ -z "$PUMA_TEST_HOST4" ]; then export PUMA_TEST_HOST4=127.0.0.1; fi
if [ -z "$PUMA_TEST_HOST6" ]; then export PUMA_TEST_HOST6=::1;       fi
if [ -z "$PUMA_TEST_PORT"  ]; then export PUMA_TEST_PORT=40001;      fi
if [ -z "$PUMA_TEST_CTRL"  ]; then export PUMA_TEST_CTRL=40010;      fi
if [ -z "$PUMA_TEST_STATE" ]; then export PUMA_TEST_STATE=tmp/bench_test_puma.state; fi

export PUMA_CTRL=$PUMA_TEST_HOST4:$PUMA_TEST_CTRL

while getopts :b:C:c:D:d:kR:r:s:T:t:w:Y option
do
case "${option}" in
#———————————————————— RUBY options
Y) export RUBYOPT=--yjit;;
#———————————————————— Puma options
C) conf=${OPTARG};;
t) threads=${OPTARG};;
w) workers=${OPTARG};;
r) rackup_file=${OPTARG};;
#———————————————————— app/common options
b) body_conf=${OPTARG};;
s) skt_type=${OPTARG};;
d) dly_app=${OPTARG};;
#———————————————————— request_stream options
T) stream_threads=${OPTARG};;
D) duration=${OPTARG};;
R) req_per_socket=${OPTARG};;
#———————————————————— wrk options
c) connections=${OPTARG};;
# T) stream_threads=${OPTARG};;
# D) duration=${OPTARG};;
#———————————————————— hey options
k) disable_keepalive=true;;
?) echo "Error: Invalid option was specified -$OPTARG"; exit;;
esac
done

# -n not empty, -z is empty

ruby_args="-S $PUMA_TEST_STATE"

if [ -n "$connections" ]; then
  ruby_args="$ruby_args -c$connections"
fi

if [ -n "$stream_threads" ]; then
  ruby_args="$ruby_args -T$stream_threads"
fi

if [ -n "$duration" ] ; then
  ruby_args="$ruby_args -D$duration"
fi

if [ -n "$req_per_socket" ]; then
  ruby_args="$ruby_args -R$req_per_socket"
fi

if [ -n "$dly_app" ]; then
  ruby_args="$ruby_args -d$dly_app"
fi

if [ -n "$body_conf" ]; then
  ruby_args="$ruby_args -b $body_conf"
  export CI_BODY_CONF=$body_conf
fi

if [ -z "$skt_type" ]; then
  skt_type=tcp
fi

ruby_args="$ruby_args -s $skt_type"

puma_args="-S $PUMA_TEST_STATE"

if [ -n "$workers" ]; then
  puma_args="$puma_args -w$workers"
  ruby_args="$ruby_args -w$workers"
fi


if [ -n "$disable_keepalive" ]; then
  ruby_args="$ruby_args -k"
fi

if [ -z "$threads" ]; then
  threads=0:5
fi

puma_args="$puma_args -t$threads"
ruby_args="$ruby_args -t$threads"

if [ -n "$conf" ]; then
  puma_args="$puma_args -C $conf"
fi

if [ -z "$rackup_file" ]; then
  rackup_file="test/rackup/sleep.ru"
fi

ip4=$PUMA_TEST_HOST4:$PUMA_TEST_PORT
ip6=[$PUMA_TEST_HOST6]:$PUMA_TEST_PORT

case $skt_type in
  ssl4)
  bind="ssl://$PUMA_TEST_HOST4:$PUMA_TEST_PORT?cert=examples/puma/cert_puma.pem&key=examples/puma/puma_keypair.pem&verify_mode=none"
  curl_str=https://$ip4
  wrk_str=https://$ip4
  ;;
  ssl)
  bind="ssl://$ip4?cert=examples/puma/cert_puma.pem&key=examples/puma/puma_keypair.pem&verify_mode=none"
  curl_str=https://$ip4
  wrk_str=https://$ip4
  ;;
  ssl6)
  bind="ssl://$ip6?cert=examples/puma/cert_puma.pem&key=examples/puma/puma_keypair.pem&verify_mode=none"
  curl_str=https://$ip6
  wrk_str=https://$ip6
  ;;
  tcp4)
  bind=tcp://$ip4
  curl_str=http://$ip4
  wrk_str=http://$ip4
  ;;
  tcp)
  bind=tcp://$ip4
  curl_str=http://$ip4
  wrk_str=http://$ip4
  ;;
  tcp6)
  bind=tcp://$ip6
  curl_str=http://$ip6
  wrk_str=http://$ip6
  ;;
  unix)
  bind=unix://tmp/benchmark_skt.unix
  curl_str="--unix-socket tmp/benchmark_skt.unix http:/n"
  ;;
  aunix)
  bind=unix://@benchmark_skt.aunix
  curl_str="--abstract-unix-socket benchmark_skt.aunix http:/n"
  ;;
  *)
  echo "Error: Invalid socket type option was specified '$skt_type'"
  exit
  ;;
esac

StartPuma()
{
  if [ -n "$1" ]; then
    rackup_file=$1
  fi
  export PUMA_RU_FILE=$rackup_file

  printf "\nbundle exec puma -q -b $bind $puma_args --control-url=tcp://$PUMA_CTRL --control-token=test $rackup_file\n\n"
  bundle exec puma -q -b $bind $puma_args --control-url=tcp://$PUMA_CTRL --control-token=test $rackup_file &
}

bundle exec ruby bin/puma \
                 -t 4 -b "ssl://localhost:9292?keystore=examples/puma/keystore.jks&keystore-pass=blahblah&verify_mode=none" \
                 test/rackup/realistic_response.ru &
PID1=$!
sleep 5
wrk -c 4 -d 30 --latency https://localhost:9292

kill $PID1

#!/usr/bin/env bash

set -eo pipefail

ITERATIONS=400000
HOST=127.0.0.1:9292
URL="http://$HOST/cpu/$ITERATIONS"

MIN_WORKERS=1
MAX_WORKERS=4

MIN_THREADS=4
MAX_THREADS=4

DURATION=2
MIN_CONCURRENT=1
MAX_CONCURRENT=8

retry() {
  local tries="$1"
  local sleep="$2"
  shift 2

  for i in $(seq 1 $tries); do
    if eval "$@"; then
      return 0
    fi

    sleep "$sleep"
  done

  return 1
}

ms() {
  VALUE=$(cat)
  FRAC=${VALUE%%[ums]*}
  case "$VALUE" in
    *us)
      echo "scale=1; ${FRAC}/1000" | bc
      ;;

    *ms)
      echo "scale=1; ${FRAC}/1" | bc
      ;;

    *s)
      echo "scale=1; ${FRAC}*1000/1" | bc
      ;;
  esac
}

run_wrk() {
  mkdir tmp &>/dev/null || true
  result=$(wrk -H "Connection: Close" -c "$wrk_c" -t "$wrk_t" -d "$DURATION" --latency "$@" | tee -a tmp/wrk.txt)
  req_sec=$(echo "$result" | grep "^Requests/sec:" | awk '{print $2}')
  latency_avg=$(echo "$result" | grep "^\s*Latency.*%" | awk '{print $2}' | ms)
  latency_stddev=$(echo "$result" | grep "^\s*Latency.*%" | awk '{print $3}' | ms)
  latency_50=$(echo "$result" | grep "^\s*50%" | awk '{print $2}' | ms)
  latency_75=$(echo "$result" | grep "^\s*75%" | awk '{print $2}' | ms)
  latency_90=$(echo "$result" | grep "^\s*90%" | awk '{print $2}' | ms)
  latency_99=$(echo "$result" | grep "^\s*99%" | awk '{print $2}' | ms)

  echo -e "$workers\t$threads\t$wrk_c\t$wrk_t\t$req_sec\t$latency_avg\t$latency_stddev\t$latency_50\t$latency_75\t$latency_90\t$latency_99"
}

run_concurrency_tests() {
  echo
  echo -e "PUMA_W\tPUMA_T\tWRK_C\tWRK_T\tREQ_SEC\tL_AVG\tL_DEV\tL_50%\tL_75%\tL_90%\tL_99%"
  for wrk_c in $(seq $MIN_CONCURRENT $MAX_CONCURRENT); do
    wrk_t="$wrk_c"
    eval "$@"
    sleep 1
  done
  echo
}

with_puma() {
  # start puma and wait for 10s for it to start
  bundle exec bin/puma -w "$workers" -t "$threads" -b "tcp://$HOST" -C test/config/cpu_spin.rb &
  local puma_pid=$!
  trap "kill $puma_pid" EXIT

  # wait for Puma to be up
  if ! retry 10 1s curl --fail "$URL" &>/dev/null; then
    echo "Failed to connect to $URL."
    return 1
  fi

  # execute testing command
  eval "$@"
  kill "$puma_pid" || true
  trap - EXIT
  wait
}

for workers in $(seq $MIN_WORKERS $MAX_WORKERS); do
  for threads in $(seq $MIN_THREADS $MAX_THREADS); do
    with_puma \
      run_concurrency_tests \
      run_wrk "$URL"
  done
done

#!/usr/bin/env bash

# benchmarks/local/long_tail_hey.sh

# see comments in long_tail_hey.rb

source benchmarks/local/bench_base.sh

if [ "$skt_type" == "unix" ] || [ "$skt_type" == "aunix" ]; then
  printf "\nhey doesn't support UNIXSockets...\n\n"
  exit
fi

StartPuma

ruby -I./lib benchmarks/local/long_tail_hey.rb $ruby_args -W $wrk_str
hey_exit=$?

printf "\n"
exit $hey_exit

---
name: Bug Report
about: Report a bug encountered while using puma
title: ''
labels: bug
assignees: ''

---

<!-- Please use this template while reporting a bug and provide as much info as possible. Not doing so may result in your bug not being addressed in a timely manner. Thanks!
-->

**What happened**:

**What you expected to happen**:

**How to reproduce it (as minimally and precisely as possible)**:

**Anything else we need to know?**:

**Environment**:

- puma version (use `git describe --tags --dirty --always`):
- Kernel (e.g. `uname -a`):
- Others:

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

**Describe the bug**
A clear and concise description of what the bug is.

**Puma config:**

Please copy-paste your Puma config AND your command line options here.

**To Reproduce**
Please add reproduction steps here.

Your issue will be solved very quickly if you can reproduce it with a "hello world" rack application. To do this, copy this into a file called `hello.ru`:

```
run lambda { |env| [200, {"Content-Type" => "text/plain"}, ["Hello World"]] }
```

Run it with:

```
bundle exec puma -C <where_your_config_is> hello.ru
```

If you cannot reproduce with a hello world application or other simple application, we will have a lot more difficulty helping you fix your issue, because it may be application-specific and not a bug in Puma at all.  

There is also a Dockerfile available for reproducing Linux-specific issues. To use:

```
$ docker build -f tools/Dockerfile -t puma .
$ docker run -p 9292:9292 -it puma
```

This will help you to create a container that reproduces your issue.

**Expected behavior**
A clear and concise description of what you expected to happen.

**Desktop (please complete the following information):**
 - OS: [e.g. Mac, Linux]
 - Puma Version [e.g. 4.1.1]
 - Ruby Version (please reproduce on the latest patch for your Ruby minor; CI only tests the latest patch release)

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

**Describe the bug**
A clear and concise description of what the bug is.

**Puma config:**

Please copy-paste your Puma config AND your command line options here.

**To Reproduce**
Please add reproduction steps here.

Your issue will be solved very quickly if you can reproduce it with a "hello world" rack application. To do this, copy this into a file called `hello.ru`:

```
run lambda { |env| [200, {"Content-Type" => "text/plain"}, ["Hello World"]] }
```

Run it with:

```
bundle exec puma -C <where_your_config_is> hello.ru
```

If you cannot reproduce with a hello world application or other simple application, we will have a lot more difficulty helping you fix your issue, because it may be application-specific and not a bug in Puma at all.  

There is also a Dockerfile available for reproducing Linux-specific issues. To use:

```
$ docker build -f tools/docker/Dockerfile -t puma .
$ docker run -p 9292:9292 -it puma
```

This will help you to create a container that reproduces your issue.

**Expected behavior**
A clear and concise description of what you expected to happen.

**Desktop (please complete the following information):**
 - OS: [e.g. Mac, Linux]
 - Puma Version [e.g. 4.1.1]

### Description
Thank you for contributing! You're the best.

We can read your code, so consider leaving some comments here that are more about your motivations and decision making. Some things that may be helpful to address in your description:

- What original problem led to this PR?
- Are there related issues / prior discussions?
- What alternatives have been tried? Does this supersede previous attempts?
- Why do you make the choices you did? What are the tradeoffs?

### Your checklist for this pull request
<!--- Go over all the following points, and put an `x` in all the boxes that apply. You can delete or just add an X if you think its not applicable. -->
<!--- If you're unsure about any of these, don't hesitate to ask. We're here to help! -->
- [ ] I have reviewed the [guidelines for contributing](../blob/main/CONTRIBUTING.md) to this repository.
- [ ] I have added (or updated) appropriate tests if this PR fixes a bug or adds a feature.
- [ ] My pull request is 100 lines added/removed or less so that it can be easily reviewed.
- [ ] If this PR doesn't need tests (docs change), I added `[ci skip]` to the title of the PR.
- [ ] If this closes any issues, I have added "Closes `#issue`" to the PR description or my commit messages.
- [ ] I have updated the documentation accordingly.
- [ ] All new and existing tests passed, including Rubocop.

---
name: Clean Up Request
about: Suggest to clean up code, process or tech debt to the puma project
title: ''
labels: cleanup
assignees: ''

---

<!-- Please only use this template for submitting clean up requests -->

**What would you like to be cleaned**:

**Why is this needed**:

### Description
Thank you for contributing! You're the best.

We can read your code, so consider leaving some comments here that are more about your motivations and decision making. Some things that may be helpful to address in your description:

- What original problem led to this PR?
- Are there related issues / prior discussions?
- What alternatives have been tried? Does this supersede previous attempts?
- Why do you make the choices you did? What are the tradeoffs?

### Your checklist for this pull request
<!--- Go over all the following points, and put an `x` in all the boxes that apply. You can delete or just add an X if you think its not applicable. -->
<!--- If you're unsure about any of these, don't hesitate to ask. We're here to help! -->
- [ ] I have reviewed the [guidelines for contributing](../blob/master/CONTRIBUTING.md) to this repository.
- [ ] I have added (or updated) appropriate tests if this PR fixes a bug or adds a feature.
- [ ] My pull request is 100 lines added/removed or less so that it can be easily reviewed.
- [ ] If this PR doesn't need tests (docs change), I added `[ci skip]` to the title of the PR.
- [ ] If this closes any issues, I have added "Closes `#issue`" to the PR description or my commit messages.
- [ ] I have updated the documentation accordingly.
- [ ] All new and existing tests passed, including Rubocop.

### Description
Please describe your pull request. Thank you for contributing! You're the best.

### Your checklist for this pull request
<!--- Go over all the following points, and put an `x` in all the boxes that apply. -->
<!--- If you're unsure about any of these, don't hesitate to ask. We're here to help! -->
- [ ] I have reviewed the [guidelines for contributing](../blob/master/CONTRIBUTING.md) to this repository.
- [ ] I have added (or updated) appropriate tests if this PR fixes a bug or adds a feature.
- [ ] My pull request is 100 lines added/removed or less so that it can be easily reviewed.
- [ ] If this PR doesn't need tests (docs change), I added `[ci skip]` to the title of the PR.
- [ ] If this closes any issues, I have added "Closes `#issue`" to the PR description or my commit messages.
- [ ] I have updated the documentation accordingly.
- [ ] All new and existing tests passed, including Rubocop.

# Fork-Worker Cluster Mode [Experimental]

Puma 5 introduces an experimental new cluster-mode configuration option, `fork_worker` (`--fork-worker` from the CLI). This mode causes Puma to fork additional workers from worker 0, instead of directly from the master process:

```
10000   \_ puma 4.3.3 (tcp://0.0.0.0:9292) [puma]
10001       \_ puma: cluster worker 0: 10000 [puma]
10002           \_ puma: cluster worker 1: 10000 [puma]
10003           \_ puma: cluster worker 2: 10000 [puma]
10004           \_ puma: cluster worker 3: 10000 [puma]
```

The `fork_worker` option allows your application to be initialized only once for copy-on-write memory savings, and it has two additional advantages:

1. **Compatible with phased restart.** Because the master process itself doesn't preload the application, this mode works with phased restart (`SIGUSR1` or `pumactl phased-restart`). When worker 0 reloads as part of a phased restart, it initializes a new copy of your application first, then the other workers reload by forking from this new worker already containing the new preloaded application.

   This allows a phased restart to complete as quickly as a hot restart (`SIGUSR2` or `pumactl restart`), while still minimizing downtime by staggering the restart across cluster workers.

2. **'Refork' for additional copy-on-write improvements in running applications.** Fork-worker mode introduces a new `refork` command that re-loads all nonzero workers by re-forking them from worker 0.

   This command can potentially improve memory utilization in large or complex applications that don't fully pre-initialize on startup, because the re-forked workers can share copy-on-write memory with a worker that has been running for a while and serving requests.

   You can trigger a refork by sending the cluster the `SIGURG` signal or running the `pumactl refork` command at any time. A refork will also automatically trigger once, after a certain number of requests have been processed by worker 0 (default 1000). To configure the number of requests before the auto-refork, pass a positive integer argument to `fork_worker` (e.g., `fork_worker 1000`), or `0` to disable.

### Usage Considerations

- `fork_worker` introduces new `on_refork` and `after_refork` configuration hooks. Note the following:
    - When initially forking the parent process to the worker 0 child, `before_fork` will trigger on the parent process and `on_worker_boot` will trigger on the worker 0 child as normal.
    - When forking the worker 0 child to grandchild workers, `on_refork` and `after_refork` will trigger on the worker 0 child, and `on_worker_boot` will trigger on each grandchild worker.
    - For clarity, `before_fork` does not trigger on worker 0, and `after_refork` does not trigger on the grandchild.
- As a general migration guide:
    - Copy any logic within your existing `before_fork` hook to the `on_refork` hook.
    - Consider to copy logic from your `on_worker_boot` hook to the `after_refork` hook, if it is needed to reset the state of worker 0 after it forks.

### Limitations

- This mode is still very experimental so there may be bugs or edge-cases, particularly around expected behavior of existing hooks. Please open a [bug report](https://github.com/puma/puma/issues/new?template=bug_report.md) if you encounter any issues.

- In order to fork new workers cleanly, worker 0 shuts down its server and stops serving requests so there are no open file descriptors or other kinds of shared global state between processes, and to maximize copy-on-write efficiency across the newly-forked workers. This may temporarily reduce total capacity of the cluster during a phased restart / refork.

- In a cluster with `n` workers, a normal phased restart stops and restarts workers one by one while the application is loaded in each process, so `n-1` workers are available serving requests during the restart. In a phased restart in fork-worker mode, the application is first loaded in worker 0 while `n-1` workers are available, then worker 0 remains stopped while the rest of the workers are reloaded one by one, leaving only `n-2` workers to be available for a brief period of time. Reloading the rest of the workers should be quick because the application is preloaded at that point, but there may be situations where it can take longer (slow clients, long-running application code, slow worker-fork hooks, etc).

# Fork-Worker Cluster Mode [Experimental]

Puma 5 introduces an experimental new cluster-mode configuration option, `fork_worker` (`--fork-worker` from the CLI). This mode causes Puma to fork additional workers from worker 0, instead of directly from the master process:

```
10000   \_ puma 4.3.3 (tcp://0.0.0.0:9292) [puma]
10001       \_ puma: cluster worker 0: 10000 [puma]
10002           \_ puma: cluster worker 1: 10000 [puma]
10003           \_ puma: cluster worker 2: 10000 [puma]
10004           \_ puma: cluster worker 3: 10000 [puma]
```

The `fork_worker` option allows your application to be initialized only once for copy-on-write memory savings, and it has two additional advantages:

1. **Compatible with phased restart.** Because the master process itself doesn't preload the application, this mode works with phased restart (`SIGUSR1` or `pumactl phased-restart`). When worker 0 reloads as part of a phased restart, it initializes a new copy of your application first, then the other workers reload by forking from this new worker already containing the new preloaded application.

   This allows a phased restart to complete as quickly as a hot restart (`SIGUSR2` or `pumactl restart`), while still minimizing downtime by staggering the restart across cluster workers.

2. **'Refork' for additional copy-on-write improvements in running applications.** Fork-worker mode introduces a new `refork` command that re-loads all nonzero workers by re-forking them from worker 0.

   This command can potentially improve memory utilization in large or complex applications that don't fully pre-initialize on startup, because the re-forked workers can share copy-on-write memory with a worker that has been running for a while and serving requests.

   You can trigger a refork by sending the cluster the `SIGURG` signal or running the `pumactl refork` command at any time. A refork will also automatically trigger once, after a certain number of requests have been processed by worker 0 (default 1000). To configure the number of requests before the auto-refork, pass a positive integer argument to `fork_worker` (e.g., `fork_worker 1000`), or `0` to disable.

### Usage Considerations

- `fork_worker` introduces new `before_refork` and `after_refork` configuration hooks. Note the following:
    - When initially forking the parent process to the worker 0 child, `before_fork` will trigger on the parent process and `before_worker_boot` will trigger on the worker 0 child as normal.
    - When forking the worker 0 child to grandchild workers, `before_refork` and `after_refork` will trigger on the worker 0 child, and `before_worker_boot` will trigger on each grandchild worker.
    - For clarity, `before_fork` does not trigger on worker 0, and `after_refork` does not trigger on the grandchild.
- As a general migration guide:
    - Copy any logic within your existing `before_fork` hook to the `before_refork` hook.
    - Consider to copy logic from your `before_worker_boot` hook to the `after_refork` hook, if it is needed to reset the state of worker 0 after it forks.

### Limitations

- This mode is still very experimental so there may be bugs or edge-cases, particularly around expected behavior of existing hooks. Please open a [bug report](https://github.com/puma/puma/issues/new?template=bug_report.md) if you encounter any issues.

- In order to fork new workers cleanly, worker 0 shuts down its server and stops serving requests so there are no open file descriptors or other kinds of shared global state between processes, and to maximize copy-on-write efficiency across the newly-forked workers. This may temporarily reduce total capacity of the cluster during a phased restart / refork.

- In a cluster with `n` workers, a normal phased restart stops and restarts workers one by one while the application is loaded in each process, so `n-1` workers are available serving requests during the restart. In a phased restart in fork-worker mode, the application is first loaded in worker 0 while `n-1` workers are available, then worker 0 remains stopped while the rest of the workers are reloaded one by one, leaving only `n-2` workers to be available for a brief period of time. Reloading the rest of the workers should be quick because the application is preloaded at that point, but there may be situations where it can take longer (slow clients, long-running application code, slow worker-fork hooks, etc).

# Testing - test/rackup/ci-*.ru files

## Overview

Puma should efficiently handle a variety of response bodies, varying both by size
and by the type of object used for the body.

Five rackup files are located in 'test/rackup' that can be used.  All have their
request body size (in kB) set via `Body-Conf` header or with `ENV['CI_BODY_CONF']`.
Additionally, the ci_select.ru file can have it's body type set via a starting
character.

* **ci_array.ru** - body is an `Array` of 1kB strings.  `Content-Length` is not set.
* **ci_chunked.ru** - body is an `Enumerator` of 1kB strings.  `Content-Length` is not set.
* **ci_io.ru** - body is a File/IO object.  `Content-Length` is set.
* **ci_string.ru** - body is a single string.  `Content-Length` is set.
* **ci_select.ru** - can be any of the above.

All responses have 25 headers, total length approx 1kB.  ci_array.ru and ci_chunked.ru
contain 1kB items.

All can be delayed by a float value (seconds) specified by the `Dly` header

Note that rhe `Body-Conf` header takes precedence, and `ENV['CI_BODY_CONF']` is
only read on load.

## ci_select.ru

The ci_select.ru file allows a starting character to specify the body type in the
`Body-Conf` header or with `ENV['CI_BODY_CONF']`.
* **a** - array of strings
* **c** - chunked (enum)
* **s** - single string
* **i** - File/IO

A value of `a100` would return a body as an array of 100 1kB strings.

# Testing - benchmark/local files

These files generate data that shows request-per-second (RPS), etc. Typically, files are in 
pairs, a shell script and a Ruby script. The shell script starts the server, then runs the 
Ruby file, which starts client request stream(s), then collects and logs metrics.

## response_time_wrk.sh

This uses [wrk] for generating data. One or more wrk runs are performed. Summarizes RPS and 
wrk latency times. The default for the `-b` argument runs 28 different client request streams, 
and takes a bit over 5 minutes.  See 'Request Stream Configuration' below for `-b` argument
description.

<details>
  <summary>Summary output for<br/><code>benchmarks/local/response_time_wrk.sh -w2 -t5:5 -s tcp6</code>:</summary>

```
Type   req/sec    50%     75%     90%     99%    100%  Resp Size
─────────────────────────────────────────────────────────────────    1kB
array   13710    0.74    2.52    5.23    7.76   37.45      1024
chunk   13502    0.76    2.55    5.28    7.84   11.23      1042
string  13794    0.74    2.51    5.20    7.75   14.07      1024
io       9615    1.16    3.45    7.13   10.57   15.75      1024
─────────────────────────────────────────────────────────────────   10kB
array   13458    0.76    2.57    5.31    7.93   13.94     10239
chunk   13066    0.78    2.64    5.46    8.18   38.48     10320
string  13500    0.76    2.55    5.29    7.88   11.42     10240
io       9293    1.18    3.59    7.39   10.94   16.99     10240
─────────────────────────────────────────────────────────────────  100kB
array   11315    0.96    3.06    6.33    9.49   17.69    102424
chunk    9916    1.10    3.48    7.20   10.73   15.14    103075
string  10948    1.00    3.17    6.57    9.83   17.88    102378
io       8901    1.21    3.72    7.48   11.27   59.98    102407
─────────────────────────────────────────────────────────────────  256kB
array    9217    1.15    3.82    7.88   11.74   17.12    262212
chunk    7339    1.45    4.76    9.81   14.63   22.70    264007
string   8574    1.19    3.81    7.73   11.21   15.80    262147
io       8911    1.19    3.80    7.55   15.25   60.01    262183
─────────────────────────────────────────────────────────────────  512kB
array    6951    1.49    5.03   10.28   15.90   25.08    524378
chunk    5234    2.03    6.56   13.57   20.46   32.15    527862
string   6438    1.55    5.04   10.12   16.28   72.87    524275
io       8533    1.15    4.62    8.79   48.15   70.51    524327
───────────────────────────────────────────────────────────────── 1024kB
array    4122    1.80   15.59   41.87   67.79  121.00   1048565
chunk    3158    2.82   15.22   31.00   71.39   99.90   1055654
string   4710    2.24    6.66   13.65   20.38   70.44   1048575
io       8355    1.23    3.95    7.94   14.08   68.54   1048498
───────────────────────────────────────────────────────────────── 2048kB
array    2454    4.12   14.02   27.70   43.48   88.89   2097415
chunk    1743    6.26   17.65   36.98   55.78   92.10   2111358
string   2479    4.38   12.52   25.65   38.44   95.62   2097502
io       8264    1.25    3.83    7.76   11.73   65.69   2097090

Body    ────────── req/sec ──────────   ─────── req 50% times ───────
 KB     array   chunk  string      io   array   chunk  string      io
1       13710   13502   13794    9615   0.745   0.757   0.741   1.160
10      13458   13066   13500    9293   0.760   0.784   0.759   1.180
100     11315    9916   10948    8901   0.960   1.100   1.000   1.210
256      9217    7339    8574    8911   1.150   1.450   1.190   1.190
512      6951    5234    6438    8533   1.490   2.030   1.550   1.150
1024     4122    3158    4710    8355   1.800   2.820   2.240   1.230
2048     2454    1743    2479    8264   4.120   6.260   4.380   1.250
─────────────────────────────────────────────────────────────────────
wrk -t8 -c16 -d10s
benchmarks/local/response_time_wrk.sh -w2 -t5:5 -s tcp6 -Y
Server cluster mode -w2 -t5:5, bind: tcp6
Puma repo branch 00-response-refactor
ruby 3.2.0dev (2022-06-14T01:21:55Z master 048f14221c) +YJIT [x86_64-linux]

[2136] - Gracefully shutting down workers...
[2136] === puma shutdown: 2022-06-13 21:16:13 -0500 ===
[2136] - Goodbye!

 5:15 Total Time
```
</details><br/>

## bench_base.sh, bench_base.rb

These two files setup parameters for the Puma server, which is normally started in a shell 
script. It then starts a Ruby file (a subclass of BenchBase), passing arguments to it. The 
Ruby file is normally used to generate a client request stream(s).

### Puma Configuration

The following arguments are used for the Puma server:

* **`-C`** - configuration file
* **`-d`** - app delay
* **`-r`** - rackup file, often defaults to test/rackup/ci_select.ru
* **`-s`** - bind socket type, default is tcp/tcp4, also tcp6, ssl/ssl4, ssl6, unix, or aunix
  (unix & abstract unix are not available with wrk).
* **`-t`** - threads, expressed as '5:5', same as Puma --thread
* **`-w`** - workers, same as Puma --worker
* **`-Y`** - enable Ruby YJIT

### Request Stream Configuration

The following arguments are used for request streams:

* **`-b`** - response body configuration. Body type options are a array, c chunked, s string,
  and i for File/IO. None or any combination can be specified, they should start the option.
  Then, any combination of comma separated integers can be used for the response body size
  in kB. The string 'ac50,100' would create four runs, 50kb array, 50kB chunked, 100kB array,
  and 100kB chunked. See 'Testing - test/rackup/ci-*.ru files' for more info.
* **`-c`** - connections per client request stream thread, defaults to 2 for wrk.
* **`-D`** - duration of client request stream in seconds.
* **`-T`** - number of threads in the client request stream. For wrk, this defaults to
  80% of Puma workers * max_threads.

### Notes - Configuration

The above lists script arguments.

`bench_base.sh` contains most server defaults. Many can be set via ENV variables.

`bench_base.rb` contains the client request stream defaults. The default value for
`-b` is `acsi1,10,100,256,512,1024,2048`, which is a 4 x 7 matrix, and hence, runs
28 jobs. Also, the i body type (File/IO) generates files, they are placed in the
`"#{Dir.tmpdir}/.puma_response_body_io"` directory, which is created.

### Notes - wrk

The shell scripts use `-T` for wrk's thread count, since `-t` is used for Puma
server threads.  Regarding the `-c` argument, wrk has an interesting behavior.
The total number of connections is set by `(connections/threads).to_i`. The scripts
here use `-c` as connections per thread.  Hence, using `-T4 -c2` will yield a total
of eight wrk connections, two per thread. The equivalent wrk arguments would be `-t4 -c8`.

Puma can only process so many requests, and requests will queue in the backlog
until Puma can respond to them. With wrk, if the number of total connections is
too high, one will see the upper latency times increase, pushing into the lower
latency times as the connections are increased. The default values for wrk's
threads and connections were chosen to minimize requests' time in the backlog.

An example with four wrk runs using `-b s10`.  Notice that `req/sec` varies by
less than 1%, but the `75%` times increase by an order of magnitude:
```
req/sec    50%     75%     90%     99%    100%  Resp Size   wrk cmd line
─────────────────────────────────────────────────────────────────────────────
 13597   0.755   2.550   5.260   7.800  13.310     12040    wrk -t8  -c16 -d10
 13549   0.793   4.430   8.140  11.220  16.600     12002    wrk -t10 -c20 -d10
 13570   1.040  25.790  40.010  49.070  58.300     11982    wrk -t8  -c64 -d10
 13684   1.050  25.820  40.080  49.160  66.190     12033    wrk -t16 -c64 -d10
```
Finally, wrk's output may cause rounding errors, so the response body size calculation is
imprecise.

[wrk]: <https://github.com/ioquatix/wrk>

The [unix signal](https://en.wikipedia.org/wiki/Unix_signal) is a method of sending messages between [processes](https://en.wikipedia.org/wiki/Process_(computing)). When a signal is sent, the operating system interrupts the target process's normal flow of execution. There are standard signals that are used to stop a process, but there are also custom signals that can be used for other purposes. This document is an attempt to list all supported signals that Puma will respond to. In general, signals need only be sent to the master process of a cluster.

## Sending Signals

If you are new to signals, it can be helpful to see how they are used. When a process starts in a *nix-like operating system, it will have a [PID - or process identifier](https://en.wikipedia.org/wiki/Process_identifier) that can be used to send signals to the process. For demonstration, we will create an infinitely running process by tailing a file:

```sh
$ echo "foo" >> my.log
$ irb
> pid = Process.spawn 'tail -f my.log'
```

From here, we can see that the tail process is running by using the `ps` command:

```sh
$ ps aux | grep tail
schneems        87152   0.0  0.0  2432772    492 s032  S+   12:46PM   0:00.00 tail -f my.log
```

You can send a signal in Ruby using the [Process module](https://docs.ruby-lang.org/en/master/Process.html#method-c-kill):

```
$ irb
> puts pid
=> 87152
Process.detach(pid) # https://docs.ruby-lang.org/en/master/Process.html#method-c-detach
Process.kill("TERM", pid)
```

Now you will see via `ps` that there is no more `tail` process. Sometimes when referring to signals, the `SIG` prefix will be used. For example, `SIGTERM` is equivalent to sending `TERM` via `Process.kill`.

## Puma Signals

Puma cluster responds to these signals:

- `TTIN`: Increment the worker count by 1.
- `TTOU`: Decrement the worker count by 1.
- `TERM`: Send `TERM` to worker. The worker will attempt to finish then exit.
- `USR2`: Restart workers. This also reloads the Puma configuration file, if there is one.
- `USR1`: Restart workers in phases, a rolling restart. This will not reload the configuration file.
- `HUP`:  Reopen log files defined in `stdout_redirect` configuration parameter. If there is no `stdout_redirect` option provided, it will behave like `INT`.
- `INT`:  Equivalent of sending Ctrl-C to cluster. Puma will attempt to finish then exit.
- `CHLD`: Reap zombie child processes and wake event loop in `fork_worker` mode.
- `URG`:  Refork workers in phases from worker 0 if `fork_worker` option is enabled.
- `INFO` (or `PWR` for systems without `INFO`) print backtraces of all puma threads (if supported on your platform).

## Callbacks order in case of different signals

### Start application

```
puma configuration file reloaded, if there is one
* Pruning Bundler environment
puma configuration file reloaded, if there is one

before_fork
before_worker_fork
after_worker_fork

Gemfile in context

before_worker_boot

Code of the app is loaded and running
```

### Send USR2

```
before_worker_shutdown
before_restart

puma configuration file reloaded, if there is one

before_fork
before_worker_fork
after_worker_fork

Gemfile in context

before_worker_boot

Code of the app is loaded and running
```

### Send USR1

```
before_worker_shutdown
before_worker_fork
after_worker_fork

Gemfile in context

before_worker_boot

Code of the app is loaded and running
```

# Architecture

## Overview

![http://bit.ly/2iJuFky](images/puma-general-arch.png)

Puma is a threaded web server, processing requests across a TCP or UNIX socket.

Workers accept connections from the socket and a thread in the worker's thread pool processes the client's request.

Clustered mode is shown/discussed here. Single mode is analogous to having a single worker process.

## Connection pipeline

![http://bit.ly/2zwzhEK](images/puma-connection-flow.png)

* Upon startup, Puma listens on a TCP or UNIX socket.
  * The backlog of this socket is configured (with a default of 1024), determining how many established but unaccepted connections can exist concurrently.
  * This socket backlog is distinct from the "backlog" of work as reported by the control server stats. The latter is the number of connections in that worker's "todo" set waiting for a worker thread.
* By default, a single, separate thread is used to receive HTTP requests across the socket.
  * When at least one worker thread is available for work, a connection is accepted and placed in this request buffer
  * This thread waits for entire HTTP requests to be received over the connection
    * The time spent waiting for the HTTP request body to be received is exposed to the Rack app as `env['puma.request_body_wait']` (milliseconds)
  * Once received, the connection is pushed into the "todo" set
* Worker threads pop work off the "todo" set for processing
  * The thread processes the request via the rack application (which generates the HTTP response)
  * The thread writes the response to the connection
  * Finally, the thread become available to process another connection in the "todo" set

### Disabling `queue_requests`

![http://bit.ly/2zxCJ1Z](images/puma-connection-flow-no-reactor.png)

The `queue_requests` option is `true` by default, enabling the separate thread used to buffer requests as described above.

If set to `false`, this buffer will not be used for connections while waiting for the request to arrive.
In this mode, when a connection is accepted, it is added to the "todo" queue immediately, and a worker will synchronously do any waiting necessary to read the HTTP request from the socket.

# Restarts

To perform a restart, there are 3 builtin mechanisms:

  * Send the `puma` process the `SIGUSR2` signal (normal restart)
  * Send the `puma` process the `SIGUSR1` signal (restart in phases (a "rolling restart"), cluster mode only)
  * Use the status server and issue `/restart`

No code is shared between the current and restarted process, so it should be safe to issue a restart any place where you would manually stop Puma and start it again.

If the new process is unable to load, it will simply exit. You should therefore run Puma under a process monitor (see below) when using it in production.

### Normal vs Hot vs Phased Restart

A hot restart means that no requests will be lost while deploying your new code, since the server socket is kept open between restarts.

But beware, hot restart does not mean that the incoming requests won’t hang for multiple seconds while your new code has not fully deployed. If you need a zero downtime and zero hanging requests deploy, you must use phased restart.

When you run pumactl phased-restart, Puma kills workers one-by-one, meaning that at least another worker is still available to serve requests, which lead to zero hanging requests (yay!).

But again beware, upgrading an application sometimes involves upgrading the database schema. With phased restart, there may be a moment during the deployment where processes belonging to the previous version and processes belonging to the new version both exist at the same time. Any database schema upgrades you perform must therefore be backwards-compatible with the old application version.

If you perform a lot of database migrations, you probably should not use phased restart and use a normal/hot restart instead (`pumactl restart`). That way, no code is shared while deploying (in that case, `preload_app!` might help for quicker deployment, see ["Clustered Mode" in the README](../README.md#clustered-mode)).

**Note**: Hot and phased restarts are only available on MRI, not on JRuby. They are also unavailable on Windows servers.

### Release Directory

If your symlink releases into a common working directory (i.e., `/current` from Capistrano), Puma won't pick up your new changes when running phased restarts without additional configuration. You should set your working directory within Puma's config to specify the directory it should use. This is a change from earlier versions of Puma (< 2.15) that would infer the directory for you.

```ruby
# config/puma.rb

directory '/var/www/current'
```

### Cleanup Code

Puma isn't able to understand all the resources that your app may use, so it provides a hook in the configuration file you pass to `-C` called `on_restart`. The block passed to `on_restart` will be called, unsurprisingly, just before Puma restarts itself.

You should place code to close global log files, redis connections, etc. in this block so that their file descriptors don't leak into the restarted process. Failure to do so will result in slowly running out of descriptors and eventually obscure crashes as the server is restarted many times.

# Using gRPC with Puma in Clustered Mode

This guide shows how to set up gRPC with Puma in a clustered environment using Puma's hooks to manage gRPC's lifecycle methods during forking.

## The Problem

In a clustered Puma setup, you might encounter the following error when using gRPC:

```
grpc cannot be used between calls to GRPC.prefork and GRPC.postfork_child or GRPC.postfork_parent
```

To work correctly, gRPC needs these methods called at specific points in the process lifecycle:
- `GRPC.prefork`: Called before forking.
- `GRPC.postfork_child`: Called in the child process after forking.
- `GRPC.postfork_parent`: Called in the parent process after forking.

Puma provides hooks such as `before_worker_fork`, `after_worker_fork`, and `before_worker_boot` to execute code during these lifecycle events. Understanding the behavior of these hooks is key to ensuring gRPC operates correctly in a clustered setup.

## The Solution

### Example Configuration

This configuration integrates gRPC's lifecycle methods in a clustered Puma setup and works whether preloading is enabled or not.

```ruby
# config/puma.rb

is_mac = RUBY_PLATFORM.include?("darwin")

before_worker_fork do |index|
  GRPC.prefork unless is_mac
end

after_worker_fork do |index|
  GRPC.postfork_parent unless is_mac
end

before_worker_boot do
  GRPC.postfork_child unless is_mac
end
```

### Understanding the Lifecycle and Hooks

Puma's hooks determine when to call gRPC's lifecycle methods. Each hook plays a specific role in managing the lifecycle during forking:

- **`before_worker_fork`**:
  - This hook runs before forking workers and is where you call `GRPC.prefork`.
  - In preloading setups (default in Puma v7), it runs in the **master process** before workers are forked, as the application is preloaded in the master process.
  - Without preloading, it still runs in the **master process** before forking workers, but the application is not preloaded.
  - `GRPC.prefork` is called here to prepare GRPC for the forking process.

- **`after_worker_fork`**:
  - This hook always runs in the **master process** after a worker is forked, regardless of whether preloading is enabled.
  - Call `GRPC.postfork_parent` here to finalize the master process's state after forking.

- **`before_worker_boot`**:
  - This hook always runs in the **worker process** after it is forked, regardless of whether preloading is enabled.
  - Call `GRPC.postfork_child` here to finalize the worker's state.

**Note**: On macOS, these methods are skipped because gRPC does not require them due to differences in how forking works.

# Nginx configuration example file

This is a very common setup using an upstream. It was adapted from some Capistrano recipe I found on the Internet a while ago.

```nginx
upstream myapp {
  server unix:///myapp/tmp/puma.sock;
}

server {
  listen 80;
  server_name myapp.com;

  # ~2 seconds is often enough for most folks to parse HTML/CSS and
  # retrieve needed images/icons/frames, connections are cheap in
  # nginx so increasing this is generally safe...
  keepalive_timeout 5;

  # path for static files
  root /myapp/public;
  access_log /myapp/log/nginx.access.log;
  error_log /myapp/log/nginx.error.log info;

  # this rewrites all the requests to the maintenance.html
  # page if it exists in the doc root. This is for capistrano's
  # disable web task
  if (-f $document_root/maintenance.html) {
    rewrite  ^(.*)$  /maintenance.html last;
    break;
  }

  location / {
    proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    proxy_set_header Host $host;

    # If the file exists as a static file serve it directly without
    # running all the other rewrite tests on it
    if (-f $request_filename) {
      break;
    }

    # check for index.html for directory index
    # if it's there on the filesystem then rewrite
    # the url to add /index.html to the end of it
    # and then break to send it to the next config rules.
    if (-f $request_filename/index.html) {
      rewrite (.*) $1/index.html break;
    }

    # this is the meat of the rack page caching config
    # it adds .html to the end of the url and then checks
    # the filesystem for that file. If it exists, then we
    # rewrite the url to have explicit .html on the end
    # and then send it on its way to the next config rule.
    # if there is no file on the fs then it sets all the
    # necessary headers and proxies to our upstream pumas
    if (-f $request_filename.html) {
      rewrite (.*) $1.html break;
    }

    if (!-f $request_filename) {
      proxy_pass http://myapp;
      break;
    }
  }

  # Now this supposedly should work as it gets the filenames with querystrings that Rails provides.
  # BUT there's a chance it could break the ajax calls.
  location ~* \.(ico|css|gif|jpe?g|png|js)(\?[0-9]+)?$ {
     expires max;
     break;
  }

  # Error pages
  # error_page 500 502 503 504 /500.html;
  location = /500.html {
    root /myapp/current/public;
  }
}
```

# systemd

[systemd](https://www.freedesktop.org/wiki/Software/systemd/) is a
commonly available init system (PID 1) on many Linux distributions. It
offers process monitoring (including automatic restarts) and other
useful features for running Puma in production.

## Service Configuration

Below is a sample puma.service configuration file for systemd, which
can be copied or symlinked to /etc/systemd/system/puma.service, or if
desired, using an application or instance specific name.

Note that this uses the systemd preferred "simple" type where the
start command remains running in the foreground (does not fork and
exit). See also, the
[Alternative Forking Configuration](#alternative-forking-configuration)
below.

~~~~ ini
[Unit]
Description=Puma HTTP Server
After=network.target

# Uncomment for socket activation (see below)
# Requires=puma.socket

[Service]
# Foreground process (do not use --daemon in ExecStart or config.rb)
Type=simple

# Preferably configure a non-privileged user
# User=

# The path to the your application code root directory.
# Also replace the "<YOUR_APP_PATH>" place holders below with this path.
# Example /home/username/myapp
WorkingDirectory=<YOUR_APP_PATH>

# Helpful for debugging socket activation, etc.
# Environment=PUMA_DEBUG=1

# SystemD will not run puma even if it is in your path. You must specify
# an absolute URL to puma. For example /usr/local/bin/puma
# Alternatively, create a binstub with `bundle binstubs puma --path ./sbin` in the WorkingDirectory
ExecStart=/<FULLPATH>/bin/puma -C <YOUR_APP_PATH>/puma.rb

# Variant: Rails start.
# ExecStart=/<FULLPATH>/bin/puma -C <YOUR_APP_PATH>/config/puma.rb ../config.ru

# Variant: Use `bundle exec --keep-file-descriptors puma` instead of binstub
# Variant: Specify directives inline.
# ExecStart=/<FULLPATH>/puma -b tcp://0.0.0.0:9292 -b ssl://0.0.0.0:9293?key=key.pem&cert=cert.pem


Restart=always

[Install]
WantedBy=multi-user.target
~~~~

See [systemd.exec](https://www.freedesktop.org/software/systemd/man/systemd.exec.html)
for additional details.

## Socket Activation

systemd and puma also support socket activation, where systemd opens
the listening socket(s) in advance and provides them to the puma
master process on startup. Among other advantages, this keeps
listening sockets open across puma restarts and achieves graceful
restarts, including when upgraded puma, and is compatible with both
clustered mode and application preload.

**Note:** Any wrapper scripts which `exec`, or other indirections in
`ExecStart`, may result in activated socket file descriptors being closed
before they reach the puma master process. For example, if using `bundle exec`,
pass the `--keep-file-descriptors` flag. `bundle exec` can be avoided by using a
`puma` executable generated by `bundle binstubs puma`. This is tracked in
[#1499].

**Note:** Socket activation doesn't currently work on jruby. This is
tracked in [#1367].

To use socket activation, configure one or more `ListenStream` sockets
in a companion `*.socket` unit file. Also uncomment the associated
`Requires` directive for the socket unit in the service file (see
above.) Here is a sample puma.socket, matching the ports used in the
above puma.service:

~~~~ ini
[Unit]
Description=Puma HTTP Server Accept Sockets

[Socket]
ListenStream=0.0.0.0:9292
ListenStream=0.0.0.0:9293

# AF_UNIX domain socket
# SocketUser, SocketGroup, etc. may be needed for Unix domain sockets
# ListenStream=/run/puma.sock

# Socket options matching Puma defaults
NoDelay=true
ReusePort=true
Backlog=1024

[Install]
WantedBy=sockets.target
~~~~

See [systemd.socket](https://www.freedesktop.org/software/systemd/man/systemd.socket.html)
for additional configuration details.

Note that the above configurations will work with Puma in either
single process or cluster mode.

### Sockets and symlinks

When using releases folders, you should set the socket path using the
shared folder path (ex. `/srv/projet/shared/tmp/puma.sock`), not the
release folder path (`/srv/projet/releases/1234/tmp/puma.sock`).

Puma will detect the release path socket as different than the one provided by
systemd and attempt to bind it again, resulting in the exception
 `There is already a server bound to:`.

## Usage

Without socket activation, use `systemctl` as root (e.g. via `sudo`) as
with other system services:

~~~~ sh
# After installing or making changes to puma.service
systemctl daemon-reload

# Enable so it starts on boot
systemctl enable puma.service

# Initial start up.
systemctl start puma.service

# Check status
systemctl status puma.service

# A normal restart. Warning: listeners sockets will be closed
# while a new puma process initializes.
systemctl restart puma.service
~~~~

With socket activation, several but not all of these commands should
be run for both socket and service:

~~~~ sh
# After installing or making changes to either puma.socket or
# puma.service.
systemctl daemon-reload

# Enable both socket and service so they start on boot.  Alternatively
# you could leave puma.service disabled and systemd will start it on
# first use (with startup lag on first request)
systemctl enable puma.socket puma.service

# Initial start up. The Requires directive (see above) ensures the
# socket is started before the service.
systemctl start puma.socket puma.service

# Check status of both socket and service.
systemctl status puma.socket puma.service

# A "hot" restart, with systemd keeping puma.socket listening and
# providing to the new puma (master) instance.
systemctl restart puma.service

# A normal restart, needed to handle changes to
# puma.socket, such as changing the ListenStream ports. Note
# daemon-reload (above) should be run first.
systemctl restart puma.socket puma.service
~~~~

Here is sample output from `systemctl status` with both service and
socket running:

~~~~
● puma.socket - Puma HTTP Server Accept Sockets
   Loaded: loaded (/etc/systemd/system/puma.socket; enabled; vendor preset: enabled)
   Active: active (running) since Thu 2016-04-07 08:40:19 PDT; 1h 2min ago
   Listen: 0.0.0.0:9233 (Stream)
           0.0.0.0:9234 (Stream)

Apr 07 08:40:19 hx systemd[874]: Listening on Puma HTTP Server Accept Sockets.

● puma.service - Puma HTTP Server
   Loaded: loaded (/etc/systemd/system/puma.service; enabled; vendor preset: enabled)
   Active: active (running) since Thu 2016-04-07 08:40:19 PDT; 1h 2min ago
 Main PID: 28320 (ruby)
   CGroup: /system.slice/puma.service
           ├─28320 puma 3.3.0 (tcp://0.0.0.0:9233,ssl://0.0.0.0:9234?key=key.pem&cert=cert.pem) [app]
           ├─28323 puma: cluster worker 0: 28320 [app]
           └─28327 puma: cluster worker 1: 28320 [app]

Apr 07 08:40:19 hx puma[28320]: Puma starting in cluster mode...
Apr 07 08:40:19 hx puma[28320]: * Version 3.3.0 (ruby 2.2.4-p230), codename: Jovial Platypus
Apr 07 08:40:19 hx puma[28320]: * Min threads: 0, max threads: 16
Apr 07 08:40:19 hx puma[28320]: * Environment: production
Apr 07 08:40:19 hx puma[28320]: * Process workers: 2
Apr 07 08:40:19 hx puma[28320]: * Phased restart available
Apr 07 08:40:19 hx puma[28320]: * Activated tcp://0.0.0.0:9233
Apr 07 08:40:19 hx puma[28320]: * Activated ssl://0.0.0.0:9234?key=key.pem&cert=cert.pem
Apr 07 08:40:19 hx puma[28320]: Use Ctrl-C to stop
~~~~

## Alternative Forking Configuration

Other systems/tools might expect or need puma to be run as a
"traditional" forking server, for example so that the `pumactl`
command can be used directly and outside of systemd for
stop/start/restart. This use case is incompatible with systemd socket
activation, so it should not be configured. Below is an alternative
puma.service config sample, using `Type=forking` and the `--daemon`
flag in `ExecStart`. Here systemd is playing a role more equivalent to
SysV init.d, where it is responsible for starting Puma on boot
(multi-user.target) and stopping it on shutdown, but is not performing
continuous restarts. Therefore running Puma in cluster mode, where the
master can restart workers, is highly recommended. See the systemd
[Restart] directive for details.

~~~~ ini
[Unit]
Description=Puma HTTP Forking Server
After=network.target

[Service]
# Background process configuration (use with --daemon in ExecStart)
Type=forking

# Preferably configure a non-privileged user
# User=

# The path to the puma application root
# Also replace the "<WD>" place holders below with this path.
WorkingDirectory=

# The command to start Puma
# (replace "<WD>" below)
ExecStart=bundle exec puma -C <WD>/shared/puma.rb --daemon

# The command to stop Puma
# (replace "<WD>" below)
ExecStop=bundle exec pumactl -S <WD>/shared/tmp/pids/puma.state stop

# Path to PID file so that systemd knows which is the master process
PIDFile=<WD>/shared/tmp/pids/puma.pid

# Should systemd restart puma?
# Use "no" (the default) to ensure no interference when using
# stop/start/restart via `pumactl`.  The "on-failure" setting might
# work better for this purpose, but you must test it.
# Use "always" if only `systemctl` is used for start/stop/restart, and
# reconsider if you actually need the forking config.
Restart=no

# `puma_ctl restart` wouldn't work without this. It's because `pumactl`
# changes PID on restart and systemd stops the service afterwards
# because of the PID change. This option prevents stopping after PID
# change.
RemainAfterExit=yes

[Install]
WantedBy=multi-user.target
~~~~

### capistrano3-puma

By default,
[capistrano3-puma](https://github.com/seuros/capistrano-puma) uses
`pumactl` for deployment restarts, outside of systemd.  To learn the
exact commands that this tool would use for `ExecStart` and
`ExecStop`, use the following `cap` commands in dry-run mode, and
update from the above forking service configuration accordingly. Note
also that the configured `User` should likely be the same as the
capistrano3-puma `:puma_user` option.

~~~~ sh
stage=production # or different stage, as needed
cap $stage puma:start --dry-run
cap $stage puma:stop  --dry-run
~~~~

[Restart]: https://www.freedesktop.org/software/systemd/man/systemd.service.html#Restart=
[#1367]: https://github.com/puma/puma/issues/1367

# Deployment engineering for puma

Puma is software that is expected to be run in a deployed environment eventually.
You can certainly use it as your dev server only, but most people look to use
it in their production deployments as well.

To that end, this is meant to serve as a foundation of wisdom how to do that
in a way that increases happiness and decreases downtime.

## Specifying puma

Most people want to do this by putting `gem "puma"` into their Gemfile, so we'll
go ahead and assume that. Go add it now... we'll wait.


Welcome back!

## Single vs Cluster mode

Puma was originally conceived as a thread-only webserver, but grew the ability to
also use processes in version 2.

Here are some rules of thumb:

### MRI

* Use cluster mode and set the number of workers to 1.5x the number of cpu cores
  in the machine, minimum 2.
* Set the number of threads to desired concurrent requests / number of workers.
  Puma defaults to 16 and that's a decent number.

#### Migrating from Unicorn

* If you're migrating from unicorn though, here are some settings to start with:
  * Set workers to half the number of unicorn workers you're using
  * Set threads to 2
  * Enjoy 50% memory savings
* As you grow more confident in the thread safety of your app, you can tune the
  workers down and the threads up.

#### Ubuntu / Systemd (Systemctl) Installation

See [systemd.md](systemd.md)

#### Worker utilization

**How do you know if you've got enough (or too many workers)?**

A good question. Due to MRI's GIL, only one thread can be executing Ruby code at a time.
But since so many apps are waiting on IO from DBs, etc., they can utilize threads
to make better use of the process.

The rule of thumb is you never want processes that are pegged all the time. This
means that there is more work to do than the process can get through. On the other
hand, if you have processes that sit around doing nothing, then they're just eating
up resources.

Watch your CPU utilization over time and aim for about 70% on average. This means
you've got capacity still but aren't starving threads.

**Measuring utilization**

Using a timestamp header from an upstream proxy server (eg. nginx or haproxy), it's
possible to get an indication of how long requests have been waiting for a Puma
thread to become available.

* Have your upstream proxy set a header with the time it received the request:
    * nginx: `proxy_set_header X-Request-Start "${msec}";`
    * haproxy: `http-request set-header X-Request-Start "%t";`
* In your Rack middleware, determine the amount of time elapsed since `X-Request-Start`.
* To improve accuracy, you will want to subtract time spent waiting for slow clients:
    * `env['puma.request_body_wait']` contains the number of milliseconds Puma spent
      waiting for the client to send the request body.
    * haproxy: `%Th` (TLS handshake time) and `%Ti` (idle time before request) can
      can also be added as headers.

## Daemonizing

I prefer to not daemonize my servers and use something like `runit` or `upstart` to
monitor them as child processes. This gives them fast response to crashes and
makes it easy to figure out what is going on. Additionally, unlike `unicorn`,
puma does not require daemonization to do zero-downtime restarts.

I see people using daemonization because they start puma directly via capistrano
task and thus want it to live on past the `cap deploy`. To these people I say:
You need to be using a process monitor. Nothing is making sure puma stays up in
this scenario! You're just waiting for something weird to happen, puma to die,
and to get paged at 3am. Do yourself a favor, at least the process monitoring
your OS comes with, be it `sysvinit`, `upstart`, or `systemd`. Or branch out
and use `runit` or hell, even `monit`.

## Restarting

You probably will want to deploy some new code at some point, and you'd like
puma to start running that new code. Minimizing the amount of time the server
is unavailable would be nice as well. Here's how to do it:

1. Don't use `preload!`. This dirties the master process and means it will have
to shutdown all the workers and re-exec itself to get your new code. It is not compatible with phased-restart and `prune_bundler` as well.

1. Use `prune_bundler`. This makes it so that the cluster master will detach itself
from a Bundler context on start. This allows the cluster workers to load your app
and start a brand new Bundler context within the worker only. This means your
master remains pristine and can live on between new releases of your code.

1. Use phased-restart (`SIGUSR1` or `pumactl phased-restart`). This tells the master
to kill off one worker at a time and restart them in your new code. This minimizes
downtime and staggers the restart nicely. **WARNING** This means that both your
old code and your new code will be running concurrently. Most deployment solutions
already cause that, but it's worth warning you about it again. Be careful with your
migrations, etc!

## Accessing stats

Stats can be accessed in two ways:

### control server

`$ pumactl stats` or `GET /stats`

[Read more about `pumactl` and the control server in the README.](https://github.com/puma/puma#controlstatus-server).

### Puma.stats

`Puma.stats` produces a JSON string. `Puma.stats_hash` produces a ruby hash.

#### in single mode

Invoke `Puma.stats` anywhere in runtime, e.g. in a rails initializer:

```ruby
# config/initializers/puma_stats.rb

Thread.new do
  loop do
    sleep 30
    puts Puma.stats
  end
end
```

#### in cluster mode

Invoke `Puma.stats` from the master process

```ruby
# config/puma.rb

before_fork do
  Thread.new do
    loop do
      puts Puma.stats
      sleep 30
    end
  end
end
```


## Explanation of stats

`Puma.stats` returns different information and a different structure depending on if Puma is in single vs. cluster mode. There is one top-level attribute that is common to both modes:

* started_at: when Puma was started

### single mode and individual workers in cluster mode

When Puma runs in single mode, these stats are available at the top level. When Puma runs in cluster mode, these stats are available within the `worker_status` array in a hash labeled `last_status`, in an array of hashes where one hash represents each worker.

* backlog: requests that are waiting for an available thread to be available. if this is frequently above 0, you need more capacity.
* running: how many threads are spawned. A spawned thread may be busy processing a request or waiting for a new request. If `min_threads` and `max_threads` are set to the same number,
  this will be a never-changing number (other than rare cases when a thread dies, etc).
* busy_threads: `running` - `how many threads are waiting to receive work` + `how many requests are waiting for a thread to pick them up`.
  this is a "wholistic" stat reflecting the overall current state of work to be done and the capacity to do it.
* pool_capacity: `how many threads are waiting to receive work` + `max_threads` - `running`. In a typical configuration where `min_threads`
  and `max_threads` are configured to the same number, this is simply `how many threads are waiting to receive work`. This number exists only as a stat
  and is not used for any internal decisions, unlike `busy_theads`, which is usually a more useful stat.
* max_threads: the maximum number of threads Puma is configured to spool per worker
* requests_count: the number of requests this worker has served since starting


### cluster mode

* phase: which phase of restart the process is in, during [phased restart](https://github.com/puma/puma/blob/master/docs/restart.md)
* workers: ??
* booted_workers: how many workers currently running?
* old_workers: ??
* worker_status: array of hashes of info for each worker (see below)

### worker status

* started_at: when the worker started
* pid: the process id of the worker process
* index: each worker gets a number. if Puma is configured to have 3 workers, then this will be 0, 1, or 2
* booted: if it's done booting [?]
* last_checkin: Last time the worker responded to the master process' heartbeat check.
* last_status: a hash of info about the worker's state handling requests. See the explanation for this in "single mode and individual workers in cluster mode" section above.


## Examples

Here are two example stats hashes produced by `Puma.stats`:

### single

```json
{
  "started_at": "2021-01-14T07:12:35Z",
  "backlog": 0,
  "running": 5,
  "pool_capacity": 5,
  "max_threads": 5,
  "requests_count": 3
}
```

### cluster

```json
{
  "started_at": "2021-01-14T07:09:17Z",
  "workers": 2,
  "phase": 0,
  "booted_workers": 2,
  "old_workers": 0,
  "worker_status": [
    {
      "started_at": "2021-01-14T07:09:24Z",
      "pid": 64136,
      "index": 0,
      "phase": 0,
      "booted": true,
      "last_checkin": "2021-01-14T07:11:09Z",
      "last_status": {
        "backlog": 0,
        "running": 5,
        "pool_capacity": 5,
        "max_threads": 5,
        "requests_count": 2
      }
    },
    {
      "started_at": "2021-01-14T07:09:24Z",
      "pid": 64137,
      "index": 1,
      "phase": 0,
      "booted": true,
      "last_checkin": "2021-01-14T07:11:09Z",
      "last_status": {
        "backlog": 0,
        "running": 5,
        "pool_capacity": 5,
        "max_threads": 5,
        "requests_count": 1
      }
    }
  ]
}
```

# Welcome to Puma 6: Sunflower.

![Image by Todd Trapani, Unsplash](https://user-images.githubusercontent.com/845662/192706685-774d3d0d-f4a9-4b93-b27b-5a3b7f44ff31.jpg)

Puma 6 brings performance improvements for most applications, experimental Rack 3 support, support for Sidekiq 7 Capsules, and more.

Here's what you should do:

1. Review the Upgrade section below to look for breaking changes that could affect you.
2. Upgrade to version 6.0 in your Gemfile and deploy.
3. Open up a new bug issue if you find any problems.
4. Join us in building Puma! We welcome first-timers. See [CONTRIBUTING.md](../CONTRIBUTING.md).

For a complete list of changes, see [History.md](../History.md).

## What's New

Puma 6 is mostly about a few nice-to-have performance changes, and then a few breaking API changes we've been putting off for a while.

### Improved Performance

We've improved throughput and latency in Puma 6 in a few areas.

1. **Large chunked response body throughput 3-10x higher** Chunked response bodies >100kb should be 3 to 10 times faster than in Puma 5. String response bodies should be ~10% faster.
2. **File response throughput is 3x higher.** File responses (e.g. assets) should be about 3x faster.
3. **wait_for_less_busy_worker is now default, meaning lower latencies for high-utilization servers** `wait_for_less_busy_worker` was an experimental feature in Puma 5 and it's now the default in Puma 6. This feature makes each Puma child worker in cluster mode wait before listening on the socket, and that wait time is proportional to N * `number_of_threads_responding_to_requests`. This means that it's more likely that a request is picked up by the least-loaded Puma child worker listening on the socket. Many users reported back that this option was stable and decreased average latency, particularly in environments with high load and utilization.

### Experimental Rack 3 Support

[Rack 3 is now out](https://github.com/rack/rack/blob/main/UPGRADE-GUIDE.md) and we've started on Rack 3 support. Please open a bug if you find any incompatibilites.

### Sidekiq 7 Capsules

Sidekiq 7 (releasing soon) introduces Capsules, which allows you to run a Sidekiq server inside your Puma server (or any other Ruby process for that matter). We've added support by allowing you to pass data into `run_hooks`, see [issue #2915](https://github.com/puma/puma/issues/2915).

## Upgrade

Check the following list to see if you're depending on any of these behaviors:

1. Configuration constants like `DefaultRackup` removed, see [#2928](https://github.com/puma/puma/pull/2928/files#diff-2dc4e3e83be7fd97cebc482ae07d6a8216944003de82458783fb00b5ae9524c8) for the full list.
1. We have changed the names of the following environment variables: `DISABLE_SSL` is now `PUMA_DISABLE_SSL`, and `MAKE_WARNINGS_INTO_ERRORS` is now `PUMA_MAKE_WARNINGS_INTO_ERRORS`.
1. Nakayoshi GC (`nakayoshi_fork` option in config) has been removed without replacement.
1. `wait_for_less_busy_worker` is now on by default. If you don't want to use this feature, you must add `wait_for_less_busy_worker 0` in your config.
1. We've removed the following public methods on Puma::Server: `Puma::Server#min_threads`, `Puma::Server#max_threads`. Instead, you can pass in configuration as an option to Puma::Server#new. This might make certain gems break (`capybara` for example).
1. We've removed the following constants: `Puma::StateFile::FIELDS`, `Puma::CLI::KEYS_NOT_TO_PERSIST_IN_STATE` and `Puma::Launcher::KEYS_NOT_TO_PERSIST_IN_STATE`, and `Puma::ControlCLI::COMMANDS`.
1. We no longer support Ruby 2.2, 2.3, or JRuby on Java 1.7 or below.
1. The behavior of `remote_addr` has changed. When using the set_remote_address header: "header_name" functionality, if the header is not passed, REMOTE_ADDR is now set to the physical peeraddr instead of always being set to 127.0.0.1. When an error occurs preventing the physical peeraddr from being fetched, REMOTE_ADDR is now set to the unspecified source address ('0.0.0.0') instead of to '127.0.0.1'
1. Previously, Puma supported anything as an HTTP method and passed it to the app. We now only accept the following 8 HTTP methods, based on [RFC 9110, section 9.1](https://www.rfc-editor.org/rfc/rfc9110.html#section-9.1).  The [IANA HTTP Method Registry](https://www.iana.org/assignments/http-methods/http-methods.xhtml) contains a full list of HTTP methods.
   ```
   HEAD GET POST PUT DELETE OPTIONS TRACE PATCH
   ```
   As of Puma 6.2, these can be overridden by `supported_http_methods` in your config file, see `Puma::DSL#supported_http_methods`.

Then, update your Gemfile:

`gem 'puma', '< 7'`

## Plugins

Puma 3.0 added support for plugins that can augment configuration and service
operations.

2 canonical plugins to look to aid in development of further plugins:

* [tmp\_restart](https://github.com/puma/puma/blob/master/lib/puma/plugin/tmp_restart.rb):
  Restarts the server if the file `tmp/restart.txt` is touched
* [heroku](https://github.com/puma/puma-heroku/blob/master/lib/puma/plugin/heroku.rb):
  Packages up the default configuration used by puma on Heroku

Plugins are activated in a puma configuration file (such as `config/puma.rb'`)
by adding `plugin "name"`, such as `plugin "heroku"`.

Plugins are activated based simply on path requirements so, activating the
`heroku` plugin will simply be doing `require "puma/plugin/heroku"`. This
allows gems to provide multiple plugins (as well as unrelated gems to provide
puma plugins).

The `tmp_restart` plugin is bundled with puma, so it can always be used.

To use the `heroku` plugin, add `puma-heroku` to your Gemfile or install it.

### API

## Server-wide hooks

Plugins can use a couple of hooks at server level: `start` and `config`.

`start` runs when the server has started and allows the plugin to start other
functionality to augment puma.

`config` runs when the server is being configured and is passed a `Puma::DSL`
object that can be used to add additional configuration.

Any public methods in `Puma::Plugin` are the public API that any plugin may
use.

# Contributing to Puma

By participating in this project, you agree to follow the [code of conduct].

[code of conduct]: https://github.com/puma/puma/blob/main/CODE_OF_CONDUCT.md

There are lots of ways to contribute to Puma. Some examples include:

* creating a [bug report] or [feature request]
* verifying [existing bug reports] and adding [reproduction steps]
* reviewing [pull requests] and testing the changes locally on your machine
* writing or editing [documentation]
* improving test coverage
* fixing a [reproducing bug] or adding a new feature

[bug report]: https://github.com/puma/puma/issues/new?template=bug_report.md
[feature request]: https://github.com/puma/puma/issues/new?template=feature_request.md
[existing bug reports]: https://github.com/puma/puma/issues?q=is%3Aopen+is%3Aissue+label%3Aneeds-repro
[pull requests]: https://github.com/puma/puma/pulls
[documentation]: https://github.com/puma/puma/tree/main/docs
[reproduction steps]: https://github.com/puma/puma/blob/CONTRIBUTING.md#reproduction-steps
[reproducing bug]: https://github.com/puma/puma/issues?utf8=%E2%9C%93&q=is%3Aopen+is%3Aissue+label%3Abug

Newbies welcome! We would be happy to help you make your first contribution to a F/OSS project.

## Setup

Any questions about contributing may be asked in our [Discussions](https://github.com/puma/puma/discussions).

**If you're nervous, get stuck, need help, or want to know where to start and where you can help**, please don't hesitate to [book 30 minutes with maintainer @nateberkopec here](https://savvycal.com/nateberkopec/puma). He is happy to help!

Nate also [gave a 40 minute conference talk in 2022](https://www.youtube.com/watch?v=w4X_oBuPmTM) detailing how Puma works, a brief overview of its internals, and a quick guide on how to contribute.

#### Clone the repo

Clone the Puma repository:
```sh
git clone git@github.com:puma/puma.git && cd puma
```

#### Ragel

You need to install [ragel] (use Ragel version 7.0.0.9) to generate Puma's extension code.

macOS:

```sh
brew install ragel
```

Linux:
```sh
apt-get install ragel
```

Windows (Ruby 2.5 and later):
```sh
ridk exec pacman -S mingw-w64-x86_64-openssl mingw-w64-x86_64-ragel
```

#### Install Ruby dependencies

Install the Ruby dependencies:
```sh
bundle install
```

#### Compile the native extensions

To run Puma locally, you must compile the native extension. Running the `test` rake task does this automatically, but you may need to manually run the compile command if you want to run Puma and haven't run the tests yet:

Ubuntu, macOS, etc:
```sh
bundle exec rake compile
```

Windows:
```sh
bundle exec rake -rdevkit compile
```

#### Run your local Puma

Now, you should be able to run Puma locally:

```sh
bundle exec bin/puma test/rackup/hello.ru
# -or-
bundle exec ruby -Ilib bin/puma test/rackup/hello.ru
```

Alternatively, you can reference your local copy in a project's `Gemfile`:

```ruby
gem "puma", path: "/path/to/local/puma"
```

See the [Bundler docs](https://bundler.io/man/gemfile.5.html#PATH) for more details.

[ragel]: https://www.colm.net/open-source/ragel/

## Running tests

To run rubocop + tests:

```sh
bundle exec rake
```

To run the test suite only:
```sh
bundle exec rake test
```

To run a single test file:
```sh
bundle exec ruby test/test_binder.rb
```

You can also run tests with [`m`](https://github.com/qrush/m):
```sh
bundle exec m test/test_binder.rb
```

To run a single test:
```sh
bundle exec m test/test_binder.rb:37
```

To run a single test with 5 seconds as the test case timeout:
```sh
TEST_CASE_TIMEOUT=5 bundle exec m test/test_binder.rb:37
```

If you would like more information about extension building, SSL versions, your local Ruby version, and more, use the PUMA_TEST_DEBUG env variable:

```sh
PUMA_TEST_DEBUG=1 bundle exec rake test
```

Puma also has a helper file for running tests, see the comments at the top of the `test/runner` file.  Example:
```
test/runner -v test_puma_server.rb
```

#### File limits

Puma's test suite opens up a lot of sockets. This may exceed the default limit of your operating system. If your file limits are low, you may experience "too many open file" errors when running the Puma test suite.

```
# check your file limit
ulimit -S -n

# change file limit for the current session
ulimit -S -n <value>
```

We find that values of 4000 or more work well. [Learn more about your file limits and how to change them here.](https://wilsonmar.github.io/maximum-limits/)

## How to contribute

Puma could use your help in several areas!

**Don't worry about "claiming an issue". No issues are "claimed" in Puma.** Just start working on it. The issue tracker is almost always kept updated, so if there is an open issue, it is ready for you to contribute (unless you have questions about how to close issue - then please ask!). Once you have a few lines of code, post a draft PR. We are more than happy to help once you have a draft PR up.

**New to systems programming? That's ok!** Puma deals with concepts you may not have been familiar with before, like sockets, TCP, UDP, SSL, and Threads. That's ok! You can learn by contributing. Also, see the "Bibliography" section at the end of this document.

**The [contrib-wanted] label indicates that an issue might approachable to first-time contributors.**

**Reproducing bug reports**: The [needs-repro] label indicates than an issue lacks reproduction steps. You can help by reproducing the issue and sharing the steps you took in the comments.

**Helping with our native extensions**: If you are interested in writing C or Java, we could really use your help. Check out the issue labels for [c-ext] and [JRuby].

**Fixing bugs**: Issues with the [bug] label have working reproduction steps, which you can use to write a test and submit a patch.

**Writing features**: The [feature] label highlights requests for new functionality. Write tests and code up our new feature!

**Code review**: Take a look at open pull requests and offer your feedback. Code review is not just for maintainers. We need your help and eyeballs!

**Write documentation**: Puma needs more docs in many areas, especially where we have open issues with the [docs] label.

[bug]: https://github.com/puma/puma/issues?q=is%3Aopen+is%3Aissue+label%3Abug
[c-ext]: https://github.com/puma/puma/issues?q=is%3Aopen+is%3Aissue+label%3Ac-ext
[contrib-wanted]: https://github.com/puma/puma/issues?q=is%3Aopen+is%3Aissue+label%3Acontrib-wanted
[docs]: https://github.com/puma/puma/issues?q=is%3Aopen+is%3Aissue+label%3Adocs
[feature]: https://github.com/puma/puma/issues?q=is%3Aopen+is%3Aissue+label%3Afeature
[jruby]: https://github.com/puma/puma/issues?q=is%3Aopen+is%3Aissue+label%3Ajruby
[needs-repro]: https://github.com/puma/puma/issues?q=is%3Aopen+is%3Aissue+label%3Aneeds-repro

## Reproduction steps

Reproducing a bug helps identify the root cause of that bug so it can be fixed.

To get started, create a rackup file and config file and then run your test app
with:
```sh
bundle exec puma -C <path/to/config.rb> <path/to/rackup.ru>
```

For example, using a test rack app ([`test/rackup/hello.ru`][rackup]) and a
test config file ([`test/config/settings.rb`][config]):
```sh
bundle exec puma -C test/config/settings.rb test/rackup/hello.ru
```

There is also a Dockerfile available for reproducing Linux-specific issues:
```sh
docker build -f tools/Dockerfile -t puma .
docker run -p 9292:9292 -it puma
```

[rackup]: https://github.com/puma/puma/blob/main/test/rackup/hello.ru
[config]: https://github.com/puma/puma/blob/main/test/config/settings.rb

## Pull requests

Please open draft PRs as soon as you are ready for feedback from the community.

Code contributions should generally include test coverage. If you aren't sure how to
test your changes, please open a pull request and leave a comment asking for
help.

There's no need to update the changelog ([`History.md`](History.md)); that is done [when a new release is made](Release.md).

Puma uses [GitHub Actions](https://docs.github.com/en/actions) for CI testing. Please consider running the workflows in your fork before creating a PR. It is possible to enable GitHub Actions on your fork in the repositories' `Actions` tab.

CI runs against the latest patch release of each supported Ruby minor version. When reporting bugs or reproducing issues, please use the latest patch release for your Ruby minor version so your environment matches CI coverage.

## Backports

Puma does not have a backport "policy" - maintainers will not consistently backport bugfixes to previous minor or major versions (we do treat security differently, see [`SECURITY.md`](SECURITY.md).

For Ruby patch-level bugs, we may add targeted workarounds. When we do, we keep those workarounds in place for the lifetime of the affected Ruby minor series, even if a later patch release fixes the underlying issue.

As a contributor, you may make pull requests against `-stable` branches to backport fixes, and maintainers will release them once they're merged. For example, if you'd like to make a backport for 4.3.x, you can make a pull request against `4-3-stable`. If there is no appropriate branch for the release you'd like to backport against, please just open an issue and we'll make one for you.

## Join the community

If you're looking to contribute to Puma, please join us in [Discussions](https://github.com/puma/puma/discussions).

We govern this project according to the process in [GOVERNANCE.md](./GOVERNANCE.md).

## Bibliography/Reading

Puma can be a bit intimidating for your first contribution because there's a lot of concepts here that you've probably never had to think about before - Rack, sockets, forking, threads etc. Here are some helpful links for learning more about things related to Puma:

* [Puma's Architecture docs](https://github.com/puma/puma/blob/main/docs/architecture.md)
* [The Rack specification](https://github.com/rack/rack/blob/main/SPEC.rdoc)
* [Working with...](https://workingwithruby.com/) "Working With" is a excellent (and now free) Ruby book series about working with Threads, TCP and Unix Sockets.
* The Ruby docs for IO.pipe, TCPServer/Socket.
* [nio4r documentation](https://github.com/socketry/nio4r/wiki/Getting-Started)

% !Rnw weave = knitr
%-*- mode: noweb; noweb-default-code-mode: R-mode; -*-
%\VignetteIndexEntry{puma User Guide}
%\VignetteKeywords{Preprocessing, Affymetrix, Clustering}
%\VignetteDepends{Biobase, affy}
%\VignettePackage{puma}
%documentclass[12pt, a4paper]{article}


\documentclass[12pt]{article}
\usepackage[utf8]{inputenc}
\usepackage{graphicx}
\usepackage{amsmath}
\usepackage{float}
\usepackage{hyperref}
\usepackage[numbers,round]{natbib}

\restylefloat{figure}

\textwidth=6.2in
\textheight=8.5in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\puma}{\Rpackage{puma} }
\newcommand{\limma}{\Rpackage{limma} }

\author{R. D. Pearson, X. Liu, M. Rattray, M. Milo, N. D. Lawrence\\
                          G. Sanguinetti, Li Zhang}
\usepackage{Sweave}
\begin{document}
\title{puma User Guide}

\maketitle
\tableofcontents
\sloppy
%\SweaveOpts{keep.source=TRUE}

\section{Abstract}
Most analyses of Affymetrix GeneChip data (including tranditional 3' arrays and exon arrays) are based on point estimates of expression levels and ignore the uncertainty of such estimates. By propagating uncertainty to downstream analyses we can improve results from microarray analyses. For the first time, the puma package makes a suite of uncertainty propagation methods available to a general audience. In additon to calculte gene expression from Affymetrix 3' arrays, puma also provides methods to process exon arrays and produces gene and isoform expression for alternative splicing study. puma also offers improvements in terms of scope and speed of execution over previously available uncertainty propagation methods. Included are summarisation, differential expression detection, clustering and PCA methods, together with useful plotting functions.

\section{Citing \puma}
The \puma package is based on a large body of methodological research.
Citing \puma in publications will usually involve citing one or more of
the methodology papers \cite{mgmos},\cite{mmgmos},\cite{pumapca},\cite{briefings},\cite{pplr},\cite{pumaclust},\cite{ipplr},\cite{pumaclustii} that the software is based on as well as citing
the software package itself. For the methodology papers, see
http://www.bioinf.manchester.ac.uk/resources/puma/.
\puma makes use of the donlp2() function \cite{donlp2} by Peter Spellucci. The use of donlp2() must be acknowledged in any publication which contains results obtained with puma or parts of it. Citation of the author's name and netlib-source is suitable. The software
itself as well as the extension of PPLR to the multi-factorial case
(the \Rfunction{pumaDE} function) can be cited as:

  puma: a Bioconductor package for Propagating Uncertainty in
  Microarray Analysis (2007) Pearson et al. BMC Bioinformatics, 2009, 10:211

The functionalities for processing of exon array data to calculate isoform and gene
expression can be cited as:

  puma 3.0: improved uncertainty propagation methods for gene and transcript ex-
pression analysis, Liu et al. BMC Bioinformatics, 2013, 14:39.

<<echo=FALSE, eval=TRUE>>=
options(width = 60)
@

\newpage
\section{Introduction}
Microarrays provide a practical method for measuring the expression level of thousands of genes simultaneously. This technology is associated with many significant sources of experimental uncertainty, which must be considered in order to make confident inferences from the data. Affymetrix GeneChip arrays have multiple probes associated with each target. The probe-set can be used to measure the target concentration and this measurement is then used in the downstream analysis to achieve the biological aims of the experiment, e.g. to detect significant differential expression between conditions, or for the visualisation, clustering or supervised classification of data.

Most currently popular methods for the probe-level analysis of Affymetrix arrays (e.g. RMA, MAS5.0) only provide a single point estimate that summarises the target concentration. Yet the probe-set also contains much useful information about the uncertainty associated with this measurement. By using probabilistic methods for probe-level analysis it is possible to associate gene expression levels with credibility intervals that quantify the measurement uncertainty associated with the estimate of target concentration within a sample. This within-sample variance is a very significant source of uncertainty in microarray experiments, especially for relatively weakly expressed genes, and we argue that this information should not be discarded after the probe-level analysis. Indeed, we provide a number of examples were the inclusion of this information gives improved results on benchmark data sets when compared with more traditional methods which do not make use of this information.

PUMA is an acronym for Propagating Uncertainty in Microarray Analysis. The \Rpackage{puma} package is a suite of analysis methods for Affymetrix GeneChip data. It includes functions to:
\begin{enumerate}
\item Calculate expression levels and confidence measures for those levels from raw CEL file data.
\item Combine uncertainty information from replicate arrays
\item Determine differential expression between conditions, or between more complex contrasts such as interaction terms
\item Cluster data taking the expression-level uncertainty into account
\item Perform a noise-propagation version of principal components analysis (PCA)
\end{enumerate}

There are a number of other Bioconductor packages which can be used to perform the various stages of analysis highlighted above. The \Rpackage{affy} package gives access to a number of methods for calculating expression levels from raw CEL file data. The \Rpackage{limma} package provides well-proven methods for determination of differentially expressed genes. Other packages give access to clustering and PCA methods. In keeping with the Bioconductor philosophy, we aim to reuse as much code as possible. In many cases, however, we offer techniques that can be seen as alternatives to techniques available in other packages. Where this is the case, we have attempted to provide tools to enable the user to easily compare the different methods.

We believe that the best method for learning new techniques is to use them. As such, the majority of this user manual (Section 4) is given over to case studies which highlight different aspects of the package. The case studies include the scripts required to recreate the results shown. At present there is just one case study (based on data from the \Rpackage{estrogen} package), but others will soon be included.

One of the most popular packages within Bioconductor is \Rpackage{limma}. Because many users of the \Rpackage{puma} package are already likely to be familiar with \Rpackage{limma}, we have written a special section (Section 5), highlighting the similarities and differences between the two packages. While this section might help experienced \Rpackage{limma} users get up to speed with \Rpackage{puma} more quickly, it is not required reading, particularly for those with little or no experience of \Rpackage{limma}.

The main benefit of using the propagation of uncertainty in microarray analysis is the potential of improved end results. However, this improvement does come at the cost of increased computational demand, particularly that of the time required to run the various algorithms. The key algorithms are, however, parallelisable, and we have built this parallel functionality into the package. Users that have access to a computer cluster, or even a number of machines on a network, can make use of this functionality. Details of how this should be set up are given in Section 6. This section can be skipped by those who will be running \Rpackage{puma} on a single machine only.

The \Rpackage{puma} package is intended as a full analysis suite which can be used for all stages of a typical microarray analysis project. Many users will want to compare different analysis methods within R, and the package has been designed with this is mind. Some users, however, may prefer to carry out some stages of the analysis using tools other than R. Section 7 gives details on writing out results from key stages of a typical analysis, which can then be read into other software tools.

We have chosen to leave details of individual functions out of this vignette, though comprehensive details can be found in the online help for each function.

% We begin, in the next section, with a brief introduction to the main functions of the \Rpackage{puma} package, by applying them to the small \Robject{affybatch.example} data set from the \Rpackage{affy} package.

This software package uses the optimization program donlp2~\cite{donlp2}.


\newpage

\section{Introductory example analysis - estrogen}
\label{section:Introductory example}

In this section we introduce the main functions of the \Rpackage{puma} package by applying them to the data from the \Rpackage{estrogen} package

\subsection{Installing the \Rpackage{puma} package}

The recommended way to install \Rpackage{puma} is to use the \Rfunction{install} function available via the BiocManager package. Installing in this way should ensure that all appropriate dependencies are met.

<< eval=FALSE >>===
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("puma")
@

\subsection{Loading the package and getting help}

The first step in any \Rpackage{puma} analysis is to load the package. Start \Rpackage{R}, and then type the following command:
<<>>=
library(puma)
@

To get help on any function, use the \Rfunction{help} command. For example, to get help on the \Rfunction{pumaDE} type one of the following (they are equivalent):
<<eval=FALSE>>===
help(pumaDE)
?pumaDE
@

To see all functions that are available within \Rpackage{puma} type:
<<eval=FALSE>>===
help(package="puma")
@

\subsection{Loading in the data}

To import data using the \Rpackage{oligo} package,the user must have data at the probe-level.This means that if Affymetrix data are to be imported,the user is expected to have CEL files.

Once sets of such files are available,the user can two tools,depending on the array manufacturer,to improt the data:\Rfunction{read.celfiles} function for CEL files.To assist the user on obtaining the names of the CEL files,the package providers the \Rfunction{list.celfiles} function,which accept the same argrments as the \Rfunction{list.files} function defined in the \Rpackage{R base} package.The basic usage of the package tools to import CEL files present in the current directory consists in combing the \Rfunction{read.files} functions with their \Rfunction{list.files} function counterparts,as shown below,in a hypothetical example:

<<eval=FALSE>>===
library(oligo)
estrogenFilenames<-list.celfiles()
oligo.estrogen<-read.celfiles(celFiles)
pData(oligo.estrogen) <- data.frame(
    "estrogen"=c("absent","absent","present","present"
        ,"absent","absent","present","present")
,   "time.h"=c("10","10","10","10","48","48","48","48")
,   row.names=rownames(pData(oligo.estrogen))
)
@

When the user use the \Rfunction{read.celfiles} function to read the CEL files,the \Rpackage{oligo} package will attempt to identif the annotation package required to read the data in.If this annotation package is not available on BioConductor,the user should use the \Rpackage{pdInfoBuilder} package to create to create an appropriate annotation.In case \Rpackage{oligo} fails to identify the annotation package's name correctly,the user can use the pkgname argument available for \Rfunction{read.celfiles}.

<<echo=FALSE, eval=TRUE>>=
library(pumadata)
data(oligo.estrogen)
@
<<>>=
show(oligo.estrogen)
@

Here we can see some information about oligo.estrogen
<<>>=
pData(oligo.estrogen)
@

We can see from this phenotype data that this experiment has 2 factors (estrogen and time.h),each of which has two levels (absent vs present, and 10 vs 48), hence this is a 2x2 factorial experiment. For each combination of levels we have two replicates,making a total of 2x2x2 = 8 arrays.

\subsection{Determining expression levels for Affymetrix array}

We will first use multi-mgMOS to create an expression set object from our raw data. This step is similar to using other summarisation methods such as MAS5.0 or RMA, and for comparison purposes we will also create an expression set object from our raw data using RMA. Note that the following lines of code are likely to take a significant amount of time to run, so if you in hurry and you have the \Rpackage{pumadata} library loaded simply type \Rfunction{data(eset\_oligo\_mmgmos)} and \Rfunction{data(eset\_oligo\_rma)} at the command prompt.

<<eval=FALSE>>===
eset_estrogen_mmgmos<-mmgmos(oligo.estrogen,gsnorm="none")
eset_estrogen_rma<-rma(oligo.estrogen)
@

Note that we have \Rfunction{gsnorm="none"} in running mmgmos. The \Rfunction{gsnorm} option enables different global scaling (between array) normalizations to be applied to the data. We have chosen to use no global scaling normalization here so that we can highlight the need for such normalization (which we do below). The default option with \Rfunction{mmgmos} is to provide a median global scaling normalization, and this is generally recommended.

Unlike many other methods, multi-mgMOS provides information about the expected uncertainty in the expression level, as well as a point estimate of the expression level.

<<echo=FALSE,eval=TRUE>>=
data(eset_estrogen_mmgmos)
@

<<eval=FALSE>>===
exprs(eset_estrogen_mmgmos)[1,]
assayDataElement(eset_estrogen_mmgmos,"se.exprs")[1,]
@

Here we can see the expression levels, and standard errors of those expression levels, for the first probe set of the \Robject{oligo.estrogen} data set.

If we want to write out the expression levels and standard errors, to be used elsewhere, this can be done using the \Rfunction{write.reslts} function.

<<eval=FALSE>>===
write.reslts(eset_estrogen_mmgmos, file="eset_estrogen_mmgmos.rda")
@

This code will create seven different comma-separated value (csv) files in the working directory. \Robject{eset\_estrogen\_exprs.csv} will contain expression levels. \Robject{eset\_estrogen\_se.csv} will contain standard errors. The other files contain different percentiles of the posterior distribution, which will only be of interest to expert users. For more details type \Rfunction{?write.reslts} at the R prompt.

We also provide a method, PMmmgmos, to calculate gene expression level use PM intensities only. PMmmgmos also return an expression set object.

<<eval=FALSE>>===
eset_estrogen_pmmmgmos <- PMmmgmos(oligo.estrogen,gsnorm="none")
@

The extraction of expression mean and standard deviation is the same as above.

\subsection{Determining expression levels for Affymetrix exon arrays}

\subsubsection{\Rfunction{gmoExon} function}

We use \Rfunction{gmoExon} function to calculate gene and transcript expression levels. First you have to install \Rpackage{oligo} packages for read exon arrays. Second,gmoExon needs to use the relationships between genes, transcripts and probes which we put into \Rpackage{pumadata} R package. You need to download the latest pumadata package, and type \Rfunction{BiocManager::install("pumadata")}, \Rfunction{library(pumadata)} at the R prompt to have it installed. 

The following scripts use example to show the use of \Rfunction{gmoExon} function.

<<eval=FALSE>>===
setwd(cel.path)   ## go to the directory where you put the CEL files.
exonFilenames<-c("C0006.CEL","C021.CEL"
                ,"F023_NEG.CEL","F043_NEG.CEL") ## or you can use  exonFilenames<-list.celfiles()
oligo.exon<-read.celfiles(exonFilenames)
@

And now we can can use the \Rfunction{gmoExon} function to calculate the gene and transcript expression levels.

<<eval=FALSE>>===
eset_gmoExon<-gmoExon(oligo.exon,exontype="Human",gsnorm="none")
@

Note that we have exontype="Human", gsnorm="none" in running \Rfunction{gmoExon}. The exontype option enables gmoExon to be applied to Human,Mouse and Rat exon arrays. The gsnorm option enables different global scaling (between array) normalizations to be applied to the data. We have chosen to use no global scaling normalization here so that we can highlight the need for such normalization (which we do below). The default option with gmoExon is to provide a median global scaling normalization, and this is generally recommended.

<<echo=FALSE,eval=TRUE>>=
data(eset_gmoExon)
@

<<eval=FALSE>>===
exprs(eset_gmoExon$gene)[1,]
assayDataElement(eset_gmoExon$gene,"se.exprs")[1,]
exprs(eset_gmoExon$transcript)[1,]
assayDataElement(eset_gmoExon$transcript,"se.exprs")[1,]
@

Here we can see the gene and transcript expression levels, and standard errors of those expression levels, for the first mapped gene and transcripts of the oligo.exon data set

If we want to write out the expression levels and standard errors, to be used elsewhere,this can be done using the write.reslts function.

<<eval=FALSE>>===
write.reslts(eset_gmoExon$gene, file="eset_gmoExon_gene")
@

This code will create seven different comma-separated value (csv) files in the working 
directory. File \Robject{eset\_gmoExon\_gene\_exprs.csv} will contain gene expression levels. 
\Robject{eset\_gmoExon\_gene\_se.csv} will contain gene standard errors. The other files contain
different percentiles of the posterior distribution, which will only be of interest 
to expert users. For more details type ?write.reslts at the R prompt.

<<eval=FALSE>>===
write.reslts(eset_gmoExon$transcript, file="eset_gmoExon_transcript")
@

This code will create seven different comma-separated value (csv) files in the working 
directory. File \Robject{eset\_gmoExon\_transcript\_exprs.csv} will contain transcript expression levels.
File \Robject{eset\_gmoExon\_transcript\_se.csv} will contain transcirpt standard errors. The other files
contain different percentiles of the posterior distribution, which will only be of interest 
to expert users. For more details type ?write.reslts at the R prompt.

\subsubsection{\Rfunction{igmoExon} function}
   
Besides the gmoExon,we also can  use igmoExon to calculate gene and transcript expression levels,which it is effective than \Rfunction{gmoExon} function.The function requires following inputs:

\begin{description}
\item[cel.path]The directory where you put the CEL files.
\item[SampleNameTable] It is a tab-separated   tablewith two columns,ordered by "Celnames","Condition".For our testing dataset,we can formulate the SampleNameTable like below:
	Celnames: \Robject{C006.CEL} \Robject{C021.CEL} \Robject{F023\_POS.CEL}  \Robject{FO43\_NEG.CEL} ;  
	Condition: \Robject{1}        \Robject{1}        \Robject{2}              \Robject{2}
                        
\item[exontype] A string with value be one of "Human", "Mouse", "Rat", specifying the chip type of the data.
\item[gnsorm] The way you want to normalized,and the value is one of "median", "none", "mean", "meanlog". 
\item[condition] Yes or No. Choose Yes means  the \Rfunction{igmoExon} function separately calculate the gene expression values by the conditions and than combined the every condition's result,and normalized finally.Choose No means the \Rfunction{igmoExon} calulate the gene expression values as same as the \Rfunction{gmoExon} function.
\end{description}

Here are the two example as follows:

<<eval=FALSE>>===
cel.path<-"cel.path"  ## for example  cel.path<-"/home/gao/celData"  
SampleNameTable<-"SampleNameTable" 
eset_igmoExon<-igmoExon(cel.path="cel.path",SampleNameTable="SampleNameTable"
                       , exontype="Human"
                       , gsnorm="none", condition="Yes")
@

And now we can use the same methods to get the gene and transcript levels by exprs and se.exprs.

\subsection{Determining expression levels for Affymetrix hta2.0 arrays}

We use \Rfunction{gmhta} function to calculate gene and transcript expression levels. First you have to install \Rpackage{oligo} packages for read hta2.0 arrays. Second,gmhta needs to use the relationships between genes, transcripts and probes which we put into \Rpackage{pumadata} R package. You need to download the latest pumadata package, and type \Rfunction{BiocManager::install("pumadata")}, \Rfunction{library(pumadata)} at the R prompt to have it installed. 

The following scripts use example to show the use of \Rfunction{gmhta} function.

<<eval=FALSE>>===
setwd(cel.path)   ## go to the directory where you put the CEL files.
library(puma)
library(oligo)
oligo.hta<-read.celfiles(celFiles)
eset_gmhta<-gmhta(oligo.hta,gsnorm="none")
@

Note that we have gsnorm="none" in running \Rfunction{gmhta}. The gsnorm option enables different global scaling (between array) normalizations to be applied to the data. We have chosen to use no global scaling normalization here so that we can highlight the need for such normalization (which we do below). The default option with gmhta is to provide a median global scaling normalization, and this is generally recommended.

<<echo=FALSE,eval=TRUE>>=
data(eset_gmhta)
@

<<eval=FALSE>>===
exprs(eset_gmhta$gene)[2,]
se.exprs(eset_gmhta$gene)[2,]
exprs(eset_gmhta$transcript)[2,]
se.exprs(eset_gmhta$transcript)[2,]
@

Here we can see the gene and transcript expression levels, and standard errors of those expression levels, for the first mapped gene and transcripts of the oligo.hta data set

If we want to write out the expression levels and standard errors, to be used elsewhere,this can be done using the write.reslts function.

<<eval=FALSE>>===
write.reslts(eset_gmhta$gene, file="eset_gmhta_gene")
@

This code will create seven different comma-separated value (csv) files in the working 
directory. File \Robject{eset\_gmhta\_gene\_exprs.csv} will contain gene expression levels.
File \Robject{eset\_gmhta\_gene\_se.csv} will contain gene standard errors. The other files
contain different percentiles of the posterior distribution, which will only be of interest 
to expert users. For more details type ?write.reslts at the R prompt.

<<eval=FALSE>>===
write.reslts(eset_gmhta$transcript, file="eset_gmhta_transcript")
@

This code will create seven different comma-separated value (csv) files in the working 
directory. File \Robject{eset\_gmhta\_transcript\_exprs.csv} will contain transcript expression levels.
File \Robject{eset\_gmhta\_transcript\_se.csv} will contain transcript standard errors. The other files
contain different percentiles of the posterior distribution, which will only be of interest 
to expert users. For more details type ?write.reslts at the R prompt.

\subsection{Determining gross differences between arrays}

A useful first step in any microarray analysis is to look for gross differences between arrays. This can give an early indication of whether arrays are grouping according to the different factors being tested. This can also help to identify outlying arrays, which might indicate problems, and might lead an analyst to remove some arrays from further analysis.

Principal components analysis (PCA) is often used for determining such gross differences. \Rpackage{puma} has a variant of PCA called Propagating Uncertainty in Microarray Analysis Principal Components Analysis (pumaPCA) which can make use of the uncertainty in the expression levels determined by multi-mgMOS.
Again, note that the following example can take some time to run, so to speed things up, simply type \Rfunction{data(pumapca\_estrogen)} at the R prompt.

<<eval=FALSE>>=
pumapca_estrogen <- pumaPCA(eset_estrogen_mmgmos)
@
<<echo=FALSE, eval=TRUE>>=
data(pumapca_estrogen)
data(eset_estrogen_rma)
data(eset_estrogen_mmgmos)
@

For comparison purposes, we will run standard PCA on the expression set created using RMA.

<<>>=
pca_estrogen <- prcomp(t(exprs(eset_estrogen_rma)))
@

\setkeys{Gin}{width=1\textwidth}
\begin{figure}[H]
\begin{center}
<<fig=TRUE, width=10, height=5>>=
par(mfrow=c(1,2))
plot(pumapca_estrogen,legend1pos="right",legend2pos="top",main="pumaPCA")
plot(
	pca_estrogen$x
,	xlab="Component 1"
,	ylab="Component 2"
,	pch=unclass(as.factor(pData(eset_estrogen_rma)[,1]))
,	col=unclass(as.factor(pData(eset_estrogen_rma)[,2]))
,	main="Standard PCA"
)
@
\end{center}
\caption{First two components after applying \Rfunction{pumapca} and \Rfunction{prcomp} to the \Robject{estrogen} data set processed by multi-mgMOS and RMA respectively.
	\label{pumapca_estrogen}
}
\end{figure}
\setkeys{Gin}{width=0.8\textwidth}

It can be seen from Figure 1 that the first component appears to be separating the arrays by time, whereas the second component appears to be separating the arrays by presence or absence of estrogen. Note that grouping of the replicates is much tighter with multi-mgMOS/pumaPCA. With RMA/PCA, one of the absent.48 arrays appears to be closer to one of the absent.10 arrays than the other absent.48 array. This is not the case with multi-mgMOS/pumaPCA.

The results from \Rfunction{pumaPCA} can be written out to a text (csv) file as follows:

<<eval=FALSE>>=
write.reslts(pumapca_estrogen, file="pumapca_estrogen")
@

Before carrying out any further analysis, it is generally advisable to check the distributions of expression values created by your summarisation method. Like PCA analysis, this can help in identifying problem arrays. It can also inform whether further normalisation needs to be carried out. One way of determining distributions is by using box plots.

\setkeys{Gin}{width=1\textwidth}
\begin{figure}[H]
\begin{center}
<<fig=TRUE, width=10, height=5>>=
par(mfrow=c(1,2))
boxplot(data.frame(exprs(eset_estrogen_mmgmos)),main="mmgMOS - No norm")
boxplot(data.frame(exprs(eset_estrogen_rma)),main="Standard RMA")
@
\end{center}
\caption{Box plots for \Robject{estrogen} data set processed by multi-mgMOS and RMA respectively.
	\label{boxplots_estrogen}
}
\end{figure}
\setkeys{Gin}{width=0.8\textwidth}

From Figure 2 we can see that the expression levels of the time=10 arrays are generally lower than those of the time=48 arrays, when summarised using multi-mgMOS. Note that we do not see this with RMA because the quantile normalisation used in RMA will remove such differences. If we intend to look for genes which are differentially expressed between time 10 and 48, we will first need to normalise the mmgmos results.

\setkeys{Gin}{width=0.5\textwidth}
\begin{figure}[H]
\begin{center}
<<fig=TRUE, width=5, height=5>>=
eset_estrogen_mmgmos_normd <- pumaNormalize(eset_estrogen_mmgmos)
boxplot(data.frame(exprs(eset_estrogen_mmgmos_normd))
    , main="mmgMOS - median scaling")
@
\end{center}
\caption{Box plot for \Robject{estrogen} data set processed by multi-mgMOS and normalisation using global median scaling.
	\label{boxplots_estrogen_normd}
}
\end{figure}
\setkeys{Gin}{width=0.8\textwidth}

Figure 3 shows the data after global median scaling normalisation. We can now see that the distributions of expression levels are similar across arrays. Note that the default option when running \Rfunction{mmgmos} is to apply a global median scaling normalization, so this separate normalization using \Rfunction{pumaNormalize} will generally not be needed.

\subsection{Identifying differentially expressed (DE) genes with PPLR method}
\label{sec:PPLR}

There are many different methods available for identifying differentially expressed genes. \Rpackage{puma} incorporates the Probability of Positive Log Ratio (PPLR) method \cite{pplr}. The PPLR method can make use of the information about uncertainty in expression levels provided by multi-mgMOS. This proceeds in two stages. Firstly, the expression level information from the different replicates of each condition is combined to give a single expression level (and standard error of this expression level) for each condition. Note that the following code can take a long time to run and a new faster version, IPPLR, is now available as described in section~\ref{sec:IPPLR}. The end result is available as part of the \Rpackage{pumadata} package, so the following line can be replaced with \Rfunction{data(eset\_estrogen\_comb)}.


<<eval=FALSE>>=
eset_estrogen_comb <- pumaComb(eset_estrogen_mmgmos_normd)
@
<<echo=FALSE, eval=TRUE>>=
data(eset_estrogen_comb)
@

Note that because this is a 2 x 2 factorial experiment, there are a number of contrasts that could potentially be of interest. \Rpackage{puma} will automatically calculate contrasts which are likely to be of interest for the particular design of your data set. For example, the following command shows which contrasts \Rpackage{puma} will calculate for this data set

<<>>=
colnames(createContrastMatrix(eset_estrogen_comb))
@

Here we can see that there are seven contrasts of potential interest. The first four are simple comparisons of two conditions. The next two are comparisons between the two levels of one of the factors. These are often referred to as ``main effects''. The final contrast is known as an ``interaction effect''.

Don't worry if you are not familiar with factorial experiments and the previous paragraph seems confusing. The techniques of the \Rpackage{puma} package were originally developed for simple experiments where two different conditions are compared, and this will probably be how most people will use \Rpackage{puma}. For such comparisons there will be just one contrast of interest, namely ``condition A vs condition B''.

The results from \Rfunction{pumaComb} can be written out to a text (csv) file as follows:

<<eval=FALSE>>=
write.reslts(eset_estrogen_comb, file="eset_estrogen_comb")
@

To identify genes that are differentially expressed between the different conditions use the \Rfunction{pumaDE} function. For the sake of comparison, we will also determine genes that are differentially expressed using a more well-known method, namely using the \Rpackage{limma} package on results from the RMA algorithm.

<<>>=
pumaDERes <- pumaDE(eset_estrogen_comb)
limmaRes <- calculateLimma(eset_estrogen_rma)
@

The results of these commands are ranked gene lists. If we want to write out the statistics of differential expression (the PPLR values), and the fold change values, we can use the \Rfunction{write.reslts}.

<<eval=FALSE>>===
write.reslts(pumaDERes, file="pumaDERes")
@

This code will create two different comma-separated value (csv) files in the working directory. \Robject{pumaDERes\_statistics.csv} will contain the statistic of differential expression (PPLR values if created using pumaDE). \Robject{pumaDERes\_FC.csv} will contain log fold changes.

Suppose we are particularly interested in the interaction term. We saw above that this was the seventh contrast identified by \Rpackage{puma}. The following commands will identify the gene deemed to be most likely to be differentially expressed due to the interaction term by our two methods

<<>>=
topLimmaIntGene <- topGenes(limmaRes, contrast=7)
toppumaDEIntGene <- topGenes(pumaDERes, contrast=7)
@

Let's look first at the gene determined by RMA/limma to be most likely to be differentially expressed due to the interaction term

\setkeys{Gin}{width=0.5\textwidth}
\begin{figure}[H]
\begin{center}
<<fig=TRUE>>=
plotErrorBars(eset_estrogen_rma, topLimmaIntGene)
@
\end{center}
\caption{Expression levels (as calculated by RMA) for the gene most likely to be differentially expressed due to the interaction term in the \Robject{estrogen} data set by RMA/limma
	\label{topgene_rmalimma}
}
\end{figure}

The gene shown in Figure 4 would appear to be a good candidate for a DE gene. There seems to be an increase in the expression of this gene due to the combination of the estrogen=absent and time=48 conditions. The within condition variance (i.e. between replicates) appears to be low, so it would seem that the effect we are seeing is real.

We will now look at this same gene, but showing both the expression level, and, crucially, the error bars of the expression levels, as determined by multi-mgMOS.

\setkeys{Gin}{width=0.5\textwidth}
\begin{figure}[H]
\begin{center}
<<fig=TRUE>>=
plotErrorBars(eset_estrogen_mmgmos_normd, topLimmaIntGene)
@
\end{center}
\caption{Expression levels and error bars (as calculated by multi-mgMOS) for the gene determined most likely to be differentially expressed due to the interaction term in the \Robject{estrogen} data set by RMA/limma
	\label{topgene_mmgmoslimma}
}
\end{figure}

Figure 5 tells a somewhat different story from that shown in figure 4. Again, we see that the expected expression level for the absent:48 condition is higher than for other conditions. Also, we again see that the within condition variance of expected expression level is low (the two replicates within each condition have roughly the same value). However, from figure 5 we can now see that we actually have very little confidence in the expression level estimates (the error bars are large), particularly for the time=10 arrays. Indeed the error bars of absent:10 and present:10 both overlap with those of absent:48, indicating that the effect previously seen might actually be an artifact.

\setkeys{Gin}{width=0.5\textwidth}
\begin{figure}[H]
\begin{center}
<<fig=TRUE>>=
plotErrorBars(eset_estrogen_mmgmos_normd, toppumaDEIntGene)
@
\end{center}
\caption{Expression levels and error bars (as calculated by multi-mgMOS) for the gene determined most likely to be differentially expressed due to the interaction term in the \Robject{estrogen} data set by mmgmos/pumaDE
	\label{topgene_mmgmospumade}
}
\end{figure}

Finally, figure 6 shows the gene determined by multi-mgMOS/PPLR to be most likely to be differentially expressed due to the interaction term. For this gene, there appears to be lower expression of this gene due to the combination of the estrogen=absent and time=48 conditions. Unlike with the gene shown in 5, however, there is no overlap in the error bars between the genes in this condition, and those in other conditions. Hence, this would appear to be a better candidate for a DE gene.



\subsection{Identifying differentially expressed (DE) genes with IPPLR method}
\label{sec:IPPLR}


The PPLR method is useful as it effectively makes use of the information about uncertainty in expression level information. However, the original published version of PPLR uses importance sampling in the E-step of the variational EM algorithm which is quite computationally intensive, especially when the experiment involves a large number of chips.

The improved PPLR (IPPLR) method \cite{ipplr} also uses information about uncertainty in expression level information, but avoids the use of importance sampling in the E-step of the variational EM algorithm. This improves both computational efficiency and the IPPLR method greatly improves computational efficiency when there are many chips in the dataset.

The IPPLR method identifies differentially expressed genes in two stages in the same way as the PPLR method described in Section~\ref{sec:PPLR}. Firstly, the expression level information from the different replicates of each condition is combined to give a single expression level (and standard error of this expression level) for each condition. Note that the following dataset uses the \Rfunction{data(eset\_mmgmos)}.


<<>>=
data(eset_mmgmos)
eset_mmgmos_100 <- eset_mmgmos[1:100,]
pumaCombImproved <- pumaCombImproved(eset_mmgmos_100)
@

As described for the PPLR method, \Rpackage{puma} will automatically calculate contrasts which are likely to be of interst for the particular design of your data set. For example, the following command shows which contrasts \Rpackage{puma} will calculate for this data set

<<>>=
colnames(createContrastMatrix(pumaCombImproved))
@

From the results, we see that there are seven contrasts of potential interest. The first four are simple comparisons of two conditions. The next two are comparisons between the two levels of one of the factors. These are often referred to as ``main effects". The final contrast is known as an ``interaction effect".

The results from the \Rfunction{pumaCombImproved} can be written out to a text(csv) file as follows:

<<>>=
write.reslts(pumaCombImproved,file="eset_mmgmo_combimproved")
@

The IPPLR method uses the PPLR values to identify the differentially expressed genes. This process is the same as the PPLR method, so the IPPLR method also uses the \Rfunction{pumaDE}.

<<>>=

pumaDEResImproved <- pumaDE(pumaCombImproved)
@

The results of the command is ranked gene lists. If we want to write out the statistics of differentiall expression (the PPLR values), and the fold change values, we can use the \Rfunction{write.reslts}.

<<>>=
write.reslts(pumaDEResImproved,file="pumaDEResImproved")
@

Section~\ref{sec:IPPLR} gives further examples of how to use the results of this analysis.

\subsection{Clustering with pumaClust}
\label{sec:clust}

The following code will identify seven clusters from the output of \Rfunction{mmgmos}:

<<>>=
pumaClust_estrogen <- pumaClust(eset_estrogen_mmgmos, clusters=7)
@

The result of this is a list with different components such as the cluster each probeset is assigned to and cluster centers. The following code will identify the number of probesets in each cluster, the cluster centers, and will write out a csv file with probeset to cluster mappings:

<<>>=
summary(as.factor(pumaClust_estrogen$cluster))
pumaClust_estrogen$centers
@
<<eval=FALSE>>=
write.csv(pumaClust_estrogen$cluster, file="pumaClust_clusters.csv")
@



\subsection{Clustering with pumaClustii}

The more recently developed \Rfunction{pumaClustii} method clusters probe-sets taking into account the uncertainties associated with gene expression measurements (from a probe-level analysis model like mgMOS and multi-mmgMOS) but also allowing for replicate information. The probabilistic model used is a Student's t mixture model \cite{pumaclustii} which provides greater robustness than the more standard Gaussian mixture model used by \Rfunction{pumaClust} (Section~\ref{sec:clust}).

The following code will identify six clusters from the output of mmgmos:

<<>>=
data(Clustii.exampleE)
data(Clustii.exampleStd)
  r<-vector(mode="integer",0)
  for (i in c(1:20))
    for (j in c(1:4))
      r<-c(r,i)
cl<-pumaClustii(Clustii.exampleE,Clustii.exampleStd,
                mincls=6,maxcls=6,conds=20,reps=r,eps=1e-3)
@

In this example the vector r contains the labels identifying which
experiments should be treated as replicate, and the maxcls and mincls 
are represented the maximum and minimum number of clusters respectively.

The result of this is a list with different components such as the cluster each probeset is assigned to and cluster centers.You can use the commands described in Section~\ref{sec:clust} to obtain information about the results.


\subsection{Analysis using remapped CDFs}

There is increasing awareness that the original probe-to-probeset mappings provided by Affymetrix are unreliable for various reasons. Various groups have developed alternative probe-to-probeset mappings, or “remapped CDFs”, and many of these are available either as Bioconductor annotation packages, or as easily downloadable cdf packages.

Importing the CEL files is achieved with the \Rfunction{read.celfiles} function. The function will, in general, correctly identify the annotation package to be used with the experimental data being imported, but the user can specify the pkgname argument to force the use of a particular one, if for some reason this is required. If the annotation package is not available from BioConductor, user can use the pdInfoBuilder package to build one.

If you have the ( pd.hg.u95a) and pd.hg.u95b annotation packages, you can do it as follows:

<<eval=FALSE>>=
oligo.estrogen<-read.celfiles(celFiles,pkgname="pd.hg.u95a")
@

One of the issues with using remapped CDFs is that many probesets in the remapped data have very few probes. This makes reliable estimation of the expression level of such probesets even more problematic than with the original mappings. Because of this, we believe that even greater attention should be given to the uncertainty in expression level measurements when using remapped CDFs than when using the original mappings. In this section we show how to apply the uncertainty propogation methods of puma to the re-analysis the estrogen data using a remapped CDF. Note that most of the commands in this section are the same as the commands in the previous section, showing how straight-forward it is to do such analysis in puma.

To see the effect of the remapping, the following commands give the numbers of probes per probeset using the original, and the remapped CDFs:

<<>>=
table(table(oligo::probeNames(oligo.estrogen)))
@

Note that, while for the original mapping the vast majority of probesets have 16 probes, for the remapped CDF many probesets have less than 16 probes. With this particular CDF, probesets with less than 5 probes have been excluded, but this is not the same for all remapped CDFs.

Analysis can then proceed essentially as before. In the following we will compare the use of mmgmos/pumaPCA/pumaDE with that of RMA/PCA/limma.


\newpage
\section{\Rpackage{puma} for \Rpackage{limma} users}

\Rpackage{puma} and \Rpackage{limma} both have the same primary goal: to identify differentially expressed genes. Given that many potential users of \Rpackage{puma} will already be familiar with \Rpackage{limma}, we have consciously attempted to incorporate many of the features of \Rpackage{limma}. Most importantly we have made the way models are specified in \Rpackage{puma}, through the creation of design and contrast matrices, very similar to way this is done in \Rpackage{limma}. Indeed, if you have already created design and contrast matrices in \Rpackage{limma}, these same matrices can be used as arguments to the \Rfunction{pumaComb} and \Rfunction{pumaDE} functions.

One of the big differences between the two packages is the ability to automatically create design and contrast matrices within \Rpackage{puma}, based on the phenotype data supplied with the raw data. We believe that these automatically created matrices will be sufficient for the large majority of analyses, including factorial designs with up to three different factors. It is even possible, through the use of the \Rfunction{createDesignMatrix} and \Rfunction{createContrastMatrix} functions, to automatically create these matrices using \Rpackage{puma}, but then use them in a \Rpackage{limma} analysis. More details on the automatic creation of design and contrast matrices is given in Appendix A.

One type of analysis that cannot currently be performed within \Rpackage{puma}, but that is available in \Rpackage{limma}, is the detection of genes which are differentially expressed in at least one out of three or more different conditions (see e.g. Section 8.6 of the \Rpackage{limma} user manual). Factors with more than two levels can be analysed within \Rpackage{puma}, but only at present by doing pairwise comparisons of the different levels. The authors are currently working on extending the functionality of \Rpackage{puma} to incorporate the detection of genes differentially expressed in at least one level of multi-level factors.

% some stuff about the DEGRes class if I get round to doing this...

\Rpackage{puma} is currently only applicable to Affymetrix GeneChip arrays, unlike \Rpackage{limma}, which is applicable to a wide range of arrays. This is due to the calculation of expression level uncertainties within multi-mgMOS from the PM and MM probes which are specific to GeneChip arrays.


\newpage
\section{Parallel processing with \Rpackage{puma}}

The most time-consuming step in a typical \puma analysis is running the \Rfunction{pumaComb} function. This function, however, operates on a probe set by probe set basis, and therefore it is possible to divide the full set of probe sets into a number of different ``chunks'', and process each chunk separately on separate machines, or even on separate cores of a single multi-core machine, hence significantly speeding up the function.

This parallel processing capability has been built in to the \puma package, making use of functionality from the R package \Rpackage{snow}. The \Rpackage{snow} package itself has been designed to run on the following three underlying technologies: MPI, PVM and socket connections. The \puma package has only been tested using MPI and socket connections. We have found little difference in processing time between these two methods, and currently recommend the use of socket connections as this is easier to set up. Parallel processing in \puma has also only been tested to date on a Sun GridEngine cluster. The steps to set up \puma on such an architecture using socket connections and MPI are discussed in the following two sections

\subsection{Parallel processing using socket connections}

If you do not already have the package \Rpackage{snow} installed, install this using the following commands:

<< eval=FALSE >>==
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("snow")
@

\subsubsection{Parallelisation of pumaComb}

To use the parallel functionality of \Rfunction{pumaComb} you will first need to create a \Rfunction{snow} ``cluster''. This can be done with the following commands. Note that you can have as many nodes in the \Rfunction{makeCluster} command as you like. You will need to use your own machine names in the place of ``node01'', ``node02'', etc. Note you can also use full IP addresses instead of machine names.

<< eval=FALSE >>==
library(snow)
cl <- makeCluster(c("node01", "node02", "node03", "node04"), type = "SOCK")
@

You can then run \Rfunction{pumaComb} with the created cluster, ensuring the \Rfunction{cl} parameter is set, as in the following example, which compares the times running on a single node, and running on four nodes:

<< eval=FALSE >>==
library(puma)
data(affybatch.estrogen)
pData(affybatch.estrogen) <- data.frame(
	"level"=c("twenty","twenty","ten")
,	"batch"=c("A","B","A")
,	row.names=rownames(pData(affybatch.example)))
eset_mmgmos <- mmgmos(oligo.estrogen)
system.time(eset_comb_1 <- pumaComb(eset_mmgmos))
system.time(eset_comb_4 <- pumaComb(eset_mmgmos, cl=cl))
@

To run pumaComb on multi-cores of a multi-core machine, use a makeCluster command such as the following:
<< eval=FALSE >>==
library(snow)
cl <- makeCluster(c("localhost", "localhost"), type = "SOCK")
@

We have found that on a dual-core notebook, the using both cores reduced execution time by about a third.

Finally, to run on multi-cores of a multi-node cluster, a command such as the following can be used:

<< eval=FALSE >>==
library(snow)
cl <- makeCluster(c("node01", "node01", "node02", "node02"
, "node03", "node03", "node04", "node04"), type = "SOCK")
@

\subsubsection{Parallelisation of gmoExon}

To use the parallel functionality of gmoExon you also need to create a snow “cluster”.This can be done with the following commands:

<<eval=FALSE>>=
library(snow)
cl<-makeCluster(c("node01","node02","node03","node04"),type = "SOCK")
@

You can then run gmoExon with the created cluster, as in the following example:

<<eval=FALSE>>=
library(puma)
library(oligo)
object<-read.celfiles("filename.CEL")
eset<-gmoExon(object,exontype="Human",GT="gene",gsnorm="none",cl=cl)
@

To run gmoExon on multi-core machine, use a makeCluster command such as the following:

<<eval=FALSE>>=
ibrary(snow)
cl<-makeCluster(c("loaclhost","localhost"),type = "SOCK")
@

Finally, to run on multi-cores of a multi-node cluster, a command such as the following can be used:

<<eval=FALSE>>=
library(snow)
cl<-makeCluster(c("node01","node01","node02" ,"node02"
,"node03" ,"node03" ,"node04" ,"node04"), type = "SOCK")
@

\subsubsection{Parallelisation of gmhta}

To use the parallel functionality of gmhta you also need to create a snow “cluster”.This can be done with the following commands:

<<eval=FALSE>>=
library(snow)
cl<-makeCluster(c("node01","node02","node03","node04"),type = "SOCK")
@

You can then run gmhta with the created cluster, as in the following example:

<<eval=FALSE>>=
library(puma)
library(oligo)
object<-read.celfiles("filename.CEL")
eset<-gmhta(object,gsnorm="none",cl=cl)
@

To run gmhta on multi-core machine, use a makeCluster command such as the following:

<<eval=FALSE>>=
ibrary(snow)
cl<-makeCluster(c("loaclhost","localhost"),type = "SOCK")
@

Finally, to run on multi-cores of a multi-node cluster, a command such as the following can be used:

<<eval=FALSE>>=
library(snow)
cl<-makeCluster(c("node01","node01","node02" ,"node02"
,"node03" ,"node03" ,"node04" ,"node04"), type = "SOCK")
@


\subsection{Parallel processing using MPI}

First follow the steps listed here:

\begin{enumerate}
\item Download the latest version of lam-mpi from http://www.lam-mpi.org/
\item Install lam-mpi following the instructions available at http://www.lam-mpi.org/
\item Create a text file called \verb+hostfile+, the first line of which has the IP address of the master node of your cluster, and subsequent line of which have the IP addresses of each node you wish to use for processing
\item From the command line type the command \verb+lamboot hostfile+. If this is successful you should see a message saying \begin{verbatim}LAM 7.1.2/MPI 2 C++/ROMIO - Indiana University\end{verbatim} (or similar)
\item Install R and the \puma package on each node of the cluster (note this will often simply involve running R CMD INSTALL on the master node)
\item Install the R packages \Rpackage{snow} and \Rpackage{Rmpi} on each node of the cluster
\end{enumerate}

The function \Rfunction{pumaComb} should automatically run in parallel if the \verb+lamboot+ command was successful, and \puma, \Rpackage{snow} and \Rpackage{Rmpi} are all installed on each node of the cluster. By default the function will use all available nodes.

If you want to override the default parallel behaviour of \Rfunction{pumaComb}, you can set up your own cluster which will subsequently be used by the function. This cluster has to be named \verb+cl+. To run a cluster with, e.g. four nodes, run the following code:

<<eval = FALSE>>=
library(Rmpi)
library(snow)
cl <- makeCluster(4)
clusterEvalQ(cl, library(puma))
@

Note that it is important to use the variable name \Robject{cl} to hold the \Rfunction{makeCluster} object as \puma  checks for a variable of this name. The argument to \Rfunction{makeCluster} (here 4) should be the number of nodes on which you want the processing to run (usually the same as the number of nodes included in the \verb+hostfile+ file, though can also be less).

Running \Rfunction{pumaComb} in parallel should generally give a speed up almost linear in terms of the number of nodes (e.g. with four nodes you should expect the function to complete in about a quarter of the time as if using just one node).

\section{Session info}

This vignette was created using the following:
<<>>=
sessionInfo()
@

\newpage
\appendix

\section{Automatic creation of design and contrast matrices}

The \puma  package has been designed to be as easy to use as possible, while not compromising on power and flexibility. One of the most difficult tasks for many users, particularly those new to microarray analysis, or statistical analysis in general, is setting up design and contrast matrices. The \puma  package will automatically create such matrices, and we believe the way this is done will suffice for most users' needs.

It is important to recognise that the automatic creation of design and contrast matrices will only happen if appropriate information about the levels of each factor is available for each array in the experimental design. This data should be held in an \Robject{AnnotatedDataFrame} class. The easiest way of doing this is to ensure that the \Robject{affybatch} object holding the raw CEL file data has an appropriate phenoData slot. This information will then be passed through to any \Robject{ExpressionSet} object created, for example through the use of \Rfunction{mmgmos}. The \Robject{phenoData} slot of an \Robject{ExpressionSet} object can also be manipulated directly if necessary.

Design and contrast matrices are dependent on the experimental design. The simplest experimental designs have just one factor, and hence the \Robject{phenoData} slot will have a matrix with just one column. In this case, each unique value in that column will be treated as a distinct level of the factor, and hence \Rfunction{pumaComb} will group arrays according to these levels. If there are just two levels of the factor, e.g. A and B, the contrast matrix will also be very simple, with the only contrast of interest being A vs B. For factors with more than two levels, a contrast matrix will be created which reflects all possible combinations of levels. For example, if we have three levels A, B and C, the contrasts of interest will be A vs B, A vs C and B vs C. In addition, from \puma version 1.2.1, the following additional contrasts will be created: A vs other (i.e. A vs B \& C), B vs other and C vs other.

If we now consider the case of two or more factors, things become more complicated. There are now two cases to be considered: factorial experiments, and non-factorial experiments. A factorial experiment is one where all the combinations of the levels of each factor are tested by at least one array (though ideally we would have a number of biological replicates for each combination of factor levels). The \Robject{estrogen} case study (Section \ref{section:Introductory example}) is an example of a factorial experiment. A non-factorial experiment is one where at least one combination of levels is not tested. If we treat the example used in the \Robject{puma-package} help page as a two-factor experiment (with factors ``level'' and ``batch''), we can see that this is not a factorial experiment as we have no array to test the conditions ``level=ten'' and ``batch=B''. We will treat the factorial and non-factorial cases separately in the following sections.

\subsection{Factorial experiments}

For factorial experiments, the design matrix will use all columns from the \Robject{phenoData} slot. This will mean that \Rfunction{combineRepliactes} will group arrays according to a combination of the levels of all the factors.

% The contrast matrix will need to reflect...

\subsection{Non-factorial designs}

For non-factorial designed experiments, we will simply ignore columns (right to left) from the \Robject{phenoData} slot until we have a factorial design or a single factor. We can see this in the example used in the \Robject{puma-package} help page. Here we have ignored the ``batch'' factor, and modelled the experiment as a single-factor experiment (with that single factor being ``level'').

\subsection{Further help}

There are examples of the automated creation of design and contrast matrices for increasingly complex experimental designs in the help pages for \Robject{createDesignMatrix} and \Robject{createContrastMatrix}.

\newpage
\bibliographystyle{unsrt}
\bibliography{puma}

\end{document}

# Java Options

`System Properties` or `Environment Variables` can be used to change Puma's
default configuration for its Java extension. The provided values are evaluated
during initialization, and changes while running the app have no effect.
Moreover, default values may be used in case of invalid inputs.

## Supported Options

| ENV Name                     | Default Value |        Validation        |
|------------------------------|:-------------:|:------------------------:|
| PUMA_QUERY_STRING_MAX_LENGTH |   1024 * 10   | Positive natural number  |
| PUMA_REQUEST_PATH_MAX_LENGTH |     8192      | Positive natural number  |
| PUMA_REQUEST_URI_MAX_LENGTH  |   1024 * 12   | Positive natural number  |
| PUMA_SKIP_SIGUSR2            |   nil         | n/a                      |

## Examples

### Invalid inputs

An empty string will be handled as missing, and the default value will be used instead.
Puma will print an error message for other invalid values.

```
foo@bar:~/puma$ PUMA_QUERY_STRING_MAX_LENGTH=abc PUMA_REQUEST_PATH_MAX_LENGTH='' PUMA_REQUEST_URI_MAX_LENGTH=0 bundle exec bin/puma test/rackup/hello.ru

The value 0 for PUMA_REQUEST_URI_MAX_LENGTH is invalid. Using default value 12288 instead.
The value abc for PUMA_QUERY_STRING_MAX_LENGTH is invalid. Using default value 10240 instead.
Puma starting in single mode...
```

### Valid inputs

```
foo@bar:~/puma$ PUMA_REQUEST_PATH_MAX_LENGTH=9 bundle exec bin/puma test/rackup/hello.ru

Puma starting in single mode...
```
```
foo@bar:~ export path=/123456789 # 10 chars
foo@bar:~ curl "http://localhost:9292${path}"

Puma caught this error: HTTP element REQUEST_PATH is longer than the 9 allowed length. (Puma::HttpParserError)

foo@bar:~ export path=/12345678 # 9 chars
foo@bar:~ curl "http://localhost:9292${path}"
Hello World
```

### Java Flight Recorder Compatibility

Unfortunately Java Flight Recorder uses `SIGUSR2` internally. If you wish to 
use JFR, turn off Puma's trapping of `SIGUSR2` by setting the environment variable
`PUMA_SKIP_SIGUSR2` to any value.

# Security Policy

## Supported Versions

| Version       | Supported  |
| :------------ | :--------: |
| Latest release in 8.x | ✅ |
| Latest release in 7.x | ✅ |
| All other releases    | ❌ |

## Reporting a Vulnerability

[Report on Github](https://github.com/puma/puma/security) or contact [Evan Phoenix.](https://github.com/evanphx)

# systemd

[systemd](https://www.freedesktop.org/wiki/Software/systemd/) is a commonly
available init system (PID 1) on many Linux distributions. It offers process
monitoring (including automatic restarts) and other useful features for running
Puma in production.

## Service Configuration

Below is a sample puma.service configuration file for systemd, which can be
copied or symlinked to `/etc/systemd/system/puma.service`, or if desired, using
an application or instance-specific name.

Note that this uses the systemd preferred "simple" type where the start command
remains running in the foreground (does not fork and exit).

~~~~ ini
[Unit]
Description=Puma HTTP Server
After=network.target

# Uncomment for socket activation (see below)
# Requires=puma.socket

[Service]
# Puma supports systemd's `Type=notify` and watchdog service
# monitoring, as of Puma 5.1 or later.
# On earlier versions of Puma or JRuby, change this to `Type=simple` and remove
# the `WatchdogSec` line.
Type=notify

# If your Puma process locks up, systemd's watchdog will restart it within seconds.
WatchdogSec=10

# Preferably configure a non-privileged user
# User=

# The path to your application code root directory.
# Also replace the "<YOUR_APP_PATH>" placeholders below with this path.
# Example /home/username/myapp
WorkingDirectory=<YOUR_APP_PATH>

# Helpful for debugging socket activation, etc.
# Environment=PUMA_DEBUG=1

# SystemD will not run puma even if it is in your path. You must specify
# an absolute URL to puma. For example /usr/local/bin/puma
# Alternatively, create a binstub with `bundle binstubs puma --path ./sbin` in the WorkingDirectory
ExecStart=/<FULLPATH>/bin/puma -C <YOUR_APP_PATH>/puma.rb

# Variant: Rails start.
# ExecStart=/<FULLPATH>/bin/puma -C <YOUR_APP_PATH>/config/puma.rb ../config.ru

# Variant: Use `bundle exec puma` instead of binstub
# Variant: Specify directives inline.
# ExecStart=/<FULLPATH>/puma -b tcp://0.0.0.0:9292 -b ssl://0.0.0.0:9293?key=key.pem&cert=cert.pem


Restart=always

[Install]
WantedBy=multi-user.target
~~~~

See
[systemd.exec](https://www.freedesktop.org/software/systemd/man/systemd.exec.html)
for additional details.

## Socket Activation

systemd and Puma also support socket activation, where systemd opens the
listening socket(s) in advance and provides them to the Puma master process on
startup. Among other advantages, this keeps listening sockets open across puma
restarts and achieves graceful restarts, including when upgraded Puma, and is
compatible with both clustered mode and application preload.

**Note:** Any wrapper scripts which `exec`, or other indirections in `ExecStart`
may result in activated socket file descriptors being closed before reaching the
puma master process.

**Note:** Socket activation doesn't currently work on JRuby. This is tracked in
[#1367].

Configure one or more `ListenStream` sockets in a companion `*.socket` unit file
to use socket activation. Also, uncomment the associated `Requires` directive
for the socket unit in the service file (see above.) Here is a sample
puma.socket, matching the ports used in the above puma.service:

~~~~ ini
[Unit]
Description=Puma HTTP Server Accept Sockets

[Socket]
ListenStream=0.0.0.0:9292
ListenStream=0.0.0.0:9293

# AF_UNIX domain socket
# SocketUser, SocketGroup, etc. may be needed for Unix domain sockets
# ListenStream=/run/puma.sock

# Socket options matching Puma defaults
ReusePort=true
Backlog=1024
# Enable this if you're using Puma with the "low_latency" option, read more in Puma DSL docs and systemd docs:
# https://www.freedesktop.org/software/systemd/man/latest/systemd.socket.html#NoDelay=
# NoDelay=true

[Install]
WantedBy=sockets.target
~~~~

See
[systemd.socket](https://www.freedesktop.org/software/systemd/man/systemd.socket.html)
for additional configuration details.

Note that the above configurations will work with Puma in either single process
or cluster mode.

### Sockets and symlinks

When using releases folders, you should set the socket path using the shared
folder path (ex. `/srv/projet/shared/tmp/puma.sock`), not the release folder
path (`/srv/projet/releases/1234/tmp/puma.sock`).

Puma will detect the release path socket as different than the one provided by
systemd and attempt to bind it again, resulting in the exception `There is
already a server bound to:`.

### Binding

By default, you need to configure Puma to have binds matching with all
ListenStream statements. Any mismatched systemd ListenStreams will be closed by
Puma.

To automatically bind to all activated sockets, the option
`--bind-to-activated-sockets` can be used. This matches the config DSL
`bind_to_activated_sockets` statement. This will cause Puma to create a bind
automatically for any activated socket. When systemd socket activation is not
enabled, this option does nothing.

This also accepts an optional argument `only` (DSL: `'only'`) to discard any
binds that's not socket activated.

## Usage

Without socket activation, use `systemctl` as root (i.e., via `sudo`) as with
other system services:

~~~~ sh
# After installing or making changes to puma.service
systemctl daemon-reload

# Enable so it starts on boot
systemctl enable puma.service

# Initial startup.
systemctl start puma.service

# Check status
systemctl status puma.service

# A normal restart. Warning: listener's sockets will be closed
# while a new puma process initializes.
systemctl restart puma.service
~~~~

With socket activation, several but not all of these commands should be run for
both socket and service:

~~~~ sh
# After installing or making changes to either puma.socket or
# puma.service.
systemctl daemon-reload

# Enable both socket and service, so they start on boot.  Alternatively
# you could leave puma.service disabled, and systemd will start it on
# the first use (with startup lag on the first request)
systemctl enable puma.socket puma.service

# Initial startup. The Requires directive (see above) ensures the
# socket is started before the service.
systemctl start puma.socket puma.service

# Check the status of both socket and service.
systemctl status puma.socket puma.service

# A "hot" restart, with systemd keeping puma.socket listening and
# providing to the new puma (master) instance.
systemctl restart puma.service

# A normal restart, needed to handle changes to
# puma.socket, such as changing the ListenStream ports. Note
# daemon-reload (above) should be run first.
systemctl restart puma.socket puma.service
~~~~

Here is sample output from `systemctl status` with both service and socket
running:

~~~~
● puma.socket - Puma HTTP Server Accept Sockets
   Loaded: loaded (/etc/systemd/system/puma.socket; enabled; vendor preset: enabled)
   Active: active (running) since Thu 2016-04-07 08:40:19 PDT; 1h 2min ago
   Listen: 0.0.0.0:9233 (Stream)
           0.0.0.0:9234 (Stream)

Apr 07 08:40:19 hx systemd[874]: Listening on Puma HTTP Server Accept Sockets.

● puma.service - Puma HTTP Server
   Loaded: loaded (/etc/systemd/system/puma.service; enabled; vendor preset: enabled)
   Active: active (running) since Thu 2016-04-07 08:40:19 PDT; 1h 2min ago
 Main PID: 28320 (ruby)
   CGroup: /system.slice/puma.service
           ├─28320 puma 3.3.0 (tcp://0.0.0.0:9233,ssl://0.0.0.0:9234?key=key.pem&cert=cert.pem) [app]
           ├─28323 puma: cluster worker 0: 28320 [app]
           └─28327 puma: cluster worker 1: 28320 [app]

Apr 07 08:40:19 hx puma[28320]: Puma starting in cluster mode...
Apr 07 08:40:19 hx puma[28320]: * Version 3.3.0 (ruby 2.2.4-p230), codename: Jovial Platypus
Apr 07 08:40:19 hx puma[28320]: * Min threads: 0, max threads: 16
Apr 07 08:40:19 hx puma[28320]: * Environment: production
Apr 07 08:40:19 hx puma[28320]: * Process workers: 2
Apr 07 08:40:19 hx puma[28320]: * Phased restart available
Apr 07 08:40:19 hx puma[28320]: * Activated tcp://0.0.0.0:9233
Apr 07 08:40:19 hx puma[28320]: * Activated ssl://0.0.0.0:9234?key=key.pem&cert=cert.pem
Apr 07 08:40:19 hx puma[28320]: Use Ctrl-C to stop
~~~~

### capistrano3-puma

By default, [capistrano3-puma](https://github.com/seuros/capistrano-puma) uses
`pumactl` for deployment restarts outside of systemd. To learn the exact
commands that this tool would use for `ExecStart` and `ExecStop`, use the
following `cap` commands in dry-run mode, and update from the above forking
service configuration accordingly. Note also that the configured `User` should
likely be the same as the capistrano3-puma `:puma_user` option.

~~~~ sh
stage=production # or different stage, as needed
cap $stage puma:start --dry-run
cap $stage puma:stop  --dry-run
~~~~

### Disabling Puma Systemd Integration

If you would like to disable Puma's systemd integration, for example if you handle it elsewhere
in your code yourself, simply set the the environment variable `PUMA_SKIP_SYSTEMD` to any value.



[Restart]: https://www.freedesktop.org/software/systemd/man/systemd.service.html#Restart=
[#1367]: https://github.com/puma/puma/issues/1367
[#1499]: https://github.com/puma/puma/issues/1499

# Welcome to Puma 5: Spoony Bard.

![Spoony Bard](https://i1.kym-cdn.com/entries/icons/original/000/006/385/Spoony_Bard.jpg "Spoony Bard")

>Note: Puma 5 now automatically uses `WEB_CONCURRENCY` env var if set see [this post for an explanation](https://github.com/puma/puma/issues/2393#issuecomment-702352208). If your memory use goes up after upgrading to Puma 5 it indicates you're now running with multiple workers (processes). You can decrease memory use by tuning this number to be lower.

Puma 5 brings new experimental performance features, a few quality-of-life features and loads of bugfixes. Here's what you should do:

1. Review the Upgrade section below to see if any of 5.0's breaking changes will affect you.
2. Upgrade to version 5.0 in your Gemfile and deploy.
3. Try the new performance experiments outlined below and report your results back to the Puma issue tracker.

Puma 5 was named Spoony Bard by our newest supercontributor, [@wjordan](https://github.com/puma/puma/commits?author=wjordan). Will brought you one of our new perf features for this release, as well as [many other fixes and refactors.](https://github.com/puma/puma/commits?author=wjordan) If you'd like to name a Puma release in the future, take a look at [CONTRIBUTING.md](../CONTRIBUTING.md) and get started helping us out :)

Puma 5 also welcomes [@MSP-Greg](https://github.com/puma/puma/commits?author=MSP-Greg) as our newest committer. Greg has been instrumental in improving our CI setup and SSL features. Greg also [named our 4.3.0 release](https://github.com/puma/puma/releases/tag/v4.3.0): Mysterious Traveller.

## What's New

Puma 5 contains three new "experimental" performance features for cluster-mode Pumas running on MRI.

If you try any of these features, please report your results to [our report issue](https://github.com/puma/puma/issues/2258).

Part of the reason we're calling them _experimental_ is because we're not sure if they'll actually have any benefit. People's workloads in the real world are often not what we anticipate, and synthetic benchmarks are usually not of any help in figuring out if a change will be beneficial or not.

We do not believe any of the new features will have a negative effect or impact the stability of your application. This is either a "it works" or "it does nothing" experiment.

If any of the features turn out to be particularly beneficial, we may make them defaults in future versions of Puma.

### Lower latency, better throughput

From our friends at GitLab, the new experimental `wait_for_less_busy_worker` config option may reduce latency and improve throughput for high-load Puma apps on MRI. See the [pull request](https://github.com/puma/puma/pull/2079) for more discussion.

Users of this option should see reduced request queue latency and possibly less overall latency.

Add the following to your `puma.rb` to try it:

```ruby
wait_for_less_busy_worker
# or
wait_for_less_busy_worker 0.001
```

Production testing at GitLab suggests values between `0.001` and `0.010` are best.

### Better memory usage

5.0 brings two new options to your config which may improve memory usage.

#### nakayoshi_fork

`nakayoshi_fork` calls GC a handful of times and compacts the heap on Ruby 2.7+ before forking. This may reduce memory usage of Puma on MRI with preload enabled. It's inspired by [Koichi Sasada's work](https://github.com/ko1/nakayoshi_fork).

To use it, you can add this to your `puma.rb`:

```ruby
nakayoshi_fork
```

#### fork_worker

Puma 5 introduces an experimental new cluster-mode configuration option, `fork_worker` (`--fork-worker` from the CLI). This mode causes Puma to fork additional workers from worker 0, instead of directly from the master process:

```
10000   \_ puma 4.3.3 (tcp://0.0.0.0:9292) [puma]
10001       \_ puma: cluster worker 0: 10000 [puma]
10002           \_ puma: cluster worker 1: 10000 [puma]
10003           \_ puma: cluster worker 2: 10000 [puma]
10004           \_ puma: cluster worker 3: 10000 [puma]
```

It is compatible with phased restarts. It also may improve memory usage because the worker process loads additional code after processing requests.

To learn more about using `refork` and `fork_worker`, see ['Fork Worker'](fork_worker.md).

### What else is new?

* **Loads of bugfixes**.
* Faster phased restarts and worker timeouts.
* pumactl now has a `thread-backtraces` command to print thread backtraces, bringing thread backtrace printing to all platforms, not just *BSD and Mac. (#2053)
* Added incrementing `requests_count` to `Puma.stats`. (#2106)
* Faster phased restart and worker timeout. (#2220)
* Added `state_permission` to config DSL to set state file permissions (#2238)
* Ruby 2.2 support will be dropped in Puma 6. This is the final major release series for Ruby 2.2.

## Upgrade

* Setting the `WEB_CONCURRENCY` environment variable will now configure the number of workers (processes) that Puma will boot and enable preloading of the application.
* If you did not explicitly set `environment` before, Puma now checks `RAILS_ENV` and will use that, if available in addition to `RACK_ENV`.
* If you have been using the `--control` CLI option, update your scripts to use `--control-url`.
* If you are using `worker_directory` in your config file, change it to `directory`.
* If you are running MRI, default thread count on Puma is now 5, not 16. This may change the amount of threads running in your threadpool. We believe 5 is a better default for most Ruby web applications on MRI. Higher settings increase latency by causing GVL contention.
* If you are using a worker count of more than 1, set using `WEB_CONCURRENCY`, Puma will now preload the application by default (disable with `preload_app! false`). We believe this is a better default, but may cause issues in non-Rails applications if you do not have the proper `before` and `after` fork hooks configured. See documentation for your framework. Rails users do not need to change anything. **Please note that it is not possible to use [the phased restart](restart.md) with preloading.**
* tcp mode and daemonization have been removed without replacement. For daemonization, please use a modern process management solution, such as systemd or monit.
* `connected_port` was renamed to `connected_ports` and now returns an Array, not an Integer.

Then, update your Gemfile:

`gem 'puma', '< 6'`

# long_tail_hey

`long_tail_hey` uses hey to create a stream of requests, and logs its report data, along with Puma data.

The main purpose is to see Puma's behavior when it has more requests than available processing threads.

The number of 'processing threads' is `<number of workers> * <max threads>`.

Current code is set to run several `hey` commands, each increasing the number of connections.
The configuration for each set is done in the `CONNECTION_MULT` array in `benchmarks/local/long_tail_hey.rb`.
Change this array to suite your needs.

A few examples:
```text
benchmarks/local/long_tail_hey.sh     -t5:5 -R100 -d0.2
benchmarks/local/long_tail_hey.sh -w2 -t5:5 -R100 -d0.2
benchmarks/local/long_tail_hey.sh -w4 -t5:5 -R100 -d0.2
```

## Arguments

### Puma

| Arg | Description | Example |
| :-: | ----------- | ------- |
| -t  | Threads     | 5:5     |
| -w  | Workers     | 2       |
| -r  | rackup file | \<path\>|
| -C  | config file | \<path\>|

### Hey

| Arg | Description        | Example |
| :-: | ------------------ | ------- |
| -R  | req per conn       | 100     |
| -k  | disable Keep-Alive | na      |
| -d  | req delay          | float   |

### Ruby

| Arg | Description  |
| :-: | ------------ |
| -Y  | enable YJIT  |

## ENV Settings

| ENV       | Description (Default)                  |
| --------  | -------------------------------------- |
| HEY       | path to hey unless in PATH (hey)       |
| HEY_CPUS  | number of cpu's for hey                |
| PUMA_TEST_HOST4  | IPv4 host (127.0.0.1)           |
| PUMA_TEST_HOST6  | IPv6 host (::1)                 |
| PUMA_TEST_PORT   | port (40001)                    |


## Example Output
```text
$ benchmarks/local/long_tail_hey.sh -w4 -t5:5 -R100 -d0.2

bundle exec bin/puma -q -b tcp://127.0.0.1:40001 -S tmp/bench_test_puma.state -w4 -t5:5 --control-url=tcp://127.0.0.1:40010 --control-token=test test/rackup/sleep.ru

[162886] Puma starting in cluster mode...
[162886] * Puma version: 6.5.0 ("Sky's Version")
[162886] * Ruby version: ruby 3.4.0dev (2024-11-26T17:58:43Z master c1dcd1d496) +PRISM [x86_64-linux]
[162886] *  Min threads: 5
[162886] *  Max threads: 5
[162886] *  Environment: development
[162886] *   Master PID: 162886
[162886] *      Workers: 4
[162886] *     Restarts: (✔) hot (✔) phased
[162886] * Listening on http://127.0.0.1:40001
[162886] Use Ctrl-C to stop
[162886] * Starting control server on http://127.0.0.1:40010
[162886] - Worker 0 (PID: 162895) booted in 0.01s, phase: 0
[162886] - Worker 1 (PID: 162899) booted in 0.01s, phase: 0
[162886] - Worker 2 (PID: 162902) booted in 0.01s, phase: 0
[162886] - Worker 3 (PID: 162906) booted in 0.01s, phase: 0

hey -c  20 -n  2000 -cpus 16  http://127.0.0.1:40001/sleep0.2
hey -c  30 -n  3000 -cpus 16  http://127.0.0.1:40001/sleep0.2
hey -c  40 -n  4000 -cpus 16  http://127.0.0.1:40001/sleep0.2
hey -c  60 -n  6000 -cpus 16  http://127.0.0.1:40001/sleep0.2
hey -c  80 -n  8000 -cpus 16  http://127.0.0.1:40001/sleep0.2


Branch: 00-long-tail-hey Puma: -w4  -t5:5  dly 0.2                                         ─────── Worker Request Info ───────
                         ─────────────────────────── Latency ───────────────────────────    Std        % deviation       Total
Mult/Conn     req/sec      10%     25%     50%     75%     90%     95%     99%    100%      Dev        from 25.00%        Reqs
1.00  20      97.0120    0.2010  0.2018  0.2042  0.2085  0.2098  0.2105  0.2127  0.2186    0.000    0.0  0.0  0.0  0.0    2000
1.50  30      90.7293    0.2060  0.2130  0.2913  0.3983  0.4061  0.4098  0.4141  0.4204    0.935   -3.6 -1.6 -1.1  6.3    3000
2.00  40      96.3451    0.4009  0.4023  0.4074  0.4132  0.4188  0.4507  0.5939  0.6144    0.597   -4.1  0.9  1.4  1.8    4000
3.00  60      96.3643    0.6020  0.6051  0.6109  0.6178  0.6257  0.6396  0.7764  0.8148    0.261   -1.6  0.1  0.1  1.3    6000
4.00  80      95.5128    0.6978  0.8031  0.8117  0.8291  0.9165  0.9970  1.0142  1.2035    0.555   -3.0 -1.2  1.5  2.7    8000

[162886] - Gracefully shutting down workers...
[162886] === puma shutdown: 2024-11-26 13:14:43 -0600 ===
[162886] - Goodbye!

 4:27 Total Time
```

# Welcome to Puma 6: Sunflower.

![Image by Todd Trapani, Unsplash](https://user-images.githubusercontent.com/845662/192706685-774d3d0d-f4a9-4b93-b27b-5a3b7f44ff31.jpg)

Puma 6 brings performance improvements for most applications, experimental Rack 3 support, support for Sidekiq 7 Capsules, and more.

Here's what you should do:

1. Review the Upgrade section below to look for breaking changes that could affect you.
2. Upgrade to version 6.0 in your Gemfile and deploy.
3. Open up a new bug issue if you find any problems.
4. Join us in building Puma! We welcome first-timers. See [CONTRIBUTING.md](./CONTRIBUTING.md).

For a complete list of changes, see [History.md](./History.md).

## What's New

Puma 6 is mostly about a few nice-to-have performance changes, and then a few breaking API changes we've been putting off for a while.

### Improved Performance

We've improved throughput and latency in Puma 6 in a few areas.

1. **Large chunked response body throughput 3-10x higher** Chunked response bodies >100kb should be 3 to 10 times faster than in Puma 5. String response bodies should be ~10% faster.
2. **File response throughput is 3x higher.** File responses (e.g. assets) should be about 3x faster.
3. **wait_for_less_busy_worker is now default, meaning lower latencies for high-utilization servers** `wait_for_less_busy_worker` was an experimental feature in Puma 5 and it's now the default in Puma 6. This feature makes each Puma child worker in cluster mode wait before listening on the socket, and that wait time is proportional to N * `number_of_threads_responding_to_requests`. This means that it's more likely that a request is picked up by the least-loaded Puma child worker listening on the socket. Many users reported back that this option was stable and decreased average latency, particularly in environments with high load and utilization.

### Experimental Rack 3 Support

[Rack 3 is now out](https://github.com/rack/rack/blob/main/UPGRADE-GUIDE.md) and we've started on Rack 3 support. Please open a bug if you find any incompatibilites.

### Sidekiq 7 Capsules

Sidekiq 7 (releasing soon) introduces Capsules, which allows you to run a Sidekiq server inside your Puma server (or any other Ruby process for that matter). We've added support by allowing you to pass data into `run_hooks`, see [issue #2915](https://github.com/puma/puma/issues/2915).

## Upgrade

Check the following list to see if you're depending on any of these behaviors:

1. Configuration constants like `DefaultRackup` removed, see [#2928](https://github.com/puma/puma/pull/2928/files#diff-2dc4e3e83be7fd97cebc482ae07d6a8216944003de82458783fb00b5ae9524c8) for the full list.
1. We have changed the names of the following environment variables: `DISABLE_SSL` is now `PUMA_DISABLE_SSL`, and `MAKE_WARNINGS_INTO_ERRORS` is now `PUMA_MAKE_WARNINGS_INTO_ERRORS`.
1. Nakayoshi GC (`nakayoshi_fork` option in config) has been removed without replacement.
1. `wait_for_less_busy_worker` is now on by default. If you don't want to use this feature, you must add `wait_for_less_busy_worker 0` in your config.
1. We've removed the following public methods on Puma::Server: `Puma::Server#min_threads`, `Puma::Server#max_threads`. Instead, you can pass in configuration as an option to Puma::Server#new. This might make certain gems break (`capybara` for example).
1. We've removed the following constants: `Puma::StateFile::FIELDS`, `Puma::CLI::KEYS_NOT_TO_PERSIST_IN_STATE` and `Puma::Launcher::KEYS_NOT_TO_PERSIST_IN_STATE`, and `Puma::ControlCLI::COMMANDS`.
1. We no longer support Ruby 2.2, 2.3, or JRuby on Java 1.7 or below.
1. The behavior of `remote_addr` has changed. When using the set_remote_address header: "header_name" functionality, if the header is not passed, REMOTE_ADDR is now set to the physical peeraddr instead of always being set to 127.0.0.1. When an error occurs preventing the physical peeraddr from being fetched, REMOTE_ADDR is now set to the unspecified source address ('0.0.0.0') instead of to '127.0.0.1'
1. Previously, Puma supported anything as an HTTP method and passed it to the app. We now only accept the following 8 HTTP methods, based on [RFC 9110, section 9.1](https://www.rfc-editor.org/rfc/rfc9110.html#section-9.1).  The [IANA HTTP Method Registry](https://www.iana.org/assignments/http-methods/http-methods.xhtml) contains a full list of HTTP methods.
   ```
   HEAD GET POST PUT DELETE OPTIONS TRACE PATCH
   ```
   As of Puma 6.2, these can be overridden by `supported_http_methods` in your config file, see `Puma::DSL#supported_http_methods`.

Then, update your Gemfile:

`gem 'puma', '< 7'`

# How to Release Puma

Releasing Puma requires the following steps:

1. Choose the target base branch:
   - `main` for the next major or minor line.
   - `<major>-<minor>-stable` for patch releases on an existing stable line (for example, release `7.2.3` from `7-2-stable`).
1. Ensure your local target branch is checked out, clean, and matches `origin/<target-branch>`.
1. Check the CI status for the current `HEAD`. Stop unless everything is passing.
1. Decide on the next version number based on [SemVer 2.0](https://semver.org/). Treat `breaking change` PR labels as strong evidence that a `major` bump is needed.
1. For minor and major releases, determine who "earned" the codename via `git shortlog`. This person will be the "Namer."
1. For major releases, update `SECURITY.md` and write a `docs/X.X-Upgrade.md` upgrade guide.
1. Update `History.md` in the existing format and update `lib/puma/const.rb`. If a codename change is required for a minor or major release, change the codename constant to "INSERT CODENAME HERE."
1. Create a release branch named `release-vX.Y.Z` from your target base branch, commit the release changes, and open a PR.
1. Create or update a draft GitHub release for the upcoming tag using the new `History.md` section as the release notes.
1. **STOP** for manual review. The PR must be reviewed and checked by at least one human.

Once the PR is merged:

1. Ensure the release tag points at `HEAD`, then push that tag to GitHub.
1. Build the CRuby gem with `bundle exec rake build`.
1. If `mise` is installed, look up the latest JRuby version, run `mise exec jruby@<latest> -- rake java gem`, and build the JRuby gem. Otherwise, manage your environment yourself.
1. `gem push` both artifacts to rubygems.org. This requires manual 2FA.

Once both gems have been pushed to rubygems.org:

1. Create or update the GitHub release based on the release tag.
1. Publish the release if it is still a draft.
1. Upload the built gem artifacts to the GitHub release:
   - `pkg/puma-<version>.gem`
   - `pkg/puma-<version>-java.gem`
1. Verify post-publish state:
   - RubyGems shows `puma` version `<version>`.
   - The GitHub release is published and includes both gem artifacts.

## Branch Conventions

- Name release PR branches as `release-vX.Y.Z`.
- Target `main` for major/minor releases.
- Target `<major>-<minor>-stable` for patch releases on maintained stable lines.

## The "Namer"

We usually let the leader of `git shortlog -s -n --no-merges <LAST_VERSION>..HEAD` name the release.

Tag this person on the new version PR and ask them to propose a codename.

## The Changelog Format

In the past, we've used [Greg's tool](https://github.com/MSP-Greg/issue-pr-link) to generate it, but anything that follows the existing format is fine.

## Updating Puma test cert files

One must have openssl and keytool in their Path.  Keytool is part of the JDK.

It maybe helpful to install the ['certificate_authority'](https://github.com/cchandler/certificate_authority) gem.

Then run 'examples/generate_all_certs' from a bash shell.

# Governance

## The Short Version

Evan Phoenix ([@evanphx](https://github.com/evanphx)) created Puma and has final say on everything. [Maintainers](./MAINTAINERS) serve at his pleasure.

## Access Levels

We have two levels of access and privileges:

### Gem Release Access

This is kept intentionally small for security reasons. If you can cut a gem release, you can push code to a lot of production systems, so we're intentionally quite narrow here.

**Current members:** Evan Phoenix ([@evanphx](https://github.com/evanphx)), Nate Berkopec ([@nateberkopec](https://github.com/nateberkopec)), and Richard Schneeman ([@schneems](https://github.com/schneems)).

We cut releases ~whenever we feel like it.

We may add or remove people from this group if releases start getting bottlenecked, but security is the priority.

### Commit Bit ("Maintainers" or "Core Team")

We give commit bit if you make significant contributions to minor (or major) releases, consistently over time. Show up, do good work, stick around.

We review this access periodically, but we're looser with it than gem release access.

If you have commit bit, we trust you enough to merge to `main` without necessarily getting review first.

While all [security reports go to Evan directly](./SECURITY.md), maintainers will collaborate together on the fix.

**Current members:** Everyone on the [Maintainers](./MAINTAINERS) list.

## How Decisions Get Made

Evan has final say on who gets these rights. Maintainers make suggestions and talk things through, but ultimately it's his call.

In general, Puma maintainership works on the principle of [lazy consensus](https://openoffice.apache.org/docs/governance/lazyConsensus.html).

We try to mostly work in public, so that more people outside the maintainer team can contribute and help out.

If you have questions or want to suggest changes to how we run things, open an issue.

# Welcome to Puma 8.0: Into the Arena.

Puma 8 brings IPv6 by default, increased control over the threadpool, and more.

Here's what you should do:

1. Review the Upgrade section below to look for breaking changes that could affect you.
2. Upgrade to version 8.0 in your Gemfile and deploy.
3. Open up a new bug issue if you find any problems.
4. Join us in building Puma! We welcome first-timers. See [CONTRIBUTING.md](./CONTRIBUTING.md).

For a complete list of changes, see [History.md](./History.md).

## What's New

### Smarter concurrency controls

**IO-bound requests can now go past your normal thread ceiling.** Puma 8 adds `max_io_threads` and injects `env["puma.mark_as_io_bound"]` into the Rack env so your app or middleware can tell Puma when a request has become mostly I/O wait. That helps mixed workloads a lot: slow API calls, report generation, and similar wait-heavy requests no longer need to crowd out CPU-bound work as aggressively. This landed in [#3816](https://github.com/puma/puma/pull/3816) and was refined in [#3894](https://github.com/puma/puma/pull/3894).

```ruby
# config/puma.rb
threads 0, 5
max_io_threads 5
```

```ruby
# config.ru
run lambda { |env|
  env['puma.mark_as_io_bound'].call
  report = SlowReportService.fetch

  [200, { 'content-type' => 'application/json' }, [report]]
}
```

We anticipate this will mainly by used by framework authors who have threads or types of requests they know are extremely IO-bound, and don't recommend it for use at the application level.

**Thread pool limits can be changed at runtime.** Puma now exposes `Puma::Server#update_thread_pool_min_max`, and hook/plugin code can do the same through `Puma::ServerPluginControl`.

```ruby
# from a plugin or other trusted in-process integration
server.update_thread_pool_min_max(min: 2, max: 12)
```

If you already use `before_thread_start`, note that hook behavior changed in this release; see the Upgrade section below.

### Cleaner config for single and cluster mode

**New `single` and `cluster` blocks let one config file express both modes cleanly.** These blocks run after config files are loaded, so you can keep the mode-specific settings in one obvious place instead of scattering `if` logic through `config/puma.rb`. This makes shared configs much easier to read and reuse across development, review apps, and production. See [#3621](https://github.com/puma/puma/pull/3621).

```ruby
workers ENV.fetch('WEB_CONCURRENCY', 0)

single do
  silence_fork_callback_warning
end

# Only runs if workers > 0
cluster do
  preload_app!
  before_worker_boot do
    # Do a thing
  end
end
```

### Better debugging and operations

**`shutdown_debug` can now be limited to forced shutdowns.** If you want thread backtraces only when a graceful shutdown turns into a forced one, use `shutdown_debug on_force: true`. That keeps normal deploy logs quieter while still giving you the "what is hanging?" escape hatch when you need it. See [#3671](https://github.com/puma/puma/pull/3671).

```ruby
shutdown_debug on_force: true
force_shutdown_after 30
```

**Thread backtrace via signal works on more platforms.** On systems without `SIGINFO`, Puma now uses `SIGPWR` for thread backtrace dumps. See [#3829](https://github.com/puma/puma/pull/3829).

**Phased restart is safer with `fork_worker`.** Puma no longer reforks from a stale worker 0 during phased restarts in `fork_worker` mode. There is nothing new to configure, but if you have tooling that watches worker order, check the Upgrade section because the rollout sequence changed. See [#3853](https://github.com/puma/puma/pull/3853).

### Networking and performance

**Puma now prefers IPv6 wildcard binds when the host supports them.** When Puma detects a non-loopback IPv6 interface, the default TCP host becomes `::` and the default bind becomes `tcp://[::]:PORT`. That lines Puma up better with modern dual-stack hosts, while still falling back to IPv4 when IPv6 is unavailable. See [#3847](https://github.com/puma/puma/pull/3847). If you need IPv4-only behavior, pin the bind explicitly.

```ruby
bind 'tcp://0.0.0.0:9292'
```

**There are also a couple of hot-path performance wins.** JRuby gets a faster HTTP parser with fewer copies and cheaper lookups, and Puma now avoids redundant header key downcasing when building responses. See [#3838](https://github.com/puma/puma/pull/3838) and [#3874](https://github.com/puma/puma/pull/3874).

## Upgrade

Check the following list to see if you're depending on any of these behaviors:

1. Puma will now listen on `::` (IPv6) by default. Previously, it listened to `0.0.0.0` (IPv4). Systems that support both IPv6 and IPv4 (Ubuntu and Mac commonly do) will still support receiving to `0.0.0.0`. See [[the support table in the PR](https://github.com/puma/puma/pull/3847)](https://github.com/puma/puma/pull/3847) for a binding compatibility. For systems that ONLY bind to IPv6 (without IPv4 support) this may be a breaking change. You can overwrite this default behavior by setting `bind 'tcp://0.0.0.0:9292'`, `port ENV.fetch('PORT', 9292), '0.0.0.0'`, or `set_default_host '0.0.0.0'` explicitly to remain IPv4 only. Review any firewall rules, health checks, deploy scripts, or host-string parsing code that assumed `0.0.0.0`, `127.0.0.1`, or unbracketed `HOST:PORT` formatting.
2. If you explicitly configure `bind 'tcp://[::]:...'`, `bind 'ssl://[::]:...'`, or equivalent `ssl_bind '::', ...`, Puma will now rewrite that unspecified IPv6 bind to `0.0.0.0` when the host has no non-loopback IPv6 interface, and it will warn on boot. If you were using `::` to force IPv6-only behavior or to detect IPv6 availability, switch to a concrete IPv6 address instead of `::`, or ensure the machine actually has a usable IPv6 interface before Puma starts.
3. `before_thread_start` hooks now receive a `Puma::ServerPluginControl` argument. Update any zero-arity lambdas, method objects, or other strict-arity hook code to accept one argument, for example `before_thread_start { |_control| ... }`, or Puma can raise `ArgumentError` when the hook runs.
4. On platforms without `SIGINFO`, Puma now traps `SIGPWR`, and `pumactl info` sends `SIGPWR` there. If your supervisor, init script, or container tooling already uses `SIGPWR` for something else, change that wiring before upgrading and update any runbooks that assumed Puma would ignore `SIGPWR`.
5. Requests rejected by `supported_http_methods` are now treated as parser/client errors earlier in request processing. If you use `supported_http_methods`, re-test unsupported-method requests and do not depend on the old 501 timing, connection handling, or `lowlevel_error_handler` behavior; if your error handler still sees these requests, make sure it tolerates a less-normalized Rack `env`.
6. `http_content_length_limit` enforcement is stricter now. A `413` on an HTTP/1.1 keep-alive request now forces `connection: close`, and chunked request bodies are rejected as soon as they cross the limit during parsing. Update clients, proxies, and tests not to reuse the socket after a `413`, and re-test any upload flows or custom error handling that depended on Puma's previous oversized-body behavior.
7. If you use `fork_worker`, phased restart order changed. During `USR1` or `pumactl phased-restart`, worker `0` is now reinserted and restarted/reforked first after replacement. Update deployment scripts, canary logic, or monitoring that assumed the old worker sequence or keyed rollout steps off worker index order.

\name{clusterApplyLBDots}
\alias{clusterApplyLBDots}
\title{clusterApplyLB with dots to indicate progress}
\description{
This is basically the \code{\link[snow:snow-cluster]{clusterApplyLB}}
function from the \pkg{snow} package, but with dots displayed to
indicate progress. 
}
\usage{
clusterApplyLBDots(cl, x, fun, ...)
}
\arguments{
	\item{cl}{ cluster object }
	\item{x}{ array }
	\item{fun}{ function or character string naming a function }
	\item{\dots}{ additional arguments to pass to standard function }
}
\author{ Richard D. Pearson (modified from original \pkg{snow} function)}
\keyword{manip}

\name{exampleE}
\alias{exampleE}
\docType{data}
\title{ The example data of the mean gene expression levels}
\description{
  This data is an artificial example of the mean gene expression levels from 
  golden spike-in data set in Choe et al. (2005).
}
\usage{data(exampleE)}
\format{
  A 200x6 matrix including 200 genes and 6 chips. The first 3 chips are replicates for 
  C condition and the last 3 chips are replicates for S conditon.
}
\source{
  Choe,S.E., Boutros,M., Michelson,A.M., Church,G.M., Halfon,M.S.: 
  Preferred analysis methods for Affymetrix GeneChips revealed by a wholly defined control dataset. 
  Genome Biology, 6 (2005) R16.
}
\seealso{\code{\link{exampleStd}}}
\keyword{datasets}

\name{pumaPCARes-class}
\docType{class}
\alias{class:pumaPCARes}
\alias{pumaPCARes}
\alias{pumaPCARes-class}
\alias{write.reslts,pumaPCARes-method}

\title{Class pumaPCARes}
\description{
This is a class representation for storing the outputs of the pumaPCA function. Objects of this class should usually only be created through the \code{\link{pumaPCA}} function.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("pumaPCARes", ...)}.
}
\section{Slots}{
	\describe{
		\item{\code{model}:}{Object of class "pumaPCAModel" representing the model parameters}
		\item{\code{expectations}:}{Object of class "pumaPCAExpectations" representing the model expectations}
		\item{\code{varY}:}{Object of class "matrix" representing the variance in the expression levels}
		\item{\code{Y}:}{Object of class "matrix" representing the expression levels}
		\item{\code{phenoData}:}{Object of class "AnnotatedDataFrame" representing the phenotype information}
		\item{\code{timeToCompute}:}{Object of class "numeric" representing the time it took \code{\link{pumaPCA}} to run}
		\item{\code{numberOfIterations}:}{Object of class "numeric" representing the number of iterations it took \code{\link{pumaPCA}} to converge}
		\item{\code{likelihoodHistory}:}{Object of class "list" representing the history of likelihood values while \code{\link{pumaPCA}} was running}
		\item{\code{timingHistory}:}{Object of class "list" representing the history of how long each iteration took while \code{\link{pumaPCA}} was running}
		\item{\code{modelHistory}:}{Object of class "list" representing the history of how the model was changing while \code{\link{pumaPCA}} was running}
		\item{\code{exitReason}:}{Object of class "character" representing the reason \code{\link{pumaPCA}} halted. Can take the values "Update of Likelihood less than tolerance x", "Update of W less than tolerance x", "Iterations exceeded", "User interrupt", "unknown exit reason"}
	}
}
\section{Methods}{
	\describe{
		\item{plot}{\code{signature(x="pumaPCARes-class")}: plots two principal components on a scatter plot.}
		\item{write.reslts}{\code{signature(x = "pumaPCARes-class")}: writes the principal components for each array to a file. It takes the same arguments as \code{\link{write.table}}. The argument "file" does not need to set any extension. The file name and extension "csv" will be added automatically. The default file name is "tmp". }
	}
}
\author{ Richard D. Pearson }

\seealso{
Related method \code{\link{pumaPCA}} and related class \code{\link{pumaPCARes}}.
}
\keyword{classes}

\name{Clustii.exampleStd}
\alias{Clustii.exampleStd}
\docType{data}
\title{ The example data of the standard deviation for gene expression levels }
\description{
  This data is an artificial example of the standard deviation for gene exapression levels generated 
  by package \code{\link[puma]{mmgmos}}.
}
\usage{data(Clustii.exampleStd)}
\format{
  A 600x80 matrix including 600 genes and 20 conditions. Each condition has 4 replicates. Every 100 genes belong to one cluster from the first gene. 
  There are 6 clusters.
}
\source{
Liu,X. and Rattray,M. (2009) 
Including probe-level measurement error in robust mixture clustering of replicated microarray gene expression, 
technical report available upon request.
}
\seealso{\code{\link[puma]{Clustii.exampleE}}}
\keyword{datasets}

\name{pumaPCAModel-class}
\docType{class}
\alias{pumaPCAModel-class}
\alias{pumaPCAModel}

\title{Class pumaPCAModel}
\description{
This is a class representation for storing a pumaPCA model. It is an internal representation and shouldn't normally be instantiated.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("pumaPCAModel", ...)}.
}
\section{Slots}{
	\describe{
		\item{\code{sigma}:}{Object of class "numeric" representing sigma}
		\item{\code{m}:}{Object of class "matrix" representing m}
		\item{\code{Cinv}:}{Object of class "matrix" representing Cinv}
		\item{\code{W}:}{Object of class "matrix" representing W}
		\item{\code{mu}:}{Object of class "matrix" representing mu}
	}
}
\section{Methods}{
This class has no methods defined
}
\author{ Richard D. Pearson }

\seealso{
Related method \code{\link{pumaPCA}} and related class \code{\link{pumaPCARes}}.
}
\keyword{classes}

\name{matrixDistance}
\alias{matrixDistance}
\title{Calculate distance between two matrices}
\description{
This calculates the mean Euclidean distance between the rows of two matrices. It is used in the function \code{\link{pumaPCA}}
}
\usage{
matrixDistance(
    matrixA
,   matrixB
)
}
\arguments{
	\item{matrixA}{ the first matrix }
	\item{matrixB}{ the second matrix }
}
\value{
	A numeric giving the mean distance
}
\author{ Richard D. Pearson }
\seealso{Related class \code{\link{pumaPCA}}}
\examples{
if(FALSE){
	show(matrixDistance(matrix(1,2,2),matrix(2,2,2)))
}
}
\keyword{manip}

\name{pumaDEUnsorted}
\alias{pumaDEUnsorted}
\title{Return an unsorted matrix of PPLR values}
\description{
Returns the output from \code{\link{pumaDE}} as an unsorted matrix (i.e. sorted according to the original sorting in the ExpressionSet)
}
\usage{
pumaDEUnsorted(pp)
}
\arguments{
	\item{pp}{ A list as output by \code{\link{pumaDE}}. }
}
\value{
  A matrix of PPLR values
}
\author{ Richard D. Pearson }
\seealso{Related method \code{\link{pumaDE}}}
\keyword{manip}

\name{pumaPCA}
\alias{pumaPCA}
\alias{pumaPCAEstep}
\alias{pumaPCALikelihoodBound}
\alias{pumaPCALikelihoodCheck}
\alias{pumaPCANewtonUpdateLogSigma}
\alias{newtonStep}
\alias{pumaPCARemoveRedundancy}
\alias{pumaPCASigmaGradient}
\alias{pumaPCASigmaObjective}
\alias{pumaPCAUpdateCinv}
\alias{pumaPCAUpdateM}
\alias{pumaPCAUpdateMu}
\alias{pumaPCAUpdateW}
\title{PUMA Principal Components Analysis}
\description{
This function carries out principal components analysis (PCA), taking into
account not only the expression levels of genes, but also the variability
in these expression levels.

The various other pumaPCA... functions are called during the execution of pumaPCA
}
\usage{
pumaPCA(
    eset
,   latentDim           = 	if(dim(exprs(eset))[2] <= 3)
 								dim(exprs(eset))[[2]]-1
							else
								3
,   sampleSize          =	if(dim(exprs(eset))[1] <= 1000)
								 dim(exprs(eset))[[1]]
							else
								1000	## Set to integer or FALSE for all
,   initPCA             =	TRUE	## Initialise parameters with PCA
,   randomOrder         =	FALSE	## Update parameters in random order
,   optimMethod         =	"BFGS"  ## ?optim for details of methods
,   stoppingCriterion   =	"deltaW"## can also be "deltaL"
,   tol                 =	1e-3	## Stop when delta update < this
,   stepChecks          =	FALSE	## Check likelihood after each update?
,   iterationNumbers    =	TRUE	## Show iteration numbers?
,   showUpdates         =	FALSE	## Show values after each update?
,   showTimings         =	FALSE	## Show timings after each update?
,   showPlot            =	FALSE	## Show projection plot after each update?
,   maxIters            =	500		## Number of EM iterations.
,   transposeData       =	FALSE	## Transpose eset matrices?
,   returnExpectations  =	FALSE
,   returnData          =	FALSE
,   returnFeedback      =	FALSE
,	pumaNormalize		=	TRUE
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
	\item{latentDim}{ An integer specifying the number of latent dimensions (kind of like the number of principal components). }
	\item{sampleSize}{ An integer specifying the number of probesets to sample (default is 1000), or FALSE, meaning use all the data. }
	\item{initPCA}{ A boolean indicating whether to initialise using standard PCA (the default, and generally quicker and recommended).  }
	\item{randomOrder}{ A boolean indicating whether the parameters should be updated in a random order (this is generally not recommended, and the default is FALSE). }
	\item{optimMethod}{ See ?optim for details of methods. }
	\item{stoppingCriterion}{ If set to "deltaW" will stop when W changes by less than \code{tol}. If "deltaL" will stop when L (lambda) changes by less than \code{tol}. }
	\item{tol}{ Tolerance value for \code{stoppingCriterion}. }
	\item{stepChecks}{ Boolean. Check likelihood after each update? }
	\item{iterationNumbers}{ Boolean. Show iteration numbers? }
	\item{showUpdates}{ Boolean. Show values after each update? }
	\item{showTimings}{ Boolean. Show timings after each update? }
	\item{showPlot}{ Boolean. Show projection plot after each update? }
	\item{maxIters}{ Integer. Maximum number of EM iterations. }
	\item{transposeData}{ Boolean. Transpose eset matrices? }
	\item{returnExpectations}{ Boolean. Return expectation values? }
	\item{returnData}{ Boolean. Return expectation data? }
	\item{returnFeedback}{ Boolean. Return feedback on progress of optimisation? }
	\item{pumaNormalize}{ Boolean. Normalise data prior to running algorithm (recommended)? }
}
\value{
  An object of class \code{\link{pumaPCARes}}
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{pumaDE}}, \code{\link{createDesignMatrix}} and \code{\link{createContrastMatrix}}}
\examples{
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)

	pumapca_mmgmos <- pumaPCA(eset_mmgmos)
	plot(pumapca_mmgmos)
}
\keyword{multivariate}

\name{igmoExon}
\alias{igmoExon}
\title{ Separately Compute gene and transcript expression values and standard deviatons from exon CEL Files by the conditions.}
\description{
    The principle of this function is as same as the function gmoExon.This function separately calculates gene expression values by the conditions and 
    then combined every condition's results, and normalises them finally.                            
}
\usage{
igmoExon(
      cel.path
     ,SampleNameTable
     ,exontype = c("Human", "Mouse", "Rat")
     ,background=FALSE
     ,gsnorm=c("median", "none", "mean", "meanlog")     
     ,savepar=FALSE
     ,eps=1.0e-6
     ,addConstant = 0
     ,condition=c("Yes","No")
     ,cl=NULL
     ,BatchFold=10
)	
}
\arguments{
	\item{cel.path}{The directory where you put the CEL files.}
          \item{SampleNameTable}{It is a tab-separated  table with two columns,ordered by "Celnames","Condition"}
	\item{exontype}{character. specifying the type of exon chip.}
          \item{background}{Logical value. If \code{TRUE}, perform background correction before applying gmoExon.}
	\item{savepar}{Logical value. If \code{TRUE} the estimated parameters of the model are saved in file par\_gmoExon.txt }
	\item{eps}{Optimisation termination criteria.}
          \item{addConstant}{numeric. This is an experimental feature and should not generally be changed from the default value. }
          \item{gsnorm}{character. specifying the algorithm of global scaling normalisation.}
          \item{condition}{ Yes or No. ``Yes'' means  the \code{\link{igmoExon}} function separately calculates gene expression values by the conditions and then combined every condition's results, and normalises them finally. ``No'' means the \code{\link{igmoExon}} calulates the gene expression values as same as the \code{\link{gmoExon}} function.}
      \item{cl}{This function can be parallelised by setting parameter cl. For more details, please refer to the vignette.}
        \item{BatchFold}{ we divide tasks into BatchFold*n jobs where n is the number of cluster nodes. The first n jobs are placed on the n nodes. When the first job is completed,the next job is placed on the available node. This continues until all jobs are completed. The default value is ten. The user also can change the value according to the number of cluster nodes n. We suggest that for bigger n BatchFold should be smaller.}
}
\details{
  The obtained expression measures are in log base 2 scale.
  Using the known relationships between genes, transcripts and probes,
  we propose a gamma model for exon array data to calculate transcript and gene expression levels.
  The algorithms of global scaling normalisation can be one of "median", "none", "mean", "meanlog".
  "mean" and "meanlog" are mean-centered normalisation on raw scale and log scale respectively, and "median" 
  is median-centered normalisation. "none" will result in no global scaling normalisation being applied.
 
  }
\value{
  A list of two object of class \code{exprReslt}.
}
\references{Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2005) A tractable probabilistic model for 
Affymetrix probe-level analysis across multiple chips, Bioinformatics, 21:3637-3644.

Milo,M., Niranjan,M., Holley,M.C., Rattray,M. and Lawrence,N.D. (2004) A probabilistic approach for summarising 
oligonucleotide gene expression data, technical report available upon request.

Milo,M., Fazeli,A., Niranjan,M. and Lawrence,N.D. (2003) A probabilistic model for the extractioin of expression
 levels from oligonucleotide arrays, Biochemical Society Transactions, 31: 1510-1512.

Peter Spellucci. DONLP2 code and accompanying documentation. Electronically available via 
http://plato.la.asu.edu/donlp2.html

Risueno A, Fontanillo C, Dinger ME, De Las Rivas J. GATExplorer: genomic and transcriptomic explorer; mapping expression
probes to gene loci, transcripts, exons and ncRNAs. BMC Bioinformatics.2010.}

\author{Xuejun Liu, Zhenzhu gao, Magnus Rattray, Marta Milo, Neil D. Lawrence}

\seealso{ Related class \code{\link{exprReslt-class}} }

\examples{
if(FALSE){
## The following scripts show the use of the method.
## load CEL files
# cel.path<-cel.path;
# SampleNameTable<-"SampleNameTable"
#eset_igmoExon<-igmoExon(cel.path="cel.path"
                   # , SampleNameTable="SampleNameTable"
                   # , exontype="Human"
                   # , gsnorm="none", condition="Yes",cl=cl)
}
}
\keyword{manip}

\name{pumaClustii}
\alias{pumaClustii}
\title{Propagate probe-level uncertainty in robust t mixture clustering on replicated gene expression data}
\description{
  This function clusters gene expression by including uncertainties of gene expression measurements from probe-level analysis models and 
replicate information into a robust t mixture clustering model. The inputs are gene expression levels and the probe-level standard
  deviation associated with expression measurement for each gene on each chip. The outputs 
  is the clustering results.
}
\usage{
pumaClustii(e=NULL, se=NULL, efile=NULL, sefile=NULL, 
      subset=NULL, gsnorm=FALSE, mincls, maxcls, conds, reps, verbose=FALSE,
      eps=1.0e-5, del0=0.01)
}
\arguments{
  \item{e}{ data frame containing the expression level for each gene on each chip. }
  \item{se}{ data frame containing the standard deviation of gene expression levels. }
  \item{efile}{ character, the name of the file which contains gene expression measurements. }
  \item{sefile}{ character, the name of the file which contains the standard deviation of gene expression measurements. }
  \item{subset}{ vector specifying the row number of genes which are clustered on.}
  \item{gsnorm}{ logical specifying whether do global scaling normalisation or not. }
  \item{mincls}{integer, the minimum number of clusters. }
  \item{maxcls}{ integer, the maximum number of clusters. }
  \item{conds}{ integer, the number of conditions. }
  \item{reps}{ vector, specifying which condition each column of the input data matrix belongs to. }
  \item{verbose}{ logical value. If 'TRUE' messages about the progress of the function is printed. }
  \item{eps}{ numeric, optimisation parameter. }
  \item{del0}{ numeric, optimisation parameter. }
}
\details{
  The input data is specified either by e and se, or by efile and sefile.
 
}
\value{
  The result is a list with components
  
  cluster: vector, containing the membership of clusters for each gene;
  centers: matrix, the center of each cluster;
  centersigs: matrix, the center variance of each cluster;
  likelipergene: matrix, the likelihood of belonging to each cluster for each gene;
  optK: numeric, the optimal number of clusters.
  optF: numeric, the maximised value of target function.
  
}
\references{
Liu,X. and Rattray,M. (2009) 
Including probe-level measurement error in robust mixture clustering of replicated microarray gene expression, 
Statistical Application in Genetics and Molecular Biology, 9(1), Article 42.

Liu,X., Lin,K.K., Andersen,B., and Rattray,M. (2007) 
Propagating probe-level uncertainty in model-based gene expression clustering, 
BMC Bioinformatics, 8:98.

Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2005) A tractable probabilistic model for 
Affymetrix probe-level analysis across multiple chips, Bioinformatics, 21(18):3637-3644.
}
\author{ Xuejun Liu }
\seealso{ Related method \code{\link[puma]{mmgmos}} and \code{\link[puma]{pumaclust}}}
\examples{
  data(Clustii.exampleE)
  data(Clustii.exampleStd)
  r<-vector(mode="integer",0)
  for (i in c(1:20))
    for (j in c(1:4))
      r<-c(r,i)
  cl<-pumaClustii(Clustii.exampleE,Clustii.exampleStd,mincls=6,maxcls=6,conds=20,reps=r,eps=1e-3)
}
\keyword{ manip }
\keyword{ models }

\name{normalisation.gs}
\alias{normalisation.gs}
\title{ Global scaling normalisation }
\description{
This function is only included for backwards compatibility with the \pkg{pplr} package. This function is now superceded by \code{\link{pumaNormalize}}.

This function does the global scaling normalisation.
}
\usage{
normalisation.gs(x)
}
\arguments{
  \item{x}{ a matrix or data frame which contains gene expression level on log2 scale. }
}
\details{
  Each row of x is related to a gene and each column is related to a chip.
}
\value{
  The return matrix is in the same format as the input x.
}
\author{ Xuejun Liu, Marta Milo, Neil D. Lawrence, Magnus Rattray }
\seealso{ See Also as \code{\link{bcomb}} and \code{\link{hcomb}} }
\examples{
if(FALSE){
data(exampleE)
exampleE.normalised<-normalisation.gs(exampleE)
data(Clust.exampleE)
Clust.exampleE.normalised<-normalisation.gs(Clust.exampleE)
}
}
\keyword{ manip }

\name{calcAUC}
\alias{calcAUC}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate Area Under Curve (AUC) for a standard ROC plot. }
\description{
	Calculates the AUC values for one or more ROC plots.
}
\usage{
calcAUC(scores, truthValues, includedProbesets = 1:length(truthValues))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{scores}{ A vector of scores. This could be, e.g. one of the columns of the statistics of a \code{\link{DEResult}} object. }
  \item{truthValues}{ A boolean vector indicating which scores are True Positives. }
  \item{includedProbesets}{ A vector of indices indicating which scores (and truthValues) are to be used in the calculation. The default is to use all, but a subset can be used if, for example, you only want a subset of the probesets which are not True Positives to be treated as False Positives. }
}
\value{
  A single number which is the AUC value.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{plotROC}} and \code{\link{numFP}}.}
\examples{
#class1a <- rnorm(1000,0.2,0.1)
#class2a <- rnorm(1000,0.6,0.2)
#class1b <- rnorm(1000,0.3,0.1)
#class2b <- rnorm(1000,0.5,0.2)
#scores_a <- c(class1a, class2a)
#scores_b <- c(class1b, class2b)
#classElts <- c(rep(FALSE,1000), rep(TRUE,1000))
#print(calcAUC(scores_a, classElts))
#print(calcAUC(scores_b, classElts))

}
\keyword{manip}

\name{numOfFactorsToUse}
\alias{numOfFactorsToUse}
\title{Determine number of factors to use from an ExpressionSet}
\description{
This is really an internal function used to determine how many factors to use in design and contrast matrices}
\usage{
numOfFactorsToUse(eset)
}
\arguments{
	\item{eset}{ An object of class
	  \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. } 
}
\value{
  An integer denoting the number of factors to be used.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{createDesignMatrix}} and  \code{\link{createContrastMatrix}}}
\examples{
if(FALSE){
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)
	numOfFactorsToUse(eset_mmgmos)
}
}
\keyword{manip}

\name{pumaCombImproved}
\alias{pumaCombImproved}
\title{Combining replicates for each condition with the true gene expression  }
\description{
This function calculates the combined (from replicates) signal for each condition using Bayesian models, which are added a hidden variable to represent the true expression for each gene on each chips. The inputs are gene expression levels and the probe-level standard deviations associated with expression measurements for each gene on each chip. The outputs include gene expression levels and standard deviation for each condition.
}
\usage{
pumaCombImproved(
	eset
,	design.matrix=NULL
,	numOfChunks=1000
,       maxOfIterations=200
,	save_r=FALSE
,	cl=NULL
,	parallelCompute=FALSE
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
	\item{design.matrix}{ A design matrix. }
	\item{numOfChunks}{ An integer defining how many chunks the data is divided into before processing. There is generally no need to change the default value. }
	\item{maxOfIterations}{ The maximum number of iterations controls the convergence. }
	\item{save_r}{ Will save an internal variable \code{r} to a file. Used for debugging purposes. }
\item{cl}{ A "cluster" object. See
	\code{\link[snow:snow-startstop]{makeCluster}} function from
	\pkg{snow} package for more details (if available).} 
	\item{parallelCompute}{ Boolean identifying whether processing in parallel should occur. }
}
\details{
It is generally recommended that data is normalised prior to using this function. Note that the default behaviour of mmgmos is to normalise data so this shouldn't generally be an issue. See the function \code{\link{pumaNormalize}} for more details on normalisation.

The maxOfIterations is used to control the maximum number of the iterations in the EM algorithm. You can change the number of maxOfIterations, but the best value of the maxOfIterations is from 200 to 1000, and should be set 200 at least. The default value is 200. 
}
\value{
  The result is an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object.
}
\references{Gelman,A., Carlin,J.B., Stern,H.S., Rubin,D.B., Bayesian data analysis. London: Chapman & Hall; 1995.

Zhang,L. and Liu,X. (2009) An improved probabilistic model for finding differential gene expression, technical report available request.
the 2nd BMEI 17-19 oct. 2009. Tianjin. China.

Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2006)  Probe-level variances improve accuracy in detecting differential
gene expression, Bioinformatics, 22(17):2107-13.}
\author{ Li Zhang, Xuejun Liu }
\seealso{Related methods \code{\link{pumaNormalize}}, \code{\link{hcomb}}, \code{\link{mmgmos}} and \code{\link{pumaDE}}}
\examples{
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)

	#	Next line shows that eset_mmgmos has 4 arrays, each of which is a different
	#   condition (the experimental design is a 2x2 factorial, with both liver and
	#	scanner factors)
	pData(eset_mmgmos)
	
	#	Next line shows expression levels of first 3 probe sets
	exprs(eset_mmgmos)[1:3,]

	#	Next line used so eset_mmgmos only has information about the liver factor
	#	The scanner factor will thus be ignored, and the two arrays of each level
	#	of the liver factor will be treated as replicates
	pData(eset_mmgmos) <- pData(eset_mmgmos)[,1,drop=FALSE]

	#	To save time we'll just use 100 probe sets for the example
	eset_mmgmos_100 <- eset_mmgmos[1:100,]
	eset_combimproved <- pumaCombImproved(eset_mmgmos_100)
	
	#	We can see that the resulting ExpressionSet object has just two conditions
	#	and 1 expression level for each condition
	pData(eset_combimproved)
	exprs(eset_combimproved)[1:3,]
}
\keyword{ manip }
\keyword{ models }

\name{eset_mmgmos}
\alias{eset_mmgmos}
\docType{data}
\title{ An example ExpressionSet created from the Dilution data with mmgmos}
\description{
  This data is created by applying mmgmos to the Dilution AffyBatch object
  from the affydata package.
}
\usage{data(eset_mmgmos)}
\format{
  An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}.
}
\source{
  see \code{\link[affydata:Dilution]{Dilution}}
}
\keyword{datasets}

\name{hcomb}
\alias{hcomb}
\title{Combining replicates for each condition with the true gene expression }
\description{
 This function calculates the combined (from replicates) signal for each condition using Bayesian models, which are added a hidden variable to represent the true expression for each gene on each chips. The inputs are gene expression levels and the probe-level standard deviations associated with expression measurements for each gene on each chip. The outputs include gene expression levels and standard deviation for each condition.
}
\usage{
hcomb(e, se, replicates, max_num=c(200,500,1000),gsnorm=FALSE, eps=1.0e-6)
}
\arguments{
  \item{e}{ a data frame containing the expression level for each gene on each chip. }
  \item{se}{ a data frame containing the standard deviation of gene expression levels. }
  \item{replicates}{ a vector indicating which chip belongs to which condition. }  
  \item{max_num}{integer. The maximum number of iterations controls the convergence.  }
  \item{gsnorm}{ logical specifying whether do global scaling normalisation or not. }
  \item{eps}{ a numeric, optimisation parameter. }
}
\details{
  Each element in replicate represents the condition of the chip which is in the same column order as 
  in the expression and standard deviation matrix files.
  
  The max\_num is used to control the maximum number of the iterations in the EM algorithm. 
  The best value of the max\_num is from 200 to 1000, 
  and should be set 200 at least. The default value is 200.
   
  }
\value{
  The result is a data frame with components named 'M1', 'M2', and so on, which represent the 
  mean expression values for condition 1, condition 2, and so on. It also has components named 
  'Std1', 'Std2', and so on, which represent the standard deviation of the gene expression values 
  for condition 1, condtion 2, and so on.
}
\references{Gelman,A., Carlin,J.B., Stern,H.S., Rubin,D.B., Bayesian data analysis. London: Chapman & Hall; 1995.

Zhang,L. and Liu,X. (2009) An improved probabilistic model for finding differential gene expression, technical report available request.

Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2006)  Probe-level variances improve accuracy in detecting differential
gene expression, Bioinformatics, 22(17):2107-13.
}
\author{ Li Zhang, Xuejun Liu }
\seealso{ Related method  \code{\link{pumaCombImproved}}, \code{\link{mmgmos}} and \code{\link{pplr}}}
\examples{
if(FALSE){
  data(exampleE)
  data(exampleStd)
  r<-hcomb(exampleE,exampleStd,replicates=c(1,1,1,2,2,2))
}
}
\keyword{ manip }
\keyword{ models }

\name{numFP}
\alias{numFP}
\title{ Number of False Positives for a given proportion of True Positives. }
\description{
  Often when evaluating a differential expression method, we are interested in how well a classifier performs for very small numbers of false positives. This method gives one way of calculating this, by determining the number of false positives for a set proportion of true positives.
}
\usage{
numFP(scores, truthValues, TPRate = 0.5)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{scores}{ A vector of scores. This could be, e.g. one of the columns of the statistics of a \code{\link{DEResult}} object. }
  \item{truthValues}{ A boolean vector indicating which scores are True Positives. }
  \item{TPRate}{ A number between 0 and 1 identify the proportion of true positives for which we wish to determine the number of false positives. }
}
\value{
  An integer giving the number of false positives.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{plotROC}} and \code{\link{calcAUC}}.}
\examples{
if(FALSE){
class1a <- rnorm(1000,0.2,0.1)
class2a <- rnorm(1000,0.6,0.2)
class1b <- rnorm(1000,0.3,0.1)
class2b <- rnorm(1000,0.5,0.2)
scores_a <- c(class1a, class2a)
scores_b <- c(class1b, class2b)
classElts <- c(rep(FALSE,1000), rep(TRUE,1000))
print(numFP(scores_a, classElts))
print(numFP(scores_b, classElts))
}
}
\keyword{manip}

\name{compareLimmapumaDE}
\alias{compareLimmapumaDE}
\title{Compare pumaDE with a default Limma model}
\description{
This function compares the identification of differentially expressed (DE) genes using the \code{\link{pumaDE}} function and the \pkg{limma} package.
}
\usage{
compareLimmapumaDE(
	eset_mmgmos
,	eset_comb = NULL
,	eset_other = eset_mmgmos
,	limmaRes = calculateLimma(eset_other)
,	pumaDERes = pumaDE(eset_comb)
,	contrastMatrix = createContrastMatrix(eset_mmgmos)
,	numberToCompareForContrasts = 3
,	numberToCompareForVenn = 100
,	plotContrasts = TRUE
,	contrastsFilename = NULL
,	plotOther = FALSE
,	otherFilename = "other"
,	plotBcombContrasts = FALSE
,	bcombContrastsFilename = "bcomb_contrasts"
,	plotVenn = FALSE
,	vennFilename = "venn.pdf"
,	showTopMatches = FALSE
,	returnResults = FALSE
)
}
\arguments{
	\item{eset_mmgmos}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}, that includes both expression levels as well as standard errors of the expression levels. This will often have been created using \code{\link{mmgmos}}, but might also have been created by \code{\link{mgmos}}, or any other method capable of providing standard errors. }
	\item{eset_comb}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}, includes both expression levels as well as standard errors of the expression levels for each unique condition in an experiment (i.e. created from combining the information from each replicate). This will usually have been created using  \code{\link{pumaComb}}. }
	\item{eset_other}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}, that includes expression levels , and may optionally also include standard errors of the expression levels. This is used for comparison with \code{eset_mmgmos}, and might have been created by any summarisation method, e.g. \code{\link[affy]{rma}}. }
	\item{limmaRes}{ A list with two elements, usually created using the function \code{\link{calculateLimma}}. The first element is a matrix of p-values. Each column represent one contrast. Within each column the p-values are ordered. The second element is a matrix of row numbers, which can be used to map p-values back to probe sets. If not supplied this will be automatically created from \code{eset_other}. }
	\item{pumaDERes}{ A list with two elements, usually created using the function \code{\link{pumaDE}}. The first element is a matrix of PPLR values. Each column represent one contrast. Within each column the PPLR values are ordered. The second element is a matrix of row numbers, which can be used to map PPLR values back to probe sets. If not supplied this will be automatically created from \code{eset_comb}. }
	\item{contrastMatrix}{ A contrast matrix. If not supplied this will be created from \code{eset_mmgmos} }
	\item{numberToCompareForContrasts}{ An integer specifying the number of most differentially expressed probe sets (genes) that will be used in comparison charts. }
	\item{numberToCompareForVenn}{ An integer specifying the number of most differentially expressed probe sets (genes) that will be used for comparison in the Venn  diagram. }
	\item{plotContrasts}{ A boolean specifying whether or not to plot the most differentially expressed probe sets (genes) for each contrast for the \code{eset_mmgmos} \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
	\item{contrastsFilename}{ A character string specifying a file name stem for the PDF files which will be created to hold the contrast plots for the \code{eset_mmgmos} \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. The actually filenames will have the name of the contrast appended to this stem. }
	\item{plotOther}{ A boolean specifying whether or not to plot the most differentially expressed probe sets (genes) for each contrast for the \code{eset_other} \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
	\item{otherFilename}{ A character string specifying a file name stem for the PDF files which will be created to hold the contrast plots for the \code{eset_other} \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. The actually filenames will have the name of the contrast appended to this stem. }
	\item{plotBcombContrasts}{ A boolean specifying whether or not to plot the most differentially expressed probe sets (genes) for each contrast for the \code{eset_comb} \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
	\item{bcombContrastsFilename}{ A character string specifying a file name stem for the PDF files which will be created to hold the contrast plots for the \code{eset_comb} \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. The actually filenames will have the name of the contrast appended to this stem. }
	\item{plotVenn}{ A boolean specifying whether or not to plot a Venn diagram showing the overlap in the most differentially expressed probe sets (genes) as identified from the two different methods being compared. }
	\item{vennFilename}{ A character string specifying the filename for the PDF file which will hold the Venn diagram showing the overlap in the most differentially expressed probe sets (genes) as identified from the two different methods being compared. }
	\item{showTopMatches}{ A boolean specifying whether or not to show the probe sets which are deemed most likely to be differentially expressed. }
	\item{returnResults}{ A boolean specifying whether or not to return a list containing results generated. }
}
\value{
The main outputs from this function are a number of PDF files.

The function only returns results if returnResults=TRUE
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{pumaDE}} and \code{\link{calculateLimma}}}
\keyword{manip}

\name{gmhta}
\alias{gmhta}
\title{ Compute gene and transcript expression values and standard deviatons from hta2.0 CEL Files }
\description{
   This function converts an object of \code{\link[oligoClasses:FeatureSet-class]{FeatureSet}} into an object of class 
  \code{\link{exprReslt}} using the gamma model for hta2.0 chips. 
   This function obtains confidence of measures, standard deviation and 5, 
  25, 50, 75 and 95 percentiles, as well as the estimated expression levels.
}
\usage{
gmhta(
      object
     ,background=FALSE
     ,gsnorm=c("median", "none", "mean", "meanlog")
     ,savepar=FALSE
     ,eps=1.0e-6
     ,addConstant = 0
     ,cl=NULL
     ,BatchFold=10
)	
}
\arguments{
	\item{object}{an object of \code{\link[oligoClasses:FeatureSet-class]{FeatureSet}}}
          \item{background}{Logical value. If \code{TRUE}, perform background correction before applying gmhta.}
          \item{gsnorm}{character. specifying the algorithm of global scaling normalisation.}
	\item{savepar}{Logical value. If \code{TRUE} the estimated parameters of the model are saved in file par\_gmhta.txt }
	\item{eps}{Optimisation termination criteria.}
          \item{addConstant}{numeric. This is an experimental feature and should not generally be changed from the default value. }
          \item{cl}{This function can be parallelised by setting parameter cl. For more details, please refer to the vignette.}
          \item{BatchFold}{ we divide tasks into BatchFold*n jobs where n is the number of cluster nodes. The first n jobs are placed on the n nodes. When the first job is completed,the next job is placed on the available node. This continues until all jobs are completed. The default value is ten. The user also can change the value according to the number of cluster nodes n. We suggest that for bigger n BatchFold should be smaller.}
}
\details{
  The obtained expression measures are in log base 2 scale.
  Using the known relationships between genes, transcripts and probes,
  we propose a gamma model for hta2.0  data to calculate transcript and gene expression levels.
  The algorithms of global scaling normalisation can be one of "median", "none", "mean", "meanlog".
  "mean" and "meanlog" are mean-centered normalisation on raw scale and log scale respectively, and "median" 
  is median-centered normalisation. "none" will result in no global scaling normalisation being applied.
  This function can be parallelised by setting parameter cl. For more details, please refer to the vignette.
 

  }
\value{
  A list of two object of class \code{exprReslt}.
}
\references{XueJun Liu. (2013) puma 3.0: improved uncertainty propagation methods for gene and transcript expression
analysis, BMC Bioinformatics, 14:39.


Manhong Dai, Pinglang Wang,Andrew D. Boyd. (2005) Evolving gene/transcript definitions significantly
alter the interpretation of GeneChip data,Nucleic Acid Research 33(20):e175.
}

\author{Xuejun Liu,WuJun Zhang,Zhenzhu gao, Magnus Rattray}

\seealso{ Related class \code{\link{exprReslt-class}} }

\examples{
if(FALSE){
## The following scripts show the use of the method.
#library(puma)
## load CEL files
# object<-read.celfiles("celnames")
#eset<-gmhta(object,gsnorm="none",cl=cl)

}
}

\keyword{manip}

\name{plotHistTwoClasses}
\alias{plotHistTwoClasses}
\title{Stacked histogram plot of two different classes}
\description{
Stacked histogram plot of two different classes
}
\usage{
plotHistTwoClasses(
	scores
,	class1Elements
,	class2Elements
,	space=0
,	col=c("white", "grey40")
,	xlab="PPLR"
,	ylab="Number of genes"
,	ylim=NULL
,	las=0 # axis labels all perpendicular to axes
,	legend=c("non-spike-in genes", "spike-in genes")
,	inset=0.05
,	minScore=0
,	maxScore=1
,	numOfBars=20
,	main=NULL
)
}
\arguments{
	\item{scores}{ A numeric vector of scores (e.g. from the output of \code{\link{pumaDE}}) }
	\item{class1Elements}{ Boolean vector, TRUE if element is in first class }
	\item{class2Elements}{ Boolean vector, TRUE if element is in second class }
	\item{space}{ Numeric. x-axis distance between bars }
	\item{col}{ Colours for the two different classes }
	\item{xlab}{ Title for the x-axis }
	\item{ylab}{ Title for the y-axis }
	\item{ylim}{ 2-element numeric vector showing minimum and maximum values for y-axis. }
	\item{las}{ See \code{\link[graphics]{par}}. Default of 0 means axis labels all perpendicular to axes. }
	\item{legend}{ 2-element string vector giving text to appear in legend for the two classes. }
	\item{inset}{ See \code{\link[graphics]{legend}} }
	\item{minScore}{ Numeric. Minimum score to plot. }
	\item{maxScore}{ Numeric. Maximum score to plot. }
	\item{numOfBars}{ Integer. Number of bars to plot. }
	\item{main}{ String. Main title for the plot. }
}
\value{
	This function has no return value. The output is the plot created.
}
\author{ Richard D. Pearson }
\examples{
	class1 <- rnorm(1000,0.2,0.1)
	class2 <- rnorm(1000,0.6,0.2)
	class1[which(class1<0)] <- 0
	class1[which(class1>1)] <- 1
	class2[which(class2<0)] <- 0
	class2[which(class2>1)] <- 1
	scores <- c(class1, class2)
	class1elts <- c(rep(TRUE,1000), rep(FALSE,1000))
	class2elts <- c(rep(FALSE,1000), rep(TRUE,1000))
	plotHistTwoClasses(scores, class1elts, class2elts, ylim=c(0,300))
}
\keyword{hplot}

\name{puma-package}
\alias{puma-package}
\alias{puma}
\docType{package}
\title{
	puma - Propagating Uncertainty in Microarray Analysis
}
\description{
Most analyses of Affymetrix GeneChip data (including tranditional 3' arrays and exon arrays) are based on point estimates of expression levels and ignore the uncertainty of such estimates. By propagating uncertainty to downstream analyses we can improve results from microarray analyses. For the first time, the puma package makes a suite of uncertainty propagation methods available to a general audience. In additon to calculte gene expression from Affymetrix 3' arrays, puma also provides methods to process exon arrays and produces gene and isoform expression for alternative splicing study. puma also offers improvements in terms of scope and speed of execution over previously available uncertainty propagation methods. Included are summarisation, differential expression detection, clustering and PCA methods, together with useful plotting functions.
}
\details{
	\tabular{ll}{
		Package: \tab puma\cr
		Type: \tab Package\cr
		Version: \tab 3.4.3\cr
		Date: \tab 2013-11-04\cr
		License: \tab LGPL excluding donlp2\cr
	}
	For details of using the package please refer to the Vignette
}
\author{
	Richard Pearson, Xuejun Liu, Guido Sanguinetti, Marta Milo, Neil D. Lawrence, Magnus Rattray, Li Zhang

	Maintainer: Richard Pearson <richard.pearson@postgrad.manchester.ac.uk>, Li Zhang <leo.zhang@nuaa.edu.cn>
}
\references{
	Milo, M., Niranjan, M., Holley, M. C., Rattray, M. and Lawrence, N. D. (2004) A probabilistic approach for summarising oligonucleotide gene expression data, technical report available upon request.
	
	Liu, X., Milo, M., Lawrence, N. D. and Rattray, M. (2005) A tractable probabilistic model for Affymetrix probe-level analysis across multiple chips, Bioinformatics, 21(18):3637-3644.
	
	Sanguinetti, G., Milo, M., Rattray, M. and Lawrence, N. D. (2005) Accounting for probe-level noise in principal component analysis of microarray data, Bioinformatics, 21(19):3748-3754.

	Rattray, M., Liu, X., Sanguinetti, G., Milo, M. and Lawrence, N. D. (2006) Propagating uncertainty in Microarray data analysis, Briefings in Bioinformatics, 7(1):37-47. 
	
	Liu, X., Milo, M., Lawrence, N. D. and Rattray, M. (2006) Probe-level measurement error improves accuracy in detecting differential gene expression, Bioinformatics, 22(17):2107-2113.
	
	Liu, X. Lin, K., Andersen, B. Rattray, M. (2007) Including probe-level uncertainty in model-based gene expression clustering, BMC Bioinformatics, 8(98).

	Pearson, R. D., Liu, X., Sanguinetti, G., Milo, M., Lawrence, N. D., Rattray, M. (2008)  puma: a Bioconductor package for Propagating Uncertainty in Microarray Analysis, BMC Bioinformatics, 2009, 10:211.

          Zhang,L. and Liu,X. (2009) An improved probabilistic model for finding differential gene expression, the 2nd BMEI 17-19 oct. 2009. Tianjin. China.	

          Liu,X. and Rattray,M. (2009) Including probe-level measurement error in robust mixture clustering of replicated microarray gene expression, Statistical Application in Genetics and Molecular Biology, 9(1), Article 42.

          puma 3.0: improved uncertainty propagation methods for gene and transcript expression analysis, Liu et al. BMC Bioinformatics, 2013, 14:39.


}
\examples{
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)
	pumapca_mmgmos <- pumaPCA(eset_mmgmos)
	plot(pumapca_mmgmos)
	eset_mmgmos_100 <- eset_mmgmos[1:100,]
	eset_comb <- pumaComb(eset_mmgmos_100)
        eset_combImproved <- pumaCombImproved(eset_mmgmos_100)
	esetDE <- pumaDE(eset_comb)
        esetDEImproved <- pumaDE(eset_combImproved)
}
\keyword{ package }

\name{pumaClust}
\alias{pumaClust}
\title{Propagate probe-level uncertainty in model-based clustering on gene expression data}
\description{
  This function clusters gene expression using a Gaussian mixture model including probe-level 
  measurement error. The inputs are gene expression levels and the probe-level standard
  deviation associated with expression measurement for each gene on each chip. The outputs 
  is the clustering results.
}
\usage{
pumaClust(e=NULL, se=NULL, efile=NULL, sefile=NULL, 
      subset=NULL, gsnorm=FALSE, clusters, 
      iter.max=100, nstart=10, eps=1.0e-6, del0=0.01)
}
\arguments{
  \item{e}{ either a valid \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object, or a data frame containing the expression level for each gene on each chip. }
  \item{se}{ data frame containing the standard deviation of gene expression levels. }
  \item{efile}{ character, the name of the file which contains gene expression measurements. }
  \item{sefile}{ character, the name of the file which contains the standard deviation of gene expression measurements. }
  \item{subset}{ vector specifying the row number of genes which are clustered on.}
  \item{gsnorm}{ logical specifying whether do global scaling normalisation or not. }
  \item{clusters}{integer, the number of clusters. }
  \item{iter.max}{ integer, the maximum number of iterations allowed in the parameter initialisation. }
  \item{nstart}{ integer, the number of random sets chosen in the parameter initialisation. }
  \item{eps}{ numeric, optimisation parameter. }
  \item{del0}{ numeric, optimisation parameter. }
}
\details{
  The input data is specified either as an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object (in which case se, efile and sefile will be ignored), or by e and se, or by efile and sefile.
 
}
\value{
  The result is a list with components
  
  cluster: vector, containing the membership of clusters for each gene;
  centers: matrix, the center of each cluster;
  centersigs: matrix, the center variance of each cluster;
  likelipergene: matrix, the likelihood of belonging to each cluster for each gene;
  bic: numeric, the Bayesian Information Criterion score.
  
}
\references{
Liu,X., Lin,K.K., Andersen,B., and Rattray,M. (2006) 
Propagating probe-level uncertainty in model-based gene expression clustering, 
BMC Bioinformatics, 8(98).

Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2005) A tractable probabilistic model for 
Affymetrix probe-level analysis across multiple chips, Bioinformatics, 21(18):3637-3644.
}
\author{ Xuejun Liu, Magnus Rattray }
\seealso{ Related method \code{\link{mmgmos}} and \code{\link[puma]{pumaClustii}}}
\examples{
  data(Clust.exampleE)
  data(Clust.exampleStd)
  pumaClust.example<-pumaClust(Clust.exampleE,Clust.exampleStd,clusters=7)
}
\keyword{ manip }
\keyword{ models }

\name{create_eset_r}
\alias{create_eset_r}
\title{Create an ExpressionSet from a PPLR matrix}
\description{
This is really an internal function called from pumaComb. It is used to create an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object from the output of the bcomb function (which was originally part of the \pkg{pplr} package. Don't worry about it!
}
\usage{
create_eset_r(
	eset
,	r
,	design.matrix=createDesignMatrix(eset)
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. The phenotype information from this is used as the phenotype information of the returned object }
	\item{r}{ A data frame with components named 'M1', 'M2', and so on, which represent the mean expression values for condition 1, condition 2, and so on. It also has components named 'Std1', 'Std2', and so on, which represent the standard deviation of the gene expression values for condition 1, condtion 2, and so on. This type of data frame is output by function \code{\link{bcomb}} and \code{\link{hcomb}} }
	\item{design.matrix}{ A design matrix. }
}
\value{
An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{bcomb}}, \code{\link{hcomb}}, \code{\link{pumaComb}} and \code{\link{pumaCombImproved}}}
\keyword{manip}

\name{createDesignMatrix}
\alias{createDesignMatrix}
\title{Automatically create a design matrix from an ExpressionSet}
\description{
Automatically create a design matrix from an ExpressionSet.
}
\usage{
createDesignMatrix(eset)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
}
\details{
The \pkg{puma} package has been designed to be as easy to use as possible, while not compromising on power and flexibility. One of the most difficult tasks for many users, particularly those new to microarray analysis, or statistical analysis in general, is setting up design and contrast matrices. The \pkg{puma} package will automatically create such matrices, and we believe the way this is done will suffice for most users' needs.

It is important to recognise that the automatic creation of design and contrast matrices will only happen if appropriate information about the levels of each factor is available for each array in the experimental design. This data should be held in an \code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame}} class. The easiest way of doing this is to ensure that the \code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame}} object holding the raw CEL file data has an appropriate \code{phenoData} slot. This information will then be passed through to any \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object created, for example through the use of \code{\link{mmgmos}}. The \code{phenoData} slot of an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object can also be manipulated directly if necessary.

Design and contrast matrices are dependent on the experimental design. The simplest experimental designs have just one factor, and hence the \code{phenoData} slot will have a matrix with just one column. In this case, each unique value in that column will be treated as a distinct level of the factor, and hence \code{\link{pumaComb}} will group arrays according to these levels. If there are just two levels of the factor, e.g. A and B, the contrast matrix will also be very simple, with the only contrast of interest being A vs B. For factors with more than two levels, a contrast matrix will be created which reflects all possible combinations of levels. For example, if we have three levels A, B and C, the contrasts of interest will be A vs B, A vs C and B vs C.

If we now consider the case of two or more factors, things become more complicated. There are now two cases to be considered: factorial experiments, and non-factorial experiments. A factorial experiment is one where all the combinations of the levels of each factor are tested by at least one array (though ideally we would have a number of biological replicates for each combination of factor levels). The \code{estrogen} case study from the package vignette is an example of a factorial experiment.

A non-factorial experiment is one where at least one combination of levels is not tested. If we treat the example used in the \code{\link{puma-package}} help page as a two-factor experiment (with factors ``level'' and ``batch''), we can see that this is not a factorial experiment as we have no array to test the conditions ``level=ten'' and ``batch=B''. We will treat the factorial and non-factorial cases separately in the following sections.

Factorial experiments

For factorial experiments, the design matrix will use all columns from the \code{phenoData} slot. This will mean that \code{\link{pumaComb}} will group arrays according to a combination of the levels of all the factors.

Non-factorial designs

For non-factorial designed experiments, we will simply ignore columns (right to left) from the \code{phenoData} slot until we have a factorial design or a single factor. We can see this in the example used in the \code{\link{puma-package}} help page. Here we have ignored the ``batch'' factor, and modelled the experiment as a single-factor experiment (with that single factor being ``level'').
}
\value{
	The result is a matrix. See the code below for an example.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{createContrastMatrix}}, \code{\link{pumaComb}}, \code{\link{pumaDE}} and \code{\link{pumaCombImproved}}}
\examples{
	if(FALSE){
	# This is a simple example based on a real data set. Note that this is an "unbalanced" design, the "level" factor has two replicates of the "twenty" condition, but only one replicate of the "ten" condition. Also note that the second factor, "batch" is not used in the design or contrast matrices, as we don't have every combination of the levels of "level" and "batch" (there is no array for level=twenty and batch=B).
		
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)
	createDesignMatrix(eset_mmgmos)
	
	# The following shows a set of 15 synthetic data sets with increasing complexity. We first create the data sets, then look at the design matrices.

	# single 2-level factor
	eset1 <- new("ExpressionSet", exprs=matrix(0,100,4))
	pData(eset1) <- data.frame("class"=c(1,1,2,2))

	# single 2-level factor - unbalanced design
	eset2 <- new("ExpressionSet", exprs=matrix(0,100,4))
	pData(eset2) <- data.frame("class"=c(1,2,2,2))

	# single 3-level factor
	eset3 <- new("ExpressionSet", exprs=matrix(0,100,6))
	pData(eset3) <- data.frame("class"=c(1,1,2,2,3,3))

	# single 4-level factor
	eset4 <- new("ExpressionSet", exprs=matrix(0,100,8))
	pData(eset4) <- data.frame("class"=c(1,1,2,2,3,3,4,4))

	# 2x2 factorial
	eset5 <- new("ExpressionSet", exprs=matrix(0,100,8))
	pData(eset5) <- data.frame("fac1"=c("a","a","a","a","b","b","b","b"), "fac2"=c(1,1,2,2,1,1,2,2))

	# 2x2 factorial - unbalanced design
	eset6 <- new("ExpressionSet", exprs=matrix(0,100,10))
	pData(eset6) <- data.frame("fac1"=c("a","a","a","b","b","b","b","b","b","b"), "fac2"=c(1,2,2,1,1,1,2,2,2,2))

	# 3x2 factorial
	eset7 <- new("ExpressionSet", exprs=matrix(0,100,12))
	pData(eset7) <- data.frame("fac1"=c("a","a","a","a","b","b","b","b","c","c","c","c"), "fac2"=c(1,1,2,2,1,1,2,2,1,1,2,2))

	# 2x3 factorial
	eset8 <- new("ExpressionSet", exprs=matrix(0,100,12))
	pData(eset8) <- data.frame(
		"fac1"=c("a","a","a","a","a","a","b","b","b","b","b","b")
	,	"fac2"=c(1,1,2,2,3,3,1,1,2,2,3,3) )

	# 2x2x2 factorial
	eset9 <- new("ExpressionSet", exprs=matrix(0,100,8))
	pData(eset9) <- data.frame(
		"fac1"=c("a","a","a","a","b","b","b","b")
	,	"fac2"=c(1,1,2,2,1,1,2,2)
	,	"fac3"=c("X","Y","X","Y","X","Y","X","Y") )

	# 3x2x2 factorial
	eset10 <- new("ExpressionSet", exprs=matrix(0,100,12))
	pData(eset10) <- data.frame(
		"fac1"=c("a","a","a","a","b","b","b","b","c","c","c","c")
	,	"fac2"=c(1,1,2,2,1,1,2,2,1,1,2,2)
	,	"fac3"=c("X","Y","X","Y","X","Y","X","Y","X","Y","X","Y") )

	# 3x2x2 factorial
	eset11 <- new("ExpressionSet", exprs=matrix(0,100,12))
	pData(eset11) <- data.frame(
		"fac1"=c("a","a","a","a","a","a","b","b","b","b","b","b")
	,	"fac2"=c(1,1,2,2,3,3,1,1,2,2,3,3)
	,	"fac3"=c("X","Y","X","Y","X","Y","X","Y","X","Y","X","Y") )

	# 3x2x2 factorial
	eset12 <- new("ExpressionSet", exprs=matrix(0,100,18))
	pData(eset12) <- data.frame(
		"fac1"=c("a","a","a","a","a","a","b","b","b","b","b","b","c","c","c","c","c","c")
	,	"fac2"=c(1,1,2,2,3,3,1,1,2,2,3,3,1,1,2,2,3,3)
	,	"fac3"=c("X","Y","X","Y","X","Y","X","Y","X","Y","X","Y","X","Y","X","Y","X","Y") )

	# 2x2x2x2 factorial
	eset13 <- new("ExpressionSet", exprs=matrix(0,100,16))
	pData(eset13) <- data.frame(
		"fac1"=c("a","a","a","a","a","a","a","a","b","b","b","b","b","b","b","b")
	,	"fac2"=c(0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1)
	,	"fac3"=c(2,2,3,3,2,2,3,3,2,2,3,3,2,2,3,3)
	,	"fac4"=c("X","Y","X","Y","X","Y","X","Y","X","Y","X","Y","X","Y","X","Y") )

	# "Un-analysable" data set - all arrays are from the same class
	eset14 <- new("ExpressionSet", exprs=matrix(0,100,4))
	pData(eset14) <- data.frame("class"=c(1,1,1,1))

	# "Non-factorial" data set - there are no arrays for fac1="b" and fac2=2. In this case only the first factor (fac1) is used.
	eset15 <- new("ExpressionSet", exprs=matrix(0,100,6))
	pData(eset15) <- data.frame("fac1"=c("a","a","a","a","b","b"), "fac2"=c(1,1,2,2,1,1))

	# "pseduo 2 factor" data set - second factor is informative
	eset16 <- new("ExpressionSet", exprs=matrix(0,100,8))
	pData(eset16) <- data.frame("fac1"=c("a","a","b","b"), "fac2"=c(1,1,1,1))

	# "pseduo 2 factor" data set - first factor is informative
	eset17 <- new("ExpressionSet", exprs=matrix(0,100,8))
	pData(eset17) <- data.frame("fac1"=c("a","a","a","a"), "fac2"=c(1,1,2,2))

	# "pseudo 3 factor" data set - first factor is uninformative so actually a 2x2 factorial
	eset18 <- new("ExpressionSet", exprs=matrix(0,100,8))
	pData(eset18) <- data.frame(
		"fac1"=c("a","a","a","a","a","a","a","a")
	,	"fac2"=c(1,1,2,2,1,1,2,2)
	,	"fac3"=c("X","Y","X","Y","X","Y","X","Y") )

	# "pseudo 3 factor" data set - first and third factors are uninformative so actually a single factor
	eset19 <- new("ExpressionSet", exprs=matrix(0,100,8))
	pData(eset19) <- data.frame(
		"fac1"=c("a","a","a","a","a","a","a","a")
	,	"fac2"=c(1,1,2,2,1,1,2,2)
	,	"fac3"=c("X","X","X","X","X","X","X","X") )

	createDesignMatrix(eset1)
	createDesignMatrix(eset2)
	createDesignMatrix(eset3)
	createDesignMatrix(eset4)
	createDesignMatrix(eset5)
	createDesignMatrix(eset6)
	createDesignMatrix(eset7)
	createDesignMatrix(eset8)
	createDesignMatrix(eset9)
	createDesignMatrix(eset10)
	createDesignMatrix(eset11)
	createDesignMatrix(eset12)
	createDesignMatrix(eset13)

	# "Un-analysable" data set - all arrays are from the same class - gives an error. Note that we've commented this out so that we don't get errors which would make the package fail the Bioconductor checks!
	# createDesignMatrix(eset14)
	# "Non-factorial" data set - there are no arrays for fac1="b" and fac2=2. In this case only the first factor (fac1) is used.
	createDesignMatrix(eset15)
}
}
\keyword{manip}

\name{exprReslt-class}
\docType{class}
\alias{class:exprReslt}
\alias{exprReslt}
\alias{exprReslt-class}
\alias{se.exprs}
\alias{se.exprs<-}
\alias{prcfifty}
\alias{prcfifty<-}
\alias{prcfive}
\alias{prcfive<-}
\alias{prcninfive}
\alias{prcninfive<-}
\alias{prcsevfive}
\alias{prcsevfive<-}
\alias{prctwfive}
\alias{prctwfive<-}
\alias{write.reslts}
\alias{show,exprReslt-method}
\alias{se.exprs,exprReslt-method}
\alias{se.exprs<-,exprReslt-method}
\alias{prcfifty,exprReslt-method}
\alias{prcfifty<-,exprReslt-method}
\alias{prcfive,exprReslt-method}
\alias{prcfive<-,exprReslt-method}
\alias{prcninfive,exprReslt-method}
\alias{prcninfive<-,exprReslt-method}
\alias{prcsevfive,exprReslt-method}
\alias{prcsevfive<-,exprReslt-method}
\alias{prctwfive,exprReslt-method}
\alias{prctwfive<-,exprReslt-method}
\alias{write.reslts,exprReslt-method}
\alias{write.reslts,ExpressionSet-method}

\title{Class exprReslt}
\description{This is a class representation for Affymetrix GeneChip probe level data. 
  The main component are the intensities, estimated expression levels and the confidence 
  of expression levels from multiple arrays 
  of the same \code{CDF} type. In extends \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("exprReslt", ...)}.
}
\section{Fields}{
  \describe{
  \item{\code{prcfive}:}{Object of class "matrix" representing the 5 percentile of the 
    observed expression levels. This is a matrix with columns representing patients or cases and 
    rows representing genes. }
  \item{\code{prctwfive}:}{Object of class "matrix" representing the 25 percentile of the 
    observed expression levels. This is a matrix with columns representing patients or cases and 
    rows representing genes.}
  \item{\code{prcfifty}:}{Object of class "matrix" representing the 50 percentile of the 
    observed expression levels. This is a matrix with columns representing patients or cases and 
    rows representing genes.}
  \item{\code{prcsevfive}:}{Object of class "matrix" representing the 75 percentile of the 
    observed expression levels. This is a matrix with columns representing patients or cases and 
    rows representing genes.}
  \item{\code{prcninfive}:}{Object of class "matrix" representing the 95 percentile of the 
    observed expression levels. This is a matrix with columns representing patients or cases and 
    rows representing genes.}
  \item{\code{phenoData}:}{Object of class "phenoData" inherited from
    \code{ExpressionSet}.}
  \item{\code{annotation}:}{A character string identifying the
    annotation that may be used for the \code{ExpressionSet} instance.}
  }
}
\section{Extends}{
Class \code{"ExpressionSet"}, directly.
}
\section{Methods}{
  \describe{
  \item{se.exprs}{\code{signature(object = "exprReslt")}: obtains the standard error of the estimated 
    expression levels. }
  \item{se.exprs<-}{\code{signature(object = "exprReslt")}: replaces the standard error of the estimated 
    expression levels. }
    \item{prcfifty}{\code{signature(object = "exprReslt")}: obtains the 50 percentile of the estimated 
      expression levels. }
    \item{prcfifty<-}{\code{signature(object = "exprReslt")}: replaces the 50 percentile of the estimated 
      expression levels. }
    \item{prcfive}{\code{signature(object = "exprReslt")}: obtains the 5 percentile of the estimated 
      expression levels.  }
    \item{prcfive<-}{\code{signature(object = "exprReslt")}: replaces the 5 percentile of the estimated 
      expression levels.  }
    \item{prcninfive}{\code{signature(object = "exprReslt")}: obtains the 95 percentile of the estimated 
      expression levels.  }
    \item{prcninfive<-}{\code{signature(object = "exprReslt")}: replaces the 95 percentile of the estimated 
      expression levels.  }
    \item{prcsevfive}{\code{signature(object = "exprReslt")}: obtains the 75 percentile of the estimated 
      expression levels.  }
    \item{prcsevfive<-}{\code{signature(object = "exprReslt")}: replaces the 75 percentile of the estimated 
      expression levels.  }
    \item{prctwfive}{\code{signature(object = "exprReslt")}: obtains the 25 percentile of the estimated 
      expression levels.  }
    \item{prctwfive<-}{\code{signature(object = "exprReslt")}: replaces the 25 percentile of the estimated 
      expression levels.  }
    \item{show}{\code{signature(object = "exprReslt")}: renders information about the exprReslt in a concise 
      way on stdout. }
    \item{write.reslts}{\code{signature(x = "exprReslt")}: writes the expression levels and related confidences to
      files. It takes the same arguments as \code{\link{write.table}}. The argument "file" does not need to set any 
      extension. The different file marks and extension "csv" will be added automatically. The default file name is "tmp". 
      In the final results, expression levels are in the file "tmp\_exprs.csv", standard deviations in 
      "tmp\_se.csv", 5 percentiles in "tmp\_prctile5.csv", likewise, 25, 50, 75 and 95 percentiles in "tmp\_prctile25.csv", 
      "tmp\_prctile50.csv", "tmp\_prctile75.csv" and "tmp\_prctile95.csv" respectively. }
  }
}
\author{ Xuejun Liu, Magnus Rattray, Marta Milo, Neil D. Lawrence, Richard D. Pearson }

\seealso{
  Related method \code{\link{mmgmos}} and related class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}.
}
\examples{
if(FALSE){
## load example data from package affydata
#	Next 4 lines commented out to save time in package checks, and saved version used
# if (require(affydata)) {
#	data(Dilution)
#	eset_mmgmos <- mmgmos(Dilution)
# }
data(eset_mmgmos)

## save the expression results into files
write.reslts(eset_mmgmos, file="example")
}
}
\keyword{classes}

\name{clusterNormE}
\alias{clusterNormE}
\title{ Zero-centered normalisation }
\description{
  This function normalise the data vector to have zero mean.
}
\usage{
clusterNormE(x)
}
\arguments{
  \item{x}{ a vector which contains gene expression level on log2 scale. }
}
\details{
  Vector x is related to a gene and each element is related to a chip.
}
\value{
  The return vector is in the same format as the input x.
}
\author{ Xuejun Liu,  Magnus Rattray }
\seealso{ See Also as \code{\link{pumaClust}} and \code{\link{pumaClustii}} }
\examples{
#data(Clust.exampleE)
#Clust.exampleE.centered<-t(apply(Clust.exampleE, 1, clusterNormE))
}
\keyword{ manip }

\name{hgu95aphis}
\alias{hgu95aphis}
\docType{data}
\title{ Estimated parameters of the distribution of phi}
\description{
  The pre-estimated parameters of log normal distribution of \eqn{\phi}, 
  which is the fraction of specific signal binding to mismatch probe.
}
\usage{data(hgu95aphis)}
\format{
  The format is:
 num [1:3]  0.171 -1.341  0.653
}
\details{
  The current values of hgu95aphis are estimated from Affymetrix spike-in data sets.
  It was loaded in the method \code{"mmgmos"}.
  
  hgu95aphis[1:3] is respectively the mode, mean and variance of the log normal distribution 
  of \eqn{\phi}, and hgu95aphis[1] is also the intial value of \eqn{\phi} in the model optimisation.
}
%\source{}
%\references{}
\keyword{datasets}

\name{pplr}
\alias{pplr}
\title{ Probability of positive log-ratio }
\description{
WARNING - this function is generally not expected to be used, but is intended as an internal function. It is included for backwards compatibility with the \pkg{pplr} package, but may be deprecated and then hidden in future. Users should generally use \code{\link{pumaDE}} instead.

  This function calculates the probability of positive log-ratio (PPLR) between any two specified conditions in the input data, mean and standard deviation of gene expression level for each condition.
}
\usage{
pplr(e, control, experiment, sorted=TRUE)
}
\arguments{
  \item{e}{ a data frame containing the mean and standard deviation of gene expression 
  levels for each condition. }
  \item{control}{ an integer denoting the control condition. }
  \item{experiment}{ an integer denoting the experiment condition. }
  \item{sorted}{ Boolean. Should PPLR values be sorted by value? If FALSE, PPLR values are returned in same order as supplied.}
}
\details{
  The input of 'e' should be a data frame comprising of 2*n components, where n is 
  the number of conditions. The first 1,2,...,n components include the mean of gene expression 
  values for conditions 1,2,...,n, and the n+1, n+2,...,2*n components contain the standard deviation of 
  expression levels for condition 1,2,...,n.
}
\value{
  The return is a data frame. The description of the components are below.
  \item{index }{The original row number of genes.}
  \item{cM }{The mean expression levels under control condition.}
  \item{sM}{The mean expression levels under experiment condition.}
  \item{cStd}{The standard deviation of gene expression levels under control condition.}
  \item{sStd}{The standard deviation of gene expression levels under experiment condition.}
  \item{LRM}{The mean log-ratio between control and experiment genes.}
  \item{LRStd}{The standard deviation of log-ratio between control and experiment genes.}
  \item{stat}{A statistic value which is -mean/(sqrt(2)*standard deviation).}
  \item{PPLR}{Probability of positive log-ratio.}
}
\references{ Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2006)  Probe-level variances improve accuracy in detecting differential
gene expression, Bioinformatics, 22(17):2107-13.}
\author{ Xuejun Liu, Marta Milo, Neil D. Lawrence, Magnus Rattray }
\seealso{ Related methods \code{\link{pumaDE}}, \code{\link{bcomb}} and \code{\link{hcomb}} }
\examples{
  data(exampleE)
  data(exampleStd)
  r<-bcomb(exampleE,exampleStd,replicates=c(1,1,1,2,2,2),method="map")
  p<-pplr(r,1,2)
}
\keyword{ manip }
\keyword{ models }
 

\name{plot-methods}
\docType{methods}
\alias{plot.pumaPCARes}
\alias{plot-methods}
\alias{plot,pumaPCARes-method}
\alias{plot,pumaPCARes,missing-method}
\title{Plot method for pumaPCARes objects}
\description{
This is the method to plot objects of class pumaPCARes. It will produce a scatter plot of two of the principal components
}
\usage{
\S4method{plot}{pumaPCARes,missing}(..., firstComponent = 1, secondComponent = 2, useFilenames = FALSE, phenotype = pData(pumaPCARes@phenoData), legend1pos = "topright", legend2pos = "bottomright")
}

\arguments{
  \item{\dots}{Optional graphical parameters to adjust different components of the plot}
  \item{firstComponent}{Integer identifying which principal component to plot on the x-axis}
  \item{secondComponent}{Integer identifying which principal component to plot on the x-axis}
  \item{useFilenames}{Boolean. If TRUE then use filenames as plot points. Otherwise just use points.}
  \item{phenotype}{Phenotype information}
  \item{legend1pos}{String indicating where to put legend for first factor}
  \item{legend2pos}{String indicating where to put legend for second factor}
}
\examples{
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)
	pumapca_mmgmos <- pumaPCA(eset_mmgmos)
	plot(pumapca_mmgmos)
}
\keyword{methods}
\keyword{hplot}

\name{justmmgMOS}
\alias{justmmgMOS}
\alias{just.mmgmos}
\title{Compute mmgmos Directly from CEL Files}
\description{
  This function converts CEL files into an \code{\link{exprReslt}} using mmgmos.
}
\usage{
justmmgMOS(\dots, filenames=character(0),
          widget=getOption("BioC")$affy$use.widgets,
          compress=getOption("BioC")$affy$compress.cel,
          celfile.path=getwd(),
          sampleNames=NULL,
          phenoData=NULL,
          description=NULL,
          notes="",
          background=TRUE, gsnorm=c("median", "none", "mean", "meanlog"), savepar=FALSE, eps=1.0e-6)

just.mmgmos(\dots, filenames=character(0),
           phenoData=new("AnnotatedDataFrame"),
           description=NULL,
           notes="",
           compress=getOption("BioC")$affy$compress.cel,
           background=TRUE, gsnorm=c("median", "none", "mean", "meanlog"), savepar=FALSE, eps=1.0e-6)
}
\arguments{
  \item{\dots}{file names separated by comma.}
  \item{filenames}{file names in a character vector.}
  \item{widget}{a logical specifying if widgets should be used.}
  \item{compress}{are the CEL files compressed?}
  \item{celfile.path}{a character denoting the path where cel files locate.}    
  \item{sampleNames}{a character vector of sample names to be used in
    the \code{\link[oligoClasses:FeatureSet-class]{FeatureSet}}.}
   \item{phenoData}{an
          \code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame}}
          object.} 
  \item{description}{a \code{\link[Biobase:class.MIAME]{MIAME}} object}
  \item{notes}{ notes }
  \item{background}{Logical value. If \code{TRUE}, then perform background correction before applying mmgmos.}
  \item{gsnorm}{character. specifying the algorithm of global scaling normalisation.}
  \item{savepar}{Logical value. If \code{TRUE}, the the estimated parameters of the model are saved in file par\_mmgmos.txt and phi\_mmgmos.txt.}
  \item{eps}{Optimisation termination criteria.}
}
\details{
  This method should require much less RAM than the conventional
  method of first creating an \code{\link[oligoClasses:FeatureSet-class]{FeatureSet}} and then running
  \code{\link{mmgmos}}.
  
  Note that this expression measure is given to you in log base 2 scale. This differs from
  most of the other expression measure methods.

  The algorithms of global scaling normalisation can be one of "median", "none", "mean", "meanlog".
  "mean" and "meanlog" are mean-centered normalisation on raw scale and log scale respectively, and "median" 
  is median-centered normalisation. "none" will result in no global scaling normalisation being applied.
}
\value{
 An \code{exprReslt}.
}
\seealso{Related class \code{\link{exprReslt-class}} and related method \code{\link{mmgmos}}}

\keyword{manip}

\name{pplrUnsorted}
\alias{pplrUnsorted}
\title{Return an unsorted matrix of PPLR values}
\description{
Returns the output from \code{\link{pplr}} as an unsorted matrix (i.e. sorted according to the original sorting in the original matrix)
}
\usage{
pplrUnsorted(p)
}
\arguments{
	\item{p}{ A matrix as output by \code{\link{pplr}}. }
}
\value{
  A matrix of PPLR values
}
\author{ Richard D. Pearson }
\seealso{Related method \code{\link{pplr}}}
\keyword{manip}

\name{plotErrorBars}
\alias{plotErrorBars}
\title{Plot mean expression levels and error bars for one or more probesets}
\description{
This produces plots of probesets of interest.
}
\usage{
plotErrorBars(
	eset
,	probesets = if(dim(exprs(eset))[1] <= 12) 1:dim(exprs(eset))[1] else 1
,	arrays = 1:dim(pData(eset))[1] # default is to use all
,	xlab = paste(colnames(pData(eset))[1:numOfFactorsToUse(eset)], collapse=":")
,	ylab = "Expression Estimate"
,	xLabels = apply(
                  as.matrix(pData(eset)[arrays,1:numOfFactorsToUse(eset)])
                , 1
                , function(mat){paste(mat, collapse=":")}
                )
,	ylim = NA
,	numOfSEs = qnorm(0.975)
,	globalYlim = FALSE # Not yet implemented!
,	plot_cols = NA
,	plot_rows = NA
,	featureNames = NA
,	showGeneNames = FALSE
,	showErrorBars = if(
					length(assayDataElement(eset,"se.exprs"))==0 ||
					length(assayDataElement(eset,"se.exprs")) == sum(is.na(assayDataElement(eset,"se.exprs")))
					) FALSE else TRUE
,	plotColours = FALSE
,	log.it = if(max(exprs(eset)) > 32) TRUE else FALSE
,	eset_comb = NULL
,	jitterWidth = NA
,	qtpcrData = NULL
, ...
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. This is the main object being plotted. }
	\item{probesets}{ A vector of integers indicating the probesets to be plotted. These integers refer to the row numbers of the \code{eset}. }
	\item{arrays}{ A vector of integers indicating the arrays to be shown on plots. }
	\item{xlab}{ Character string of title to appear on x-axis }
	\item{ylab}{ Character string of title to appear on y-axis }
	\item{xLabels}{ Vector of strings for labels of individual points on x-axis. }
	\item{ylim}{ 2-element numeric vector showing minimum and maximum values for y-axis. }
	\item{numOfSEs}{ Numeric indicating the scaling for the error bars. The default value give error bars that include 95\% of expected values. }
	\item{globalYlim}{ Not yet implemented! }
	\item{plot_cols}{ Integer specifying number of columns for multi-figure plot. }
	\item{plot_rows}{ Integer specifying number of rows for multi-figure plot. }
	\item{featureNames}{ A vector of strings for \code{featureNames} (Affy IDs). This is an alternative (to the \code{probesets} argument) way of specifying probe sets. }
	\item{showGeneNames}{ Boolean indicating whether to use Affy IDs as titles for each plot. }
	\item{showErrorBars}{ Boolean indicating whether error bars should be shown on plots. }
	\item{plotColours}{ A vector of colours to plot. }
	\item{log.it}{ Boolean indicating whether expression values should be logged. }
	\item{eset_comb}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. This is a secondary object to be plotted on the same charts as \code{eset}. This should be an object created using \code{\link{pumaComb}} and \code{\link{pumaCombImproved}} which holds the values created by combining information from the replicates of each condition. }
	\item{jitterWidth}{ Numeric indicating the x-axis distance between replicates of the same condition. }
	\item{qtpcrData}{ A 2-column matrix of qRT-PCR values (or other data to be plotted on the same charts). }
	\item{\dots}{ Additional arguments to be passed to \code{\link[graphics]{plot}}. }
}
\value{
	This function has no return value. The output is the plot created.
}
\author{ Richard D. Pearson }
\examples{
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)
	plotErrorBars(eset_mmgmos)
	plotErrorBars(eset_mmgmos,1:6)
}

\keyword{hplot}

\name{plotROC}
\alias{plotROC}
\title{Receiver Operator Characteristic (ROC) plot}
\description{
Plots a Receiver Operator Characteristic (ROC) curve.
}
\usage{
plotROC(
	scoresList
,	truthValues
,	includedProbesets=1:length(truthValues)
,	legendTitles=1:length(scoresList)
,	main = "PUMA ROC plot"
,	lty = 1:length(scoresList)
,	col = rep(1,length(scoresList))
,	lwd = rep(1,length(scoresList))
,	yaxisStat = "tpr"
,	xaxisStat = "fpr"
,	downsampling = 100
,	showLegend = TRUE
,	showAUC = TRUE
,	...
)
}
\arguments{
	\item{scoresList}{ A list, each element of which is a numeric vector of scores. }
	\item{truthValues}{ A boolean vector indicating which scores are True Positives. }
	\item{includedProbesets}{ A vector of indices indicating which scores (and truthValues) are to be used in the calculation. The default is to use all, but a subset can be used if, for example, you only want a subset of the probesets which are not True Positives to be treated as False Positives. }
	\item{legendTitles}{ Vector of names to appear in legend. }
	\item{main}{ Main plot title }
	\item{lty}{ Line types. }
	\item{col}{ Colours. }
	\item{lwd}{ Line widths. }
	\item{yaxisStat}{Character string identifying what is to be plotted on the y-axis. The default is "tpr" for True Positive Rate. See \code{\link[ROCR:performance]{performance}} function from \pkg{ROCR} package.}
	\item{xaxisStat}{Character string identifying what is to be plotted on the x-axis. The default is "fpr" for False Positive Rate. See \code{\link[ROCR:performance]{performance}} function from \pkg{ROCR} package.}
\item{downsampling}{See details for
	  \code{\link[ROCR:plot-methods]{plot.performance}} from the
	  \pkg{ROCR} package. } 
	\item{showLegend}{Boolean. Should legend be displayed?}
	\item{showAUC}{Boolean. Should AUC values be included in legend?}
	\item{\dots}{ Other parameters to be passed to \code{plot}. }
}
\value{
	This function has no return value. The output is the plot created.
}
\author{ Richard D. Pearson }
\seealso{Related method \code{\link{calcAUC}}}
\examples{
if(FALSE){
	class1a <- rnorm(1000,0.2,0.1)
	class2a <- rnorm(1000,0.6,0.2)
	class1b <- rnorm(1000,0.3,0.1)
	class2b <- rnorm(1000,0.5,0.2)
	scores_a <- c(class1a, class2a)
	scores_b <- c(class1b, class2b)
	scores <- list(scores_a, scores_b)
	classElts <- c(rep(FALSE,1000), rep(TRUE,1000))
	plotROC(scores, classElts)
}
}
\keyword{hplot}

 \name{PMmmgmos}
\alias{PMmmgmos}
\title{ Multi-chip modified gamma Model for Oligonucleotide Signal using only PM probe intensities}
\description{
  This function converts an object of class \code{\link[oligoClasses:FeatureSet-class]{FeatureSet}} into an object of class
  \code{\link{exprReslt}} using the Multi-chip modified gamma Model for Oligonucleotide Signal
  (PMmulti-mgMOS). This method uses only PM probe intensites. This function obtains confidence of measures, standard deviation and 5,
  25, 50, 75 and 95 percentiles, as well as the estimated expression levels.
}
\usage{
PMmmgmos(
	object
,	background=TRUE
,	replaceZeroIntensities=TRUE
,	gsnorm=c("median", "none", "mean", "meanlog")
,	savepar=FALSE
,	eps=1.0e-6
,	addConstant = 0
)
}
\arguments{
  \item{object}{an object of \code{\link[oligoClasses:FeatureSet-class]{FeatureSet}}}
  \item{background}{Logical value. If \code{TRUE}, perform background correction before applying PMmmgmos.}
  \item{replaceZeroIntensities}{Logical value. If \code{TRUE}, replace 0 intensities with 1 before applying PMmmgmos.}
  \item{gsnorm}{character. specifying the algorithm of global scaling normalisation.}
  \item{savepar}{Logical value. If \code{TRUE} the estimated parameters of the model are saved in file par\_pmmmgmos.txt  }
  \item{eps}{Optimisation termination criteria.}
  \item{addConstant}{numeric. This is an experimental feature and should not generally be changed from the default value. }
}
\details{
  The obtained expression measures are in log base 2 scale.

  The algorithms of global scaling normalisation can be one of "median", "none", "mean", "meanlog".
  "mean" and "meanlog" are mean-centered normalisation on raw scale and log scale respectively, and "median"
  is median-centered normalisation. "none" will result in no global scaling normalisation being applied.

  There are n+2 columns in file par\_pmmmgmos.txt, n is the number of chips. The first n columns are 'alpha' values for n chips,
  column n+1 is 'c' values and the final column is values for 'd'.
}
\value{
  An object of class \code{exprReslt}.
}
\references{Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2005) A tractable probabilistic model for
Affymetrix probe-level analysis across multiple chips, Bioinformatics 21: 3637-3644.

Milo,M., Niranjan,M., Holley,M.C., Rattray,M. and Lawrence,N.D. (2004) A probabilistic approach for summarising
oligonucleotide gene expression data, technical report available upon request.

Milo,M., Fazeli,A., Niranjan,M. and Lawrence,N.D. (2003) A probabilistic model for the extractioin of expression
 levels from oligonucleotide arrays, Biochemical Society Transactions, 31: 1510-1512.

Peter Spellucci. DONLP2 code and accompanying documentation. Electronically available via
http://plato.la.asu.edu/donlp2.html}

\author{Xuejun Liu, Zhenzhu Gao, Magnus Rattray, Marta Milo, Neil D. Lawrence}

\seealso{ Related class \code{\link{exprReslt-class}} and related method \code{\link{mgmos}}}
\examples{
## Code commented out to speed up checks
## load example data from package pumadata
 #if (require(pumadata)&&require(puma)){
   # data(oligo.estrogen)
## use method PMmmgMOS to calculate the expression levels and related confidence
##of the measures for the example data
 #   eset<-PMmmgmos(oligo.estrogen,gsnorm="none")
#}
}
\keyword{manip}

\name{plotWhiskers}
\alias{plotWhiskers}
\title{Standard errors whiskers plot}
\description{
A plot showing error bars for genes of interest.
}
\usage{
plotWhiskers(
	eset
,	comparisons=c(1,2)
,	sortMethod = c("logRatio", "PPLR")
,	numGenes=50
,	xlim
,	main = "PUMA Whiskers plot"
,	highlightedGenes=NULL
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
	\item{comparisons}{ A 2-element integer vector specifying the columns of data to be compared. }
	\item{sortMethod}{ The method used to sort the genes. "logRatio" is fold change. PPLR is Probability of Positive Log Ratio (as determined by the \code{\link{pumaDE}} method). }
	\item{numGenes}{ Integer. Number of probesets to plot. }
	\item{xlim}{ The x limits of the plot. See \code{\link{plot.default}}. }
	\item{main}{ A main title for the plot. See \code{\link{plot.default}}. }
	\item{highlightedGenes}{ Row numbers of probesets to highlight with an asterisk. }
}
\value{
	This function has no return value. The output is the plot created.
}
\author{ Richard D. Pearson }
\seealso{Related method \code{\link{pumaDE}}}
\keyword{hplot}

\name{gmoExon}
\alias{gmoExon}
\title{ Compute gene and transcript expression values and standard deviatons from exon CEL Files }
\description{
   This function converts an object of \code{\link[oligoClasses:FeatureSet-class]{FeatureSet}} into an object of class 
  \code{\link{exprReslt}} using the gamma model for exon chips. 
   This function obtains confidence of measures, standard deviation and 5, 
  25, 50, 75 and 95 percentiles, as well as the estimated expression levels.
}
\usage{
gmoExon(
      object
     ,exontype = c("Human", "Mouse", "Rat")
     ,background=FALSE
     ,gsnorm=c("median", "none", "mean", "meanlog")
     ,savepar=FALSE
     ,eps=1.0e-6
     ,addConstant = 0
     ,cl=NULL
     ,BatchFold=10
)	
}
\arguments{
	\item{object}{an object of \code{\link[oligoClasses:FeatureSet-class]{FeatureSet}}}
	\item{exontype}{character. specifying the type of exon chip.}
          \item{background}{Logical value. If \code{TRUE}, perform background correction before applying gmoExon.}
          \item{gsnorm}{character. specifying the algorithm of global scaling normalisation.}
	\item{savepar}{Logical value. If \code{TRUE} the estimated parameters of the model are saved in file par\_gmoExon.txt }
	\item{eps}{Optimisation termination criteria.}
          \item{addConstant}{numeric. This is an experimental feature and should not generally be changed from the default value. }
          \item{cl}{This function can be parallelised by setting parameter cl. For more details, please refer to the vignette.}
          \item{BatchFold}{ we divide tasks into BatchFold*n jobs where n is the number of cluster nodes. The first n jobs are placed on the n nodes. When the first job is completed,the next job is placed on the available node. This continues until all jobs are completed. The default value is ten. The user also can change the value according to the number of cluster nodes n. We suggest that for bigger n BatchFold should be smaller.}
}
\details{
  The obtained expression measures are in log base 2 scale.
  Using the known relationships between genes, transcripts and probes,
  we propose a gamma model for exon array data to calculate transcript and gene expression levels.
  The algorithms of global scaling normalisation can be one of "median", "none", "mean", "meanlog".
  "mean" and "meanlog" are mean-centered normalisation on raw scale and log scale respectively, and "median" 
  is median-centered normalisation. "none" will result in no global scaling normalisation being applied.
  This function can be parallelised by setting parameter cl. For more details, please refer to the vignette.
 

  }
\value{
 A list of two object of class \code{exprReslt}.
}
\references{Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2005) A tractable probabilistic model for 
Affymetrix probe-level analysis across multiple chips, Bioinformatics, 21:3637-3644.

Milo,M., Niranjan,M., Holley,M.C., Rattray,M. and Lawrence,N.D. (2004) A probabilistic approach for summarising 
oligonucleotide gene expression data, technical report available upon request.

Milo,M., Fazeli,A., Niranjan,M. and Lawrence,N.D. (2003) A probabilistic model for the extractioin of expression
 levels from oligonucleotide arrays, Biochemical Society Transactions, 31: 1510-1512.

Peter Spellucci. DONLP2 code and accompanying documentation. Electronically available via 
http://plato.la.asu.edu/donlp2.html

Risueno A, Fontanillo C, Dinger ME, De Las Rivas J. GATExplorer: genomic and transcriptomic explorer; mapping expression
probes to gene loci, transcripts, exons and ncRNAs. BMC Bioinformatics.2010.}

\author{Xuejun Liu, Zhenzhu gao, Magnus Rattray, Marta Milo, Neil D. Lawrence}

\seealso{ Related class \code{\link{exprReslt-class}} }

\examples{
if(FALSE){
## The following scripts show the use of the method.
## load CEL files
# celFiles<-c("SR20070419HEX01.CEL", "SR20070419HEX02.CEL","SR20070419HEX06.CEL","SR20070419HEX07.CEL)
#oligo_object.exon<-read.celfiles(celFiles);

## use method gmoExon to calculate the expression levels and related confidence 
## of the measures for the example data
#eset_gmoExon<-gmoExon(oligo_object.exon,exontype="Human",gsnorm="none",cl=cl)
}
}

\keyword{manip}

\name{pumaPCAExpectations-class}
\docType{class}
\alias{pumaPCAExpectations-class}
\alias{pumaPCAExpectations}

\title{Class pumaPCAExpectations}
\description{
This is a class representation for storing a set of expectations from a pumaPCA model. It is an internal representation and shouldn't normally be instantiated.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("pumaPCAExpectations", ...)}.
}
\section{Slots}{
	\describe{
		\item{\code{x}:}{Object of class "matrix" representing x}
		\item{\code{xxT}:}{Object of class "array" representing xxT}
		\item{\code{logDetCov}:}{Object of class "numeric" representing logDetCov}
	}
}
\section{Methods}{
This class has no methods defined
}
\author{ Richard D. Pearson }

\seealso{
Related method \code{\link{pumaPCA}} and related class \code{\link{pumaPCARes}}.
}
\keyword{classes}

\name{removeUninformativeFactors}
\alias{removeUninformativeFactors}
\title{Remove uninformative factors from the phenotype data of an ExpressionSet}
\description{
This is really an internal function used to remove uninformative factors from the phenotype data. Uninformative factors here are defined as those which have the same value for all arrays in the \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}.}
\usage{
	removeUninformativeFactors(eset)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
}
\value{
  An \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object with the same data as the input, except for a new \code{phenoData} slot.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{createDesignMatrix}} and  \code{\link{createContrastMatrix}}}
\examples{
	eset_test <- new("ExpressionSet", exprs=matrix(rnorm(400,8,2),100,4))
	pData(eset_test) <- data.frame("informativeFactor"=c("A", "A", "B", "B"), "uninformativeFactor"=c("X","X","X","X"))
	eset_test2 <- removeUninformativeFactors(eset_test)
	pData(eset_test)
	pData(eset_test2)
}
\keyword{manip}

\name{clusterNormVar}
\alias{clusterNormVar}
\title{ Adjusting expression variance for zero-centered normalisation }
\description{
  This function adjusts the variance of the gene expression according to the zero-centered normalisation.
}
\usage{
clusterNormVar(x)
}
\arguments{
  \item{x}{ a vector which contains the variance of gene expression level on log2 scale. }
}
\details{
  Vector x is related to a gene and each element is related to a chip.
}
\value{
  The return vector is in the same format as the input x.
}
\author{ Xuejun Liu,  Magnus Rattray }
\seealso{ See Also as \code{\link{pumaClust}} and \code{\link{pumaClustii}} }
\examples{
#data(Clust.exampleE)
#data(Clust.exampleStd)
#Clust.exampleVar<-Clust.exampleStd^2
#Clust.exampleStd.centered<-t(apply(cbind(Clust.exampleE,Clust.exampleVar), 1, clusterNormVar))
}
\keyword{ manip }

\name{pumaComb}
\alias{pumaComb}
\title{Combining replicates for each condition}
\description{
This function calculates the combined (from replicates) signal for each condition using Bayesian models. The inputs are gene expression levels and the probe-level standard deviations associated with expression measurements for each gene on each chip. The outputs include gene expression levels and standard deviation for each condition.
}
\usage{
pumaComb(
	eset
,	design.matrix=NULL
,	method="em"
,	numOfChunks=1000
,	save_r=FALSE
,	cl=NULL
,	parallelCompute=FALSE
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
	\item{design.matrix}{ A design matrix. }
	\item{method}{ Method "map" uses MAP of a hierarchical Bayesion model with Gamma prior on the between-replicate variance (Gelman et.al. p.285) and shares the same variance across conditions. This method is fast and suitable for the case where there are many conditions.

Method "em" uses variational inference of the same hierarchical Bayesian model as in method "map" but with conjugate prior on between-replicate variance and shares the variance across conditions. This is generaly much slower than "map", but is recommended where there are few conditions (as is usually the case). }
	\item{numOfChunks}{ An integer defining how many chunks the data is divided into before processing. There is generally no need to change the default value. }
	\item{save_r}{ Will save an internal variable \code{r} to a file. Used for debugging purposes. }
\item{cl}{ A "cluster" object. See
	\code{\link[snow:snow-startstop]{makeCluster}} function from
	\pkg{snow} package for more details (if available).} 
	\item{parallelCompute}{ Boolean identifying whether processing in parallel should occur. }
}
\details{
It is generally recommended that data is normalised prior to using this function. Note that the default behaviour of mmgmos is to normalise data so this shouldn't generally be an issue. See the function \code{\link{pumaNormalize}} for more details on normalisation.
}
\value{
  The result is an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object.
}
\references{Gelman,A., Carlin,J.B., Stern,H.S., Rubin,D.B., Bayesian data analysis. London: Chapman & Hall; 1995.

Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2006) Probe-level variances improve accuracy in detecting differential
gene expression, Bioinformatics, 22:2107-2113.
}
\author{ Xuejun Liu, Marta Milo, Neil D. Lawrence, Magnus Rattray }
\seealso{Related methods \code{\link{pumaNormalize}}, \code{\link{bcomb}}, \code{\link{mmgmos}} and \code{\link{pumaDE}}}
\examples{
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)

	#	Next line shows that eset_mmgmos has 4 arrays, each of which is a different
	#   condition (the experimental design is a 2x2 factorial, with both liver and
	#	scanner factors)
	pData(eset_mmgmos)
	
	#	Next line shows expression levels of first 3 probe sets
	exprs(eset_mmgmos)[1:3,]

	#	Next line used so eset_mmgmos only has information about the liver factor
	#	The scanner factor will thus be ignored, and the two arrays of each level
	#	of the liver factor will be treated as replicates
	pData(eset_mmgmos) <- pData(eset_mmgmos)[,1,drop=FALSE]

	#	To save time we'll just use 100 probe sets for the example
	eset_mmgmos_100 <- eset_mmgmos[1:100,]
	eset_comb <- pumaComb(eset_mmgmos_100)
	
	#	We can see that the resulting ExpressionSet object has just two conditions
	#	and 1 expression level for each condition
	pData(eset_comb)
	exprs(eset_comb)[1:3,]
}
\keyword{ manip }
\keyword{ models }

\name{calculateTtest}
\alias{calculateTtest}
\title{Calculate differential expression between conditions using T-test}
\description{
Automatically creates design and contrast matrices if not specified. This function is useful for comparing T-test results with those of other differential expression (DE) methods such as \code{\link{pumaDE}}.
}
\usage{
calculateTtest(
	eset
,	design.matrix = createDesignMatrix(eset)
,	contrast.matrix = createContrastMatrix(eset)
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} }
	\item{design.matrix}{ A design matrix }
	\item{contrast.matrix}{ A contrast matrix }
}
\details{
The \code{eset} argument must be supplied, and must be a valid \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object. Design and contrast matrices can be supplied, but if not, default matrices will be used. These should usually be sufficient for most analyses.
}
\value{
  An object of class \code{\link{DEResult}}.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{pumaDE}}, \code{\link{calculateLimma}}, \code{\link{calculateFC}}, \code{\link{createDesignMatrix}} and \code{\link{createContrastMatrix}} and class \code{\link{DEResult}}}
\examples{
#	eset_test <- new("ExpressionSet", exprs=matrix(rnorm(400,8,2),100,4))
#	pData(eset_test) <- data.frame("class"=c("A", "A", "B", "B"))
#	TtestRes <- calculateTtest(eset_test)
#	plotErrorBars(eset_test, topGenes(TtestRes))
}
\keyword{manip}

\name{DEResult}
\docType{class}
\alias{class:DEResult}
\alias{DEResult}

\alias{DEResult-class}

\alias{statistic}
\alias{statistic<-}
\alias{FC}
\alias{FC<-}
\alias{statisticDescription}
\alias{statisticDescription<-}
\alias{DEMethod}
\alias{DEMethod<-}
\alias{pLikeValues}
\alias{topGenes}
\alias{topGeneIDs}
\alias{numberOfProbesets}
\alias{numberOfGenes}
\alias{numberOfContrasts}

\alias{statistic,DEResult-method}
\alias{statistic<-,DEResult,matrix-method}
\alias{FC,DEResult-method}
\alias{FC<-,DEResult,matrix-method}
\alias{statisticDescription,DEResult-method}
\alias{statisticDescription<-,DEResult,character-method}
\alias{DEMethod,DEResult-method}
\alias{DEMethod<-,DEResult,character-method}
\alias{pLikeValues,DEResult-method}
\alias{topGenes,DEResult-method}
\alias{topGeneIDs,DEResult-method}
\alias{numberOfProbesets,DEResult-method}
\alias{numberOfGenes,DEResult-method}
\alias{numberOfContrasts,DEResult-method}
\alias{show,DEResult-method}
\alias{write.reslts,DEResult-method}

\title{
  Class DEResult
}

\description{
  Class to contain and describe results of a differential expression (DE) analysis. The main components are \code{statistic} which hold the results of any statistic (e.g. p-values, PPLR values, etc.), and \code{FC} which hold the fold changes.
}
\section{Creating Objects}{

  \code{DEResult} objects will generally be created using one of the functions \code{\link{pumaDE}}, \code{\link{calculateLimma}}, \code{\link{calculateFC}} or \code{\link{calculateTtest}}.

  Objects can also be created from scratch:

  \code{new("DEResult")}

  \code{new("DEResult",
		statistic=matrix()
	,	FC=matrix()
	,	statisticDescription="unknown"
	,	DEMethod="unknown"
	)
  }
}
\section{Slots}{
   \describe{
     \item{\code{statistic}:}{Object of class "matrix" holding the statistics returned by the DE method.}
     \item{\code{FC}:}{Object of class "matrix" holding the fold changes returned by the DE method.}
     \item{\code{statisticDescription}:}{A text description of the contents of the \code{statistic} slot.}
     \item{\code{DEMethod}:}{A string indicating which DE method was used to create the object.}
  }
}
\section{Methods}{

  Class-specific methods.
  \describe{
    \item{\code{statistic(DEResult)}, \code{statistic(DEResult,matrix)<-}}{Access and
      set the \code{statistic} slot.}
    \item{\code{FC(DEResult)}, \code{FC(DEResult,matrix)<-}}{Access and
      set the \code{FC} slot.}
    \item{\code{statisticDescription(DEResult)}, \code{statisticDescription(DEResult,character)<-}}{Access and
      set the \code{statisticDescription} slot.}
    \item{\code{DEMethod(DEResult)}, \code{DEMethod(DEResult,character)<-}}{Access and
      set the \code{DEMethod} slot.}
    \item{\code{pLikeValues(object, contrast=1, direction="either")}}{Access the statistics of an object of class \code{DEResult}, converted to "p-like values".  If the object holds information on more than one contrast, only the values of the statistic for contrast number \code{contrast} are given. Direction can be "either" (meaning we want order genes by probability of being either up- or down-regulated), "up" (meaning we want to order genes by probability of being up-regulated), or "down" (meaning we want to order genes by probability of being down-regulated). "p-like values" are defined as values between 0 and 1, where 0 identifies the highest probability of being differentially expressed, and 1 identifies the lowest probability of being differentially expressed. We use this so that we can easily compare results from methods that provide true p-values (e.g. \code{\link{calculateLimma}}) and methods methods that do not provide p-values (e.g. \code{\link{pumaDE}}). For objects created using \code{\link{pumaDE}}, this returns 1-PPLR if the direction is "up", PPLR if direction is "down", and 1-abs(2*(PPLR-0.5)) if direction is "either". For objects created using \code{\link{calculateLimma}} or \code{\link{calculateTtest}}, this returns the p-value if direction is "either", ((p-1 * sign(FC))/2)+ 0.5, if the direction is "up", and ((1-p * sign(FC))/2)+ 0.5 if the direction is "down". For all other methods, this returns the rank of the appropriate statistic, scaled to lie between 0 and 1. \code{contrast} will be returned.}
    \item{\code{topGenes(object, numberOfGenes=1, contrast=1, direction="either")}}{Returns the index numbers (row numbers) of the genes determined to be most likely to be differentially expressed. \code{numberOfGenes} specifies the number of genes to be returned by the function. If the object holds information on more than one contrast, only the values of the statistic for contrast number \code{contrast} are given. Direction can be "either" (meaning we want order genes by probability of being either up- or down-regulated), "up" (meaning we want to order genes by probability of being up-ragulated), or "down" (meaning we want to order genes by probability of being down-regulated). Note that genes are ordered by "p-like values" (see \code{pLikeValues}). \code{object} is an object of class \code{DEResult}.}
    \item{\code{topGeneIDs(object, numberOfGenes=1, contrast=1, direction="either")}}{Returns the Affy IDs (row names) of the genes determined to be most likely to be differentially expressed. \code{numberOfGenes} specifies the number of genes to be returned by the function. If the object holds information on more than one contrast, only the values of the statistic for contrast number \code{contrast} are given. Direction can be "either" (meaning we want order genes by probability of being either up- or down-regulated), "up" (meaning we want to order genes by probability of being up-ragulated), or "down" (meaning we want to order genes by probability of being down-regulated). Note that genes are ordered by "p-like values" (see \code{pLikeValues}). \code{object} is an object of class \code{DEResult}.}
    \item{\code{numberOfProbesets(object)}}{Returns the number of probesets (number of rows) in an object of class \code{DEResult}. This method is synonymous with numberOfGenes.}
    \item{\code{numberOfGenes(object)}}{Returns the number of probesets (number of rows) in an object of class \code{DEResult}. This method is synonymous with numberOfProbesets.}
    \item{\code{numberOfContrasts(object)}}{Returns the number of contrasts (number of columns) in an object of class \code{DEResult}.}
    \item{\code{write.reslts(object)}}{\code{signature(x = "DEResult")}: writes the statistics and related fold changes (FCs) to
      files. It takes the same arguments as \code{\link{write.table}}. The argument "file" does not need to set any 
      extension. The different file marks and extension "csv" will be added automatically. The default file name is "tmp". 
      In the final results, statistics are in the file "tmp\_statistics.csv", and FCs are in 
      "tmp\_FCs.csv" respectively. }	}

  Standard generic methods:
	\describe{

		\item{\code{show(object)}}{Informatively display object contents.}
	}
}

\author{ Richard D. Pearson }

\seealso{
  Related methods \code{\link{pumaDE}}, \code{\link{calculateLimma}}, \code{\link{calculateFC}} or \code{\link{calculateTtest}}.
}
\examples{
if(FALSE){
## Create an example DEResult object
#	Next 4 lines commented out to save time in package checks, and saved version used
# if (require(affydata)) {
#	data(Dilution)
#	eset_mmgmos <- mmgmos(Dilution)
# }
data(eset_mmgmos)

#	Next line used so eset_mmgmos only has information about the liver factor
#	The scanner factor will thus be ignored, and the two arrays of each level
#	of the liver factor will be treated as replicates
pData(eset_mmgmos) <- pData(eset_mmgmos)[,1,drop=FALSE]

#	To save time we'll just use 100 probe sets for the example
eset_mmgmos_100 <- eset_mmgmos[1:100,]
eset_comb <- pumaComb(eset_mmgmos_100)

esetDE <- pumaDE(eset_comb)

## Use some of the methods
statisticDescription(esetDE)
DEMethod(esetDE)
numberOfProbesets(esetDE)
numberOfContrasts(esetDE)
topGenes(esetDE)
topGenes(esetDE, 3)
pLikeValues(esetDE)[topGenes(esetDE,3)]
topGeneIDs(esetDE, 3)
topGeneIDs(esetDE, 3, direction="down")

## save the expression results into files
write.reslts(esetDE, file="example")
}
}
\keyword{classes}

\name{erfc}
\alias{erfc}
\title{ The complementary error function }
\description{
  This function calculates the complementary error function of an input x.
}
\usage{
erfc(x)
}
\arguments{
  \item{x}{ a numeric, the input. }
}
\details{
  erfc is implemented using the function qnorm.
}
\value{
 The return is a numeric.
}
\author{ Xuejun Liu }
\seealso{ \code{\link{qnorm}}}
\examples{
  erfc(0.5)
}
\keyword{ math }

\name{calculateLimma}
\alias{calculateLimma}
\title{Calculate differential expression between conditions using limma}
\description{
Runs a default analysis using the \pkg{limma} package. Automatically creates design and contrast matrices if not specified. This function is useful for comparing \pkg{limma} results with those of other differential expression (DE) methods such as \code{\link{pumaDE}}.
}
\usage{
calculateLimma(
	eset
,	design.matrix = createDesignMatrix(eset)
,	contrast.matrix = createContrastMatrix(eset)
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} }
	\item{design.matrix}{ A design matrix }
	\item{contrast.matrix}{ A contrast matrix }
}
\details{
The \code{eset} argument must be supplied, and must be a valid \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object. Design and contrast matrices can be supplied, but if not, default matrices will be used. These should usually be sufficient for most analyses.
}
\value{
  An object of class \code{\link{DEResult}}.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{pumaDE}}, \code{\link{calculateTtest}}, \code{\link{calculateFC}}, \code{\link{createDesignMatrix}} and \code{\link{createContrastMatrix}} and class \code{\link{DEResult}}}
\examples{
#if (require(affydata)) {
#	data(Dilution)
#	eset_rma <- affy:::rma(Dilution)
#	#	Next line used so eset_rma only has information about the liver factor
#	#	The scanner factor will thus be ignored, and the two arrays of each level
#	#	of the liver factor will be treated as replicates
#	pData(eset_rma) <- pData(eset_rma)[,1, drop=FALSE]
#	limmaRes <- calculateLimma(eset_rma)
#	topGeneIDs(limmaRes,numberOfGenes=6)
#	plotErrorBars(eset_rma, topGenes(limmaRes))
#}
}
\keyword{manip}

\name{pumaNormalize}
\alias{pumaNormalize}
\title{Normalize an ExpressionSet}
\description{
This is used to apply a scaling normalization to set of arrays. This normalization can be at the array scale (thus giving all arrays the same mean or median), or at the probeset scale (thus giving all probesets the same mean or median).

It is generally recommended that the default option (median array scaling) is used after running \code{\link{mmgmos}} and before running \code{\link{pumaComb}} and/or \code{\link{pumaDE}}. There are however, situations where this might not be the recommended, for example in time series experiments where it is expected than there will be general up-regulation or down-regulation in overall gene expression levels between time points.
}
\usage{
pumaNormalize(
	eset
,	arrayScale = c("median", "none", "mean", "meanlog")
,	probesetScale = c("none", "mean", "median")
,	probesetNormalisation = NULL
,	replicates = list(1:dim(exprs(eset))[2])
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
	\item{arrayScale}{ A method of scale normalisation at the array level. }
	\item{probesetScale}{ A method of scale normalisation at the probe set level. }
	\item{probesetNormalisation}{ If not NULL normalises the expression levels to have zero mean and adjusts the variance of the gene expression according to the zero-centered normalisation. }
	\item{replicates}{ List of integer vectors indicating which arrays are replicates. }
}
\value{
An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} holding the normalised data.
}
\author{ Richard D. Pearson }
\seealso{Methods \code{\link{mmgmos}}, \code{\link{pumaComb}} and \code{\link{pumaDE}}}
\examples{
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)
	apply(exprs(eset_mmgmos),2,median)
	eset_mmgmos_normd <- pumaNormalize(eset_mmgmos)
	apply(exprs(eset_mmgmos_normd),2,median)
}

\keyword{manip}

\name{Clust.exampleE}
\alias{Clust.exampleE}
\docType{data}
\title{ The example data of the mean gene expression levels}
\description{
  This data is an artificial example of the mean gene expression levels.
}
\usage{data(Clust.exampleE)}
\format{
  A 700x20 matrix including 700 genes and 20 chips. Every 100 genes belong to one cluster from the first gene. 
  There are 7 clusters.
}
\source{
Liu, X. Lin, K., Andersen, B. Rattray, M. (2007) Including probe-level uncertainty in model-based gene expression clustering, BMC Bioinformatics, 8(98).
}
\seealso{\code{\link{Clust.exampleStd}}}
\keyword{datasets}

\name{pumaDE}
\alias{pumaDE}
\title{Calculate differential expression between conditions}
\description{
The function generates lists of genes ranked by probability of differential expression (DE). This uses the PPLR method.
}
\usage{
pumaDE(
	eset
,	design.matrix = createDesignMatrix(eset)
,	contrast.matrix = createContrastMatrix(eset)
)
}
\arguments{
	\item{eset}{ An object of class \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}. }
	\item{design.matrix}{ A design matrix }
	\item{contrast.matrix}{ A contrast matrix }
}
\details{
A separate list of genes will be created for each contrast of interest.

Note that this class returns a \code{\link{DEResult-class}} object. This object contains information on both the PPLR statistic values (which should generally be used to rank genes for differential expression), as well as fold change values (which are generally not recommended for ranking genes, but which might be useful, for example, to use as a filter). To understand more about the object returned see \code{\link{DEResult-class}}, noting that when created a DEResult object with the pumaDE function, the \code{statistic} method should be used to return PPLR values. Also note that the \code{pLikeValues} method can be used on the returned object to create values which can more readily be compared with p-values returned by other methods such as variants of t-tests (limma, etc.).

While it is possible to run this function on data from individual arrays, it is generally recommended that this function is run on the output of the function \code{\link{pumaComb}} (which combines information from replicates).
}
\value{
	An object of class \code{\link{DEResult-class}}.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{calculateLimma}}, \code{\link{calculateFC}}, \code{\link{calculateTtest}}, \code{\link{pumaComb}}, \code{\link{pumaCombImproved}}, \code{\link{mmgmos}}, \code{\link{pplr}}, \code{\link{createDesignMatrix}} and \code{\link{createContrastMatrix}}}
\examples{
	#	Next 4 lines commented out to save time in package checks, and saved version used
    # if (require(affydata)) {
	#	data(Dilution)
	#	eset_mmgmos <- mmgmos(Dilution)
	# }
	data(eset_mmgmos)

	#	Next line shows that eset_mmgmos has 4 arrays, each of which is a different
	#   condition (the experimental design is a 2x2 factorial, with both liver and
	#	scanner factors)
	pData(eset_mmgmos)
	
	#	Next line shows expression levels of first 3 probe sets
	exprs(eset_mmgmos)[1:3,]

	#	Next line used so eset_mmgmos only has information about the liver factor
	#	The scanner factor will thus be ignored, and the two arrays of each level
	#	of the liver factor will be treated as replicates
	pData(eset_mmgmos) <- pData(eset_mmgmos)[,1,drop=FALSE]

	#	To save time we'll just use 100 probe sets for the example
	eset_mmgmos_100 <- eset_mmgmos[1:100,]
	eset_comb <- pumaComb(eset_mmgmos_100)
        eset_combimproved <- pumaCombImproved(eset_mmgmos_100)

	pumaDEResults <- pumaDE(eset_comb)
        pumaDEResults_improved <- pumaDE(eset_combimproved)

	topGeneIDs(pumaDEResults,6) # Gives probeset identifiers
	topGeneIDs(pumaDEResults_improved,6)
	topGenes(pumaDEResults,6) # Gives row numbers
        topGenes(pumaDEResults_improved,6)
	statistic(pumaDEResults)[topGenes(pumaDEResults,6),] # PPLR scores of top six genes
	statistic(pumaDEResults_improved)[topGenes(pumaDEResults_improved,6),] 
	FC(pumaDEResults)[topGenes(pumaDEResults,6),] # Fold-change of top six genes
	FC(pumaDEResults_improved)[topGenes(pumaDEResults_improved,6),] 
}
\keyword{manip}

\name{Clustii.exampleE}
\alias{Clustii.exampleE}
\docType{data}
\title{ The example data of the mean gene expression levels}
\description{
  This data is an artificial example of the mean gene exapression levels generated 
  by package \code{\link[puma]{mmgmos}}.
}
\usage{data(Clustii.exampleE)}
\format{
  A 600x80 matrix including 600 genes and 20 conditions. Each condition has 4 replicates. Every 100 genes belong to one cluster from the first gene. 
  There are 6 clusters.
}
\source{
Liu,X. and Rattray,M. (2009) 
Including probe-level measurement error in robust mixture clustering of replicated microarray gene expression, 
Statistical Application in Genetics and Molecular Biology, 9(1), Article 42.
}
\seealso{\code{\link[puma]{Clustii.exampleStd}}}
\keyword{datasets}

\name{pumaFull}
\alias{pumaFull}
\title{Perform a full PUMA analysis}
\description{
Full analysis including pumaPCA and mmgmos/pumaDE vs rma/limma comparison
}
\usage{
pumaFull (
	ExpressionFeatureSet = NULL
,	data_dir = getwd()
,	load_ExpressionFeatureSet = FALSE
,	calculate_eset = TRUE
,	calculate_pumaPCAs = TRUE
,	calculate_bcomb = TRUE
,	mmgmosComparisons = FALSE
)

}
\arguments{
	\item{ExpressionFeatureSet}{ An object of class \code{\link[oligoClasses:FeatureSet-class]{FeatureSet}}. }
	\item{data_dir}{ A character string specifying where data files are stored. }
	\item{load_ExpressionFeatureSet}{ Boolean. Load a pre-existing ExpressionFeatureSet object? Note that this has to be named "ExpressionFeatureSet.rda" and be in the \code{data_dir} directory. }
	\item{calculate_eset}{ Boolean. Calculate ExpressionSet from \code{ExpressionFeatureSet} object? If FALSE, files named "eset\_mmgmos.rda" and "eset\_rma.rda" must be available in the \code{data\_dir} directory. }
	\item{calculate_pumaPCAs}{ Boolean. Calculate pumaPCA from \code{eset\_mmgmos} object? If FALSE, a file named "pumaPCA\_results.rda" must be available in the \code{data\_dir} directory. }
	\item{calculate_bcomb}{ Boolean. Calculate pumaComb from \code{eset\_mmgmos} object? If FALSE, files named "eset\_comb.rda" and "eset\_normd\_comb.rda" must be available in the \code{data\_dir} directory. }
	\item{mmgmosComparisons}{ Boolean. If TRUE, will compare mmgmos with default settings, with mmgmos used with background correction. }
}
\value{
  No return values. Various objects are saved as .rda files during the execution of this function, and various PDF files are created.
}
\author{ Richard D. Pearson }
\seealso{Related methods \code{\link{pumaDE}}, \code{\link{createDesignMatrix}} and \code{\link{createContrastMatrix}}}
\examples{
##	Code commented out to ensure checks run quickly
#	if (require(pumadata)) data(oligo.estrogen)
#	pumaFull(oligo.estrogen)
}
\keyword{manip}

\name{bcomb}
\alias{bcomb}
\title{Combining replicates for each condition}
\description{
This function calculates the combined signal for each condition from replicates  using Bayesian models. The inputs are gene expression levels and the probe-level standard deviation associated with expression measurement for each gene on each chip. The outputs include gene expression levels and standard deviation for each condition.
This function was originally part of the \pkg{pplr} package. Although this function can be called directly, it is recommended to use the \code{\link[puma]{pumaComb}} function instead, which can work directly on \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} objects, and can automatically determine which arrays are replicates.
}
\usage{
bcomb(e, se, replicates, method=c("map","em"), 
      gsnorm=FALSE, nsample=1000, eps=1.0e-6)
}
\arguments{
  \item{e}{ a data frame containing the expression level for each gene on each chip. }
  \item{se}{ a data frame containing the standard deviation of gene expression levels. }
  \item{replicates}{ a vector indicating which chip belongs to which condition. }
  \item{method}{ character specifying the method algorithm used.}
  \item{gsnorm}{ logical specifying whether do global scaling normalisation or not. }
  \item{nsample}{ integer. The number of sampling in parameter estimation. }
  \item{eps}{ a numeric, optimisation parameter. }
}
\details{
  Each element in replicate represents the condition of the chip which is in the same column order as in the expression and standard deviation matrix files.
  
  Method "map" uses MAP of a hierarchical Bayesion model with Gamma prior on the between-replicate variance (Gelman et.al. p.285) and shares the same variance across conditions. This method is fast and suitable for the case where there are many conditions.
  
  Method "em" uses variational inference of the same hierarchical Bayesion model as in method "map" but with conjugate prior on between-replicate variance and shares the variance across conditions.
  
  The parameter nsample should be large enough to ensure stable parameter estimates. Should be at least 1000.
}
\value{
  The result is a data frame with components named 'M1', 'M2', and so on, which represent the mean expression values for condition 1, condition 2, and so on. It also has components named 'Std1', 'Std2', and so on, which represent the standard deviation of the gene expression values for condition 1, condtion 2, and so on.
}
\references{Gelman,A., Carlin,J.B., Stern,H.S., Rubin,D.B., Bayesian data analysis. London: Chapman & Hall; 1995.

Liu,X., Milo,M., Lawrence,N.D. and Rattray,M. (2006) Probe-level variances improve accuracy in detecting differential
gene expression, Bioinformatics, 22:2107-2113.}
\author{ Xuejun Liu, Marta Milo, Neil D. Lawrence, Magnus Rattray }
\seealso{Related methods \code{\link{pumaComb}}, \code{\link{mmgmos}} and \code{\link{pplr}}}
\examples{
#  data(exampleE)
#  data(exampleStd)
#  r<-bcomb(exampleE,exampleStd,replicates=c(1,1,1,2,2,2),method="map")
}
\keyword{ manip }
\keyword{ models }
